*CMZ :  2.00/04 31/07/2000  21.05.56  by  Tancredi Carli
*CMZ :  2.00/03 10/05/2000  19.43.37  by  Tancredi Carli
*-- Author :    Tancredi Carli   10/05/2000
      Subroutine hz00040(iflag)
************************************************************************
*                                                                      *
* Author: Nick Brook (n.brook@bristol.ac.uk)                           *
*                                                                      *
* This routine plots the phi distbns                                   *
* in the hadronic centre of mass frame.                                *
* The distbn are corrected for particles coming from K0s and Lambdas   *
*                                                                      *
*                                                                      *
* Reference:                                                           *
*            DESY 00-040                                               *
*                                                                      *
************************************************************************
*
* HERA tuning defined commons
*
      Implicit Double Precision(A-H,O-Z)
#include "hzfunc.inc"
#include "hzhbook.inc"
#include "hepevtp.inc"
#include "heracmn.inc"
*
      COMMON/QUEST/IQUEST(100)
*
* Set up local variables
*
      Integer idum,ierr,nentry
      Character xxxx*5
      Real eb,ee
      Parameter (ee=27.5)
      Character*80 chtitl
      Character*2 cid
      Dimension plab(4), phcm(4), pbeam(4), pgam(4), pgam5(5)
      Real dazi(10,4), dazie(10,4)
      Real cosm(8),cose(8),cosls(8),cosus(8)
      Real cos2m(8),cos2e(8),cos2ls(8),cos2us(8)
      Real cosmc(8),cos2mc(8)
      Real cosmcsq(8),cos2mcsq(8)
      Real cosmce(8),cos2mce(8)
      Real pi, events
      Integer ntrk(8)
      Dimension pcut(8)

      SAVE xlcut, xhcut, y1cut, yhcut, zhcut, pi, nentry, events

*
      Data nentry/0/
      Data xxxx/'00040'/
*
* Data points from plots
*
      Data pcut/.25,.5,.75,1.,1.25,1.5,1.75,2./
      data cosm/-.078,-.078,-.086,-.080,-.067,-.065,-.048,-.030/
      data cose/.012,.012,.013,.014,.015,.017,.018,.020/
      data cosls/.021,.021,.024,.022,.028,.025,.031,.040/
      data cosus/.019,.017,.019,.020,.018,.024,.023,.021/
      data cos2m/.016,.021,.033,.047,.068,.080,.091,.091/
      data cos2e/.014,.014,.015,.016,.017,.018,.019,.021/
      data cos2ls/.024,.023,.027,.030,.034,.042,.044,.042/
      data cos2us/.019,.020,.021,.021,.022,.024,.024,.026/
      data dazi/.0817,.0743,.0779,.0657,.0695,
     +          .0693,.0605,.0766,.0828,.0874,
     2          .0546,.0485,.0502,.0406,.0452,
     +          .0493,.0373,.0469,.0549,.0602,
     3          .0373,.0314,.0311,.0263,.0339,
     +          .0348,.0270,.0307,.0363,.0438,
     4          .0249,.0221,.0216,.0193,.0258,
     +          .0265,.0185,.0198,.0251,.0290/
      data dazie/.0038,.0034,.0035,.0032,.0034,
     +           .0034,.0029,.0034,.0038,.0040,
     2           .0032,.0028,.0028,.0024,.0027,
     +           .0029,.0023,.0026,.0031,.0034,
     3           .0027,.0022,.0022,.0019,.0025,
     +           .0025,.0020,.0021,.0026,.0031,
     4           .0022,.0019,.0018,.0017,.0022,
     +           .0022,.0016,.0017,.0021,.0025/
*
      If(iflag.eq.1) then
*
* Initialisation: The following MUST always be done
* (i) make subdirectory in PAWC
*      - use the name as the xxxxxx in HZxxxxxx subroutine
* (i) make subdirectory in o/p file
*
        Call hcdir('//PAWC',' ')
        call hmdir('00040','S')
        Call hcdir('//HISTO',' ')
        call hmdir('00040','S')
*
* book your histograms
*
        pi = acos(-1.)
        Call Hbook1(10,' pc = 0.5',10,-pi,pi,0.)
        Call Hbook1(20,' pc = 1.0',10,-pi,pi,0.)
        Call Hbook1(30,' pc = 1.5',10,-pi,pi,0.)
        Call Hbook1(40,' pc = 2.0',10,-pi,pi,0.)
        Call Hbook1(100,' cos(phi)',8,0.25,2.25,0.)
        Call Hbook1(200,' cos(2phi)',8,0.25,2.25,0.)
        Call Hbook1(-10,' pc = 0.5',10,-pi,pi,0.)
        Call Hbook1(-20,' pc = 1.0',10,-pi,pi,0.)
        Call Hbook1(-30,' pc = 1.5',10,-pi,pi,0.)
        Call Hbook1(-40,' pc = 2.0',10,-pi,pi,0.)
        Call Hbook1(-100,' cos(phi)',8,0.25,2.25,0.)
        Call Hbook1(-200,' cos(2phi)',8,0.25,2.25,0.)
        Call Hbook1(-1100,' cos(phi)',8,0.25,2.25,0.)
        Call Hbook1(-1200,' cos(2phi)',8,0.25,2.25,0.)
        Call Hbook1(-1101,' cos(phi)',8,0.25,2.25,0.)
        Call Hbook1(-1201,' cos(2phi)',8,0.25,2.25,0.)
*
* set your plot/paper specific cuts
*
        xlcut = 0.01
        xhcut = 0.1
        ylcut = 0.2
        yhcut = 0.8
        zhcut = 0.2
*
* Initialisation
*
        Call Vzero(cosmc,8)
        Call Vzero(cos2mc,8)
        Call Vzero(cosmcsq,8)
        Call Vzero(cos2mcsq,8)
        do i=1,8
         ntrk(i)=0
        enddo
        nentry = 0
        events = 0.
*
      Else if(iflag.eq.2) then
* Filling: The following MUST always be done
* (i) move to the correct sub-directory in PAWC
*
        call hcdir('//PAWC/00040',' ')
        qsq = hzdiskin(1)
        xbj = hzdiskin(2)
        ybj  = hzdiskin(3)
        If(ybj.ge.ylcut.and.ybj.lt.yhcut.and.
     +     xbj.ge.xlcut.and.xbj.lt.xhcut) then
        Else
           Return
        Endif
*
* Fill your histograms
*
          jel = hzidelec(idum)
          if(jel.lt.0) Return
          if(hzipgam(pgam5).lt.0) Return
          if(hzibeam(ip,il).ne.1) Return
* check on electron beam energy
          nentry=nentry+1
          ierr=HZIBEAM(ibeam,idum)
          if (.not.(ierr.eq.1)) then
           write(6,*) 'HZ'//xxxx,' beams not found ! '
           return
          endif
*
          eb=real(PHEP(4,idum))
          if (abs(abs(eb)-ee).gt.0.3) then
           if (nentry.lt.10) then
            write(6,*) 'HZ'//xxxx,' Electron beam not at ',ee,'  ! '
           elseif (nentry.eq.10) then
            write(6,*) 'HZ'//xxxx,' Electron beam not at ',ee,
     &      ' ...last message ! '
           endif
           return
          endif

          do ivec = 1, 4
            pbeam(ivec) = phep(ivec,ip)
            pgam(ivec) = pgam5(ivec)
          enddo
          Call hzhcmini(pbeam,pgam,ierr)
          Nentry = Nentry + 1
          events = events + wtx
          do 30 ihep = 1, nhep
            If(isthep(ihep).eq.1.and.ihchrg(ihep).ne.0
     +         .and.ihep.ne.jel) then
             idpart=abs(idhep(jmohep(1,ihep)))
             If(idpart.eq.310.or.idpart.eq.3122) goto 30
             do ivec=1,4
               plab(ivec) = phep(ivec,ihep)
             enddo
             zh = 2.*xbj/qsq*(pbeam(4)*plab(4)-pbeam(3)*plab(3))
             if(zh.lt.zhcut) goto 30
             Call hzhcm(plab,phcm,ierr)
             azi = hzphmang(phcm(1),phcm(2))
             csazi = cos(azi)
             cs2azi = cos(2.*azi)
             pt = sqrt(phcm(1)**2+phcm(2)**2)
             Do ibin = 1, 8
               if(pt.gt.pcut(ibin)) then
                 ntrk(ibin) = ntrk(ibin) + 1
                 cosmc(ibin) = cosmc(ibin) + csazi
                 cos2mc(ibin) = cos2mc(ibin) + cs2azi
                 cosmcsq(ibin) = cosmcsq(ibin) + csazi**2
                 cos2mcsq(ibin) = cos2mcsq(ibin) + cs2azi**2
                 if(ibin.eq.2) then
                   Call hfill(10,sngl(azi),0.,wtx)
                 else if(ibin.eq.4) then
                   Call hfill(20,sngl(azi),0.,wtx)
                 else if(ibin.eq.6) then
                   Call hfill(30,sngl(azi),0.,wtx)
                 else if(ibin.eq.8) then
                   Call hfill(40,sngl(azi),0.,wtx)
                 endif
               endif
             Enddo
            endif
 30       continue
*
      Else if(iflag.eq.3) then
* Termination: The following MUST always be done
* (i) Move to the correct PAW subdirectory
*
        call hcdir('//PAWC/00040',' ')
*
* Histo manipulation
* Deal with data plots
*
          Call hzhinrm(10,0,events,1)
          Call hzhinrm(20,0,events,1)
          Call hzhinrm(30,0,events,1)
          Call hzhinrm(40,0,events,1)
          Do ibin = 1, 8
           cosmc(ibin) = cosmc(ibin)/ntrk(ibin)
           cos2mc(ibin) = cos2mc(ibin)/ntrk(ibin)
           cosmcsq(ibin) = cosmcsq(ibin)/ntrk(ibin)
           cos2mcsq(ibin) = cos2mcsq(ibin)/ntrk(ibin)
           cosmce(ibin) = sqrt((cosmcsq(ibin)-cosmc(ibin)**2)
     +                     /ntrk(ibin))
           cos2mce(ibin) = sqrt((cos2mcsq(ibin)-cos2mc(ibin)**2)
     +                     /ntrk(ibin))
          Enddo

          Call hpak(100,cosmc)
          Call hpake(100,cosmce)
          Call hpak(200,cos2mc)
          Call hpake(200,cos2mce)
          Call hpak(-10,dazi(1,1))
          Call hpake(-10,dazie(1,1))
          Call hpak(-20,dazi(1,2))
          Call hpake(-20,dazie(1,2))
          Call hpak(-30,dazi(1,3))
          Call hpake(-30,dazie(1,3))
          Call hpak(-40,dazi(1,4))
          Call hpake(-40,dazie(1,4))
          Call hpak(-100,cosm)
          Call hpake(-100,cose)
          Call hpak(-200,cos2m)
          Call hpake(-200,cos2e)
          Call hpak(-1100,cosm)
          Call hpake(-1100,cosus)
          Call hpak(-1200,cos2m)
          Call hpake(-1200,cos2us)
          Call hpak(-1101,cosm)
          Call hpake(-1101,cosls)
          Call hpak(-1201,cos2m)
          Call hpake(-1201,cos2ls)
          Call hzchisqa(-1100,-1101,100)
          Call hzchisqa(-1200,-1201,200)
          Call hzchisq(-100,100)
          Call hzchisq(-200,200)
          Call hzchisq(-10,10)
          Call hzchisq(-20,20)
          Call hzchisq(-30,30)
          Call hzchisq(-40,40)

      Endif
*
      Return
 1001 Format(/,1X,' bin # ',I2,' Mean Q = ',F4.1)
 1002 Format(A,F4.2,A,F4.2)
 1003 Format(A,F4.2,A,F4.2,A,F4.2)
      End
