*CMZ :          04/09/99   5.10.12  by  Renate Mohr
*CMZ :          03/02/99  15.10.12  by  Renate Mohr
*
      Subroutine hz3jet(OFFSET,IFLAG,njetsel,jetsel,jetsellab,thel)
*************************************************************************
*
*            iflag=1 initialisation
*            iflag=2 filling
*            iflag=3 termination
*
* Arguments:
*            jetsel =vector of selcted jets in Breit system
*            jetsellab =vector of selcted jets in lab system
*
**************************************************************************
*
	IMPLICIT NONE
*
#include "hepevtp.inc"
#include "heracmn.inc"
#include "hzfunc.inc"
#include "hzjetcmn.inc"
*
*    high Q2 Data
*
      Integer nhigq2bin
      Parameter (nhigq2bin = 4)
      Real dsigdq2(nhigq2bin),destatdq2(nhigq2bin),defulldq2(nhigq2bin)
      Real xbinq2(nhigq2bin+1)
      Data xbinq2 /150.,220.,350.,700.,5000./
      Data dsigdq2/  .114E+00, .465E-01, .207E-01, .128E-02/
      Data defulldq2/.166E-01, .786E-02, .335E-02, .177E-03/
      Data destatdq2/.855E-02, .361E-02, .156E-02, .110E-03/
*
      Integer nhigr3q2bin
      Parameter (nhigr3q2bin=4)
      Real dsigdr3q2 (nhigr3q2bin),destatdr3q2(nhigr3q2bin)
      Real defulldr3q2(nhigr3q2bin)
      Real xbinr3q2  (nhigr3q2bin+1)
      Data xbinr3q2 /150.,220.,350.,700.,5000./
      Data dsigdr3q2/.338E+00,.271E+00,.310E+00,.308E+00/
      Data defulldr3q2/.233E-01,.304E-01,.406E-01,.286E-01/
      Data destatdr3q2/.338E-01,.241E-01,.267E-01,.302E-01/
*
      Integer nhigxbjbin
      Parameter (nhigxbjbin=4)
      Real dsigdxbj(nhigxbjbin),destatdxbj(nhigxbjbin)
      Real defulldxbj(nhigxbjbin)
      Real xbinxbj(nhigxbjbin+1)
      Data xbinxbj /0.002,0.007,0.017,0.04,0.2/
      Data dsigdxbj/  .164E+04, .111E+04, .214E+03, .145E+02/
      Data defulldxbj/.210E+03, .180E+03, .295E+02, .265E+01/
      Data destatdxbj/.115E+03, .677E+02, .189E+02, .196E+01/
*
      Integer nhigmabin
      Parameter (nhigmabin=3)
      Real dsigdma(nhigmabin),destatdma(nhigmabin),defulldma(nhigmabin)
      Real xbinma(nhigmabin+1)
      Data xbinma /25.,40.,65.,140./
      Data dsigdma/  .833E+00, .470E+00, .352E-01/
      Data defulldma/.102E+00, .526E-01, .145E-01/
      Data destatdma/.458E-01, .282E-01, .504E-02/
*
      Integer nhigx3bin
      Parameter (nhigx3bin=6)
      Real dsigdx3(nhigx3bin),destatdx3(nhigx3bin),defulldx3(nhigx3bin)
      Real xbinx3(nhigx3bin+1)
      Data xbinx3 /0.4,0.65,0.7,0.8,0.88,0.95,1./
      Data dsigdx3/  .0, .255E+00, .199E+01, .521E+01, .533E+01, .0/
      Data defulldx3/.0, .543E-01, .125E+00, .182E+00, .155E+00, .0/
      Data destatdx3/.0, .108E+00, .211E+00, .375E+00, .389E+00, .0/
*
      Integer nhigx4bin
      Parameter (nhigx4bin=5)
      Real dsigdx4(nhigx4bin),destatdx4(nhigx4bin),defulldx4(nhigx4bin)
      Real xbinx4(nhigx4bin+1)
      Data xbinx4 /0.4,0.5,0.65,0.75,0.9,1./
      Data dsigdx4/  .0, .210E+01, .437E+01, .164E+01, .0/
      Data defulldx4/.0, .798E-01, .240E+00, .950E-01, .0/
      Data destatdx4/.0, .174E+00, .310E+00, .144E+00, .0/
*
      Integer nhigc3bin
      Parameter (nhigc3bin=4)
      Real dsigdc3(nhigc3bin),destatdc3(nhigc3bin),defulldc3(nhigc3bin)
      Real xbinc3(nhigc3bin+1)
      Data xbinc3 /-0.8,-0.5,0.,0.5,0.8/
      Data dsigdc3/  .987E+00,.571E+00,.451E+00,.656E+00/
      Data defulldc3/.730E-01,.342E-01,.244E-01,.308E-01/
      Data destatdc3/.858E-01,.473E-01,.442E-01,.695E-01/
*
      Integer nhigp3bin
      Parameter (nhigp3bin=4)
      Real dsigdp3(nhigp3bin),destatdp3(nhigp3bin),defulldp3(nhigp3bin)
      Real xbinp3(nhigp3bin+1)
      Data xbinp3 /0.,35.,90.,145.,180./
      Data dsigdp3/  .273E+00,.351E+00,.341E+00,.277E+00/
      Data defulldp3/.150E-01,.214E-01,.150E-01,.341E-01/
      Data destatdp3/.322E-01,.284E-01,.263E-01,.313E-01/
*
*    low Q2 Data
*
      Integer nlowq2bin,nq2
      Parameter (nlowq2bin=5)
      Real lowdsigdq2(nlowq2bin),lowdestatdq2(nlowq2bin)
      Real lowdefullldq2(nlowq2bin),lowdefullhdq2(nlowq2bin)
      Real lowxbinq2(nlowq2bin+1),binq2(nlowq2bin+nhigq2bin+2)
      Data lowxbinq2 /5.,10.,15.,25.,35.,55./
      Data lowdsigdq2/.933E+01,.441E+01,.265E+01,.170E+01,.802E+00/
      Data lowdefullldq2/.784E+00,.534E+00,.292E+00,.202E+00,.115E+00/
      Data lowdefullhdq2/.784E+00,.534E+00,.292E+00,.202E+00,.115E+00/
      Data lowdestatdq2/.448E+00,.273E+00,.148E+00,.124E+00,.537E-01/
*
      Integer nlowr3q2bin
      Parameter (nlowr3q2bin=5)
      Real lowdsigdr3q2 (nlowr3q2bin),lowdestatdr3q2(nlowr3q2bin)
      Real lowdefulldr3q2(nlowr3q2bin)
      Real lowxbinr3q2  (nlowr3q2bin+1)
      Data lowxbinr3q2 /5.,10.,15.,25.,35.,55./
      Data lowdsigdr3q2/.391E+00,.355E+00,.385E+00,.426E+00,.338E+00/
      Data lowdefulldr3q2/.125E-01,.142E-01,.135E-01,.149E-01,.206E-01/
      Data lowdestatdr3q2/.227E-01,.256E-01,.246E-01,.273E-01,.264E-01/
*
      Integer nlowxbjbin
      Parameter (nlowxbjbin=6)
      Real lowdsigdxbj(nlowxbjbin),lowdestatdxbj(nlowxbjbin)
      Real lowdefullldxbj(nlowxbjbin),lowdefullhdxbj(nlowxbjbin)
      Real lowxbinxbj(nlowxbjbin+1)
      Data lowxbinxbj /1.e-4,2.5e-4,4.e-4,6.e-4,9.5e-4,2e-3,1.e-2/
      Data lowdsigdxbj/.246E+06,.177E+06,.109E+06,.644E+05,.214E+05,
     & .102E+04/
      Data lowdefullldxbj/.237E+05,.182E+05,.140E+05,.812E+04,.273E+04,
     & .117E+03/
      Data lowdefullhdxbj/.237E+05,.182E+05,.140E+05,.812E+04,.273E+04,
     & .117E+03/
      Data lowdestatdxbj/.138E+05,.991E+04,.674E+04,.393E+04,.126E+04,
     & .856E+02/
*
      Integer nlowmabin
      Parameter (nlowmabin=4)
      Real lowdsigdma(nlowmabin),lowdestatdma(nlowmabin)
      Real lowdefullldma(nlowmabin),lowdefullhdma(nlowmabin)
      Real lowxbinma(nlowmabin+1)
      Data lowxbinma /25.,35.,50.,65.,95./
      Data lowdsigdma/.598E+01,.376E+01,.101E+01,.159E+00/
      Data lowdefullldma/.544E+00,.459E+00,.106E+00,.289E-01/
      Data lowdefullhdma/.544E+00,.459E+00,.106E+00,.289E-01/
      Data lowdestatdma/.221E+00,.150E+00,.768E-01,.191E-01/
*
      Integer nlowx3bin
      Parameter (nlowx3bin=3)
      Real lowdsigdx3(nlowx3bin),lowdestatdx3(nlowx3bin)
      Real lowdefullldx3(nlowx3bin),lowdefullhdx3(nlowx3bin)
      Real lowxbinx3(nlowx3bin+1)
      Data lowxbinx3 /0.65,.77,.84,.95/
      Data lowdsigdx3/.98E+00,.362E+01,.571E+01/
      Data lowdefullldx3/.657E-01,.167E+00,.206E+00/
      Data lowdefullhdx3/.657E-01,.167E+00,.206E+00/
      Data lowdestatdx3/ .156E+00,.366E+00,.383E+00/
*
      Integer nlowx4bin
      Parameter (nlowx4bin=3)
      Real lowdsigdx4(nlowx4bin),lowdestatdx4(nlowx4bin)
      Real lowdefullldx4(nlowx4bin),lowdefullhdx4(nlowx4bin)
      Real lowxbinx4(nlowx4bin+1)
      Data lowxbinx4 /0.5,0.68,0.8,.9/
      Data lowdsigdx4/.253E+01,.353E+01,.126E+01/
      Data lowdefullldx4/.104E+00,.127E+00,.617E-01/
      Data lowdefullhdx4/.104E+00,.127E+00,.617E-01/
      Data lowdestatdx4/ .213E+00,.275E+00,.176E+00/
*
      Integer nlowc3bin
      Parameter (nlowc3bin=5)
      Real lowdsigdc3(nlowc3bin),lowdestatdc3(nlowc3bin)
      Real lowdefullldc3(nlowc3bin),lowdefullhdc3(nlowc3bin)
      Real lowxbinc3(nlowc3bin+1)
      Data lowxbinc3 /-0.8,-0.5,-0.2,0.2,0.5,0.8/
      Data lowdsigdc3/.984E+00,.409E+00,.442E+00,.574E+00,.755E+00/
      Data lowdefullldc3/.823E-01,.492E-01,.135E-01,.256E-01,.551E-01/
      Data lowdefullhdc3/.823E-01,.492E-01,.135E-01,.256E-01,.551E-01/
      Data lowdestatdc3/.945E-01,.593E-01,.623E-01,.677E-01,.823E-01/
*
      Integer nlowp3bin
      Parameter (nlowp3bin=5)
      Real lowdsigdp3(nlowp3bin),lowdestatdp3(nlowp3bin)
      Real lowdefullldp3(nlowp3bin),lowdefullhdp3(nlowp3bin)
      Real lowxbinp3(nlowp3bin+1)
      Data lowxbinp3 /0.,0.6,1.2,1.9,2.5,3.15/
      Data lowdsigdp3/.415E+00,.33E+00,.251E+00,.283E+00,.328E+00/
      Data lowdefullldp3/.245E-01,.159E-01,.853E-02,.187E-01,.226E-01/
      Data lowdefullhdp3/.245E-01,.159E-01,.853E-02,.187E-01,.226E-01/
      Data lowdestatdp3/ .531E-01,.383E-01,.284E-01,.354E-01,.390E-01/
*
*    subroutine-related var.
*
      INTEGER njetsel,njetselgen
      DOUBLE PRECISION jetsel(maxhzjets,8),jetsellab(maxhzjets,8)
      DOUBLE PRECISION jetselgen(maxhzjets,8),jetselgenlab(maxhzjets,8)

      real q2,x,w2,y,thel
      Logical lowq2,highq2
      Integer mult
      Parameter (mult=5)
      integer iel,idum
      real jetboost(maxhzjets,4)
      real jetboost1(4),jetcms1a(4),jetblab1(4)
      real jetboost2(4),jetcms2a(4),jetblab2(4)
      real jetboost3(4),jetcms3a(4),jetblab3(4)
      real jetboost1gen(4),jetboost2gen(4),jetboost3gen(4)
      real jetcms1(4),jetcms2(4),jetcms3(4)
      real helpvec(3)
*
      Real rd,pi,dpi,deg
      Parameter (pi=3.14159,rd=180./pi,dpi=2*pi,deg=pi/180.)
      Logical lp,cut3ja,cut3jb,cut3jc
C      Data lp/.true./
      Data lp/.false./
*
      real lum,lumpb,sigma_tot
      Integer iflag,offset
      integer id,i,j,k,idp,idl
      CHARACTER*7 xxxx
      Character rout*14,string*40
      Data rout/' HZ01073: '/
      Data xxxx/'01073'/
      Real ncount2l,ncount2h
*
      Real nev,nsig,c2jmass,c3jmass
*
      Real mass3j,mass2j
      Real e3,e4,e5,x3,x4,x5
      Integer n3jx5bin,n3jx4bin,n3jx3bin
      Integer n3jmbin,n4jmbin,n3jth3bin,n3jpsi3bin
*
      Real vmod,vdotn,vdot
      Real prod1(3),prod2(3),prod3,prod4
      Real cross1(3),cross2(3),dot1,dot2, dot3,dot4,dot5,dot6
*
      Double precision beta(3), betalab(3)
      Real betav(4),betavlab(4),betavgen(4)
      Real p3cms(3),p4cms(3),p5cms(3),beamcms(3)
      Real ebeamcms(4),pbeamcms(4),ebeam(4),pbeam(4)
      Real psi3,costh3,cospsi3
*
*********************************************************************
*
*                      Initialization
*
*********************************************************************
*
      IF (iflag.eq.1) then
*
*      Initialisation: The following MUST always be done
*      (i) make subdirectory in PAWC
*      (i) make subdirectory in o/p file

       Call hcdir('//PAWC',' ')
       call hmdir(xxxx,'S')
       Call hcdir('//HISTO',' ')
       call hmdir(xxxx,'S')
*
c       write(6,*) rout,' offset= ',offset
*                                       book 1D-histos
*
       id=offset
*
*
c       write(6,*) rout,' books histos with offset ',id
*
* 3jet distributions: low Q2
*  cross sections
       call hbookb(id+1001,' dsigma/dx ',nlowxbjbin,lowxbinxbj,0.)
       call hbarx(id+1001)
       call hbookb(-id-31001,' dsigma/dx ',nlowxbjbin,lowxbinxbj,0.)
       call hbarx(-id-31001)
       call hbookb(-id-41001,' dsigma/dx ',nlowxbjbin,lowxbinxbj,0.)
       call hbarx(-id-41001)
       call hbookb(-id-51001,' dsigma/dx ',nlowxbjbin,lowxbinxbj,0.)
       call hbarx(-id-51001)
*
       call hbookb(id+1002,' dsigma/dQ2',nlowq2bin,lowxbinq2,0.)
       call hbarx(id+1002)
       call hbookb(-id-31002,' dsigma/dQ2',nlowq2bin,lowxbinq2,0.)
       call hbarx(-id-31002)
       call hbookb(-id-41002,' dsigma/dQ2',nlowq2bin,lowxbinq2,0.)
       call hbarx(-id-41002)
       call hbookb(-id-51002,' dsigma/dQ2',nlowq2bin,lowxbinq2,0.)
       call hbarx(-id-51002)
*
       call hbookb(id+1022,'dsigma/dQ2 3j',nlowr3q2bin,lowxbinr3q2,0.)
       call hbarx(id+1022)
       call hbookb(id+1012,' R2/3 vs Q2',nlowr3q2bin,lowxbinr3q2,0.)
       call hbarx(id+1012)
       call hbookb(-id-31012,' R2/3 vs Q2',nlowr3q2bin,lowxbinr3q2,0.)
       call hbarx(-id-31012)
       call hbookb(-id-41012,' R2/3 vs Q2',nlowr3q2bin,lowxbinr3q2,0.)
       call hbarx(-id-41012)
       call hbookb(-id-51012,' R2/3 vs Q2',nlowr3q2bin,lowxbinr3q2,0.)
       call hbarx(-id-51012)
*
       call hbookb(id+1004,' dsigma/dMij ',nlowmabin,lowxbinma,0.)
       call hbarx(id+1004)
       call hbookb(-id-31004,' dsigma/dMij ',nlowmabin,lowxbinma,0.)
       call hbarx(-id-31004)
       call hbookb(-id-41004,' dsigma/dMij ',nlowmabin,lowxbinma,0.)
       call hbarx(-id-41004)
       call hbookb(-id-51004,' dsigma/dMij ',nlowmabin,lowxbinma,0.)
       call hbarx(-id-51004)
*
* 3JET CMS SYSTEM X3,4,5 Psi3, costh3
*
       call hbookb(id+1502,'1/N dN/dX3 ',nlowx3bin,lowxbinx3,0.)
       call hbarx(id+1502)
       call hbookb(-id-31502,'1/N dN/dX3 ',nlowx3bin,lowxbinx3,0.)
       call hbarx(-id-31502)
       call hbookb(-id-41502,'1/N dN/dX3 ',nlowx3bin,lowxbinx3,0.)
       call hbarx(-id-41502)
       call hbookb(-id-51502,'1/N dN/dX3 ',nlowx3bin,lowxbinx3,0.)
       call hbarx(-id-51502)
*
       call hbookb(id+1512,'1/N dN/dX4 ',nlowx4bin,lowxbinx4,0.)
       call hbarx(id+1512)
       call hbookb(-id-31512,'1/N dN/dX4 ',nlowx4bin,lowxbinx4,0.)
       call hbarx(-id-31512)
       call hbookb(-id-41512,'1/N dN/dX4 ',nlowx4bin,lowxbinx4,0.)
       call hbarx(-id-41512)
       call hbookb(-id-51512,'1/N dN/dX4 ',nlowx4bin,lowxbinx4,0.)
       call hbarx(-id-51512)
*
       call hbookb(id+1532,'1/N dN/dcos(th3)',nlowc3bin,lowxbinc3,0.)
       call hbarx(id+1532)
       call hbookb(-id-31532,'1/N dN/dcos(th3)',nlowc3bin,lowxbinc3,0.)
       call hbarx(-id-31532)
       call hbookb(-id-41532,'1/N dN/dcos(th3)',nlowc3bin,lowxbinc3,0.)
       call hbarx(-id-41532)
       call hbookb(-id-51532,'1/N dN/dcos(th3)',nlowc3bin,lowxbinc3,0.)
       call hbarx(-id-51532)
*
       call hbook1(id+1632,'1/N dN/dcos(th3)',50,-0.8,0.8,0.)
       call hbarx(id+1632)
       call hbookb(-id-31632,'1/N dN/dcos(th3)',nlowc3bin,lowxbinc3,0.)
       call hbarx(-id-31632)
       call hbookb(-id-41632,'1/N dN/dcos(th3)',nlowc3bin,lowxbinc3,0.)
       call hbarx(-id-41632)
       call hbookb(-id-51632,'1/N dN/dcos(th3)',nlowc3bin,lowxbinc3,0.)
       call hbarx(-id-51632)
*
       call hbookb(id+1542,'1/N dN/d psi3 ',nlowp3bin,lowxbinp3,0.)
       call hbarx(id+1542)
       call hbookb(-id-31542,'1/N dN/d psi3 ',nlowp3bin,lowxbinp3,0.)
       call hbarx(-id-31542)
       call hbookb(-id-41542,'1/N dN/d psi3 ',nlowp3bin,lowxbinp3,0.)
       call hbarx(-id-41542)
       call hbookb(-id-51542,'1/N dN/d psi3 ',nlowp3bin,lowxbinp3,0.)
       call hbarx(-id-51542)
*
       call hbook1(id+1642,'1/N dN/d psi3 ',50,0.,3.2,0.)
       call hbarx(id+1642)
       call hbookb(-id-31642,'1/N dN/d psi3 ',nlowp3bin,lowxbinp3,0.)
       call hbarx(-id-31642)
       call hbookb(-id-41642,'1/N dN/d psi3 ',nlowp3bin,lowxbinp3,0.)
       call hbarx(-id-41642)
       call hbookb(-id-51642,'1/N dN/d psi3 ',nlowp3bin,lowxbinp3,0.)
       call hbarx(-id-51642)
*
* 3jet distributions: high Q2
*  cross sections
*
       call hbookb(id+2001,' dsigma/dx ',nhigxbjbin,xbinxbj,0.)
       call hbarx(id+2001)
       call hbookb(-id-32001,' dsigma/dx ',nhigxbjbin,xbinxbj,0.)
       call hbarx(-id-32001)
       call hbookb(-id-42001,' dsigma/dx ',nhigxbjbin,xbinxbj,0.)
       call hbarx(-id-42001)
       call hbookb(-id-52001,' dsigma/dx ',nhigxbjbin,xbinxbj,0.)
       call hbarx(-id-52001)
*
       call hbookb(id+2011,' dsigma/dx ',nhigxbjbin,xbinxbj,0.)
       call hbarx(id+2011)
       call hbookb(id+2021,' dsigma/dx ',nhigxbjbin,xbinxbj,0.)
       call hbarx(id+2021)
       call hbookb(-id-32011,' dsigma/dx ',nhigxbjbin,xbinxbj,0.)
       call hbarx(-id-32011)
       call hbookb(-id-42011,' dsigma/dx ',nhigxbjbin,xbinxbj,0.)
       call hbarx(-id-42011)
       call hbookb(-id-52011,' dsigma/dx ',nhigxbjbin,xbinxbj,0.)
       call hbarx(-id-52011)
*
       call hbookb(id+2002,' dsigma/dQ2',nhigq2bin,xbinq2,0.)
       call hbarx(id+2002)
       call hbookb(-id-32002,' dsigma/dQ2',nhigq2bin,xbinq2,0.)
       call hbarx(-id-32002)
       call hbookb(-id-42002,' dsigma/dQ2',nhigq2bin,xbinq2,0.)
       call hbarx(-id-42002)
       call hbookb(-id-52002,' dsigma/dQ2',nhigq2bin,xbinq2,0.)
       call hbarx(-id-52002)
*
       call hbookb(id+2022,'dsigma/dQ2 3j',nhigr3q2bin,xbinr3q2,0.)
       call hbarx(id+2022)
       call hbookb(id+2012,' R2/3 vs Q2',nhigr3q2bin,xbinr3q2,0.)
       call hbarx(id+2012)
       call hbookb(-id-32012,' R2/3 vs Q2',nhigr3q2bin,xbinr3q2,0.)
       call hbarx(-id-32012)
       call hbookb(-id-42012,' R2/3 vs Q2',nhigr3q2bin,xbinr3q2,0.)
       call hbarx(-id-42012)
       call hbookb(-id-52012,' R2/3 vs Q2',nhigr3q2bin,xbinr3q2,0.)
       call hbarx(-id-52012)
*
       call hbookb(id+2004,' dsigma/dMij ',nhigmabin,xbinma,0.)
       call hbarx(id+2004)
       call hbookb(-id-32004,' dsigma/dMij ',nhigmabin,xbinma,0.)
       call hbarx(-id-32004)
       call hbookb(-id-42004,' dsigma/dMij ',nhigmabin,xbinma,0.)
       call hbarx(-id-42004)
       call hbookb(-id-52004,' dsigma/dMij ',nhigmabin,xbinma,0.)
       call hbarx(-id-52004)
*
* 3JET CMS SYSTEM X3,4,5 Psi3, costh3
       call hbookb(id+2502,'1/N dN/dX3 ',nhigx3bin,xbinx3,0.)
       call hbarx(id+2502)
       call hbookb(-id-32502,'1/N dN/dX3 ',nhigx3bin,xbinx3,0.)
       call hbarx(-id-32502)
       call hbookb(-id-42502,'1/N dN/dX3 ',nhigx3bin,xbinx3,0.)
       call hbarx(-id-42502)
       call hbookb(-id-52502,'1/N dN/dX3 ',nhigx3bin,xbinx3,0.)
       call hbarx(-id-52502)
*
       call hbookb(id+2512,'1/N dN/dX4 ',nhigx4bin,xbinx4,0.)
       call hbarx(id+2512)
       call hbookb(-id-32512,'1/N dN/dX4 ',nhigx4bin,xbinx4,0.)
       call hbarx(-id-32512)
       call hbookb(-id-42512,'1/N dN/dX4 ',nhigx4bin,xbinx4,0.)
       call hbarx(-id-42512)
       call hbookb(-id-52512,'1/N dN/dX4 ',nhigx4bin,xbinx4,0.)
       call hbarx(-id-52512)
*
       call hbookb(id+2532,'1/N dN/dcos(th3)',nhigc3bin,xbinc3,0.)
       call hbarx(id+2532)
       call hbookb(-id-32532,'1/N dN/dcos(th3)',nhigc3bin,xbinc3,0.)
       call hbarx(-id-32532)
       call hbookb(-id-42532,'1/N dN/dcos(th3)',nhigc3bin,xbinc3,0.)
       call hbarx(-id-42532)
       call hbookb(-id-52532,'1/N dN/dcos(th3)',nhigc3bin,xbinc3,0.)
       call hbarx(-id-52532)
*
       call hbook1(id+2632,'1/N dN/dcos(th3)',50,-0.8,0.8,0.)
       call hbarx(id+2632)
       call hbookb(-id-32632,'1/N dN/dcos(th3)',nhigc3bin,xbinc3,0.)
       call hbarx(-id-32632)
       call hbookb(-id-42632,'1/N dN/dcos(th3)',nhigc3bin,xbinc3,0.)
       call hbarx(-id-42632)
       call hbookb(-id-52632,'1/N dN/dcos(th3)',nhigc3bin,xbinc3,0.)
       call hbarx(-id-52632)
*
       Do i=1,nhigp3bin+1
        xbinp3(i)=xbinp3(i)/rd
       enddo
*
       call hbookb(id+2542,'1/N dN/d psi3 ',nhigp3bin,xbinp3,0.)
       call hbarx(id+2542)
       call hbookb(-id-32542,'1/N dN/d psi3 ',nhigp3bin,xbinp3,0.)
       call hbarx(-id-32542)
       call hbookb(-id-42542,'1/N dN/d psi3 ',nhigp3bin,xbinp3,0.)
       call hbarx(-id-42542)
       call hbookb(-id-52542,'1/N dN/d psi3 ',nhigp3bin,xbinp3,0.)
       call hbarx(-id-52542)
*
       call hbook1(id+2642,'1/N dN/d psi3 ',50,0.,3.2,0.)
       call hbarx(id+2642)
       call hbookb(-id-32642,'1/N dN/d psi3 ',nhigp3bin,xbinp3,0.)
       call hbarx(-id-32642)
       call hbookb(-id-42642,'1/N dN/d psi3 ',nhigp3bin,xbinp3,0.)
       call hbarx(-id-42642)
       call hbookb(-id-52642,'1/N dN/d psi3 ',nhigp3bin,xbinp3,0.)
       call hbarx(-id-52642)
*
       nq2=nlowq2bin+nhigq2bin+2
       do i=1,nq2
        if (i.le.nlowq2bin+1) then
         binq2(i)=lowxbinq2(i)
        else
         binq2(i)=xbinq2(i-nlowq2bin-1)
        endif
       enddo
*
* put data into histos
* low Q2
*
       call hpak(-id-31001,lowdsigdxbj)
       call hpak(-id-41001,lowdsigdxbj)
       call hpak(-id-51001,lowdsigdxbj)
       do i=1,nlowxbjbin
          lowdefullldxbj(i)=
     &         sqrt(lowdefullldxbj(i)**2+lowdestatdxbj(i)**2)
          lowdefullhdxbj(i)=
     &         sqrt(lowdefullhdxbj(i)**2+lowdestatdxbj(i)**2)
       enddo
       call hpake(-id-31001,lowdestatdxbj)
       call hpake(-id-41001,lowdefullldxbj)
       call hpake(-id-51001,lowdefullhdxbj)
*
       call hpak(-id-31002,lowdsigdq2)
       call hpak(-id-41002,lowdsigdq2)
       call hpak(-id-51002,lowdsigdq2)
       do i=1,nlowq2bin
          lowdefullldq2(i)=
     &         sqrt(lowdefullldq2(i)**2+lowdestatdq2(i)**2)
          lowdefullhdq2(i)=
     &         sqrt(lowdefullhdq2(i)**2+lowdestatdq2(i)**2)
       enddo
       call hpake(-id-31002,lowdestatdq2)
       call hpake(-id-41002,lowdefullldq2)
       call hpake(-id-51002,lowdefullhdq2)
*
       call hpak(-id-31012,lowdsigdr3q2)
       call hpak(-id-41012,lowdsigdr3q2)
       call hpak(-id-51012,lowdsigdr3q2)
       do i=1,nlowr3q2bin
          lowdefulldr3q2(i)=
     &         sqrt(lowdefulldr3q2(i)**2+lowdestatdr3q2(i)**2)
       enddo
       call hpake(-id-31012,lowdestatdr3q2)
       call hpake(-id-41012,lowdefulldr3q2)
       call hpake(-id-51012,lowdefulldr3q2)
*
       call hpak(-id-31004,lowdsigdma)
       call hpak(-id-41004,lowdsigdma)
       call hpak(-id-51004,lowdsigdma)
       do i=1,nlowmabin
          lowdefullldma(i)=
     &         sqrt(lowdefullldma(i)**2+lowdestatdma(i)**2)
          lowdefullhdma(i)=
     &         sqrt(lowdefullhdma(i)**2+lowdestatdma(i)**2)
       enddo
       call hpake(-id-31004,lowdestatdma)
       call hpake(-id-41004,lowdefullldma)
       call hpake(-id-51004,lowdefullhdma)
*
       call hpak(-id-31502,lowdsigdx3)
       call hpak(-id-41502,lowdsigdx3)
       call hpak(-id-51502,lowdsigdx3)
       do i=1,nlowx3bin
          lowdefullldx3(i)=
     &         sqrt(lowdefullldx3(i)**2+lowdestatdx3(i)**2)
          lowdefullhdx3(i)=
     &         sqrt(lowdefullhdx3(i)**2+lowdestatdx3(i)**2)
       enddo
       call hpake(-id-31502,lowdestatdx3)
       call hpake(-id-41502,lowdefullldx3)
       call hpake(-id-51502,lowdefullhdx3)
*
       call hpak(-id-31512,lowdsigdx4)
       call hpak(-id-41512,lowdsigdx4)
       call hpak(-id-51512,lowdsigdx4)
       do i=1,nlowx4bin
          lowdefullldx4(i)=
     &         sqrt(lowdefullldx4(i)**2+lowdestatdx4(i)**2)
          lowdefullhdx4(i)=
     &         sqrt(lowdefullhdx4(i)**2+lowdestatdx4(i)**2)
       enddo
       call hpake(-id-31512,lowdestatdx4)
       call hpake(-id-41512,lowdefullldx4)
       call hpake(-id-51512,lowdefullhdx4)
*
       call hpak(-id-31532,lowdsigdc3)
       call hpak(-id-41532,lowdsigdc3)
       call hpak(-id-51532,lowdsigdc3)
       call hpak(-id-31632,lowdsigdc3)
       call hpak(-id-41632,lowdsigdc3)
       call hpak(-id-51632,lowdsigdc3)
       do i=1,nlowc3bin
          lowdefullldc3(i)=
     &         sqrt(lowdefullldc3(i)**2+lowdestatdc3(i)**2)
          lowdefullhdc3(i)=
     &         sqrt(lowdefullhdc3(i)**2+lowdestatdc3(i)**2)
       enddo
       call hpake(-id-31532,lowdestatdc3)
       call hpake(-id-41532,lowdefullldc3)
       call hpake(-id-51532,lowdefullhdc3)
       call hpake(-id-31632,lowdestatdc3)
       call hpake(-id-41632,lowdefullldc3)
       call hpake(-id-51632,lowdefullhdc3)
*
       call hpak(-id-31542,lowdsigdp3)
       call hpak(-id-41542,lowdsigdp3)
       call hpak(-id-51542,lowdsigdp3)
       call hpak(-id-31642,lowdsigdp3)
       call hpak(-id-41642,lowdsigdp3)
       call hpak(-id-51642,lowdsigdp3)
       do i=1,nlowp3bin
          lowdefullldp3(i)=
     &         sqrt(lowdefullldp3(i)**2+lowdestatdp3(i)**2)
          lowdefullhdp3(i)=
     &         sqrt(lowdefullhdp3(i)**2+lowdestatdp3(i)**2)
       enddo
       call hpake(-id-31542,lowdestatdp3)
       call hpake(-id-41542,lowdefullldp3)
       call hpake(-id-51542,lowdefullhdp3)
       call hpake(-id-31642,lowdestatdp3)
       call hpake(-id-41642,lowdefullldp3)
       call hpake(-id-51642,lowdefullhdp3)
* high Q2
       call hpak(-id-32001,dsigdxbj)
       call hpak(-id-42001,dsigdxbj)
       call hpak(-id-52001,dsigdxbj)
       do i=1,nhigxbjbin
          defulldxbj(i)=
     &         sqrt(defulldxbj(i)**2+destatdxbj(i)**2)
       enddo
       call hpake(-id-32001,destatdxbj)
       call hpake(-id-42001,defulldxbj)
       call hpake(-id-52001,defulldxbj)
*
       call hpak(-id-32002,dsigdq2)
       call hpak(-id-42002,dsigdq2)
       call hpak(-id-52002,dsigdq2)
       do i=1,nhigq2bin
          defulldq2(i)=
     &         sqrt(defulldq2(i)**2+destatdq2(i)**2)
       enddo
       call hpake(-id-32002,destatdq2)
       call hpake(-id-42002,defulldq2)
       call hpake(-id-52002,defulldq2)
*
       call hpak(-id-32012,dsigdr3q2)
       call hpak(-id-42012,dsigdr3q2)
       call hpak(-id-52012,dsigdr3q2)
       do i=1,nhigr3q2bin
          defulldr3q2(i)=
     &         sqrt(defulldr3q2(i)**2+destatdr3q2(i)**2)
       enddo
       call hpake(-id-32012,destatdr3q2)
       call hpake(-id-42012,defulldr3q2)
       call hpake(-id-52012,defulldr3q2)
*
       call hpak(-id-32004,dsigdma)
       call hpak(-id-42004,dsigdma)
       call hpak(-id-52004,dsigdma)
       do i=1,nhigmabin
          defulldma(i)=sqrt(defulldma(i)**2+destatdma(i)**2)
       enddo
       call hpake(-id-32004,destatdma)
       call hpake(-id-42004,defulldma)
       call hpake(-id-52004,defulldma)
*
       call hpak(-id-32502,dsigdx3)
       call hpak(-id-42502,dsigdx3)
       call hpak(-id-52502,dsigdx3)
       do i=1,nhigx3bin
          defulldx3(i)=sqrt(defulldx3(i)**2+destatdx3(i)**2)
       enddo
       call hpake(-id-32502,destatdx3)
       call hpake(-id-42502,defulldx3)
       call hpake(-id-52502,defulldx3)
*
       call hpak(-id-32512,dsigdx4)
       call hpak(-id-42512,dsigdx4)
       call hpak(-id-52512,dsigdx4)
       do i=1,nhigx4bin
          defulldx4(i)=sqrt(defulldx4(i)**2+destatdx4(i)**2)
       enddo
       call hpake(-id-32512,destatdx4)
       call hpake(-id-42512,defulldx4)
       call hpake(-id-52512,defulldx4)
*
       call hpak(-id-32532,dsigdc3)
       call hpak(-id-42532,dsigdc3)
       call hpak(-id-52532,dsigdc3)
       call hpak(-id-32632,dsigdc3)
       call hpak(-id-42632,dsigdc3)
       call hpak(-id-52632,dsigdc3)
       do i=1,nhigc3bin
          defulldc3(i)=sqrt(defulldc3(i)**2+destatdc3(i)**2)
       enddo
       call hpake(-id-32532,destatdc3)
       call hpake(-id-42532,defulldc3)
       call hpake(-id-52532,defulldc3)
       call hpake(-id-32632,destatdc3)
       call hpake(-id-42632,defulldc3)
       call hpake(-id-52632,defulldc3)
*
       call hpak(-id-32542,dsigdp3)
       call hpak(-id-42542,dsigdp3)
       call hpak(-id-52542,dsigdp3)
       call hpak(-id-32642,dsigdp3)
       call hpak(-id-42642,dsigdp3)
       call hpak(-id-52642,dsigdp3)
       do i=1,nhigp3bin
          defulldp3(i)=sqrt(defulldp3(i)**2+destatdp3(i)**2)
       enddo
       call hpake(-id-32542,destatdp3)
       call hpake(-id-42542,defulldp3)
       call hpake(-id-52542,defulldp3)
       call hpake(-id-32642,destatdp3)
       call hpake(-id-42642,defulldp3)
       call hpake(-id-52642,defulldp3)
*
       nev=0.
       nsig=0
       ncount2l=0.
       ncount2h=0.
*
       do i=1,3
        cross1(i)=0.
        cross2(i)=0.
        prod1(i)=0.
        prod2(i)=0.
       enddo
*
       prod3=0.
       prod4=0.
*
       c2jmass=25.
       c3jmass=25.
*
*
*********************************************************
*
*                      Event Processing
*
*********************************************************
*
*
      Else if(iflag.eq.2) then
*
*     cross section bookkeeping
*
       nev=nev+wtx
       nsig=nsig+wtx**2
*
*      Filling: The following MUST always be done
*      (i) move to the correct sub-directory in PAWC
*
       call hcdir('//PAWC/'//xxxx,' ')
*
       q2=real(HZDISKIN(1))
       x =real(HZDISKIN(2))
       y =real(HZDISKIN(3))
       w2=real(HZDISKIN(4))
*
       lowq2=.false.
       highq2=.false.
*
       if (q2.gt.5. .and.q2.lt.100..and.
     &      y.gt.0.2.and. y.lt.0.6 .and.
     &      thel*rd.gt.156.) lowq2=.true.
*
       if (q2.gt.150..and.q2.lt.5000..and.
     &      y.gt.0.2.and. y.lt.0.6) highq2=.true.
*
       if (lp) then
         write(6,*) rout,' x= ',x,' q2= ',q2,' y= ',y,' thel= ',thel*rd
     & ,' lowq2= ',lowq2,' highq2= ',highq2,' njetsel= ',njetsel
*
       endif
*
       if (njetsel.lt.2) return
*
       mass2j=(jetsel(1,4)+jetsel(2,4))**2
     &       - (jetsel(1,5)+jetsel(2,5))**2
     &       - (jetsel(1,6)+jetsel(2,6))**2
     &       - (jetsel(1,7)+jetsel(2,7))**2
       if (mass2j.gt.0.) then
        mass2j=sqrt(mass2j)
       else
        write(6,*) 'Hz',xxxx,' mass2j= ',mass2j,' < 0 ?? '
       endif
*
       mass3j=(jetsel(1,4)+jetsel(2,4)+jetsel(3,4))**2
     &       - (jetsel(1,5)+jetsel(2,5)+jetsel(3,5))**2
     &       - (jetsel(1,6)+jetsel(2,6)+jetsel(3,6))**2
     &       - (jetsel(1,7)+jetsel(2,7)+jetsel(3,7))**2
       if (mass3j.gt.0.) then
        mass3j=sqrt(mass3j)
       else
        write(6,*) 'Hz',xxxx,' mass3j= ',mass3j,' < 0 ?? '
       endif
*
       if (mass2j.gt.c2jmass) then
        if (highq2) then
         call hfill(id+2022,q2,0.,wtx)
        endif
        if (lowq2) then
         call hfill(id+1022,q2,0.,wtx)
        endif
       endif
*
       if (njetsel.lt.3) return
*
* perform boost into 3-jet-CMS frame
*---------------------------------------------------------------
* sort vector such that v(px,py,pz,E)
* 
       jetblab1(1)=jetsellab(1,5)
       jetblab1(2)=jetsellab(1,6)
       jetblab1(3)=jetsellab(1,7)
       jetblab1(4)=jetsellab(1,4)
*
       jetblab2(1)=jetsellab(2,5)
       jetblab2(2)=jetsellab(2,6)
       jetblab2(3)=jetsellab(2,7)
       jetblab2(4)=jetsellab(2,4)
*
       jetblab3(1)=jetsellab(3,5)
       jetblab3(2)=jetsellab(3,6)
       jetblab3(3)=jetsellab(3,7)
       jetblab3(4)=jetsellab(3,4)
*
* take cern lib boost routine:
* boost = f(beta vector: (v3jtot,en3jtot), input, output)
*  jets(numjets,x) = jet info vector:
* x=  | 1  | 2 | 4 | 5 | 6 | 7 | 8 |
*      eta  phi  e   px  py  pz  m    of jet axis    x=3  Et of jet
*
       do i=1,3
        betavlab(i)=jetsellab(1,i+4)+jetsellab(2,i+4)+jetsellab(3,i+4)
       enddo
       betavlab(4)=jetsellab(1,4)+jetsellab(2,4)+jetsellab(3,4)
       call LOREN4(betavlab,jetblab1,jetcms1)
       call LOREN4(betavlab,jetblab2,jetcms2)
       call LOREN4(betavlab,jetblab3,jetcms3)
*
* calculate Dalitz Variables Xi=2*E(1jet)/Mass
* sort e3>e4>e5
*
       E3=max(jetcms1(4),jetcms2(4),jetcms3(4))
       E5=min(jetcms1(4),jetcms2(4),jetcms3(4))
*
       if (jetcms1(4).ne.e3.and.jetcms1(4).ne.e5) then
        e4=jetcms1(4)
        do i=1,3
         p4cms(i)=jetcms1(i)
        enddo
       endif
*
       if (jetcms2(4).ne.e3.and.jetcms2(4).ne.e5) then
        e4=jetcms2(4)
        do i=1,3
         p4cms(i)=jetcms2(i)
        enddo
       endif
*
       if (jetcms3(4).ne.e3.and.jetcms3(4).ne.e5) then
        e4=jetcms3(4)
        do i=1,3
         p4cms(i)=jetcms3(i)
        enddo
       endif
*
       x3=2*e3/mass3j
       x4=2*e4/mass3j
       x5=2*e5/mass3j
*
* highest En jet:
*
       if (jetcms1(4).eq.e3) then
        do i=1,3
         p3cms(i)=jetcms1(i)
        enddo
       elseif (jetcms2(4).eq.e3) then
        do i=1,3
         p3cms(i)=jetcms2(i)
        enddo
       else
        do i=1,3
         p3cms(i)=jetcms3(i)
        enddo
       endif
* lowest En jet:
       if (jetcms1(4).eq.e5) then
        do i=1,3
         p5cms(i)=jetcms1(i)
        enddo
       elseif (jetcms2(4).eq.e5) then
        do i=1,3
         p5cms(i)=jetcms2(i)
        enddo
       else
        do i=1,3
         p5cms(i)=jetcms3(i)
        enddo
       endif
*
       if (lp) then
        write (6,'(2(a,f9.3))')' LAB E3= ',e3,' x3= ',x3
        write (6,'((a,4f9.3))')' p3cms',p3cms
        write (6,'(2(a,f9.3))')' LAB E4= ',e4,' x4= ',x4
        write (6,'((a,4f9.3))')' p4cms ',p4cms
        write (6,'(2(a,f9.3))')' LAB E5= ',e5,' x5= ',x5
        write (6,'((a,4f9.3))')' p5cms',p5cms
       endif
*
* calculate theta3,psi3
* for theta3, cos3 : boost average beam direction:
* take pbeam + photon from phep common to bo
* consistent with jetfinding procedure !
*
       if (hzibeam(idp,idl).ne.1) then
          write(6,*) 'HZ01073 Error: Beams not found.'
          return
       endif
       pbeam(1)=PHEP(1,idp)
       pbeam(2)=PHEP(2,idp)
       pbeam(3)=PHEP(3,idp)
       pbeam(4)=PHEP(4,idp)
*
       call LOREN4(betavlab,pbeam,pbeamcms)
*
* av beam dir in CMS
* take x,y,z components
       do i=1,3
        beamcms(i)=pbeamcms(i)
       enddo
*      vdotn= a*b/|a||b| in n components
       costh3=vdotn(beamcms,p3cms,3)
*
       if (lp) then
        write (6,*)' beamcms, costh3 ',beamcms,costh3
       endif
*
*------------------
* products for psi3
       call cross(p3cms,beamcms,cross1)
       call cross(p4cms,p5cms,cross2)
*
       dot1 = 0.
       dot2 = 0.
       dot3 = 0.
*
*build parts for psi3 formula ...
*
       do i=1,3
*       abs(p3xpb)^2
	dot1 = dot1 + cross1(i)*cross1(i)
*       abs(p4xp5)^2
	dot2 = dot2 + cross2(i)*cross2(i)
*       nominator
	dot3 = dot3 + cross1(i)*cross2(i)
       enddo
*
       cospsi3 = dot3 / (sqrt(dot1) * sqrt(dot2) )
       psi3     = acos(cospsi3)
*
*      write (6,*)'dot1, dot2, dot3, cospsi3',dot1, dot2, dot3, cospsi3
*
*---------------------------------------------------------------
*      inv MASS CUT , CUTS on 3jet var
       cut3ja=mass3j.gt.25.
       cut3jc=x3.lt.0.95.and.abs(costh3).lt.0.8
       cut3jb=cut3jc.and.mass3j.gt.40.

*--------------------------------------------------------------
*
       if (cut3ja) then
        if (lowq2) then
         call hfill(id+1001,x,0.,wtx)
         call hfill(id+1002,q2,0.,wtx)
         call hfill(id+1004,mass3j,0.,wtx)
        endif
*
        if (highq2) then
         call hfill(id+2001,x,0.,wtx)
         call hfill(id+2002,q2,0.,wtx)
         call hfill(id+2004,mass3j,0.,wtx)
        endif
*
        if (lowq2.and.cut3jb) then
         ncount2l=ncount2l+wtx
         if (lp) write(6,*) ' ncount2l= ',ncount2l,x3,x4,costh3
         call hfill(id+1502,x3,0.,wtx)
         call hfill(id+1512,x4,0.,wtx)
         call hfill(id+1532,costh3,0.,wtx)
         call hfill(id+1542,psi3,0.,wtx)
         call hfill(id+1632,costh3,0.,wtx)
         call hfill(id+1642,psi3,0.,wtx)
        endif
*
        if (highq2.and.cut3jc) then
         ncount2h=ncount2h+wtx
         if (lp) write(6,*) ' ncount2h= ',ncount2h,x3,x4,costh3
         call hfill(id+2502,x3,0.,wtx)
         call hfill(id+2512,x4,0.,wtx)
         call hfill(id+2532,costh3,0.,wtx)
         call hfill(id+2542,psi3,0.,wtx)
         call hfill(id+2632,costh3,0.,wtx)
         call hfill(id+2642,psi3,0.,wtx)
        endif
*
       endif
*
*********************************************************************
      Else if(iflag.eq.3) then
*      Termination: norm histos
*      Move to the correct PAW subdirectory
*
       call hcdir('//PAWC/'//xxxx,' ')
*
*
       sigma_tot=xsec/1000.
       if (sigma_tot.ne.0.) then
          lum=real(nev)/real(sigma_tot)
          lumpb=real(nev)/real(xsec)
       endif
       write(6,*) 'hz',xxxx,' sigma_tot = ',sigma_tot
*
       do i=1,5
        if (i.le.4.and.i.ne.3) then
         call HZHINRM( id+1000+i,0,lumpb,1)
         call HZHINRM( id+2000+i,0,lumpb,1)
        endif
*       now norm to shape (with entries after mass cut
        if (i.ne.3) then
        call HZHINRM( id+1502+10*(i-1),0,ncount2l,1)
        call HZHINRM( id+2502+10*(i-1),0,ncount2h,1)
        endif
       enddo
*
       call HZHINRM( id+1632,0,ncount2l,1)
       call HZHINRM( id+1642,0,ncount2l,1)
       call HZHINRM( id+2632,0,ncount2h,1)
       call HZHINRM( id+2642,0,ncount2h,1)
*
       call HZHINRM( id+1022,0,lumpb,1)
       call HZHINRM( id+2022,0,lumpb,1)
*
       call hopera(id+2002,'/e',id+2022,id+2012,1.,1.)
       call hopera(id+1002,'/e',id+1022,id+1012,1.,1.)
*
*********************************************************************
*
      ENDIF
      RETURN
      END

*CMZ :          28/05/99  13.35.02  by  Renate Mohr
*CMZ :  0.00/03 05/11/98  13.45.57  by  Tancredi Carli
*CMZ :  0.00/02 28/12/97  12.21.20  by  Tancredi Carli
*-- Author :
       Subroutine HZ01073(IFLAG)
*****************************************************************************
*
* returned histogramms:
*
* Arguments: iflag=1 initialisation
*            iflag=2 filling
*            iflag=3 termination
*
*****************************************************************************
*
	IMPLICIT NONE
*
#include "hepevtp.inc"
#include "heracmn.inc"
#include "hzfunc.inc"
#include "hzjetcmn.inc"
*
*
*KEEP,HZNLO.
*      NLO: 0 for LO contribution
*           1 for NLO contribution
*      In MC models NLO=0 !
*      TOT: =1: total cross section contribution
*      DIJET: Jet contribution
*
       INTEGER NLO, TOT, DIJET, TRIPJET, QUADJET
       COMMON /HZNLO/NLO, TOT, DIJET, TRIPJET, QUADJET
*
*KEND.
*                                          subroutine-related var.
*                                          -----------------------
      Integer chjet,iflag,ihep,offset
      Integer nlink,idst
      CHARACTER*7 xxxx
      character*6 jetf
      Character rout*12
      logical lp,lowq2,highq2,jetcut
      Data lp/.false./
      Data rout/' HZ01073: '/
      Data xxxx/'01073'/
      Character string*80
      Integer ierr,ibeam,idum,iel,nentry
      Data nentry/0/
      Real xw,nall,eb,ee,x,y,q2
      Parameter (ee=27.55)
      Double precision pbeam(4),pbr(4),pgam(4),ph(5)
      Integer modjet
      Real rcone
      Double precision drcone
      save modjet,rcone,drcone
 
      Double precision PLAB(5,NMXHEP),PBREIT(4,NMXHEP),pel(4)
      Real cpt1,cetal,cetah
*
      Integer id,nx
      Integer ijetb
*
      Integer njet
      DOUBLE PRECISION Jetslab(maxhzjets,8)
      DOUBLE PRECISION Jetsel(maxhzjets,8)
      DOUBLE PRECISION Jetsellab(maxhzjets,8)
      DOUBLE PRECISION PLEP,PPRO
*
      INTEGER i,j,k,l,ioff
      Real thel
*
*********************************************************************
*
*                      Initialization
*
*********************************************************************
*
      IF (iflag.eq.1) then
*
*
*      Initialisation: The following MUST always be done
*      (i) make subdirectory in PAWC
*      (i) make subdirectory in o/p file
*
*     set histo offset to 100000
       ioff=100000
*
       call hz3jet(ioff,iflag,numjets,jetsel,jetsellab,thel)
*
       modjet=3
       rcone=1.
*
        cpt1=5.
        cetal=-1.
        cetah=2.5
*
       if (lp) then
          write(6,*) rout,'CUT values: '
          write(6,*) rout,'  min Et of jets= ',cpt1
          write(6,*) rout,'  min eta lab  = ',cetal
          write(6,*) rout,'  max eta lab  = ',cetah
       endif
*
*
*********************************************************************
*
*                      Event Processing
*
*********************************************************************
*
      Else if(iflag.eq.2) then
*
*      Filling: The following MUST always be done
*      (i) move to the correct sub-directory in PAWC
*
       if ((NLO.eq.1).and.(DIJET.ne.1)) return
*
       ierr=HZIBEAM(ibeam,idum)
       if (.not.(ierr.eq.1)) then
          write(6,*) 'HZ'//xxxx,' beams not found ! '
          return
       else
          Do i=1,4
             pbeam(i)=PHEP(i,IBEAM)
          enddo
       endif
       PPRO=PHEP(3,ibeam)
*
       eb=real(PHEP(4,idum))
       if (abs(abs(eb)-ee).gt.0.2) then
          if (nentry.lt.10) then
             write(6,*) 'HZ'//xxxx,' Electron not at ',ee,' ! ',eb
          elseif (nentry.eq.10) then
             write(6,*) 'HZ'//xxxx,' Electron beam not at ',ee,
     &            ' ...last message ! '
          endif
          return
       endif
       PLEP=PHEP(3,idum)
*
* get scattered electron
*
       iel=HZIDELEC(idum)
       if (iel.eq.-1) then
          write(*,*) 'Hz'//xxxx,' electron not found '
          return
       endif
*
       thel=real(HZPHMANG(PHEP(3,iel),
     $      sqrt(PHEP(1,iel)**2+PHEP(2,iel)**2)))
*
       do i=1,4
          pel(i)=PHEP(i,iel)
       enddo
*
*     reset all quantities
*
       q2=real(HZDISKIN(1))
       x =real(HZDISKIN(2))
       y =real(HZDISKIN(3))
*
       if (lp) then
          write(6,*) rout,' bla: x= ',x,' q2= ',q2,' y= ',y,' wtx= ',wtx
       endif
*
*
       if (lp) then
          write(6,*) rout,' Lab frame: '
          call hzlihep(2)
       endif
*
       do 5 ihep=1,nhep
          Do i=1,5
             Plab(i,ihep)=PHEP(i,ihep)
          enddo
          Do i=1,5
             PBREIT(i,ihep)=PHEP(i,ihep)
          enddo
 5     continue
*
*     this is equivalent to boost a la hztool
*
       call KTBREI(2,PLEP,PPRO,pel,nhep,PBREIT,PBREIT,*10)
*     
       do i=1,4
          do j=1,4
             PHEP(j,ihep)=plab(j,ihep)
          enddo
       enddo
       do ihep=4,nhep
          if (ihep.ne.iel) then
             do j=1,4
                PHEP(j,ihep)=pbreit(j,ihep)
             enddo
          else
             do j=1,4
                PHEP(j,ihep)=plab(j,ihep)
             enddo
          endif
       enddo
*     
       if (lp) then
          write(6,*) rout,' Breit frame: '
          call hzlihep(2)
       endif
*
*     reset jets array
*
       njet=0
       nsel=0
       Do i=1,maxhzjets
          do j=1,8
             jets(i,j)=0.
             jetsel(i,j)=0.
             jetslab(i,j)=0.
             jetsellab(i,j)=0.
          enddo
          ipjet(i)=0
       enddo
*     
       drcone=rcone
       call hzjtfind(modjet,drcone,njet,jets)
       if (njet.gt.maxhzjets) then
          write(6,*) 'hz',xxxx,' too many jets found ! '
          goto 10
       endif
*
       numjets=njet
       if (lp) write(6,*) rout,' njet= ',njet
*
*     transform back from Breit to Lab
*
       call hzbrtola2(njet,jets,jetslab)
*
*     select the jets
*
       if (lp) write(6,*) ' cpt1 cetal,cetah = ',cpt1,cetal,cetah
       nsel=0
*     
       do j=1,njet
          if (lp) then
             write(6,*) rout,' pt= ',jets(j,3),jetslab(j,1)
          endif
          jetcut=jets(j,3).gt.cpt1
     &         .and. jetslab(j,1).gt.cetal .and. jetslab(j,1).lt.cetah
          if (jetcut) then
             nsel=nsel+1
             ipjet(nsel)=j
             
             do i=1,8
                jetsel(nsel,i)=jets(j,i)
                jetsellab(nsel,i)=jetslab(j,i)
             enddo
          endif
       enddo
*
       call hz3jet(ioff,iflag,nsel,jetsel,jetsellab,thel)
*
       dijet=2
*
 10    continue
*
*      put PHEP common back to lab
*
       do ihep=1,nhep
          Do i=1,5
             Phep(i,ihep)=PLAB(i,ihep)
          enddo
       enddo
*

       if (lp) then
          write(6,*) rout,' at the end '
          endfile 6
       endif
*********************************************************************
      Else if(iflag.eq.3) then
*      Termination: The following MUST always be done
*      (i) Move to the correct PAW subdirectory
*
       call hz3jet(ioff,iflag,nsel,jetsel,jetsellab,thel)
*
      ENDIF
*
      RETURN
      END
