      subroutine hz03015(IFLAG)
***********************************************
* D*-data ZEUS  photoproduction  angular dijet distributions in charm
*  DESY 03-015
* Cuts :    Q2 < 1
*        0.19< y_bj <0.87
*-- Author :  H. Jung
*   corrections by A.Cholewa
*
***********************************************
      IMPLICIT NONE
*
      real enel,thel
      Real pi,dpi,rd,ee,eb,dphi
      Real xpt1,xpt2,xxd1,xxd2
      Logical evcut,lp,lctag,lstag
      data lp/.false./
*
      Character string*20
*
      Integer nev,nentry,nd0,ndplus,ndminus
      Real Qpi,qqradp,xntot,q2,x,y,w2
      Real ptl,pth,wl,wh,etal,etah
      Integer nbpt,nbw,nbeta
      Data nev/0/
      Integer ncut
      Parameter (ncut=4,pi=3.1415927,dpi=2.*pi,rd=180./pi,ee=27.5)
*
      Integer ierr,ibeam,igam,iel,idum,idhe,idmo1,idmo2
      Double precision pbeam(4),pgam(4),pcm(4),ph(5),phc(4)
*
      integer err_flag
      real xnd0,alphem,sigma_tot,x_d,p,pt,et,th,phdum,rap
      real lum,binw
      data xnd0/0./
*
#include "hzfunc.inc"
#include "hzhbook.inc"
#include "hepevtp.inc"
#include "heracmn.inc"
#include "hzjetcmn.inc"
      Integer iflag,ihep,i,j,k,l
*     DESY Preprint number
      Character*5 xxxx
      Data xxxx/'03015'/
*
        Integer chjet
        SAVE chjet
C --- choose same jet finder as in the paper --- KTCLUS
        DATA chjet/3/
        CHARACTER*6 jetf
        Integer ktmode
        Parameter (ktmode = 3212)

C --- information returned by jet finder
        INTEGER NJET
        DOUBLE PRECISION CONER
        SAVE CONER

C --- cuts arrays
        DOUBLE PRECISION rapcut(2),Etcut(2)
        DATA Etcut/5.0d0,5.0d0/
        DATA rapcut/-2.4d0,2.4d0/
C ---
        INTEGER loop, njrap  
        Real xgam, xp
        DOUBLE PRECISION rapj(50),Etj(50),phi(50)
	  Real costh,Mij,etabar
	  Real Et1,Et2,rap1,rap2 
        Real x1,x2,xkt1,xkt2
        Integer igl1,igl2

	  Real xgamma,et_j1,et_j2,rap_j1,rap_j2
        common/cwnco1/xgamma,et_j1,et_j2,rap_j1,rap_j2
        Integer nxga 
	  Parameter (nxga=6)
	  Real xgab(7)
	  data xgab/0.25,0.375,0.5,0.625,0.75,0.875,1/
	  Real sigxg(6),sigxgst(6),sigxgsy(6),sigxgt(8)
	  Data sigxg/0.115,0.196,0.407,1.011,2.,1.727/
	  Data sigxgst/0.029,0.055,0.082,0.102,0.147,0.122/
	  Data sigxgsy/0.027,0.0135,0.03,0.103,0.155,0.071/
	  Integer nxp
	  Parameter (nxp=7)
	  Real xpb(8)
	  Data xpb/0.0055,0.011,0.0165,0.022,0.0275,0.033,0.0385,0.044/
	  Real sigxp(7),sigxpst(7),sigxpsy(7),sigxpt(7)
	  Data sigxp/23.28,36.9,30.72,18.55,7.84,3.21,2.37/
	  Data sigxpst/2.47,2.96,2.57,2.05,1.5,0.77,0.69/
	  Data sigxpsy/2.64,2.79,2.5,1.08,1.1,0.475,0.43/
	  Integer ncos
	  Parameter (ncos=8)
	  Real xcos(9)
	  Data xcos/0.,0.10375,0.2075,0.31125,0.415,0.51875,
     &     	 0.6225,0.72625,0.83/
        Real sigco1(8),sigco1st(8),sigco1sy(8),sigco1t(8)
	  Data sigco1/0.056,0.04,0.126,0.114,0.280,0.3,0.536,0.732/
	  Data sigco1st/0.034,0.027,0.041,0.032,0.062,0.069,0.088,0.108/
	  Data sigco1sy/0.022,0.019,0.024,0.029,0.053,0.077,0.085,0.121/
        Real sigco2(8),sigco2st(8),sigco2sy(8),sigco2t(8)
	  Data sigco2/0.277,0.401,0.471,0.390,0.584,0.636,0.810,0.922/
	  Data sigco2st/0.055,0.065,0.063,0.070,0.082,0.089,0.098,0.126/
	  Data sigco2sy/0.044,0.051,0.063,0.046,0.048,0.042,0.06,0.098/
        Integer ncosa
	  Parameter (ncosa=8)
	  Real xcosa(9)
	  Data xcosa/-0.83,-0.664,-0.498,-0.332,0.,
     &             0.322,0.498, 0.664,0.83 / 
        Real sigco3(8),sigco3st(8),sigco3sy(8),sigco3t(8)
	  Data sigco3/0.471,0.198,0.111,0.032,0.043,0.079,0.064,0.148/
	  Data sigco3st/0.072,0.036,0.028,0.011,0.015,0.024,0.035,0.039/
	  Data sigco3sy/0.071,0.034,0.021,0.010,0.008,0.018,0.039,0.026/
        Real sigco4(8),sigco4st(8),sigco4sy(8),sigco4t(8)
	  Data sigco4/0.557,0.371,0.258,0.183,0.198,0.212,0.313,0.308/
	  Data sigco4st/0.066,0.048,0.046,0.024,0.024,0.035,0.053,0.068/
	  Data sigco4sy/0.062,0.023,0.031,0.023,0.018,0.019,0.034,0.027/

          save nd0, ndplus, Qpi, qqradp, nbeta, etal, etah

*
*********************************************************************
*
*                      Initialization
*
*********************************************************************
      NENTRY=NENTRY+1
*
      IF (iflag.eq.1) then
*
         nd0=0
         ndplus=0
         write(6,*)' hz03015 D* Version'
         Qpi = 4.*atan(1.)
         qqradp = 180./qpi
*
*
*      Initialisation: The following MUST always be done
*      (i) make subdirectory in PAWC
*       - use the name as the xxxxxx in HZxxxxxx subroutine
*      (i) make subdirectory in o/p file
*
         Call hcdir('//PAWC',' ')
         call hmdir(xxxx,'S')
         Call hcdir('//HISTO',' ')
         call hmdir(xxxx,'S')
         nbeta = 25
         etal = -1.5
         etah = 1.5


         call hbookb(11,'xgamma d*   ',nxga,xgab,0.)
         call hbookb(-11,'xgamma d* stat  ',nxga,xgab,0.)
         call hbookb(-1011,'xgamma d* tot  ',nxga,xgab,0.)
         call hbookb(12,'xp d*       ',nxp,xpb,0.)
         call hbookb(-12,'xp d*  stat     ',nxp,xpb,0.)
         call hbookb(-1012,'xp d*  tot     ',nxp,xpb,0.)
	   call hbookb(101,'|costh| xgamma.gt.0.75 ',ncos,xcos,0.)
	   call hbookb(-101,'|costh| xgamma.gt.0.75 stat',ncos,xcos,0.)
	   call hbookb(-1101,'|costh| xgamma.gt.0.75 tot',ncos,xcos,0.)
	   call hbookb(102,'|costh| xgamma.lt.0.75 ',ncos,xcos,0.)
	   call hbookb(-102,'|costh| xgamma.lt.0.75 stat',ncos,xcos,0.)
	   call hbookb(-1102,'|costh| xgamma.lt.0.75 tot',ncos,xcos,0.)
	   call hbookb(201,'costh xgamma.gt.0.75 ',ncosa,xcosa,0.)
	   call hbookb(-201,'costh xgamma.gt.0.75 stat',ncosa,xcosa,0.)
	   call hbookb(-1201,'costh xgamma.gt.0.75 tot',ncosa,xcosa,0.)
	   call hbookb(202,'costh xgamma.lt.0.75 ',ncosa,xcosa,0.)
	   call hbookb(-202,'costh xgamma.lt.0.75 stat',ncosa,xcosa,0.)
	   call hbookb(-1202,'costh xgamma.lt.0.75 tot',ncosa,xcosa,0.)
	   
         call hbook1(121,' beam1 log(xg) (all)',50,-5.,0.,0.)
         call hbook1(131,' beam2 log(xg) (all)',50,-5.,0.,0.)
         call hbook1(122,' beam1 kt_2 (all)',50,0.,10.,0.)
         call hbook1(132,' beam2 kt_2 (all)',50,0.,10.,0.)
         call hbook1(221,' beam1 log(xg) (xgamma.gt.0.75) ',50,-5.,0.,0.
     $        )
         call hbook1(231,' beam2 log(xg) (xgamma.gt.0.75) ',50,-5.,0.,0.
     $        )
         call hbook1(222,' beam1 kt_2 (xgamma.gt.0.75) ',100,0.,20.,0.)
         call hbook1(232,' beam2 kt_2 (xgamma.gt.0.75) ',100,0.,20.,0.)
         call hbook1(321,' beam1 log(xg) (xgamma.lt.0.75) ',50,-5.,0.,0.
     $        )
         call hbook1(331,' beam2 log(xg) (xgamma.lt.0.75) ',50,-5.,0.,0.
     $        )
         call hbook1(322,' beam1 kt_2 (xgamma.lt.0.75) ',100,0.,20.,0.)
         call hbook1(332,' beam2 kt_2 (xgamma.lt.0.75) ',100,0.,20.,0.)
	   
	   
	   do i=1,6
	   sigxgt(i) = sqrt(sigxgst(i)**2 + sigxgsy(i)**2) 
	   enddo 
	   do i=1,7
	   sigxpt(i) = sqrt(sigxpst(i)**2 + sigxpsy(i)**2) 
	   enddo 
	   do i=1,8
	   sigco1t(i) = sqrt(sigco1st(i)**2 + sigco1sy(i)**2) 
	   sigco2t(i) = sqrt(sigco2st(i)**2 + sigco2sy(i)**2) 
	   sigco3t(i) = sqrt(sigco3st(i)**2 + sigco3sy(i)**2) 
	   sigco4t(i) = sqrt(sigco4st(i)**2 + sigco4sy(i)**2)
	   enddo 
         call hpak(-11,sigxg)
         call hpake(-11,sigxgst)
         call hpak(-1011,sigxg)
         call hpake(-1011,sigxgt)
         call hpak(-12,sigxp)
         call hpake(-12,sigxpst)
         call hpak(-1012,sigxp)
         call hpake(-1012,sigxpt)
         call hpak(-101,sigco2)
         call hpake(-101,sigco2st)
         call hpak(-1101,sigco2)
         call hpake(-1101,sigco2t)
         call hpak(-102,sigco1)
         call hpake(-102,sigco1st)
         call hpak(-1102,sigco1)
         call hpake(-1102,sigco1t)
         call hpak(-201,sigco4)
         call hpake(-201,sigco4st)
         call hpak(-1201,sigco4)
         call hpake(-1201,sigco4t)
         call hpak(-202,sigco3)
         call hpake(-202,sigco3st)
         call hpak(-1202,sigco3)
         call hpake(-1202,sigco3t)
	
	   call hbook1(103,' Etj ',10,5.,25.,0.)
	   call hbook1(104,' etaj ',10,-2.5,2.5,0.)
	   call hbook1(105,' Mjj ',25,0.,50.,0.)
	   call hbook1(106,' etabar ',10,-1.25,1.25,0.)
           call hbook1(110,' beam2 log(xg) (after cuts)',50,-5.,0.,0.)
	   call hbook1(203,' bef cuts Etj ',10,5.,25.,0.)
	   call hbook1(204,' bef cuts etaj ',10,-2.5,2.5,0.)
	   call hbook1(205,' bef cuts Mjj ',25,0.,50.,0.)
	   call hbook1(206,' bef cuts etabar ',10,-1.25,1.25,0.)
c         call hbook1(-1,'pt d* ZEUS data   ',nbptd,2.,pth,0.)

C --- standard cone radius is 1.0
          CALL HZJETRAD(2,CONER)
          IF (CONER.lt.0.0) THEN
            CONER=1.0
          ENDIF
          CALL HZJTNAME(chjet,jetf)

          WRITE(6,*)'**********************************************'
          WRITE(6,*)'* HZ03015 called, histograms will be output. *'
          WRITE(6,*)'*     Jet finder selected : ',jetf,'           *'
          WRITE(6,1001)'*        with cone radius : ',CONER,'   *'
          WRITE(6,*)'**********************************************'

 1001     FORMAT(A29,F5.2,A13)

*
*
*********************************************************************
*                      Event Processing
*
*********************************************************************
*
      Else if(iflag.eq.2) then
*
         call hcdir('//PAWC/'//xxxx,' ')
*
* total number of generated events
         xntot=xntot+1
*
         q2=hzphokin(1)
         IF (q2.eq.-1) THEN
            PRINT*,'hz03015: HZPHOKIN returns error for Q2'
         ELSEIF (q2.lt.0) THEN
            q2=abs(q2)
         ENDIF
         y=hzphokin(3)
         IF (y.eq.-1) THEN
            PRINT*,'hz03015: HZPHOKIN returns error for y'
         ENDIF
         ierr=HZIBEAM(ibeam,idum)
         if (.not.(ierr.eq.1)) then
            write(6,*) 'HZ'//xxxx,' beams not found ! '
            goto 20
         endif
         w2 = y*4.*PHEP(4,idum)*PHEP(4,ibeam)
         if(sqrt(w2).lt.130.0.or.sqrt(w2).gt.280.0) then

            goto 20
         endif
         if(q2.gt.1.) then

            goto 20
         endif

*
*
*
* boost crap!
*
         iel=HZIDELEC(idum)
         if (iel.eq.-1) then
            write(6,*) 'Hz'//xxxx,' electron not found '
            goto 20
         endif
         enel=real(PHEP(4,iel))
         thel=real(HZPHMANG(PHEP(3,iel), sqrt(PHEP(1,iel)**2+PHEP(2,
     +   iel)**2)))*rd
         if (lp) write(6,*) 'Hz'//xxxx, ' enel= ',enel,' thel= ',thel
*
         ierr=HZIBEAM(ibeam,idum)
         if (.not.(ierr.eq.1)) then
            write(6,*) 'HZ'//xxxx,' beams not found ! '
            goto 20
         else
            Do i=1,4
               pbeam(i)=PHEP(i,IBEAM)
            enddo
         endif
*
         eb=real(PHEP(4,idum))
         if (abs(abs(eb)-ee).gt.0.1) then
            if (nentry.lt.10) then
               write(6,*) 'HZ'//xxxx,' Electron beam not at ',ee,'  ! '
            elseif (nentry.eq.10) then
               write(6,*) 'HZ'//xxxx,' Electron beam not at ',ee,
     +         ' ...last message ! '
            endif
            goto 20
         endif
*
         ierr=HZIPGAM(ph)
         if (ierr.eq.-1) then
            write(6,*) 'HZ'//xxxx,' boson vector not found ! '
            call VZERO(ph,5)
         else
            Do i=1,4
               pgam(i)=ph(i)
            enddo
         endif
*
         call HZHCMINI(pbeam,pgam,ierr)
         if (ierr.eq.1) then
            write(6,*) 'HZ'//xxxx,' problem with boost to cms ! '
            goto 20
         endif
*
         if(gen(1:3).eq.'RAP') then
            igl1=4
            igl2=6
         elseif(gen(1:3).eq.'CAS') then
            igl1= 4
            igl2= 6
         elseif(gen(1:3).eq.'PYT') then
            igl1= 5
            igl2= 6
         endif
	   
         xkt1 = real(sqrt(phep(1,igl1)**2+phep(2,igl1)**2))
         xkt2 = real(sqrt(phep(1,igl2)**2+phep(2,igl2)**2))
         x1=(phep(4,igl1)+dabs(phep(3,igl1)))/2d0/phep(4,1)
         x2=(phep(4,igl2)+dabs(phep(3,igl2)))/2d0/phep(4,2)
            xgam = -1.


		Mij = -9999.
		etabar = -9999.
		costh = -9999.
*
            CALL hzjtfind(chjet,CONER,NJET,Jets)
            IF (NJET.ge.2) THEN
              njrap = 0
              DO loop=1,NJET
                IF(Jets(loop,1).ge.rapcut(1).and.
     +             Jets(loop,1).le.rapcut(2) ) THEN
                  njrap = njrap + 1
                  Etj(njrap)=Jets(loop,3)
                  rapj(njrap)=Jets(loop,1)
			phi(njrap) =Jets(loop,2)
                  IF (njrap.ge.2) goto 13
                ENDIF ! rapcut
              ENDDO
*
* No, there are no two jets in the eta range
*
                                  goto 17
*
* Yes, there are two jets in the eta range
*
 13           continue
*
              IF (Etj(1).ge.Etcut(1).and.Etj(2).ge.Etcut(2))
     +            THEN

              xgam=(Etj(1)*exp(-1*rapj(1))+Etj(2)*exp(-1*rapj(2)))
     +           /(2*y*PHEP(4,idum))
              xp  =(Etj(1)*exp(rapj(1))+Etj(2)*exp(rapj(2)))
     +           /(2*PHEP(4,ibeam))

              costh = tanh((rapj(1) - rapj(2))/2.)
		  Et1=Etj(1)
		  Et2=Etj(2)
		  rap1=rapj(1)
		  rap2=rapj(2)
		  Mij = sqrt(max(0.d0,2.d0*Etj(1)*Etj(2)*
     &		  (cosh(rapj(1) - rapj(2))- cos(phi(1)-phi(2)))))
 
              etabar = ((rapj(1) + rapj(2))/2.)
              ENDIF ! Et cuts

            ENDIF ! NJET.ge.2
*
 17         continue

*
         call hfill(121,real(log10(x1)),0.,1.)
         call hfill(131,real(log10(x2)),0.,1.)
         call hfill(122,xkt1,0.,1.)
         call hfill(132,xkt2,0.,1.)
	   
         lctag=.false.
         xnd0=0
         nev=nev+1
         Do 10 ihep=1,nhep
            idhe=idhep(ihep)
*
            if ( abs(idhe).eq.4 ) lctag=.true.
            if ( abs(idhe).eq.311 ) lstag=.true.
*
ccc            if ( abs(idhe) .eq. 421 ) then
            if ( abs(idhe) .eq. 413 ) then
ccc            if ( abs(idhe) .eq. 4 ) then
               Do i=1,4
                  Phc(i)=PHEP(i,ihep)
               enddo
* pcm in had cms
               call HZHCM(phc,pcm,ierr)
               if (ierr.eq.1) then
                  write(6,*) 'HZ'//xxxx,' problem with boost to cms ! '
                  goto 20
               endif
*
*                                             get particle momenta
*
*
               idmo1=jmohep(1,ihep)
               idmo2=idhep(idmo1)
*          write(6,*)' D0 found ',xntot,lctag,idmo1,idmo2
* LAB variables
               call hzgetvar(phc,p,pt,et,th,phdum,rap,err_flag)
               if ( err_flag.ne.0 ) goto 10
* CMS variables
*           call hzgetvar(pcm,p,pt,et,th,phdum,rap,err_flag)
*           if ( err_flag.ne.0 ) goto 2000
               xnd0=xnd0+1
               x_d = 2*abs(p)/sqrt(w2)
*
               if (lp) write(6,*) ' x_d= ',x_d,' w2= ',w2
*
c               if ( Iabs(idmo2) .eq. 413 ) then
*           write(6,*)' d0 from d*+ '
                  if(rap.ge.-1.5.and.rap.le.1.5) then
                     ndplus=ndplus+1
                     if(pt.gt.3..and.xgam.gt.0.) then
				   call hfill(203,Et1,1.,1.)
				   call hfill(203,Et2,1.,1.)
				   call hfill(204,rap1,1.,1.)
				   call hfill(204,rap2,1.,1.)
				   call hfill(205,Mij,1.,1.)
				   call hfill(206,etabar,1.,1.)
				   If(Mij.gt.18..and.abs(etabar).lt.0.7) Then
                           call hfill(11,xgam,1.,1.)
                           call hfill(12,xp,1.,1.)
				   if(xgam.gt.0.75) then
				    call hfill(101,abs(costh),1.,1.)
				    call hfill(201,costh,1.,1.)
                            call hfill(221,real(log10(x1)),0.,1.)
                            call hfill(231,real(log10(x2)),0.,1.)
                            call hfill(222,xkt1,0.,1.)
                            call hfill(232,xkt2,0.,1.)
				   elseif(xgam.le.0.75) then
				    call hfill(102,abs(costh),1.,1.)
				    call hfill(202,costh,1.,1.)
                            call hfill(321,real(log10(x1)),0.,1.)
                            call hfill(331,real(log10(x2)),0.,1.)
                            call hfill(322,xkt1,0.,1.)
                            call hfill(332,xkt2,0.,1.)
				    endif
				    nsel = nsel + 1
				   endif
                           endif
                  endif
c               endif
*
               if (lp) write(6,*) ' pt x_d= ',pt,x_d,' ndplus= ',
     +         ndplus,nd0
*
            endif
   10    continue
*
         if ( lctag ) then
         endif
*
*
*
*
   20    continue
*
*********************************************************************
*
*                      Termination
*
*********************************************************************
*
      Else if(iflag.eq.3) then
*
*      Termination: The following MUST always be done
*      (i) Move to the correct PAW subdirectory
*
         call hcdir('//PAWC/'//xxxx,' ')
*
         lum=999999999.
* x section in nb
         sigma_tot=xsec/1000.
         if (sigma_tot.ne.0.) then
            lum=real(xntot)/real(sigma_tot)
         else
            write(6,*) 'hz',xxxx,' sigma_tot=0 ! '
         endif
*
* Obtain total cross-section
         write(6,*) 'hz',xxxx,' sigma_tot ',sigma_tot
         write(6,*) ' Total Cross section ',sigma_tot,ntot,nsel
*
         write(6,*)'      '
*

	   call hzhinrm(11, 0, 1., 1 )
         call hopera(11,'+E',11,11,1./lum,0.)
	   call hzhinrm(12, 0, 1., 1 )
         call hopera(12,'+E',12,12,1./lum,0.)
	   call hzhinrm(101, 0, 1., 1 )
         call hopera(101,'+E',101,101,1./lum,0.)
	   call hzhinrm(102, 0, 1., 1 )
         call hopera(102,'+E',102,102,1./lum,0.)
	   call hzhinrm(201, 0, 1., 1 )
         call hopera(201,'+E',201,201,1./lum,0.)
	   call hzhinrm(202, 0, 1., 1 )
         call hopera(202,'+E',202,202,1./lum,0.)
      endif
      RETURN
      END
