      SUBROUTINE HZ03160(IFLAG)
****************************************************************************
* Purpose: 
* Inclusive Dijet Production at Low Bjorken-x  
* H1 Coll. Eur.Phys.J. C33 (2004) 477-493
* Event selection:
*
* Running:
*
* Arguments: iflag=1 initialisation
*            iflag=2 filling
*            iflag=3 termination
*
* written by:
****************************************************************************
      IMPLICIT NONE
*
#include "hzfunc.inc"
#include "hepevtp.inc"
#include "heracmn.inc"
*
*
* Function declarations for Hbook functions
*
          Real HSTATI,HMAX,HMIN,HSUM,HI,HIJ,HX,HXY
          Real HIE,HXE,HIF
          Logical HEXIST
*

CRP***18/3/00 icnlude common block containing double precision event weight 
      DOUBLE PRECISION WTXD
      COMMON/DBLW/WTXD 
CRP***

      INTEGER NUMJET
      PARAMETER (NUMJET=200)
      INTEGER IPJET(NUMJET),IJETNO(NUMJET),NSEL,NJ
      DOUBLE PRECISION PJ(NUMJET,8),PJL(NUMJET,8)
      DOUBLE PRECISION PBEAM(4),PLAB(5,NMXHEP)
CRP***Introduction of HZTOOL-Jet Common, array PJ has the
CRP***name JETS in the original common
CRP***NJ has the Name NUMJETS in the original common
      COMMON /HZJETCMN/PJ,NJ,NSEL,IPJET,IJETNO   
      INTEGER NLO, TOT, DIJET, TRIPJET, QUADJET
      COMMON /HZNLO/NLO, TOT, DIJET, TRIPJET, QUADJET
	Integer NLOJET

      DOUBLE PRECISION PELE(4)
      DOUBLE PRECISION PHAD(4,NMXHEP), PHLP(4,NMXHEP) 
*
      INTEGER NMHL

      INTEGER I,IFLAG,IHEP
      CHARACTER*5 xxxx
*
      REAL PI,RD,EB,EE
      PARAMETER (EE=27.6)
      DOUBLE PRECISION ELPBM, EPRBM
      INTEGER IEL,IDUM,IBEAM
      PARAMETER (PI=3.1415927,RD=180./PI)
      INTEGER NENTRY
      REAL X,Y,Q2,ENEL,THEL
      REAL PTJ,PTJCUT,PTJ1,PTJ2,PHJ1,PHJ2
      REAL XNORM 
      REAL DELTA
      INTEGER IDD
      INTEGER L,K,KP, KS
      INTEGER IJ,J,JL,JLS, KL,JP 
      INTEGER JK
      INTEGER IJET 
      REAL ETALO, ETAUP
      REAL eta, dph
      PARAMETER(PTJCUT=5.0) 
      PARAMETER(ETALO=-1.0,ETAUP=2.5)
      
*     
C     RP***19/4/02 Introduce Jetmass
C     RP***CRP***
      INTEGER IERR
      INTEGER MODJET
      PARAMETER (MODJET=3)
      REAL LUM 
      DOUBLE PRECISION XW
      Double PRECISION RCONE
      PARAMETER (RCONE=1.)
      LOGICAL LP,TWOJET
      Data lp/.FALSE./
*     
CRP***Double differential dijet analysis
      INTEGER NBIN
      PARAMETER (NBIN=6)
      INTEGER NBND
      PARAMETER (NBND=5)  
      INTEGER NDEL
      PARAMETER (NDEL=161)  
      INTEGER NIIN
CRP***Help array for double differntial cross section
      REAL D2JHLP(NBND-1)
CRP***Help Array and help variables to fill delta histos      
      REAL DDHLP(NDEL), EDDHLP(NDEL), ESDHLP(NDEL), EHLPST, EHLPSY
      DOUBLE PRECISION DELHX(NBIN,NBND-1,NDEL), X2JD2(NBIN,NBND-1)
      REAL X2JHL1(4), X2EHL1(4), X2SHL1(4) 
      REAL X2JHL2(3), X2EHL2(3), X2SHL2(3) 
      REAL X2JHL3(2), X2EHL3(2), X2SHL3(2) 
CRP****
      REAL RDDXB(NBND)
CRP xbins for S-distribution and double differential
CRP***dijet xsection	 
      Real sxbin1(NBND)   
      DATA sxbin1/0.0001, 0.00017, 0.0003, 0.0005, 0.001/
      Real sxbin2(NBND)   
      DATA sxbin2/0.00017, 0.0003, 0.0005, 0.001, 0.0018/
      Real sxbin3(NBND-1)   
      DATA sxbin3/0.0003, 0.0005, 0.001, 0.0022/
      Real sxbin4(NBND-1)   
      DATA sxbin4/0.0003, 0.0005, 0.001, 0.0033/
      Real sxbin5(NBND-2)   
      DATA sxbin5/0.0005,0.001,0.0055/
      Real sxbin6(NBND-2)   
      DATA sxbin6/0.001, 0.0025, 0.01/
CRP***q2bins for S-distribution and double differential
CRP***dijet xsection	 
      Real sq2bin(7)
      DATA sq2bin/5.,10.,15.,20.,30.,50.,100./
CRP***Results
CRP***The results are given in the q2,x bins as defined in the paper
CRP***for the five investigated delta   
CRP***5 < Q2 < 10
      REAL Q1X1(5),STQ1X1(5), SYQ1X1(5)           
      DATA Q1X1/6.1E5, 5.6E5, 4.6E5, 2.7E5, 1.2E5/
      DATA STQ1X1/3., 3., 3., 4., 6./
      DATA SYQ1X1/8., 7., 7., 8., 9./
CRP***
      REAL Q1X2(5),STQ1X2(5), SYQ1X2(5)           
      DATA Q1X2/4.8E5, 4.3E5, 3.4E5, 1.8E5, 6.6E4/
      DATA STQ1X2/3., 3., 3., 4.,  5. /
      DATA SYQ1X2/9., 10., 9., 9., 11./
CRP*** 
      REAL Q1X3(5),STQ1X3(5), SYQ1X3(5)           
      DATA Q1X3/2.3E5, 2.0E5, 1.5E5, 8.0E4, 2.9E4/
      DATA STQ1X3/4., 4., 4., 5., 8./
      DATA SYQ1X3/12., 12., 11., 11., 13./
CRP***
      REAL Q1X4(5),STQ1X4(5), SYQ1X4(5)           
      DATA Q1X4/5.2E4, 4.6E4, 3.4E4, 1.6E4, 5.4E3/
      DATA STQ1X4/5., 5., 5., 7., 10./
      DATA SYQ1X4/14., 13., 13., 12., 15./
CRP***10 < Q2 < 15
      REAL Q2X1(5),STQ2X1(5), SYQ2X1(5)           
      DATA Q2X1/1.7E5, 1.6E5, 1.4E5, 8.7E4, 3.7E4/
      DATA STQ2X1/4., 4., 4., 5., 7./
      DATA SYQ2X1/8., 8., 9., 9., 8./
CRP***
      REAL Q2X2(5),STQ2X2(5), SYQ2X2(5)           
      DATA Q2X2/1.3E5, 1.2E5, 9.1E4, 4.8E4, 2.0E4 /
      DATA STQ2X2/3., 3., 4., 5., 7./
      DATA SYQ2X2/10., 9., 9., 10., 11./
CRP***
      REAL Q2X3(5),STQ2X3(5), SYQ2X3(5)
      DATA Q2X3/5.9E4, 5.2E4, 4.0E4, 2.0E4, 7.3E3/
      DATA STQ2X3/6., 7., 7., 9., 17. /
      DATA SYQ2X3/12., 13., 15., 15., 22./
CRP***
      REAL Q2X4(5),STQ2X4(5), SYQ2X4(5)
      DATA Q2X4/1.1E4, 8.8E3, 6.4E3, 3.3E3, 9.3E2/
      DATA STQ2X4/6., 7., 7., 9., 17./
      DATA SYQ2X4/12., 13., 15., 15., 22./
CRP***15 < Q2 < 20
      REAL Q3X1(5),STQ3X1(5), SYQ3X1(5)      
      DATA Q3X1/7.8E4, 7.6E4, 6.4E4, 3.7E4, 1.5E4 /
      DATA STQ3X1/6., 4., 4., 5., 7./
      DATA SYQ3X1/9., 9., 9., 9., 10./
CRP***
      REAL Q3X2(5),STQ3X2(5), SYQ3X2(5)    
      DATA Q3X2/4.5E4, 4.0E4, 3.1E4, 1.6E4, 5.8E3/  
      DATA STQ3X2/4., 4., 4., 5., 8./
      DATA SYQ3X2/11., 12., 11., 11., 12./ 
CRP***
      REAL Q3X3(5), STQ3X3(5), SYQ3X3(5)
      DATA Q3X3/1.1E4, 9.9E3, 7.6E3, 3.8E3, 1.3E3/
      DATA STQ3X3/5., 5., 5., 7., 11./
      DATA SYQ3X3/12., 13., 12., 13., 15./
CRP***20 < Q2 < 30
      REAL Q4X1(5), STQ4X1(5), SYQ4X1(5)
      DATA Q4X1/2.5E4, 2.4E4, 2.1E4, 1.4E4, 6.7E3 /
      DATA STQ4X1/5., 5., 5., 6., 9./  
      DATA SYQ4X1/8., 8., 9., 8., 9./ 
CRP***
      REAL Q4X2(5), STQ4X2(5), SYQ4X2(5)
      DATA Q4X2/2.9E4, 2.7E4, 2.1E4, 1.2E4, 5.1E3/
      DATA STQ4X2/3., 3., 3., 4., 6./
      DATA SYQ4X2/9., 9., 10., 10., 10./
CRP***
      REAL Q4X3(5), STQ4X3(5), SYQ4X3(5)     
      DATA Q4X3/6.2E3, 5.5E3, 4.1E3, 2.2E3, 9.3E2/
      DATA STQ4X3/3., 3., 3., 4., 7./
      DATA SYQ4X3/11., 11., 11., 12., 13./
CRP***30 < Q2 < 50
      REAL Q5X1(5), STQ5X1(5), SYQ5X1(5)        
      DATA Q5X1/1.0E4, 9.5E3, 8.2E3, 5.4E3, 2.6E3/
      DATA STQ5X1/3., 3., 4., 4., 6./
      DATA SYQ5X1/8., 8., 10., 9., 10./
CRP***
      REAL Q5X2(5), STQ5X2(5), SYQ5X2(5)        
      DATA Q5X2/2.8E3, 2.5E3, 2.0E3, 1.1E3, 4.7E2/
      DATA STQ5X2/2., 2., 3., 3., 5./
      DATA SYQ5X2/8., 8., 10., 9, 10./
CRP***50 < Q2 < 100
      REAL Q6X1(5), STQ6X1(5), SYQ6X1(5)
      DATA Q6X1/1.4E3, 1.3E3, 1.1E3, 6.5E2, 2.8E2/
      DATA STQ6X1/3., 3., 3., 4., 6./
      DATA SYQ6X1/9., 9., 9., 10., 13./
CRP***
      REAL Q6X2(5), STQ6X2(5), SYQ6X2(5)
      DATA Q6X2/4.5E2, 4.0E2, 3.2E2, 1.8E2, 7.1E1/
      DATA STQ6X2/3., 3., 3., 4., 6./
      DATA SYQ6X2/9., 10., 11., 11., 17./
CRP***End of Double Differential xsection results
CRP***Triple differential analsyes
CRP***Cut variables
      REAL ETAMEAN, PTMAX
CRP***q2bins for triple differential analyses
      Real q2bin(4)
      Data q2bin/5.,10.,30.,100./
      Real xbin1(5)   
CRP***xbins for triple differential analyses
      DATA xbin1/0.0001, 0.00017, 0.0003, 0.0005, 0.001/
      Real xbin2(5)   
      DATA xbin2/0.00017, 0.0003, 0.0005, 0.001, 0.0033/
      Real xbin3(3)   
      DATA xbin3/0.0005, 0.001, 0.0100/
CRP***etabins 
      REAL etabin(6)
      DATA etabin/0., 0.7, 1.4, 2.1, 2.8, 3.5/  
CRP***Results of triple differential dijet analysis
c     srap11 = sigma q2bin 1, xbin 1	
	real srap11(5),srap11st(5),srap11sy(5),srap11to(5)
	data srap11/2.3e5,1.9e5,1.3e5,7.0e4,2.0e4/
	data srap11st/4., 5. ,6. ,9. ,18./
	data srap11sy/10., 11. , 9. ,9. ,13./
c     srap12 = sigma q2bin 1, xbin 2	
	real srap12(5),srap12st(5),srap12sy(5),srap12to(5)
	data srap12/1.7e5,1.4e5,1.0e5,5.1e4,1.1e4/	
	data srap12st/4., 4. ,6. ,8. ,17./
	data srap12sy/12., 12. ,14. ,12. ,30./
c     srap13 = sigma q2bin 1, xbin 3	
	real srap13(5),srap13st(5),srap13sy(5),srap13to(5)
	data srap13/8.5e4,6.9e4,4.6e4,1.7e4,0/	
	data srap13st/5., 6. ,8. ,13. ,0./
	data srap13sy/14., 15., 13., 17. ,0./
c     srap14 = sigma q2bin 1, xbin 4	
	real srap14(5),srap14st(5),srap14sy(5),srap14to(5)
	data srap14/2.0e4,1.7e4,8.6e3,0,0/	
	data srap14st/7., 8., 12., 0., 0./
	data srap14sy/14., 16. ,22., 0., 0./
c     srap21 = sigma q2bin 2, xbin 1	
	real srap21(5),srap21st(5),srap21sy(5),srap21to(5)
	data srap21/2.0e4,1.5e4,1.2e4,5.0e3,1.8e3/	
	data srap21st/5., 6., 7., 11., 20./
	data srap21sy/13.,10., 10., 13., 31./
c     srap22 = sigma q2bin 2, xbin 2	
	real srap22(5),srap22st(5),srap22sy(5),srap22to(5)
	data srap22/2.5e4,1.9e4,1.4e4,9.4e3,2.0e3/	
	data srap22st/4., 4., 5., 7., 13./
	data srap22sy/12., 11., 11., 11., 13./
c     srap23 = sigma q2bin 2, xbin 3	
	real srap23(5),srap23st(5),srap23sy(5),srap23to(5)
	data srap23/1.5e4,1.2e4,8.1e3,4.0e3,8.8e2/	
	data srap23st/3., 3., 5., 7., 16./
	data srap23sy/12., 12., 15., 14. ,30./
c     srap23 = sigma q2bin 2, xbin 4	
	real srap24(5),srap24st(5),srap24sy(5),srap24to(5)
	data srap24/2.1e3,1.8e3,9.5e2,2.2e2,0./	
	data srap24st/4., 4., 7., 13., 0./
	data srap24sy/13.1,14.1,15.6,21.6, 0./
c     srap31 = sigma q2bin 3, xbin 1	
	real srap31(5),srap31st(5),srap31sy(5),srap31to(5)
	data srap31/1.1e3,1.1e3,6.8e2,3.4e2,1.6e2/	
	data srap31st/6., 6.,  7., 11., 21./
	data srap31sy/11., 14., 12., 13., 24./
c     srap32 = sigma q2bin 2, xbin 2	
	real srap32(5),srap32st(5),srap32sy(5),srap32to(5)
	data srap32/3.4e2,2.7e2,1.8e2,6.1e1,9.1/	
	data srap32st/3., 3., 4., 6., 15./
	data srap32sy/14., 11., 13., 14., 21./

CRP***e_tbins
      REAL ptbin(5)
      DATA ptbin/7., 12., 20., 30., 60./  
c     set11 = sigma q2bin 1, xbin 1	
	real set11(4),set11st(4),set11sy(4),set11to(4)
	data set11/6.8e4, 1.2e4, 1.3e3, 7.2e1/
	data set11st/4., 6., 13., 27./
	data set11sy/9., 12., 16., 27./
c     set12 = sigma q2bin 1, xbin 2	
	real set12(4),set12st(4),set12sy(4),set12to(4)
	data set12/5.5e4, 6.8e3, 6.9e2, 3.0e1/	
	data set12st/3., 5., 13., 35./
	data set12sy/11., 14., 17., 25./
c     set13 = sigma q2bin 1, xbin 3	
	real set13(4),set13st(4),set13sy(4),set13to(4)
	data set13/2.5e4, 3.1e3, 2.9e2, 0./	
	data set13st/4., 8., 21., 0./
	data set13sy/12., 17., 21., 0./
c     set14 = sigma q2bin 1, xbin 4	
	real set14(4),set14st(4),set14sy(4),set14to(4)
	data set14/5.6e3, 6.0e2, 3.0e1, 0./	
	data set14st/5., 10., 33., 0./
	data set14sy/15., 17., 30., 0./
c     set21 = sigma q2bin 2, xbin 1	
	real set21(4),set21st(4),set21sy(4),set21to(4)
	data set21/5.5e3, 1.1e3, 1.0e2, 5.4e0/	
	data set21st/6., 7., 18., 36./
	data set21sy/11., 12., 14., 22./
c     set22 = sigma q2bin 2, xbin 2	
	real set22(4),set22st(4),set22sy(4),set22to(4)
	data set22/7.4e3, 1.2e3, 1.5e2, 1.0e1/	
	data set22st/3., 5., 11., 20./
	data set22sy/11., 13., 18., 25./
c     set23 = sigma q2bin 2, xbin 3	
	real set23(4),set23st(4),set23sy(4),set23to(4)
	data set23/4.6e3, 6.2e2, 6.1e1, 1.4e0/	
	data set23st/2., 4., 11., 36./
	data set23sy/12., 15., 18., 24./
c     set23 = sigma q2bin 2, xbin 4	
	real set24(4),set24st(4),set24sy(4),set24to(4)
	data set24/5.7e2, 7.8e1, 4.6e0, 0.1e0/	
	data set24st/3., 6., 18.,  69./
	data set24sy/14., 16., 26., 23./
c     set31 = sigma q2bin 3, xbin 1	
	real set31(4),set31st(4),set31sy(4),set31to(4)
	data set31/3.3e2, 7.8e1, 9.7e0, 0.3e0/	
	data set31st/4., 6., 17., 39./
	data set31sy/11., 14., 24., 32/
c     set32 = sigma q2bin 2, xbin 2	
	real set32(4),set32st(4),set32sy(4),set32to(4)
	data set32/9.3e1, 1.5e1, 1.3e0, 5.0e-2/	
	data set32st/2., 3., 9., 26./
	data set32sy/11., 17., 18., 30./
CRP***Introduce Parameter for DeltaPhi analysis
      REAL dph_cut
      PARAMETER (dph_cut=2./3.*pi)
      Real ssigb1(4),ssigb1st(4),ssigb1sy(4),ssigb1to(4)
	Data ssigb1/0.086,0.053,0.049,0.0379/
	Data ssigb1st/8., 9. ,13., 21./
	Data ssigb1sy/9., 9., 9., 12./
      Real ssigb2(4),ssigb2st(4),ssigb2sy(4),ssigb2to(4)
	Data ssigb2/0.056,0.048,0.039,0.022/
	Data ssigb2st/12., 13., 15., 33./
	Data ssigb2sy/9., 12., 10., 24./
      Real ssigb3(3),ssigb3st(3),ssigb3sy(3),ssigb3to(3)
	Data ssigb3/0.066, 0.050, 0.039/
	Data ssigb3st/13., 15., 23./
	Data ssigb3sy/7., 16., 24./
      Real ssigb4(3),ssigb4st(3),ssigb4sy(3),ssigb4to(3)
	Data ssigb4/0.086,0.051, 0.043/
	Data ssigb4st/16., 12., 15./
	Data ssigb4sy/14., 12., 13./
      Real ssigb5(2),ssigb5st(2),ssigb5sy(2),ssigb5to(2)
	Data ssigb5/0.0576,0.0379/
	Data ssigb5st/13., 11./
	Data ssigb5sy/10., 16./
      Real ssigb6(2),ssigb6st(2),ssigb6sy(2),ssigb6to(2)
	Data ssigb6/0.040,0.038/
	Data ssigb6st/14., 13./
	Data ssigb6sy/16., 11./

      REAL Nevt,N2,NALL,NALL2,N2PT
      SAVE XXXX,NALL,NALL2,N2,NENTRY,N2PT
	Integer idhist, idpt
	Real binq2,binx,binw
      DATA XXXX/'03160'/,NENTRY/0/
*********************************************************************
*     
*     Initialization
*     
*********************************************************************
      NENTRY=NENTRY+1
c	write(6,*) ' hzroman Weight wtx= ',wtx
*     
      IF (IFLAG.EQ.1) THEN
*     

         NALL=0.
         NALL2=0.
         N2=0.
         NLO=0
	   NLOJET = 0
*     
*     
*     Initialisation: The following MUST always be done
*     (i) make subdirectory in PAWC
*     - use the name as the xxxxxx in HZxxxxxx subroutine
*     (i) make subdirectory in o/p file
*     
         CALL HCDIR('//PAWC',' ')
         CALL HMDIR(XXXX,'S')
         CALL HCDIR('//HISTO',' ')
         CALL HMDIR(XXXX,'S')
*     
*     book histos
*     
*     
CRP***Some general control histos
         CALL HBOOK1(10,' ENEL         ', 30,  5. ,35. ,0.)
         CALL HBOOK1(11,' THEL         ', 30,150. ,180. ,0.)
         CALL HBOOK1(12,' PTJET        ', 50,0. ,50. ,0.)
         CALL HBOOK1(13,' DPT          ', 30,0.,10.,0.)
         CALL HBOOK1(14,' DRP          ', 20,0.,5.,0.)
         CALL HBOOK1(15,' XB           ', 20,1E-04,2E-02,0.) 
         CALL HBOOK1(16,' Q2           ', 20,1.,120.,0.) 
         CALL HBOOK1(17,' Njet         ', 4,2.,6.,0.)
*     

CRP***Book histos for triple differential dijet analysis (Deta)
         call hbookb(101,' dsig/deta, q2bin 1, xbin1',5,etabin,0.)
         call hbookb(102,' dsig/deta, q2bin 1, xbin2',5,etabin,0.)
         call hbookb(103,' dsig/deta, q2bin 1, xbin3',5,etabin,0.)
         call hbookb(104,' dsig/deta, q2bin 1, xbin4',5,etabin,0.)

         call hbookb(201,' dsig/deta, q2bin 2, xbin1',5,etabin,0.)
         call hbookb(202,' dsig/deta, q2bin 2, xbin2',5,etabin,0.)
         call hbookb(203,' dsig/deta, q2bin 2, xbin3',5,etabin,0.)
         call hbookb(204,' dsig/deta, q2bin 2, xbin4',5,etabin,0.)

         call hbookb(301,' dsig/deta, q2bin 3, xbin1',5,etabin,0.)
         call hbookb(302,' dsig/deta, q2bin 3, xbin2',5,etabin,0.)

         call hbookb(-101,' datst dsig/deta,q2bin1,xbin1',5,etabin,0.)
         call hbookb(-102,' datst dsig/deta,q2bin1,xbin2',5,etabin,0.)
         call hbookb(-103,' datst dsig/deta,q2bin1,xbin3',5,etabin,0.)
         call hbookb(-104,' datst dsig/deta,q2bin1,xbin4',5,etabin,0.)

         call hbookb(-201,' datst dsig/deta,q2bin2,xbin1',5,etabin,0.)
         call hbookb(-202,' datst dsig/deta,q2bin2,xbin2',5,etabin,0.)
         call hbookb(-203,' datst dsig/deta,q2bin2,xbin3',5,etabin,0.)
         call hbookb(-204,' datst dsig/deta,q2bin2,xbin4',5,etabin,0.)

         call hbookb(-301,' datst dsig/deta,q2bin3,xbin1',5,etabin,0.)
         call hbookb(-302,' datst dsig/deta,q2bin3,xbin2',5,etabin,0.)

         call hbookb(-111,' datto dsig/deta,q2bin1,xbin1',5,etabin,0.)
         call hbookb(-112,' datto dsig/deta,q2bin1,xbin2',5,etabin,0.)
         call hbookb(-113,' datto dsig/deta,q2bin1,xbin3',5,etabin,0.)
         call hbookb(-114,' datto dsig/deta,q2bin1,xbin4',5,etabin,0.)

         call hbookb(-211,' datto dsig/deta,q2bin2,xbin1',5,etabin,0.)
         call hbookb(-212,' datto dsig/deta,q2bin2,xbin2',5,etabin,0.)
         call hbookb(-213,' datto dsig/deta,q2bin2,xbin3',5,etabin,0.)
         call hbookb(-214,' datto dsig/deta,q2bin2,xbin4',5,etabin,0.)

         call hbookb(-311,' datto dsig/deta,q2bin3,xbin1',5,etabin,0.)
         call hbookb(-312,' datto dsig/deta,q2bin3,xbin2',5,etabin,0.)

	   do i=1,5
	   srap11st(i) = srap11(i)*srap11st(i)/100.
	   srap11sy(i) = srap11(i)*srap11sy(i)/100.
	   srap11to(i) = sqrt(srap11st(i)**2 + srap11sy(i)**2)
	   srap12st(i) = srap12(i)*srap12st(i)/100.
	   srap12sy(i) = srap12(i)*srap12sy(i)/100.
	   srap12to(i) = sqrt(srap12st(i)**2 + srap12sy(i)**2)
	   srap13st(i) = srap13(i)*srap13st(i)/100.
	   srap13sy(i) = srap13(i)*srap13sy(i)/100.
	   srap13to(i) = sqrt(srap13st(i)**2 + srap13sy(i)**2)
	   srap14st(i) = srap14(i)*srap14st(i)/100.
	   srap14sy(i) = srap14(i)*srap14sy(i)/100.
	   srap14to(i) = sqrt(srap14st(i)**2 + srap14sy(i)**2)
	   srap21st(i) = srap21(i)*srap21st(i)/100.
	   srap21sy(i) = srap21(i)*srap21sy(i)/100.
	   srap21to(i) = sqrt(srap21st(i)**2 + srap21sy(i)**2)
	   srap22st(i) = srap22(i)*srap22st(i)/100.
	   srap22sy(i) = srap22(i)*srap22sy(i)/100.
	   srap22to(i) = sqrt(srap22st(i)**2 + srap22sy(i)**2)
	   srap23st(i) = srap23(i)*srap23st(i)/100.
	   srap23sy(i) = srap23(i)*srap23sy(i)/100.
	   srap23to(i) = sqrt(srap23st(i)**2 + srap23sy(i)**2)
	   srap24st(i) = srap24(i)*srap24st(i)/100.
	   srap24sy(i) = srap24(i)*srap24sy(i)/100.
	   srap24to(i) = sqrt(srap24st(i)**2 + srap24sy(i)**2)
	   srap31st(i) = srap31(i)*srap31st(i)/100.
	   srap31sy(i) = srap31(i)*srap31sy(i)/100.
	   srap31to(i) = sqrt(srap31st(i)**2 + srap31sy(i)**2)
	   srap32st(i) = srap32(i)*srap32st(i)/100.
	   srap32sy(i) = srap32(i)*srap32sy(i)/100.
	   srap32to(i) = sqrt(srap32st(i)**2 + srap32sy(i)**2)
	   enddo
         call hpak(-101,srap11)
         call hpake(-101,srap11st)
         call hpak(-111,srap11)
         call hpake(-111,srap11to)
         call hpak(-102,srap12)
         call hpake(-102,srap12st)
         call hpak(-112,srap12)
         call hpake(-112,srap12to)
         call hpak(-103,srap13)
         call hpake(-103,srap13st)
         call hpak(-113,srap13)
         call hpake(-113,srap13to)
         call hpak(-104,srap14)
         call hpake(-104,srap14st)
         call hpak(-114,srap14)
         call hpake(-114,srap14to)
         call hpak(-201,srap21)
         call hpake(-201,srap21st)
         call hpak(-211,srap21)
         call hpake(-211,srap21to)
         call hpak(-202,srap22)
         call hpake(-202,srap22st)
         call hpak(-212,srap22)
         call hpake(-212,srap22to)
         call hpak(-203,srap23)
         call hpake(-203,srap23st)
         call hpak(-213,srap23)
         call hpake(-213,srap23to)
         call hpak(-204,srap24)
         call hpake(-204,srap24st)
         call hpak(-214,srap24)
         call hpake(-214,srap24to)
         call hpak(-301,srap31)
         call hpake(-301,srap31st)
         call hpak(-311,srap31)
         call hpake(-311,srap31to)
         call hpak(-302,srap32)
         call hpake(-302,srap32st)
         call hpak(-312,srap32)
         call hpake(-312,srap32to)
	   
CRP***Book histos for triple differential dijet analysis (E_T)
         PRINT*,'Before Et'
         call hbookb(401,' dsig/det, q2bin 1, xbin1',4,ptbin,0.)
         call hbookb(402,' dsig/det, q2bin 1, xbin2',4,ptbin,0.)
         call hbookb(403,' dsig/det, q2bin 1, xbin3',4,ptbin,0.)
         call hbookb(404,' dsig/det, q2bin 1, xbin4',4,ptbin,0.)

         call hbookb(501,' dsig/det, q2bin 2, xbin1',4,ptbin,0.)
         call hbookb(502,' dsig/det, q2bin 2, xbin2',4,ptbin,0.)
         call hbookb(503,' dsig/det, q2bin 2, xbin3',4,ptbin,0.)
         call hbookb(504,' dsig/det, q2bin 2, xbin4',4,ptbin,0.)

         call hbookb(601,' dsig/det, q2bin 3, xbin1',4,ptbin,0.)
         call hbookb(602,' dsig/det, q2bin 3, xbin2',4,ptbin,0.)

         call hbookb(-401,' datst dsig/det,q2bin1,xbin1',4,ptbin,0.)
         call hbookb(-402,' datst dsig/det,q2bin1,xbin2',4,ptbin,0.)
         call hbookb(-403,' datst dsig/det,q2bin1,xbin3',4,ptbin,0.)
         call hbookb(-404,' datst dsig/det,q2bin1,xbin4',4,ptbin,0.)

         call hbookb(-501,' datst dsig/det,q2bin2,xbin1',4,ptbin,0.)
         call hbookb(-502,' datst dsig/det,q2bin2,xbin2',4,ptbin,0.)
         call hbookb(-503,' datst dsig/det,q2bin2,xbin3',4,ptbin,0.)
         call hbookb(-504,' datst dsig/det,q2bin2,xbin4',4,ptbin,0.)

         call hbookb(-601,' datst dsig/det,q2bin3,xbin1',4,ptbin,0.)
         call hbookb(-602,' datst dsig/det,q2bin3,xbin2',4,ptbin,0.)

         call hbookb(-411,' datto dsig/det,q2bin1,xbin1',4,ptbin,0.)
         call hbookb(-412,' datto dsig/det,q2bin1,xbin2',4,ptbin,0.)
         call hbookb(-413,' datto dsig/det,q2bin1,xbin3',4,ptbin,0.)
         call hbookb(-414,' datto dsig/det,q2bin1,xbin4',4,ptbin,0.)

         call hbookb(-511,' datto dsig/det,q2bin2,xbin1',4,ptbin,0.)
         call hbookb(-512,' datto dsig/det,q2bin2,xbin2',4,ptbin,0.)
         call hbookb(-513,' datto dsig/det,q2bin2,xbin3',4,ptbin,0.)
         call hbookb(-514,' datto dsig/det,q2bin2,xbin4',4,ptbin,0.)

         call hbookb(-611,' datto dsig/det,q2bin3,xbin1',4,ptbin,0.)
         call hbookb(-612,' datto dsig/det,q2bin3,xbin2',4,ptbin,0.)


	   do i=1,4
	   set11st(i) = set11(i)*set11st(i)/100.
	   set11sy(i) = set11(i)*set11sy(i)/100.
	   set11to(i) = sqrt(set11st(i)**2 + set11sy(i)**2)
	   set12st(i) = set12(i)*set12st(i)/100.
	   set12sy(i) = set12(i)*set12sy(i)/100.
	   set12to(i) = sqrt(set12st(i)**2 + set12sy(i)**2)
	   set13st(i) = set13(i)*set13st(i)/100.
	   set13sy(i) = set13(i)*set13sy(i)/100.
	   set13to(i) = sqrt(set13st(i)**2 + set13sy(i)**2)
	   set14st(i) = set14(i)*set14st(i)/100.
	   set14sy(i) = set14(i)*set14sy(i)/100.
	   set14to(i) = sqrt(set14st(i)**2 + set14sy(i)**2)
	   set21st(i) = set21(i)*set21st(i)/100.
	   set21sy(i) = set21(i)*set21sy(i)/100.
	   set21to(i) = sqrt(set21st(i)**2 + set21sy(i)**2)
	   set22st(i) = set22(i)*set22st(i)/100.
	   set22sy(i) = set22(i)*set22sy(i)/100.
	   set22to(i) = sqrt(set22st(i)**2 + set22sy(i)**2)
	   set23st(i) = set23(i)*set23st(i)/100.
	   set23sy(i) = set23(i)*set23sy(i)/100.
	   set23to(i) = sqrt(set23st(i)**2 + set23sy(i)**2)
	   set24st(i) = set24(i)*set24st(i)/100.
	   set24sy(i) = set24(i)*set24sy(i)/100.
	   set24to(i) = sqrt(set24st(i)**2 + set24sy(i)**2)
	   set31st(i) = set31(i)*set31st(i)/100.
	   set31sy(i) = set31(i)*set31sy(i)/100.
	   set31to(i) = sqrt(set31st(i)**2 + set31sy(i)**2)
	   set32st(i) = set32(i)*set32st(i)/100.
	   set32sy(i) = set32(i)*set32sy(i)/100.
	   set32to(i) = sqrt(set32st(i)**2 + set32sy(i)**2)
	   enddo
         call hpak(-401,set11)
         call hpake(-401,set11st)
         call hpak(-411,set11)
         call hpake(-411,set11to)
         call hpak(-402,set12)
         call hpake(-402,set12st)
         call hpak(-412,set12)
         call hpake(-412,set12to)
         call hpak(-403,set13)
         call hpake(-403,set13st)
         call hpak(-413,set13)
         call hpake(-413,set13to)
         call hpak(-404,set14)
         call hpake(-404,set14st)
         call hpak(-414,set14)
         call hpake(-414,set14to)
         call hpak(-501,set21)
         call hpake(-501,set21st)
         call hpak(-511,set21)
         call hpake(-511,set21to)
         call hpak(-502,set22)
         call hpake(-502,set22st)
         call hpak(-512,set22)
         call hpake(-512,set22to)
         call hpak(-503,set23)
         call hpake(-503,set23st)
         call hpak(-513,set23)
         call hpake(-513,set23to)
         call hpak(-504,set24)
         call hpake(-504,set24st)
         call hpak(-514,set24)
         call hpake(-514,set24to)
         call hpak(-601,set31)
         call hpake(-601,set31st)
         call hpak(-611,set31)
         call hpake(-611,set31to)
         call hpak(-602,set32)
         call hpake(-602,set32st)
         call hpak(-612,set32)
         call hpake(-612,set32to)

         PRINT*,'AFTER ET'
CRP***


         call hbookb(801,' S vrs x  5.l.q2.lt.10 ',4,sxbin1,0.)
         call hbookb(802,' S vrs x 10.l.q2.lt.15 ',4,sxbin2,0.)
         call hbookb(803,' S vrs x 15.l.q2.lt.20 ',3,sxbin3,0.)
         call hbookb(804,' S vrs x 20.l.q2.lt.30 ',3,sxbin4,0.)
         call hbookb(805,' S vrs x 30.l.q2.lt.50 ',2,sxbin5,0.)
         call hbookb(806,' S vrs x 50.l.q2.lt.100 ',2,sxbin6,0.)
         call hbookb(811,' S all  5.l.q2.lt.10 ',4,sxbin1,0.)
         call hbookb(812,' S all 10.l.q2.lt.15 ',4,sxbin2,0.)
         call hbookb(813,' S all 15.l.q2.lt.20 ',3,sxbin3,0.)
         call hbookb(814,' S all 20.l.q2.lt.30 ',3,sxbin4,0.)
         call hbookb(815,' S all 30.l.q2.lt.50 ',2,sxbin5,0.)
         call hbookb(816,' S all 50.l.q2.lt.100 ',2,sxbin6,0.)
         call hbookb(-801,' dat st S vrs x  5.l.q2.lt.10 ',4,sxbin1,0.)
         call hbookb(-802,' dat st S vrs x 10.l.q2.lt.15 ',4,sxbin2,0.)
         call hbookb(-803,' dat st S vrs x 15.l.q2.lt.20 ',3,sxbin3,0.)
         call hbookb(-804,' dat st S vrs x 20.l.q2.lt.30 ',3,sxbin4,0.)
         call hbookb(-805,' dat st S vrs x 30.l.q2.lt.50 ',2,sxbin5,0.)
         call hbookb(-806,' dat st S vrs x 50.l.q2.lt.100 ',2,sxbin6,0.)
         call hbookb(-811,' dat tot S vrs x  5.l.q2.lt.10 ',4,sxbin1,0.)
         call hbookb(-812,' dat tot S vrs x 10.l.q2.lt.15 ',4,sxbin2,0.)
         call hbookb(-813,' dat tot S vrs x 15.l.q2.lt.20 ',3,sxbin3,0.)
         call hbookb(-814,' dat tot S vrs x 20.l.q2.lt.30 ',3,sxbin4,0.)
         call hbookb(-815,' dat tot S vrs x 30.l.q2.lt.50 ',2,sxbin5,0.)
         call hbookb(-816,' dat tot S vrs x 50.l.q2.lt.100',2,sxbin6,0.)
	   do i=1,4
	   ssigb1st(i) = ssigb1(i)*ssigb1st(i)/100.
	   ssigb1sy(i) = ssigb1(i)*ssigb1sy(i)/100.
	   ssigb1to(i) = sqrt(ssigb1st(i)**2 + ssigb1sy(i)**2)
	   ssigb2st(i) = ssigb2(i)*ssigb2st(i)/100.
	   ssigb2sy(i) = ssigb2(i)*ssigb2sy(i)/100.
	   ssigb2to(i) = sqrt(ssigb2st(i)**2 + ssigb2sy(i)**2)
	   enddo
	   do i=1,3
	   ssigb3st(i) = ssigb3(i)*ssigb3st(i)/100.
	   ssigb3sy(i) = ssigb3(i)*ssigb3sy(i)/100.
	   ssigb3to(i) = sqrt(ssigb3st(i)**2 + ssigb3sy(i)**2)
	   ssigb4st(i) = ssigb4(i)*ssigb4st(i)/100.
	   ssigb4sy(i) = ssigb4(i)*ssigb4sy(i)/100.
	   ssigb4to(i) = sqrt(ssigb4st(i)**2 + ssigb4sy(i)**2)
	   enddo
	   do i=1,2
	   ssigb5st(i) = ssigb5(i)*ssigb5st(i)/100.
	   ssigb5sy(i) = ssigb5(i)*ssigb5sy(i)/100.
	   ssigb5to(i) = sqrt(ssigb5st(i)**2 + ssigb5sy(i)**2)
	   ssigb6st(i) = ssigb6(i)*ssigb6st(i)/100.
	   ssigb6sy(i) = ssigb6(i)*ssigb6sy(i)/100.
	   ssigb6to(i) = sqrt(ssigb6st(i)**2 + ssigb6sy(i)**2)
	   enddo
         call hpak(-801,ssigb1)
         call hpake(-801,ssigb1st)
         call hpak(-811,ssigb1)
         call hpake(-811,ssigb1to)
         call hpak(-802,ssigb2)
         call hpake(-802,ssigb2st)
         call hpak(-812,ssigb2)
         call hpake(-812,ssigb2to)
         call hpak(-803,ssigb3)
         call hpake(-803,ssigb3st)
         call hpak(-813,ssigb3)
         call hpake(-813,ssigb3to)
         call hpak(-804,ssigb4)
         call hpake(-804,ssigb4st)
         call hpak(-814,ssigb4)
         call hpake(-814,ssigb4to)
         call hpak(-805,ssigb5)
         call hpake(-805,ssigb5st)
         call hpak(-815,ssigb5)
         call hpake(-815,ssigb5to)
         call hpak(-806,ssigb6)
         call hpake(-806,ssigb6st)
         call hpak(-816,ssigb6)
         call hpake(-816,ssigb6to)
	   
CRP***Booking of histos for double differential dijet analysis
CRP***xb on bins of Q2
c         PRINT*,'BEFore double'
         DO I=1,6 
            NIIN = 4
            IF(I.EQ.3.OR.I.EQ.4) NIIN = 3
            IF(I.EQ.5.OR.I.EQ.6) NIIN = 2
            K  = (1500+I)
            KS  = (1510+I)
            IF(I.EQ.1) THEN
               CALL HBOOKB(K,'  dR2/dX(Q2)  ',NIIN, SXBIN1,0.)  
               CALL HBARX(K)
               CALL HBOOKB(-K,'  dR2/dX(Q2) data ',NIIN, SXBIN1,0.)  
               CALL HBARX(-K)
               CALL HBOOKB(-KS,'  dR2/dX(Q2) data ',NIIN, SXBIN1,0.)  
               CALL HBARX(-KS)
            ENDIF
            IF(I.EQ.2) THEN
               CALL HBOOKB(K,'  dR2/dX(Q2)  ',NIIN, SXBIN2,0.)  
               CALL HBARX(K)
               CALL HBOOKB(-K,'  dR2/dX(Q2) data ',NIIN, SXBIN2,0.)  
               CALL HBARX(-K)
*!MH           CALL HBOOKB(-KS,'  dR2/dX(Q2) data ',NIIN, SXBIN1,0.)
	       CALL HBOOKB(-KS,'  dR2/dX(Q2) data ',NIIN, SXBIN2,0.)
               CALL HBARX(-KS)
            ENDIF
            IF(I.EQ.3) THEN
               CALL HBOOKB(K,'  dR2/dX(Q2)  ',NIIN, SXBIN3,0.)  
               CALL HBARX(K)
               CALL HBOOKB(-K,'  dR2/dX(Q2) data ',NIIN, SXBIN3,0.)  
               CALL HBARX(-K)
*!MH           CALL HBOOKB(-KS,'  dR2/dX(Q2) data ',NIIN, SXBIN1,0.)  
	       CALL HBOOKB(-KS,'  dR2/dX(Q2) data ',NIIN, SXBIN3,0.)
               CALL HBARX(-KS)
            ENDIF
            IF(I.EQ.4) THEN 
               CALL HBOOKB(K,'  dR2/dX(Q2)  ',NIIN, SXBIN4,0.)  
               CALL HBARX(K)
               CALL HBOOKB(-K,'  dR2/dX(Q2) data ',NIIN, SXBIN4,0.)  
               CALL HBARX(-K)
*!MH           CALL HBOOKB(-KS,'  dR2/dX(Q2) data ',NIIN, SXBIN1,0.)
	       CALL HBOOKB(-KS,'  dR2/dX(Q2) data ',NIIN, SXBIN4,0.)
               CALL HBARX(-KS)
            ENDIF
            IF(I.EQ.5) THEN
               CALL HBOOKB(K,'  dR2/dX(Q2)  ',NIIN, SXBIN5,0.)  
               CALL HBARX(K)
               CALL HBOOKB(-K,'  dR2/dX(Q2) data ',NIIN, SXBIN5,0.)  
               CALL HBARX(-K)
*!MH           CALL HBOOKB(-KS,'  dR2/dX(Q2) data ',NIIN, SXBIN1,0.) 
	       CALL HBOOKB(-KS,'  dR2/dX(Q2) data ',NIIN, SXBIN5,0.) 
               CALL HBARX(-KS)
            ENDIF
            IF(I.EQ.6) THEN
               CALL HBOOKB(K,'  dR2/dX(Q2)  ',NIIN, SXBIN6,0.)  
               CALL HBARX(K)
               CALL HBOOKB(-K,'  dR2/dX(Q2) data ',NIIN, SXBIN6,0.)  
               CALL HBARX(-K)
*!MH           CALL HBOOKB(-KS,'  dR2/dX(Q2) data ',NIIN, SXBIN1,0.) 
	       CALL HBOOKB(-KS,'  dR2/dX(Q2) data ',NIIN, SXBIN6,0.) 
               CALL HBARX(-KS)
            ENDIF
            
            
            J = (3000+I*10)
CRP***Book histos for fine binning in delta to 
CRP***watch the behaviour of NLO prediction
            DO L=1,NIIN 
               JL = J + L
               JLS = JL + 100
               CALL HBOOK1(JL,'Delta Plot ',161, -0.025 ,8.025 ,0.)
               CALL HBOOK1(-JL,'Delta Plot data',161, -0.025 ,8.025 ,0.)
               CALL HBOOK1(-JLS,'Delta Plot data',161, -0.025 ,8.025 ,0.
     $              )
CRP***Now fill the histos
               CALL VZERO(DDHLP)
               CALL VZERO(EDDHLP)
               CALL VZERO(ESDHLP)
CRP***
CRP***Go through the x,q2 bins
CRP***5<Q2<10
               IF (I.EQ.1) THEN
                  IF(L.EQ.1) THEN
                     DDHLP(1) = Q1X1(1)
                     EHLPSY = Q1X1(1)*SYQ1X1(1)/100.
                     EHLPST = Q1X1(1)*STQ1X1(1)/100.
                     ESDHLP(1) = EHLPST
                     EDDHLP(1) = SQRT(EHLPSY**2+EHLPST**2)
*     
                     DDHLP(21) = Q1X1(2)
                     EHLPSY = Q1X1(1)*SYQ1X1(1)/100.
                     EHLPST = Q1X1(1)*STQ1X1(1)/100.
                     ESDHLP(21) = EHLPST
                     EDDHLP(21) = SQRT(EHLPSY**2+EHLPST**2)
*     
                     DDHLP(41) = Q1X1(3)
                     EHLPSY = Q1X1(3)*SYQ1X1(3)/100.
                     EHLPST = Q1X1(3)*STQ1X1(3)/100.
                     ESDHLP(41) = EHLPST
                     EDDHLP(41) = SQRT(EHLPSY**2+EHLPST**2)
CRP***Fill x-section histos for Delta=2(Fig. 3 of paper)
                     X2JHL1(1) = Q1X1(3)
                     X2EHL1(1) = EHLPSY
                     X2SHL1(1) = EHLPST
*     
                     DDHLP(81) = Q1X1(4)
                     EHLPSY = Q1X1(4)*SYQ1X1(4)/100.
                     EHLPST = Q1X1(4)*STQ1X1(4)/100.
                     ESDHLP(81) = EHLPST
                     EDDHLP(81) = SQRT(EHLPSY**2+EHLPST**2)
*     HZ03160 
                     
                     DDHLP(141) = Q1X1(5)
                     EHLPSY = Q1X1(5)*SYQ1X1(5)/100.
                     EHLPST = Q1X1(5)*STQ1X1(5)/100.
                     ESDHLP(141) = EHLPST
                     EDDHLP(141) = SQRT(EHLPSY**2+EHLPST**2)
                  ENDIF
CRP***
                  IF(L.EQ.2) THEN
                     DDHLP(1) = Q1X2(1)
                     EHLPSY = Q1X2(1)*SYQ1X2(1)/100.
                     EHLPST = Q1X2(1)*STQ1X2(1)/100.
                     ESDHLP(1) = EHLPST
                     EDDHLP(1) = SQRT(EHLPSY**2+EHLPST**2)
*     
                     DDHLP(21) = Q1X2(2)
                     EHLPSY = Q1X2(1)*SYQ1X2(1)/100.
                     EHLPST = Q1X2(1)*STQ1X2(1)/100.
                     ESDHLP(21) = EHLPST
                     EDDHLP(21) = SQRT(EHLPSY**2+EHLPST**2)
*     
                     DDHLP(41) = Q1X2(3)
                     EHLPSY = Q1X2(3)*SYQ1X2(3)/100.
                     EHLPST = Q1X2(3)*STQ1X2(3)/100.
                     ESDHLP(41) = EHLPST
                     EDDHLP(41) = SQRT(EHLPSY**2+EHLPST**2)
CRP***Fill x-section histos for Delta=2(Fig. 3 of paper)
                     X2JHL1(2) = Q1X2(3)
                     X2EHL1(2) = EHLPSY
                     X2SHL1(2) = EHLPST
*     
                     DDHLP(81) = Q1X2(4)
                     EHLPSY = Q1X2(4)*SYQ1X2(4)/100.
                     EHLPST = Q1X2(4)*STQ1X2(4)/100.
                     ESDHLP(81) = EHLPST
                     EDDHLP(81) = SQRT(EHLPSY**2+EHLPST**2)
*     
                     
                     DDHLP(141) = Q1X2(5)
                     EHLPSY = Q1X2(5)*SYQ1X2(5)/100.
                     EHLPST = Q1X2(5)*STQ1X2(5)/100.
                     ESDHLP(141) = EHLPST
                     EDDHLP(141) = SQRT(EHLPSY**2+EHLPST**2)
                  ENDIF
CRP***
                  IF(L.EQ.3) THEN
                     DDHLP(1) = Q1X3(1)
                     EHLPSY = Q1X3(1)*SYQ1X3(1)/100.
                     EHLPST = Q1X3(1)*STQ1X3(1)/100.
                     ESDHLP(1) = EHLPST
                     EDDHLP(1) = SQRT(EHLPSY**2+EHLPST**2)
*     
                     DDHLP(21) = Q1X3(2)
                     EHLPSY = Q1X3(1)*SYQ1X3(1)/100.
                     EHLPST = Q1X3(1)*STQ1X3(1)/100.
                     ESDHLP(21) = EHLPST
                     EDDHLP(21) = SQRT(EHLPSY**2+EHLPST**2)
*     
                     DDHLP(41) = Q1X3(3)
                     EHLPSY = Q1X3(3)*SYQ1X3(3)/100.
                     EHLPST = Q1X3(3)*STQ1X3(3)/100.
                     ESDHLP(41) = EHLPST
                     EDDHLP(41) = SQRT(EHLPSY**2+EHLPST**2)
CRP***Fill x-section histos for Delta=2(Fig. 3 of paper)
                     X2JHL1(3) = Q1X3(3)
                     X2EHL1(3) = EHLPSY
                     X2SHL1(3) = EHLPST
*     
                     DDHLP(81) = Q1X3(4)
                     EHLPSY = Q1X3(4)*SYQ1X3(4)/100.
                     EHLPST = Q1X3(4)*STQ1X3(4)/100.
                     ESDHLP(81) = EHLPST
                     EDDHLP(81) = SQRT(EHLPSY**2+EHLPST**2)
*     
                     
                     DDHLP(141) = Q1X3(5)
                     EHLPSY = Q1X3(5)*SYQ1X3(5)/100.
                     EHLPST = Q1X3(5)*STQ1X3(5)/100.
                     ESDHLP(141) = EHLPST
                     EDDHLP(141) = SQRT(EHLPSY**2+EHLPST**2)
                  ENDIF
CRP***
                  IF(L.EQ.4) THEN
                     DDHLP(1) = Q1X4(1)
                     EHLPSY = Q1X4(1)*SYQ1X4(1)/100.
                     EHLPST = Q1X4(1)*STQ1X4(1)/100.
                     ESDHLP(1) = EHLPST
                     EDDHLP(1) = SQRT(EHLPSY**2+EHLPST**2)
*     
                     DDHLP(21) = Q1X4(2)
                     EHLPSY = Q1X4(1)*SYQ1X4(1)/100.
                     EHLPST = Q1X4(1)*STQ1X4(1)/100.
                     ESDHLP(21) = EHLPST
                     EDDHLP(21) = SQRT(EHLPSY**2+EHLPST**2)
*     
                     DDHLP(41) = Q1X4(3)
                     EHLPSY = Q1X4(3)*SYQ1X4(3)/100.
                     EHLPST = Q1X4(3)*STQ1X4(3)/100.
                     ESDHLP(41) = EHLPST
                     EDDHLP(41) = SQRT(EHLPSY**2+EHLPST**2)
CRP***Fill x-section histos for Delta=2(Fig. 3 of paper)
                     X2JHL1(4) = Q1X4(3)
                     X2EHL1(4) = EHLPSY
                     X2SHL1(4) = EHLPST
*     
                     DDHLP(81) = Q1X4(4)
                     EHLPSY = Q1X4(4)*SYQ1X4(4)/100.
                     EHLPST = Q1X4(4)*STQ1X4(4)/100.
                     ESDHLP(81) = EHLPST
                     EDDHLP(81) = SQRT(EHLPSY**2+EHLPST**2)
*     
                     
                     DDHLP(141) = Q1X4(5)
                     EHLPSY = Q1X4(5)*SYQ1X4(5)/100.
                     EHLPST = Q1X4(5)*STQ1X4(5)/100.
                     ESDHLP(141) = EHLPST
                     EDDHLP(141) = SQRT(EHLPSY**2+EHLPST**2)
                  ENDIF


               ENDIF

CRP***10<Q2<15
               IF (I.EQ.2) THEN
                  IF(L.EQ.1) THEN
                     DDHLP(1) = Q2X1(1)
                     EHLPSY = Q2X1(1)*SYQ2X1(1)/100.
                     EHLPST = Q2X1(1)*STQ2X1(1)/100.
                     ESDHLP(1) = EHLPST
                     EDDHLP(1) = SQRT(EHLPSY**2+EHLPST**2)
*     
                     DDHLP(21) = Q2X1(2)
                     EHLPSY = Q2X1(1)*SYQ2X1(1)/100.
                     EHLPST = Q2X1(1)*STQ2X1(1)/100.
                     ESDHLP(21) = EHLPST
                     EDDHLP(21) = SQRT(EHLPSY**2+EHLPST**2)
*     
                     DDHLP(41) = Q2X1(3)
                     EHLPSY = Q2X1(3)*SYQ2X1(3)/100.
                     EHLPST = Q2X1(3)*STQ2X1(3)/100.
                     ESDHLP(41) = EHLPST
                     EDDHLP(41) = SQRT(EHLPSY**2+EHLPST**2)
CRP***Fill x-section histos for Delta=2(Fig. 3 of paper)
                     X2JHL1(1) = Q2X1(3)
                     X2EHL1(1) = EHLPSY
                     X2SHL1(1) = EHLPST
*     
                     DDHLP(81) = Q2X1(4)
                     EHLPSY = Q2X1(4)*SYQ2X1(4)/100.
                     EHLPST = Q2X1(4)*STQ2X1(4)/100.
                     ESDHLP(81) = EHLPST
                     EDDHLP(81) = SQRT(EHLPSY**2+EHLPST**2)
*     
                     
                     DDHLP(141) = Q2X1(5)
                     EHLPSY = Q2X1(5)*SYQ2X1(5)/100.
                     EHLPST = Q2X1(5)*STQ2X1(5)/100.
                     ESDHLP(141) = EHLPST
                     EDDHLP(141) = SQRT(EHLPSY**2+EHLPST**2)
                  ENDIF
CRP***
                  IF(L.EQ.2) THEN
                     DDHLP(1) = Q2X2(1)
                     EHLPSY = Q2X2(1)*SYQ2X2(1)/100.
                     EHLPST = Q2X2(1)*STQ2X2(1)/100.
                     ESDHLP(1) = EHLPST
                     EDDHLP(1) = SQRT(EHLPSY**2+EHLPST**2)
*     
                     DDHLP(21) = Q2X2(2)
                     EHLPSY = Q2X2(1)*SYQ2X2(1)/100.
                     EHLPST = Q2X2(1)*STQ2X2(1)/100.
                     ESDHLP(21) = EHLPST
                     EDDHLP(21) = SQRT(EHLPSY**2+EHLPST**2)
*     
                     DDHLP(41) = Q2X2(3)
                     EHLPSY = Q2X2(3)*SYQ2X2(3)/100.
                     EHLPST = Q2X2(3)*STQ2X2(3)/100.
                     ESDHLP(41) = EHLPST
                     EDDHLP(41) = SQRT(EHLPSY**2+EHLPST**2)
CRP***Fill x-section histos for Delta=2(Fig. 3 of paper)
                     X2JHL1(2) = Q2X2(3)
                     X2EHL1(2) = EHLPSY
                     X2SHL1(2) = EHLPST
*     
                     DDHLP(81) = Q2X2(4)
                     EHLPSY = Q2X2(4)*SYQ2X2(4)/100.
                     EHLPST = Q2X2(4)*STQ2X2(4)/100.
                     ESDHLP(81) = EHLPST
                     EDDHLP(81) = SQRT(EHLPSY**2+EHLPST**2)
*     
                     
                     DDHLP(141) = Q2X2(5)
                     EHLPSY = Q2X2(5)*SYQ2X2(5)/100.
                     EHLPST = Q2X2(5)*STQ2X2(5)/100.
                     ESDHLP(141) = EHLPST
                     EDDHLP(141) = SQRT(EHLPSY**2+EHLPST**2)
                  ENDIF
CRP***
                  IF(L.EQ.3) THEN
                     DDHLP(1) = Q2X3(1)
                     EHLPSY = Q2X3(1)*SYQ2X3(1)/100.
                     EHLPST = Q2X3(1)*STQ2X3(1)/100.
                     ESDHLP(1) = EHLPST
                     EDDHLP(1) = SQRT(EHLPSY**2+EHLPST**2)
*     
                     DDHLP(21) = Q2X3(2)
                     EHLPSY = Q2X3(1)*SYQ2X3(1)/100.
                     EHLPST = Q2X3(1)*STQ2X3(1)/100.
                     ESDHLP(21) = EHLPST
                     EDDHLP(21) = SQRT(EHLPSY**2+EHLPST**2)
*     
                     DDHLP(41) = Q2X3(3)
                     EHLPSY = Q2X3(3)*SYQ2X3(3)/100.
                     EHLPST = Q2X3(3)*STQ2X3(3)/100.
                     ESDHLP(41) = EHLPST
                     EDDHLP(41) = SQRT(EHLPSY**2+EHLPST**2)
CRP***Fill x-section histos for Delta=2(Fig. 3 of paper)
                     X2JHL1(3) = Q2X3(3)
                     X2EHL1(3) = EHLPSY
                     X2SHL1(3) = EHLPST
*     
                     DDHLP(81) = Q2X3(4)
                     EHLPSY = Q2X3(4)*SYQ2X3(4)/100.
                     EHLPST = Q2X3(4)*STQ2X3(4)/100.
                     ESDHLP(81) = EHLPST
                     EDDHLP(81) = SQRT(EHLPSY**2+EHLPST**2)
*     
                     
                     DDHLP(141) = Q2X3(5)
                     EHLPSY = Q2X3(5)*SYQ2X3(5)/100.
                     EHLPST = Q2X3(5)*STQ2X3(5)/100.
                     ESDHLP(141) = EHLPST
                     EDDHLP(141) = SQRT(EHLPSY**2+EHLPST**2)
                  ENDIF
CRP***
                  IF(L.EQ.4) THEN
                     DDHLP(1) = Q2X4(1)
                     EHLPSY = Q2X4(1)*SYQ2X4(1)/100.
                     EHLPST = Q2X4(1)*STQ2X4(1)/100.
                     ESDHLP(1) = EHLPST
                     EDDHLP(1) = SQRT(EHLPSY**2+EHLPST**2)
*     
                     DDHLP(21) = Q2X4(2)
                     EHLPSY = Q2X4(1)*SYQ2X4(1)/100.
                     EHLPST = Q2X4(1)*STQ2X4(1)/100.
                     ESDHLP(21) = EHLPST
                     EDDHLP(21) = SQRT(EHLPSY**2+EHLPST**2)
*     
                     DDHLP(41) = Q2X4(3)
                     EHLPSY = Q2X4(3)*SYQ2X4(3)/100.
                     EHLPST = Q2X4(3)*STQ2X4(3)/100.
                     ESDHLP(41) = EHLPST
                     EDDHLP(41) = SQRT(EHLPSY**2+EHLPST**2)
CRP***Fill x-section histos for Delta=2(Fig. 3 of paper)
                     X2JHL1(4) = Q2X4(3)
                     X2EHL1(4) = EHLPSY
                     X2SHL1(4) = EHLPST
*     
                     DDHLP(81) = Q2X4(4)
                     EHLPSY = Q2X4(4)*SYQ2X4(4)/100.
                     EHLPST = Q2X4(4)*STQ2X4(4)/100.
                     ESDHLP(81) = EHLPST
                     EDDHLP(81) = SQRT(EHLPSY**2+EHLPST**2)
*     
                     
                     DDHLP(141) = Q2X4(5)
                     EHLPSY = Q2X4(5)*SYQ2X4(5)/100.
                     EHLPST = Q2X4(5)*STQ2X4(5)/100.
                     ESDHLP(141) = EHLPST
                     EDDHLP(141) = SQRT(EHLPSY**2+EHLPST**2)
                  ENDIF
               ENDIF
CRP***15<Q2<20
               IF (I.EQ.3) THEN
                  IF(L.EQ.1) THEN
                     DDHLP(1) = Q3X1(1)
                     EHLPSY = Q3X1(1)*SYQ3X1(1)/100.
                     EHLPST = Q3X1(1)*STQ3X1(1)/100.
                     ESDHLP(1) = EHLPST
                     EDDHLP(1) = SQRT(EHLPSY**2+EHLPST**2)
*     
                     DDHLP(21) = Q3X1(2)
                     EHLPSY = Q3X1(1)*SYQ3X1(1)/100.
                     EHLPST = Q3X1(1)*STQ3X1(1)/100.
                     ESDHLP(21) = EHLPST
                     EDDHLP(21) = SQRT(EHLPSY**2+EHLPST**2)
*     
                     DDHLP(41) = Q3X1(3)
                     EHLPSY = Q3X1(3)*SYQ3X1(3)/100.
                     EHLPST = Q3X1(3)*STQ3X1(3)/100.
                     ESDHLP(41) = EHLPST
                     EDDHLP(41) = SQRT(EHLPSY**2+EHLPST**2)
CRP***Fill x-section histos for Delta=2(Fig. 3 of paper)
                     X2JHL2(1) = Q3X1(3)
                     X2EHL2(1) = EHLPSY
                     X2SHL2(1) = EHLPST
*     
                     DDHLP(81) = Q3X1(4)
                     EHLPSY = Q3X1(4)*SYQ3X1(4)/100.
                     EHLPST = Q3X1(4)*STQ3X1(4)/100.
                     ESDHLP(81) = EHLPST
                     EDDHLP(81) = SQRT(EHLPSY**2+EHLPST**2)
*     
                     
                     DDHLP(141) = Q3X1(5)
                     EHLPSY = Q3X1(5)*SYQ3X1(5)/100.
                     EHLPST = Q3X1(5)*STQ3X1(5)/100.
                     ESDHLP(141) = EHLPST
                     EDDHLP(141) = SQRT(EHLPSY**2+EHLPST**2)
                  ENDIF
CRP***
                  IF(L.EQ.2) THEN
                     DDHLP(1) = Q3X2(1)
                     EHLPSY = Q3X2(1)*SYQ3X2(1)/100.
                     EHLPST = Q3X2(1)*STQ3X2(1)/100.
                     ESDHLP(1) = EHLPST
                     EDDHLP(1) = SQRT(EHLPSY**2+EHLPST**2)
*     
                     DDHLP(21) = Q3X2(2)
                     EHLPSY = Q3X2(1)*SYQ3X2(1)/100.
                     EHLPST = Q3X2(1)*STQ3X2(1)/100.
                     ESDHLP(21) = EHLPST
                     EDDHLP(21) = SQRT(EHLPSY**2+EHLPST**2)
*     
                     DDHLP(41) = Q3X2(3)
                     EHLPSY = Q3X2(3)*SYQ3X2(3)/100.
                     EHLPST = Q3X2(3)*STQ3X2(3)/100.
                     ESDHLP(41) = EHLPST
                     EDDHLP(41) = SQRT(EHLPSY**2+EHLPST**2)
CRP***Fill x-section histos for Delta=2(Fig. 3 of paper)
                     X2JHL2(2) = Q3X2(3)
                     X2EHL2(2) = EHLPSY
                     X2SHL2(2) = EHLPST
*     
                     DDHLP(81) = Q3X2(4)
                     EHLPSY = Q3X2(4)*SYQ3X2(4)/100.
                     EHLPST = Q3X2(4)*STQ3X2(4)/100.
                     ESDHLP(81) = EHLPST
                     EDDHLP(81) = SQRT(EHLPSY**2+EHLPST**2)
*     
                     
                     DDHLP(141) = Q3X2(5)
                     EHLPSY = Q3X2(5)*SYQ3X2(5)/100.
                     EHLPST = Q3X2(5)*STQ3X2(5)/100.
                     ESDHLP(141) = EHLPST
                     EDDHLP(141) = SQRT(EHLPSY**2+EHLPST**2)
                  ENDIF
CRP***
                  IF(L.EQ.3) THEN
                     DDHLP(1) = Q3X3(1)
                     EHLPSY = Q3X3(1)*SYQ3X3(1)/100.
                     EHLPST = Q3X3(1)*STQ3X3(1)/100.
                     ESDHLP(1) = EHLPST
                     EDDHLP(1) = SQRT(EHLPSY**2+EHLPST**2)
*     
                     DDHLP(21) = Q3X3(2)
                     EHLPSY = Q3X3(1)*SYQ3X3(1)/100.
                     EHLPST = Q3X3(1)*STQ3X3(1)/100.
                     ESDHLP(21) = EHLPST
                     EDDHLP(21) = SQRT(EHLPSY**2+EHLPST**2)
*     
                     DDHLP(41) = Q3X3(3)
                     EHLPSY = Q3X3(3)*SYQ3X3(3)/100.
                     EHLPST = Q3X3(3)*STQ3X3(3)/100.
                     ESDHLP(41) = EHLPST
                     EDDHLP(41) = SQRT(EHLPSY**2+EHLPST**2)
CRP***Fill x-section histos for Delta=2(Fig. 3 of paper)
                     X2JHL2(3) = Q3X3(3)
                     X2EHL2(3) = EHLPSY
                     X2SHL2(3) = EHLPST
*     
                     DDHLP(81) = Q3X3(4)
                     EHLPSY = Q3X3(4)*SYQ3X3(4)/100.
                     EHLPST = Q3X3(4)*STQ3X3(4)/100.
                     ESDHLP(81) = EHLPST
                     EDDHLP(81) = SQRT(EHLPSY**2+EHLPST**2)
*     
                     
                     DDHLP(141) = Q3X3(5)
                     EHLPSY = Q3X3(5)*SYQ3X3(5)/100.
                     EHLPST = Q3X3(5)*STQ3X3(5)/100.
                     ESDHLP(141) = EHLPST
                     EDDHLP(141) = SQRT(EHLPSY**2+EHLPST**2)
                  ENDIF
               ENDIF
CRP***20<Q2<30
               IF (I.EQ.4) THEN
                  IF(L.EQ.1) THEN
                     DDHLP(1) = Q4X1(1)
                     EHLPSY = Q4X1(1)*SYQ4X1(1)/100.
                     EHLPST = Q4X1(1)*STQ4X1(1)/100.
                     ESDHLP(1) = EHLPST
                     EDDHLP(1) = SQRT(EHLPSY**2+EHLPST**2)
*     
                     DDHLP(21) = Q4X1(2)
                     EHLPSY = Q4X1(1)*SYQ4X1(1)/100.
                     EHLPST = Q4X1(1)*STQ4X1(1)/100.
                     ESDHLP(21) = EHLPST
                     EDDHLP(21) = SQRT(EHLPSY**2+EHLPST**2)
*     
                     DDHLP(41) = Q4X1(3)
                     EHLPSY = Q4X1(3)*SYQ4X1(3)/100.
                     EHLPST = Q4X1(3)*STQ4X1(3)/100.
                     ESDHLP(41) = EHLPST
                     EDDHLP(41) = SQRT(EHLPSY**2+EHLPST**2)
CRP***Fill x-section histos for Delta=2(Fig. 3 of paper)
                     X2JHL2(1) = Q4X1(3)
                     X2EHL2(1) = EHLPSY
                     X2SHL2(1) = EHLPST
*     
                     DDHLP(81) = Q4X1(4)
                     EHLPSY = Q4X1(4)*SYQ4X1(4)/100.
                     EHLPST = Q4X1(4)*STQ4X1(4)/100.
                     ESDHLP(81) = EHLPST
                     EDDHLP(81) = SQRT(EHLPSY**2+EHLPST**2)
*     
                     
                     DDHLP(141) = Q4X1(5)
                     EHLPSY = Q4X1(5)*SYQ4X1(5)/100.
                     EHLPST = Q4X1(5)*STQ4X1(5)/100.
                     ESDHLP(141) = EHLPST
                     EDDHLP(141) = SQRT(EHLPSY**2+EHLPST**2)
                  ENDIF
CRP***
                  IF(L.EQ.2) THEN
                     DDHLP(1) = Q4X2(1)
                     EHLPSY = Q4X2(1)*SYQ4X2(1)/100.
                     EHLPST = Q4X2(1)*STQ4X2(1)/100.
                     ESDHLP(1) = EHLPST
                     EDDHLP(1) = SQRT(EHLPSY**2+EHLPST**2)
*     
                     DDHLP(21) = Q4X2(2)
                     EHLPSY = Q4X2(1)*SYQ4X2(1)/100.
                     EHLPST = Q4X2(1)*STQ4X2(1)/100.
                     ESDHLP(21) = EHLPST
                     EDDHLP(21) = SQRT(EHLPSY**2+EHLPST**2)
*     
                     DDHLP(41) = Q4X2(3)
                     EHLPSY = Q4X2(3)*SYQ4X2(3)/100.
                     EHLPST = Q4X2(3)*STQ4X2(3)/100.
                     ESDHLP(41) = EHLPST
                     EDDHLP(41) = SQRT(EHLPSY**2+EHLPST**2)
CRP***Fill x-section histos for Delta=2(Fig. 3 of paper)
                     X2JHL2(2) = Q4X2(3)
                     X2EHL2(2) = EHLPSY
                     X2SHL2(2) = EHLPST
*     
                     DDHLP(81) = Q4X2(4)
                     EHLPSY = Q4X2(4)*SYQ4X2(4)/100.
                     EHLPST = Q4X2(4)*STQ4X2(4)/100.
                     ESDHLP(81) = EHLPST
                     EDDHLP(81) = SQRT(EHLPSY**2+EHLPST**2)
*     
                     
                     DDHLP(141) = Q4X2(5)
                     EHLPSY = Q4X2(5)*SYQ4X2(5)/100.
                     EHLPST = Q4X2(5)*STQ4X2(5)/100.
                     ESDHLP(141) = EHLPST
                     EDDHLP(141) = SQRT(EHLPSY**2+EHLPST**2)
                  ENDIF
CRP***
                  IF(L.EQ.3) THEN
                     DDHLP(1) = Q4X3(1)
                     EHLPSY = Q4X3(1)*SYQ4X3(1)/100.
                     EHLPST = Q4X3(1)*STQ4X3(1)/100.
                     ESDHLP(1) = EHLPST
                     EDDHLP(1) = SQRT(EHLPSY**2+EHLPST**2)
*     
                     DDHLP(21) = Q4X3(2)
                     EHLPSY = Q4X3(1)*SYQ4X3(1)/100.
                     EHLPST = Q4X3(1)*STQ4X3(1)/100.
                     ESDHLP(21) = EHLPST
                     EDDHLP(21) = SQRT(EHLPSY**2+EHLPST**2)
*     
                     DDHLP(41) = Q4X3(3)
                     EHLPSY = Q4X3(3)*SYQ4X3(3)/100.
                     EHLPST = Q4X3(3)*STQ4X3(3)/100.
                     ESDHLP(41) = EHLPST
                     EDDHLP(41) = SQRT(EHLPSY**2+EHLPST**2)
CRP***Fill x-section histos for Delta=2(Fig. 3 of paper)
                     X2JHL2(3) = Q4X3(3)
                     X2EHL2(3) = EHLPSY
                     X2SHL2(3) = EHLPST
*     
                     DDHLP(81) = Q4X3(4)
                     EHLPSY = Q4X3(4)*SYQ4X3(4)/100.
                     EHLPST = Q4X3(4)*STQ4X3(4)/100.
                     ESDHLP(81) = EHLPST
                     EDDHLP(81) = SQRT(EHLPSY**2+EHLPST**2)
*     
                     
                     DDHLP(141) = Q4X3(5)
                     EHLPSY = Q4X3(5)*SYQ4X3(5)/100.
                     EHLPST = Q4X3(5)*STQ4X3(5)/100.
                     ESDHLP(141) = EHLPST
                     EDDHLP(141) = SQRT(EHLPSY**2+EHLPST**2)
                  ENDIF
               ENDIF
CRP***30<Q2<50
               IF (I.EQ.5) THEN
                  IF(L.EQ.1) THEN
                     DDHLP(1) = Q5X1(1)
                     EHLPSY = Q5X1(1)*SYQ5X1(1)/100.
                     EHLPST = Q5X1(1)*STQ5X1(1)/100.
                     ESDHLP(1) = EHLPST
                     EDDHLP(1) = SQRT(EHLPSY**2+EHLPST**2)
*     
                     DDHLP(21) = Q5X1(2)
                     EHLPSY = Q5X1(2)*SYQ5X1(2)/100.
                     EHLPST = Q5X1(2)*STQ5X1(2)/100.
                     ESDHLP(21) = EHLPST
                     EDDHLP(21) = SQRT(EHLPSY**2+EHLPST**2)
*     
                     DDHLP(41) = Q5X1(3)
                     EHLPSY = Q5X1(3)*SYQ5X1(3)/100.
                     EHLPST = Q5X1(3)*STQ5X1(3)/100.
                     ESDHLP(41) = EHLPST
                     EDDHLP(41) = SQRT(EHLPSY**2+EHLPST**2)
CRP***Fill x-section histos for Delta=2(Fig. 3 of paper)
                     X2JHL3(1) = Q5X1(3)
                     X2EHL3(1) = EHLPSY
                     X2SHL3(1) = EHLPST
*     
                     DDHLP(81) = Q5X1(4)
                     EHLPSY = Q5X1(4)*SYQ5X1(4)/100.
                     EHLPST = Q5X1(4)*STQ5X1(4)/100.
                     ESDHLP(81) = EHLPST
                     EDDHLP(81) = SQRT(EHLPSY**2+EHLPST**2)
*     
                     
                     DDHLP(141) = Q5X1(5)
                     EHLPSY = Q5X1(5)*SYQ5X1(5)/100.
                     EHLPST = Q5X1(5)*STQ5X1(5)/100.
                     ESDHLP(141) = EHLPST
                     EDDHLP(141) = SQRT(EHLPSY**2+EHLPST**2)
                  ENDIF
CRP***
                  IF(L.EQ.2) THEN
                     DDHLP(1) = Q5X2(1)
                     EHLPSY = Q5X2(1)*SYQ5X2(1)/100.
                     EHLPST = Q5X2(1)*STQ5X2(1)/100.
                     ESDHLP(1) = EHLPST
                     EDDHLP(1) = SQRT(EHLPSY**2+EHLPST**2)
*     
                     DDHLP(21) = Q5X2(2)
                     EHLPSY = Q5X2(1)*SYQ5X2(1)/100.
                     EHLPST = Q5X2(1)*STQ5X2(1)/100.
                     ESDHLP(21) = EHLPST
                     EDDHLP(21) = SQRT(EHLPSY**2+EHLPST**2)
*     
                     DDHLP(41) = Q5X2(3)
                     EHLPSY = Q5X2(3)*SYQ5X2(3)/100.
                     EHLPST = Q5X2(3)*STQ5X2(3)/100.
                     ESDHLP(41) = EHLPST
                     EDDHLP(41) = SQRT(EHLPSY**2+EHLPST**2)
CRP***Fill x-section histos for Delta=2(Fig. 3 of paper)
                     X2JHL3(2) = Q5X2(3)
                     X2EHL3(2) = EHLPSY
                     X2SHL3(2) = EHLPST
*     
                     DDHLP(81) = Q5X2(4)
                     EHLPSY = Q5X2(4)*SYQ5X2(4)/100.
                     EHLPST = Q5X2(4)*STQ5X2(4)/100.
                     ESDHLP(81) = EHLPST
                     EDDHLP(81) = SQRT(EHLPSY**2+EHLPST**2)
*     
                     
                     DDHLP(141) = Q5X2(5)
                     EHLPSY = Q5X2(5)*SYQ5X2(5)/100.
                     EHLPST = Q5X2(5)*STQ5X2(5)/100.
                     ESDHLP(141) = EHLPST
                     EDDHLP(141) = SQRT(EHLPSY**2+EHLPST**2)
                  ENDIF
               ENDIF
CRP***50<Q2<100
               IF (I.EQ.6) THEN
                  IF(L.EQ.1) THEN
                     DDHLP(1) = Q6X1(1)
                     EHLPSY = Q6X1(1)*SYQ6X1(1)/100.
                     EHLPST = Q6X1(1)*STQ6X1(1)/100.
                     ESDHLP(1) = EHLPST
                     EDDHLP(1) = SQRT(EHLPSY**2+EHLPST**2)
*     
                     DDHLP(21) = Q6X1(2)
                     EHLPSY = Q6X1(1)*SYQ6X1(1)/100.
                     EHLPST = Q6X1(1)*STQ6X1(1)/100.
                     ESDHLP(21) = EHLPST
                     EDDHLP(21) = SQRT(EHLPSY**2+EHLPST**2)
*     
                     DDHLP(41) = Q6X1(3)
                     EHLPSY = Q6X1(3)*SYQ6X1(3)/100.
                     EHLPST = Q6X1(3)*STQ6X1(3)/100.
                     ESDHLP(41) = EHLPST
                     EDDHLP(41) = SQRT(EHLPSY**2+EHLPST**2)
CRP***Fill x-section histos for Delta=2(Fig. 3 of paper)
                     X2JHL3(1) = Q6X1(3)
                     X2EHL3(1) = EHLPSY
                     X2SHL3(1) = EHLPST
*     
                     DDHLP(81) = Q6X1(4)
                     EHLPSY = Q6X1(4)*SYQ6X1(4)/100.
                     EHLPST = Q6X1(4)*STQ6X1(4)/100.
                     ESDHLP(81) = EHLPST
                     EDDHLP(81) = SQRT(EHLPSY**2+EHLPST**2)
*     
                     
                     DDHLP(141) = Q6X1(5)
                     EHLPSY = Q6X1(5)*SYQ6X1(5)/100.
                     EHLPST = Q6X1(5)*STQ6X1(5)/100.
                     ESDHLP(141) = EHLPST
                     EDDHLP(141) = SQRT(EHLPSY**2+EHLPST**2)
                  ENDIF
CRP***
                  IF(L.EQ.2) THEN
                     DDHLP(1) = Q6X2(1)
                     EHLPSY = Q6X2(1)*SYQ6X2(1)/100.
                     EHLPST = Q6X2(1)*STQ6X2(1)/100.
                     ESDHLP(1) = EHLPST
                     EDDHLP(1) = SQRT(EHLPSY**2+EHLPST**2)
*     
                     DDHLP(21) = Q6X2(2)
                     EHLPSY = Q6X2(1)*SYQ6X2(1)/100.
                     EHLPST = Q6X2(1)*STQ6X2(1)/100.
                     ESDHLP(21) = EHLPST
                     EDDHLP(21) = SQRT(EHLPSY**2+EHLPST**2)
*     
                     DDHLP(41) = Q6X2(3)
                     EHLPSY = Q6X2(3)*SYQ6X2(3)/100.
                     EHLPST = Q6X2(3)*STQ6X2(3)/100.
                     ESDHLP(41) = EHLPST
                     EDDHLP(41) = SQRT(EHLPSY**2+EHLPST**2)
CRP***Fill x-section histos for Delta=2(Fig. 3 of paper)
                     X2JHL3(2) = Q6X2(3)
                     X2EHL3(2) = EHLPSY
                     X2SHL3(2) = EHLPST
*     
                     DDHLP(81) = Q6X2(4)
                     EHLPSY = Q6X2(4)*SYQ6X2(4)/100.
                     EHLPST = Q6X2(4)*STQ6X2(4)/100.
                     ESDHLP(81) = EHLPST
                     EDDHLP(81) = SQRT(EHLPSY**2+EHLPST**2)
*     
                     
                     DDHLP(141) = Q6X2(5)
                     EHLPSY = Q6X2(5)*SYQ6X2(5)/100.
                     EHLPST = Q6X2(5)*STQ6X2(5)/100.
                     ESDHLP(141) = EHLPST
                     EDDHLP(141) = SQRT(EHLPSY**2+EHLPST**2)
                  ENDIF
               ENDIF
               
               CALL HPAK(-JL,DDHLP)
               CALL HPAKE(-JL,ESDHLP)
               CALL HPAK(-JLS,DDHLP)
               CALL HPAKE(-JLS,EDDHLP)
               
            ENDDO 

         write(6,*) 'after hpak '

CRP***Fill xsections into histos
         IF(I.EQ.1.OR.I.EQ.2) THEN
CRP          PRINT*,'X2JHL1=', X2JHL1
          CALL HPAK(-K,X2JHL1) 
          CALL HPAKE(-K, X2EHL1)
          CALL HPAK(-KS,X2JHL1) 
          CALL HPAKE(-KS, X2SHL1)
         ENDIF
c       write(6,*) 'after hpak1 '
CRP***
         IF(I.EQ.3.OR.I.EQ.4) THEN
*!MH      CALL HFILL(-K,X2JHL2)
 	  CALL HPAK(-K,X2JHL2)
          CALL HPAKE(-K, X2EHL2)
*!MH      CALL HFILL(-KS,X2JHL2) 
	  CALL HPAK(-KS,X2JHL2)
          CALL HPAKE(-KS, X2SHL2)
         ENDIF
CRP***
         IF(I.EQ.5.OR.I.EQ.6) THEN
*!MH      CALL HFILL(-K,X2JHL3) 
	  CALL HPAK(-K,X2JHL3)
          CALL HPAKE(-K, X2EHL3)
*!MH      CALL HFILL(-KS,X2JHL3) 
	  CALL HPAK(-KS,X2JHL3)
          CALL HPAKE(-KS, X2SHL3)
         ENDIF
CRP***
c       write(6,*) 'after hpak1 '
      ENDDO
CRP         PRINT*,'
 
*     
*********************************************************************
*     
*     Event Processing
*     
*********************************************************************
      ELSEIF(IFLAG.EQ.2) THEN
*     
*     Filling: The following MUST always be done
*     (i) move to the correct sub-directory in PAWC
*     
         CALL HCDIR('//PAWC/'//xxxx,' ')
*     
	   
         IF(NLO.eq.1.and.TOT.ne.1) GoTo 11112
c	      write(6,*) ' 2nd NLO ',NLO,' TOT ',TOT,wtx,nevt
c	      write(6,*) ' 2nd NLO  hzroman',NLO,' TOT ',TOT,wtx,nevt
            Nevt = Nevt + wtx
            NALL=NALL+wtx
11112	   Continue
           if(Nevt.le.0) then
	      write(6,*) ' hzroman NLO ',NLO,' TOT ',TOT,wtx,nevt
	   endif
	   NLOJET = DIJET + TRIPJET + QUADJET
*     
           IERR=HZIBEAM(IBEAM,IDUM)
           IF (.NOT.(IERR.EQ.1)) THEN
              WRITE(6,*) 'HZ'//xxxx,' beams not found ! '
              RETURN
           ELSE
              DO I=1,4
                 PBEAM(i)=PHEP(i,IBEAM)
              ENDDO
           ENDIF
*     
CRP         PRINT*,'IDUM=', IDUM
         EB=REAL(PHEP(4,IDUM))
         IF (ABS(ABS(EB)-EE).GT.0.2) THEN
            IF (NENTRY.lt.10) THEN
               WRITE(6,*) 'HZ'//xxxx,' Electron not at ',ee,' ! ',eb
            ELSEIF (NENTRY.eq.10) then
               WRITE(6,*) 'HZ'//xxxx,' Electron beam not at ',ee,
     &              ' ...last message ! '
            ENDIF
            RETURN
         ENDIF
*     
*     Event selection
*     
         Q2=REAL(HZDISKIN(1))
         X =REAL(HZDISKIN(2))
         Y =REAL(HZDISKIN(3))
*     
         IF (LP) THEN
            WRITE(*,*) 'Hz'//xxxx,' x y q2=',x,y,q2
         ENDIF
*     
*     get electron variables for kinematic selection
*     
         IEL=HZIDELEC(IDUM)
         IF (IEL.EQ.-1) THEN
            WRITE(*,*) 'Hz'//xxxx,' electron not found '
            RETURN
         ENDIF
         ENEL=REAL(PHEP(4,IEL))
         THEL=REAL(HZPHMANG(PHEP(3,IEL),
     $        SQRT(PHEP(1,IEL)**2+PHEP(2,IEL)**2)))*RD
*     
C     RP***Store four vector of scattered lepton into PELE-array
C     RP         print*,'iel=', iel
         DO I=1,4
            PELE(I) =  PHEP(I,iel)      
         ENDDO
C     RP***
         IF (LP) THEN
            WRITE(6,*) 'Hz'//xxxx,' enel= ',enel,' thel= ',thel
            WRITE(6,*) 'Hz'//xxxx,' y= ',y,' q2= ',q2
         ENDIF
*     
*     
         TWOJET=.TRUE.
         IF (Y.LT.0.1) TWOJET=.FALSE.
         IF (Y.GT.0.7) TWOJET=.FALSE.
         IF (ENEL.LT.8.6) THEN
            TWOJET=.FALSE.
         ENDIF
         IF (THEL.LT.156.0) TWOJET=.FALSE.
         IF (THEL.GT.175.2) THEN
            TWOJET=.FALSE.
         ENDIF
*     
*     
*     
         IF (TWOJET) THEN
*     
	   IF((NLO.eq.1).AND.(NLOJET.eq.0)) goto 11114

*
          DO 5 IHEP=1,NHEP
             DO I=1,4
CRP***Store 'old' PHEP array into plab
                PLAB(I,IHEP) = PHEP(I,IHEP)
CRP***HELP VECTOR PHLP CONTAINING FOUR VECTORS OF LAB OBJECTS
                PHLP(I,IHEP) = PHEP(I,IHEP) 
             ENDDO
*
 5        CONTINUE
CRP***Use boost routine from ktclus package for boost objects to 
CRP***hadronic cms 
          ELPBM = DBLE(EE)
          EPRBM = PBEAM(3)           
CRP          PRINT*,'Proton beam=', EPRBM

CRP***Choose if hcms
          CALL KTHADR(2,-ELPBM,EPRBM,PELE,NHEP,PHLP,PHAD,*999
     $        )
CRP***First copy objects in hcms to PHEP array 
          DO IHEP=1,NHEP
             IF (ISTHEP(IHEP).EQ.1.AND.IHEP.NE.IEL) THEN
                DO J =1,4
                   PHEP(J,IHEP) = PHAD(J,IHEP)
                ENDDO
             ENDIF  
          ENDDO
*
*
*
*       find the jets
*
          CALL HZJTFIND(MODJET,RCONE,NJ,PJ)
          IF (NJ.GT.NUMJET) THEN
             WRITE(6,*) 'hz',xxxx,' too many jets found ! '
             RETURN
          ENDIF
*

CRP***Choose if hcms
CRP          PRINT*,'Proton beam before hzcmtola2=', EPRBM
          CALL HZCMTOLA2(NJ,PJ,PJL)
*
          NSEL=0
*     
          DO IJ=1,NJ
*
             PTJ=REAL(PJ(IJ,3))
*
             IF (PTJ.GT.PTJCUT) THEN
                IF(REAL(PJL(IJ,1)).GT.ETALO.AND.
     $               REAL(PJL(IJ,1)).LT.ETAUP) THEN
                   NSEL = NSEL + 1
                   IPJET(NSEL) = IJ
                ENDIF
             ENDIF
          ENDDO
*
            IF (NSEL.GT.1) THEN
                if (lp) write(6,*) nsel,' jet analysis: jets found ! '
CRP            PRINT*,'HZroman WTXD=', XW,WTXD
                PTJ1 = real(pj(ipjet(1),3))
                PTJ2 = real(pj(ipjet(2),3))
****
                PHJ1 = real(pj(ipjet(1),2))
                PHJ2 = real(pj(ipjet(2),2))
                IF(PHJ1.GT.PHJ2) THEN
                   DPH = (PHJ1-PHJ2)
                ELSE
                   DPH = (PHJ2-PHJ1)
                ENDIF
                IF(DPH.GT.PI) THEN
                   DPH = ABS(DPH-2*PI)   
                ENDIF
                eta = ABS(real(pj(ipjet(1),1))-real(pj(ipjet(2),1)))
CRP***Double differential analysis
CRP***jet xsec. as function of xb in bins of q2      
                DO I=1,6 
                  NIIN = 4
                  IF(I.EQ.3.OR.I.EQ.4) NIIN = 3
                  IF(I.EQ.5.OR.I.EQ.6) NIIN = 2 
CRP***Fill histos for xb value of 2-Jet Events
                  IF(Q2.GT.SQ2BIN(I).AND.Q2.LT.SQ2BIN(I+1)) THEN
CRP***Fill help array with bin borders of double differential
CRP***dijet xsec.-analysis to prepare plot of details delta behavour of NLO 
CRP***calculations 
                     IF(I.EQ.1) THEN
                        DO J=1,NIIN+1
                           RDDXB(J) = SXBIN1(J) 
                        ENDDO
                     ENDIF

                     IF(I.EQ.2) THEN
                        DO J=1,NIIN+1
                           RDDXB(J) = SXBIN2(J) 
                        ENDDO
                     ENDIF
                     
                     IF(I.EQ.3) THEN
                        DO J=1,NIIN+1
                           RDDXB(J) = SXBIN3(J) 
                        ENDDO
                     ENDIF
                     
                     IF(I.EQ.4) THEN
                        DO J=1,NIIN+1
                           RDDXB(J) = SXBIN4(J) 
                        ENDDO
                     ENDIF
                     IF(I.EQ.5) THEN
                        DO J=1,NIIN+1
                           RDDXB(J) = SXBIN5(J) 
                        ENDDO
                     ENDIF
                   
                     IF(I.EQ.6) THEN
                        DO J=1,NIIN+1
                           RDDXB(J) = SXBIN6(J) 
                        ENDDO
                     ENDIF
                     
CRP         
                     DO J=1,NIIN
                        JL = (3000+10*I+J)
                        IF(X.GT.RDDXB(J).AND.X.LT.RDDXB(J+1)) THEN
CRP***Scan the pts of the to hardest jets for a bloody lot of deltas
                           DO L=0,160
                              IF(PTJ1.GT.PTJCUT+FLOAT(L)*0.05.OR
     $                             .PTJ2.GT.PTJCUT+FLOAT(L)*0.05)
     $                             THEN
                                 
                                 IF(L.EQ.40) THEN
                                    X2JD2(I,J) =  X2JD2(I,J) + WTX
     $                                   
CRP                                    EX2JD2(I,J) =  EX2JD2(I,J) +
CRP     $                                   WTX**2                      
CRP***
CRP***
                                 ENDIF 

                                 DELHX(I,J,L+1)=DELHX(I,J,L+1)+WTX 
CRP                                 EDELHX(I,J,L+1)=EDELHX(I,J,L+1)
CRP     $                                +WTX**2
                                         
                              ENDIF
                           ENDDO
                        ENDIF
                     ENDDO 
                  ENDIF
               ENDDO


***Delta = 2.
                IF(PTJ1.GT.PTJCUT+2..OR.PTJ2.GT.PTJCUT+2.) THEN
                 n2 = n2 + 1 
			 
                 IF(PTJ1.GT.PTJ2) THEN
                    PTMAX = PTJ1
                 ELSE
                    PTMAX = PTJ2
                 ENDIF               


                   IF(Q2.GT.5..AND.Q2.LT.10.) THEN
			   if(x.ge.xbin1(1).and.x.lt.xbin1(2)) then 
			      call hfill(101,eta,0.,wtx)
			      call hfill(401,ptmax,0.,wtx)
			   elseif(x.ge.xbin1(2).and.x.lt.xbin1(3)) then 
			      call hfill(102,eta,0.,wtx)
			      call hfill(402,ptmax,0.,wtx)
			   elseif(x.ge.xbin1(3).and.x.lt.xbin1(4)) then 
			      call hfill(103,eta,0.,wtx)
			      call hfill(403,ptmax,0.,wtx)
 			   elseif(x.ge.xbin1(4).and.x.lt.xbin1(5)) then 
			      call hfill(104,eta,0.,wtx)
			      call hfill(404,ptmax,0.,wtx)
			   endif
                   ENDIF

                   IF(Q2.GT.10..AND.Q2.LT.30.) THEN
			   if(x.ge.xbin2(1).and.x.lt.xbin2(2)) then 
			      call hfill(201,eta,0.,wtx)
			      call hfill(501,ptmax,0.,wtx)
			   elseif(x.ge.xbin2(2).and.x.lt.xbin2(3)) then 
			      call hfill(202,eta,0.,wtx)
			      call hfill(502,ptmax,0.,wtx)
			   elseif(x.ge.xbin2(3).and.x.lt.xbin2(4)) then 
			      call hfill(203,eta,0.,wtx)
			      call hfill(503,ptmax,0.,wtx)
 			   elseif(x.ge.xbin2(4).and.x.lt.xbin2(5)) then 
			      call hfill(204,eta,0.,wtx)
			      call hfill(504,ptmax,0.,wtx)
			   endif
                   ENDIF

                   IF(Q2.GT.30..and.Q2.Lt.100.) THEN
			   if(x.ge.xbin3(1).and.x.lt.xbin3(2)) then 
			      call hfill(301,eta,0.,wtx)
			      call hfill(601,ptmax,0.,wtx)
			   elseif(x.ge.xbin3(2).and.x.lt.xbin3(3)) then 
			      call hfill(302,eta,0.,wtx)
			      call hfill(602,ptmax,0.,wtx)
			   endif
                   ENDIF
c S distribution 		
                   if(q2.gt.sq2bin(1).and.q2.le.sq2bin(2)) then
			    if(dph.lt.dph_cut) call hfill(801,real(x),0.,wtx)  	 
			    call hfill(811,real(x),0.,wtx)  	 
                   elseif(q2.gt.sq2bin(2).and.q2.le.sq2bin(3)) then
 			    if(dph.lt.dph_cut) call hfill(802,real(x),0.,wtx)  	 
 			    call hfill(812,real(x),0.,wtx)  	 
                   elseif(q2.gt.sq2bin(3).and.q2.le.sq2bin(4)) then
 			    if(dph.lt.dph_cut) call hfill(803,real(x),0.,wtx)  	 
  			    call hfill(813,real(x),0.,wtx)  	 
                   elseif(q2.gt.sq2bin(4).and.q2.le.sq2bin(5)) then
 			    if(dph.lt.dph_cut) call hfill(804,real(x),0.,wtx)  	 
 			    call hfill(814,real(x),0.,wtx)  	 
                   elseif(q2.gt.sq2bin(5).and.q2.le.sq2bin(6)) then
 			    if(dph.lt.dph_cut) call hfill(805,real(x),0.,wtx)  	 
 			    call hfill(815,real(x),0.,wtx)  	 
                   elseif(q2.gt.sq2bin(6).and.q2.le.sq2bin(7)) then
 			    if(dph.lt.dph_cut) call hfill(806,real(x),0.,wtx) 
 			    call hfill(816,real(x),0.,wtx) 
			 endif 	 
               ENDIF 
             
            ENDIF
*
CRP***Put PLAB back into PHEP
          DO IHEP=1,NHEP
             DO I=1,4
                PHEP(I,IHEP)= PLAB(I,IHEP)
             ENDDO
          ENDDO
*
11114	   continue		 
        ENDIF
********************************************************************
*
*                      Termination
*
*********************************************************************

      ELSEIF(IFLAG.EQ.3) THEN

* Termination: The following MUST always be done
* (i) Move to the correct PAW subdirectory
*
         CALL HCDIR('//PAWC/'//xxxx,' ')
*
         LUM=999999999.
         if (XSEC.NE.0.) then
            LUM=REAL(NALL)/REAL(XSEC)
         else
            write(6,*) 'hz',xxxx,' xsec=0 ! Analytical Calculation ?'
         endif
CRP***Needed for DISENT check for other NLO programs what is needed
         IF (NLO.EQ.1) LUM = 1.

*
         write(6,*) 'hz',xxxx,': Total Cross= ',
     &        real(xsec),' nall= ',nall
         write(6,*) 'lumi=',lum

         
CRP***Finalize the triple differential dijet cross section (eta)
CRP***and pt Figs. 4-7 in paper
	   Do I=1,4
           binq2 = q2bin(2) - q2bin(1)
	     binx = xbin1(i+1)- xbin1(i)
	     binw = binq2 * binx 
	     idhist = 100+I
             idpt = 400+I
           call hzhinrm(idhist,0,binw*lum,1)   
           call hzhinrm(idpt,0,binw*lum,1)   
	   Enddo  
 	   Do I=1,4
           binq2 = q2bin(3) - q2bin(2)
	     binx = xbin2(i+1)- xbin2(i)
	     binw = binq2 * binx 
	     idhist = 200+I
             idpt = 500+I
           call hzhinrm(idhist,0,binw*lum,1)   
           call hzhinrm(idpt,0,binw*lum,1)   
	   Enddo  
 	   Do I=1,2
           binq2 = q2bin(4) - q2bin(3)
	     binx = xbin3(i+1)- xbin3(i)
	     binw = binq2 * binx 
	     idhist = 300+I
             idpt = 600+I
           call hzhinrm(idhist,0,binw*lum,1)   
           call hzhinrm(idpt,0,binw*lum,1)   
	   Enddo  

CRP***Finalize the results on the S-distribution
CRP***Figs.9,10 and 11 in paper
	   call hopera(801,'/E',811,801,1.,1.) 
	   call hopera(802,'/E',812,802,1.,1.) 
	   call hopera(803,'/E',813,803,1.,1.) 
	   call hopera(804,'/E',814,804,1.,1.) 
	   call hopera(805,'/E',815,805,1.,1.) 
	   call hopera(806,'/E',816,806,1.,1.) 
CRP***

CRP***Fill the double differential histos
           DO I=1,6 
              NIIN = 4
              IF(I.EQ.3.OR.I.EQ.4) NIIN = 3
              IF(I.EQ.5.OR.I.EQ.6) NIIN = 2 
CRP***Fill and finalize the usual dd histos Fig. 3 of paper
              DO K=1,NIIN
                 D2JHLP(K)=REAL(X2JD2(I,K))
CRP               E2JHLP(K)=REAL(SQRT(EX2JD2(I,K)))
              ENDDO
              CALL HPAK(1500+I,D2JHLP)  
              BINW = SQ2BIN(I+1) - SQ2BIN(I)
              CALL HZHINRM(1500+I,0,BINW*LUM,1)
CRP***Fill histos for xb value of 2-Jet Events
CRP***Fill the help variable
              IF(I.EQ.1) THEN
                 DO K=1,NIIN+1
                    RDDXB(K) = SXBIN1(K) 
                 ENDDO
              ENDIF
                 
              IF(I.EQ.2) THEN
                 DO K=1,NIIN+1
                    RDDXB(K) = SXBIN2(K) 
                 ENDDO
              ENDIF
                 
              IF(I.EQ.3) THEN
                 DO K=1,NIIN+1
                    RDDXB(K) = SXBIN3(K) 
                 ENDDO
              ENDIF
              
              IF(I.EQ.4) THEN
                 DO K=1,NIIN+1
                    RDDXB(K) = SXBIN4(K) 
                 ENDDO
              ENDIF

              IF(I.EQ.5) THEN
                 DO K=1,NIIN+1
                    RDDXB(K) = SXBIN5(K) 
                 ENDDO
              ENDIF

              IF(I.EQ.6) THEN
                 DO K=1,NIIN+1
                    RDDXB(K) = SXBIN6(K) 
                 ENDDO
              ENDIF

CRP***Fill the delta plots Fig.2 in paper
              J = (3000+I*10)               
              DO K=1,NIIN 
                 JK = J + K    
                 BINW = (RDDXB(K+1)-RDDXB(K))*(SQ2BIN(I+1)-SQ2BIN(I))
                 DO L=1,161           
                    DDHLP(L) =  REAL(DELHX(I,K,L)) 
                 ENDDO
                 CALL HPAK(JK,DDHLP)                    
                 CALL HZHINRM(JK,0,BINW*LUM/0.05,1)
              ENDDO
           ENDDO

*
*
*
         write(6,*) 'hz',xxxx,nall,' out of which: 2+1 jets= ',n2

*
*
*
      ENDIF
*
 999  RETURN
      END











