*CMZ :  2.00/06 02/05/2002  14.23.52  by  Tancredi Carli
*-- Author :
*
*CMZ :  1.01/15 15/04/98  10.55.08  by  Tancredi Carli
*CMZ :  1.01/11 09/12/97  16.44.12  by  Tancredi Carli
*CMZ :  1.01/07 10/10/97  19.46.50  by  Tancredi Carli
*CMZ :  1.01/05 06/09/96  18.41.26  by   Tancredi Carli
*CMZ :  1.01/01 28/03/96  16.22.17  by  Tancredi Carli
*CMZ :  1.00/02 12/03/96  18.53.24  by  Tancredi Carli
*CMZ :  1.00/01 23/02/96  15.10.08  by  Tancredi Carli
*CMZ :  0.00/10 16/02/96  18.08.45  by  Tancredi Carli
*CMZ :  0.00/09 16/02/96  17.16.06  by  Tancredi Carli
*CMZ :  0.00/08 15/02/96  15.41.39  by  Renate Mohr
*CMZ :  0.00/06 02/02/96  19.54.21  by  Tancredi Carli
*-- Author :  Tancredi Carli   10/01/96
      subroutine HZ94033(IFLAG)
****************************************************************************
* Purpose: produced histograms for:
*           o) energy flows in lab and cms for x<10^-3 and x>10^-3
*           o) energy-energy correlation   for x<10^-3 and x>10^-3
*           o) charged particle spectra (Xf, seagull)
* Event selection:
* Eel>14 172.5 Thel>157 w2>3000 and cut on forward energy
*
* Running: Ee=26.7 HERA running 1992
* Reference: Z. Phys C63,377-389 (1994)
* Arguments: iflag=1 initialisation
*            iflag=1 filling
*            iflag=3 termination
*
* written by: Tancredi Carli and Renate Mohr
*             (carli@mail.desy.de mohr@mail.desy.de)
****************************************************************************
      IMPLICIT NONE
*
#include "hzfunc.inc"
#include "hzhbook.inc"
#include "hepevtp.inc"
#include "heracmn.inc"
*
      Integer iflag,ihep,i,j,k,l
      Character*5 xxxx
*
      Real pi,rd,ee,eb
      Logical take,evcut,lp
      Integer jcut,ncut,iel,idum,id
      Parameter (ncut=4,pi=3.1415927,rd=180./pi,ee=26.7)
      Integer nentry,nevnt(2)
      Real nev(ncut)
      Real x,y,q2,w2,enel,ptel,thel,efwd,th,rap,pt,et,p,costh
      Real xmi,xma,ymi,yma
      Integer nx,ny,nwt,loc
      Character chtitl*80
*
      Real VMIN,VMAX
      Integer ncbin,nlbin,nee1bin,nee2bin,nxfbin,nxfsbin
      Real nw(3),nww
      Integer nweight,npte
      Real neecor1,neecor2
      Parameter (ncbin=27,nlbin=30,nee1bin=36,nee2bin=28)
      Parameter (nxfbin=12,nxfsbin=8)
      Real om1(nee1bin+1),omeg1(nee1bin),eest1(nee1bin),eesys1(nee1bin)
      Real om2(nee2bin+1),omeg2(nee2bin),eest2(nee2bin),eesys2(nee2bin)
*
*
      Real erre1(nee1bin),erre2(nee2bin)
      Real xfd(nxfbin+1),w1(nxfbin),w2a(nxfbin),w3(nxfbin)
      real w4(nxfbin)
      Real xfdaux(nxfbin),xfsaux(nxfsbin)
      Real estatw1(nxfbin),estatw2(nxfbin)
      Real estatw3(nxfbin)
      Real esysw1(nxfbin),esysw2(nxfbin),esysw3(nxfbin)
      Real errw1(nxfbin),errw2(nxfbin),errw3(nxfbin),errw4(nxfbin)
      Real xfs(nxfsbin+1),pts(nxfsbin)
      Real xf,pt2,w
      real eptsstat(nxfsbin),eptssys(nxfsbin),errpts(nxfsbin)
      Real etl(ncbin),els(ncbin),ely(ncbin)
      Real etg(ncbin),egs(ncbin),egy(ncbin)
      Real el(nlbin),eel(nlbin),eg(nlbin),deg(nlbin)
      Real errl(nlbin),errg(nlbin)
      Real etal(nlbin+1),etac(ncbin+1),etalm(nlbin),etacm(ncbin)
      Real phi1,phi2,eta1,eta2,deltaphi,th2,om,et2,wt
      Real xlmin,xlmax,xcmin,xcmax,xe1min,xe1max,xe2min,xe2max
      Integer ierr,ibeam,igam
      Double precision pbeam(4),pgam(4),pcm(4),ph(5),phc(4)
*
      Data nev/0.,0.,0.,0./,lp/.false./,nentry/0/
*     DESY Preprint number
      Data xxxx/'94033'/

      save nw, nww, neecor1, neecor2, nev
*
******************************************************************************
* Data points from plots
*
*                                            dEt/deta CMS
*
* et-flow low x
      Data etl/0.34,1.06,1.43,1.91,1.76,1.89,1.90,2.07,2.00,2.19,
     &         1.95,1.95,2.10,2.51,2.01,3.00,2.00,2.41,2.14,1.75,
     &         1.36,0.85,0.55,0.50,0.27,0.17,0.10/
* stat error et-flow
      Data els/0.07,0.13,0.13,0.16,0.16,0.17,0.17,0.18,0.17,0.22,
     &         0.20,0.22,0.23,0.29,0.22,0.44,0.24,0.26,0.25,0.23,
     &         0.17,0.11,0.09,0.08,0.06,0.04,0.03/
* sy error et-flow
      Data ely/0.04,0.09,0.10,0.12,0.10,0.11,0.10,0.10,0.10,0.11,
     &         0.09,0.10,0.11,0.13,0.10,0.15,0.10,0.12,0.11,0.09,
     &         0.08,0.05,0.04,0.04,0.03,0.03,0.02/
* et-flow high x
      Data etg/0.00,0.10,0.40,0.81,1.24,1.52,1.90,1.82,1.81,1.89,
     &         2.05,2.18,2.09,2.26,2.35,2.31,2.33,2.06,1.35,0.90,
     &         0.69,0.41,0.31,0.15,0.08,0.04,0.03/
* stat error high x
      Data egs/0.00,0.02,0.05,0.08,0.09,0.10,0.13,0.12,0.11,0.13,
     &         0.13,0.16,0.16,0.17,0.17,0.16,0.18,0.16,0.12,0.09,
     &         0.08,0.05,0.04,0.02,0.02,0.01,0.01/
      Data egy/0.00,0.01,0.03,0.04,0.05,0.06,0.08,0.07,0.07,0.07,
     &         0.08,0.08,0.08,0.09,0.10,0.10,0.11,0.11,0.08,0.06,
     &         0.05,0.04,0.03,0.02,0.01,0.01,0.01/
*
      Data etac/-1.25,-1.00,-0.75,-0.50,-0.25,0.00,0.25,0.50,0.75,
     &          1.00, 1.25, 1.50, 1.75, 2.00,2.25,2.50,2.75,3.00,
     &          3.25, 3.50, 3.75, 4.00, 4.25,4.50,4.75,5.00,5.25,
     &          5.50/
*
*                                            dEt/d(eta-eta_q) lab
*
* et-flow low x
      Data  el/ 0.  , 0.  , 0.  , 0.03, 0.08,0.29,0.62,1.07,1.73,
     &          2.16, 2.72, 2.64, 2.70, 2.28,2.47,2.54,2.04,2.01,
     &          1.92, 1.87, 2.08, 2.41, 2.04,2.07,2.08,1.76,1.50,
     &          1.18, 0.70, 0.33/
* total error et-flow
      Data eel/ 0.  , 0.  , 0.  ,0.03 , 0.06,0.09,0.12,0.17,0.23,
     &          0.25, 0.32, 0.33,0.36 , 0.31,0.35,0.31,0.26,0.23,
     &          0.20, 0.21, 0.25,0.21 , 0.21,0.22,0.19,0.19,0.20,
     &          0.18, 0.13, 0.08/
* et-flow high x
      Data  eg/ 0.  , 0.  , 0.  ,0.11 , 0.20,0.42,0.86,2.07,3.92,
     &          4.25, 3.80, 3.20,3.03 , 2.49,2.13,2.02,2.00,2.04,
     &          1.83, 1.43, 1.44,1.03 , 0.74,0.57,0.26,0.15,0.13,
     &          0.  , 0.  , 0./
*
* total error high x
      Data deg/ 0.  , 0.  , 0.  ,0.11 , 0.07,0.11,0.13,0.22,0.36,
     &          0.36, 0.31, 0.25,0.25 , 0.21,0.17,0.15,0.17,0.17,
     &          0.15, 0.13, 0.14,0.11 , 0.08,0.08,0.09,0.08,0.06,
     &          0.  ,  0. ,  0./
*
      Data etal/-2.00,-1.75,-1.50,-1.25,-1.00,-0.75,-0.50,-0.25,
     &           0.00, 0.25, 0.50, 0.75, 1.00, 1.25, 1.50, 1.75,
     &           2.00, 2.25, 2.50, 2.75, 3.00, 3.25, 3.50, 3.75,
     &           4.00, 4.25, 4.50, 4.75, 5.00, 5.25, 5.50/
*

*
* energy-energy correlation
*
*x<10**-3
*
*x-axis
      Data  om1/0.15,0.30,0.45,0.60,0.75,0.90,1.05,1.20,1.35,
     &          1.50,1.65,1.80,1.95,2.10,2.25,2.40,2.55,2.70,
     &          2.85,3.00,3.15,3.30,3.45,3.60,3.75,3.90,4.05,
     &          4.20,4.35,4.50,4.65,4.80,4.95,5.10,5.25,5.40,
     &          5.55/
*y-axis
      Data omeg1/1.28,1.34,1.28,1.38,1.25,1.36,1.44,1.39,1.48,1.43,1.50,
     &           1.59,1.63,1.69,1.84,1.90,2.02,2.28,2.57,2.66,2.17,1.71,
     &           1.47,1.14,1.02,0.82,0.68,0.58,0.51,0.37,0.28,0.27,0.16,
     &           0.13,0.07,0.03/
*stat. error e-e-cor
      Data eest1/0.28,0.17,0.15,0.17,0.14,0.15,0.17,0.15,0.16,0.17,0.17,
     &           0.18,0.18,0.18,0.20,0.20,0.22,0.27,0.31,0.33,0.31,0.25,
     &           0.18,0.13,0.13,0.10,0.08,0.07,0.07,0.06,0.04,0.05,0.03,
     &           0.03,0.01,0.01/
*syst. error e-e-cor
      Data eesys1/0.20,0.14,0.06,0.05,0.09,0.14,0.17,0.17,0.18,0.16,
     &           0.16,0.15,0.14,0.12,0.12,0.10,0.07,0.05,0.02,0.07,
     &           0.11,0.14,0.18,0.18,0.21,0.21,0.21,0.18,0.16,0.12,
     &           0.10,0.09,0.05,0.04,0.02,0.01/
*
* x>10**-3
*
*x-axis
      Data   om2/0.15,0.30,0.45,0.60,0.75,0.90,1.05,1.20,1.35,1.50,1.65,
     &           1.80,1.95,2.10,2.25,2.40,2.55,2.70,2.85,3.00,3.15,3.30,
     &           3.45,3.60,3.75,3.90,4.05,4.20,4.35/
*y-axis
      Data omeg2/0.46,0.57,0.53,0.52,0.47,0.44,0.42,0.41,0.42,0.43,0.44,
     &           0.43,0.43,0.43,0.45,0.45,0.48,0.53,0.54,0.52,0.37,0.25,
     &           0.19,0.13,0.08,0.06,0.04,0.03/
*stat. error e-e-cor
      Data eest2/0.04,0.05,0.04,0.03,0.03,0.03,0.03,0.03,0.03,0.03,0.03,
     &           0.03,0.03,0.03,0.03,0.03,0.04,0.04,0.04,0.04,0.03,0.02,
     &           0.02,0.01,0.01,0.01,0. ,0./
*syst error e-e-cor
      Data eesys2/0.04,0.05,0.04,0.04,0.04,0.03,0.03,0.03,0.03,0.03,
     &           0.03,0.03,0.03,0.03,0.03,0.03,0.03,0.04,0.04,0.03,0.02,
     &           0.01,0.01,0.01,0.01,0.01,0.01,0.01/

*
*
*    charged particle spectra
*
*  xf distribution
* x-axis
      Data   xfd/0.00,0.02,0.04,0.06,0.08,0.12,0.16,0.20,0.24,0.28,0.36,
     &          0.44,0.52/
*y-axis ,errors
*
*  <W>=77 GeV
      Data      w1/0.,67.,36.,24.,18.3,9.0,5.9,3.8,2.1,2.5,1.3,0.6/
*  stat error
      Data estatw1/0.,5.,3.,2.,1.4,0.9,0.8,0.6,0.4,0.4,0.3,0.2/
*  syst error
      Data esysw1/0.,5.,3.,2.,1.8,1.2,0.8,0.5,0.3,0.4,0.3,0.2/
*
*  <W>=122 GeV
      Data     w2a/0.,69.,37.,21.,14.8,11.0,5.9,5.0,2.4,1.5,0.62,0.33/
      Data estatw2/0.,4.,3.,2.,1.2,1.1,0.8,0.7,0.5,0.3,0.18,0.12/
      Data esysw2/0.,3.,2.,2.,1.3,1.1,0.7,0.6,0.3,0.2,0.09,0.07/
*
*  <W>=169 GeV
      Data   w3/250.,59.,42.,29.,15.,8.8,5.8,4.7,4.2,1.8,1.2,0.4/
      Data   estatw3/12.,5.,4.,3.,2.,1.3,1.1,0.9,1.0,0.4,0.4,0.2/
      Data   esysw3/18.,5.,5.,4.,2.,1.1,0.8,0.7,0.6,0.4,0.3,0.1/
*
*
* Seagull
       Data   xfs/0.00,0.03,0.07,0.11,0.15,0.20,0.28,0.40,0.54/
       Data pts/0.21,0.39,0.57,0.72,0.88,1.20,1.38,2.40/
* stat error
       Data eptsstat/0.01,0.03,0.07,0.17,0.13,0.28,0.28,0.72/
* syst error
       Data eptssys/0.01,0.03,0.05,0.06,0.10,0.17,0.21,0.65/
*
*
******************************************************************************
      NENTRY=NENTRY+1
*
      IF (iflag.eq.1) then
*
*      Initialisation: The following MUST always be done
*      (i) make subdirectory in PAWC
*       - use the name as the xxxxxx in HZxxxxxx subroutine
*      (i) make subdirectory in o/p file
*
       Call hcdir('//PAWC',' ')
       call hmdir(xxxx,'S')
       Call hcdir('//HISTO',' ')
       call hmdir(xxxx,'S')
*
*
*      book your histograms  (data: ID<0)
*                                     (VZERO, VMIN, VMAX see CERNLIB F121)
       xcmin=VMIN(etac,ncbin+1)
       xcmax=VMAX(etac,ncbin+1)
       call hbook1(-10,'dEt/deta CMS low x',ncbin,xcmin,xcmax, 0.)
       call hbook1(-11,'dEt/deta CMS high x',ncbin,xcmin,xcmax, 0.)
       call hbook1( 10,'dEt/deta CMS low x',ncbin,xcmin,xcmax, 0.)
       call hbook1( 11,'dEt/deta CMS high x',ncbin,xcmin,xcmax, 0.)
*
       xlmin=VMIN(etal,nlbin+1)
       xlmax=VMAX(etal,nlbin+1)
       call hbook1( 12,'dEt/deta lab low x ',nlbin,xlmin,xlmax, 0.)
       call hbook1(-13,'dEt/deta lab high x',nlbin,xlmin,xlmax, 0.)
       call hbook1(-12,'dEt/deta lab low x ',nlbin,xlmin,xlmax, 0.)
       call hbook1( 13,'dEt/deta lab high x',nlbin,xlmin,xlmax, 0.)
*
       xe1min=VMIN(om1,nee1bin+1)
       xe1max=VMAX(om1,nee1bin+1)
       call hbook1(-14,'eecor low X',nee1bin,xe1min,xe1max, 0.)
       call hbook1( 14,'eecor low X',nee1bin,xe1min,xe1max, 0.)
       call hbook1(114,'eecor low X',50,0.,6., 0.)
*
       xe2min=VMIN(om2,nee2bin+1)
       xe2max=VMAX(om2,nee2bin+1)
       call hbook1(-15,'eecor high X',nee2bin,xe2min,xe2max, 0.)
       call hbook1( 15,'eecor high X',nee2bin,xe2min,xe2max, 0.)
       call hbook1(115,'eecor high X',50,0.,6., 0.)
*
       call hbook1( 16,'Xf-spec. <W>=77GeV ',70,0.,1., 0.)
       call hbook1( 17,'Xf-spec. <W>=122GeV',70,0.,1., 0.)
       call hbook1( 18,'Xf-spec. <W>=169GeV',70,0.,1., 0.)
*
*     MC Histo with non-equid. Data-Binning
       call hbookb(116,'non-equ. MC Xf-spec W=77 ',nxfbin,xfd,0.)
       call hbookb(117,'non-equ. MC Xf-spec W=122',nxfbin,xfd,0.)
       call hbookb(118,'non-equ. MC Xf-spec W=169',nxfbin,xfd,0.)
*
       call hbook1(-161,'X-ax Xf Spec',nxfbin+1,0.,real(nxfbin),0.)
       call hbook1(-162,'Y-ax W=77 ',nxfbin,0.,real(nxfbin),0.)
       call hbook1(-172,'Y-ax W=122',nxfbin,0.,real(nxfbin),0.)
       call hbook1(-182,'Y-ax W=169',nxfbin,0.,real(nxfbin),0.)
*
*     Data histo non-equid.
       call hbookb(-116,'non-equ. data Xf-spec W=77 ',nxfbin,xfd,0.)
       call hbookb(-117,'non-equ. data Xf-spec W=122',nxfbin,xfd,0.)
       call hbookb(-118,'non-equ. data Xf-spec W=169',nxfbin,xfd,0.)
*
       call hbook1(-191,'X-axis Seagull',nxfsbin+1,0.,real(nxfsbin),0.)
       call hbook1(-192,'Y-axis Seagull',nxfsbin,0.,real(nxfsbin),0.)
       call hbook1( 19,'Seagull Plot',20,0.,0.6, 0.)
       call hbook1( 21,'aux hist. xf',20,0.,0.6, 0.)
       call hbook1( 22,'Seagull without norm. ..',20,0.,0.6,0.)
       call hbook1( 20,'Seagull Plot (remn region)',20,-1.,1., 0.)
       call hbook1( 23,'Seagull aux (remn region)',20,-1.,1., 0.)
       call hbook1( 24,'Seagull remn.without norm. ..',20,-1.,1., 0.)
*
*     MC Histo with Data-Binning
       call hbookb(119,'non-equ. MC Seagull',nxfsbin,xfs,0.)
       call hbookb(121,'non-equ. MC aux hist xf',nxfsbin,xfs,0.)
       call hbookb(221,'non-equ. MC aux pt   ',nxfsbin,xfs,0.)
       call hbookb(122,'non-equ. MC seag. without norm.',nxfsbin,xfs,0.)
*     Data histo non-equid.
       call hbookb(-119,'non-equ. data Seagull',nxfsbin,xfs,0.)
*
* Data-histos with statistical errors only
*
       call hbook1(-210,'(st.err.)dEt/deta CMS low x',ncbin,
     &      xcmin,xcmax, 0.)
       call hbook1(-211,'(st.err.)dEt/deta CMS high x',ncbin,
     &     xcmin,xcmax, 0.)
       call hbook1(-214,'(st.err.)eecor low X',nee1bin,
     &       xe1min,xe1max, 0.)
       call hbook1(-215,'(st.err.)eecor high X',nee2bin,
     &        xe2min,xe2max, 0.)
       call hbookb(-216,'(st.err.) data Xf-spec W=77 ',nxfbin,xfd,0.)
       call hbookb(-217,'(st.err.) data Xf-spec W=122',nxfbin,xfd,0.)
       call hbookb(-218,'(st.err.) data Xf-spec W=169',nxfbin,xfd,0.)
       call hbookb(-219,'(st.err.) data Seagull',nxfsbin,xfs,0.)
*
       nw(1)=0.
       nw(2)=0.
       nw(3)=0.
       nww=0.
       neecor1=0.
       neecor2=0.
*
*********************************************************************
*
      Else if(iflag.eq.2) then
*      Filling: The following MUST always be done
*      (i) move to the correct sub-directory in PAWC
*
       call hcdir('//PAWC/'//xxxx,' ')
*
*      Event selection
*
       q2=real(HZDISKIN(1))
       x =real(HZDISKIN(2))
       y =real(HZDISKIN(3))
       w2=real(HZDISKIN(4))
       w=sqrt(w2)
       if (lp) write(6,*) 'Hz'//xxxx,
     & ' x= ',x,' q2 ',q2,' y= ',y,' w2= ',w2
*
*      get position of scattered electron, energy,Pt and polar angle
*
       iel=HZIDELEC(idum)
       if (iel.eq.-1) then
        write(6,*) 'Hz'//xxxx,' electron not found '
        return
       endif
       ptel= real(sqrt(PHEP(1,iel)**2+PHEP(2,iel)**2))
       enel=real(PHEP(4,iel))
       Thel=real(HZPHMANG(PHEP(3,iel),
     &               sqrt(PHEP(1,iel)**2+PHEP(2,iel)**2)))*rd
       if (lp) write(6,*) 'Hz'//xxxx,
     &                       ' enel= ',enel,' thel= ',thel
*
*
*      cut on forward energy
*
       efwd=0.
       Do 5 ihep=1,nhep
        if (isthep(ihep).ne.1.or.ihep.eq.iel) goto 5
        th=real(HZPHMANG(PHEP(3,ihep),
     &              sqrt(PHEP(1,ihep)**2+PHEP(2,ihep)**2)))*rd
        if(th.gt.4.4.and.th.lt.15.) then
         efwd=real(PHEP(4,ihep))+efwd
        endif
 5     continue
*
*      cut on kinematics
*
       evcut= enel.gt.14.
       evcut= thel.gt.157. .and. thel.lt.172.5 .and. evcut
       evcut= w2.ge.3000..and. evcut
       evcut=efwd.gt.0.5.and.evcut
       if (lp) write(6,*) 'Hz'//xxxx,
     &                         ' efwd= ',efwd,' evcut= ',evcut
*
*      set up CMS boost needed later
*
       ierr=HZIBEAM(ibeam,idum)
       if (.not.(ierr.eq.1)) then
        write(6,*) 'HZ'//xxxx,' beams not found ! '
        return
       else
        Do i=1,4
         pbeam(i)=PHEP(i,IBEAM)
        enddo
       endif
*
       eb=real(PHEP(4,idum))
       if (abs(abs(eb)-ee).gt.0.2) then
        if (nentry.lt.10) then
         write(6,*) 'HZ'//xxxx,' Electron beam not at ',ee,
     &  ' but ',eb,' abs= ',abs(abs(eb)-ee)
        elseif (nentry.eq.10) then
         write(6,*) 'HZ'//xxxx,' Electron beam not at ',ee,
     &   ' ...last message ! '
        endif
C       return
       endif
*
       ierr=HZIPGAM(ph)
       if (ierr.eq.-1) then
        write(6,*) 'HZ'//xxxx,' boson vector not found ! '
C        call VZERO(ph,5)
        Do i=1,5
         ph(i)=0.
        enddo
       else
        Do i=1,4
         pgam(i)=ph(i)
        enddo
       endif
*
       call HZHCMINI(pbeam,pgam,ierr)
       if (ierr.eq.1) then
        write(6,*) 'HZ'//xxxx,' problem with boost to cms ! '
        return
       endif
*
*      count entries for normalization
*
       if (evcut) then
        if(w.gt.50..and.w.le.100.)  nw(1)=nw(1)+wtx
        if(w.gt.100..and.w.le.150.) nw(2)=nw(2)+wtx
        if(w.gt.150..and.w.le.200.) nw(3)=nw(3)+wtx
        if (x.lt.0.001) then
         neecor1=neecor1+wtx
        else
         neecor2=neecor2+wtx
        endif
       endif
*
*    -----------------------------------------------------------
*
*      loop over bins in x jcut.ge.3 lab ,  else cms
*
       do 10 jcut = 1,ncut
*                               find the correct bin for this evt.
        take=.false.
        if (jcut.eq.1 .and.x.lt.0.001) take=.true.
        if (jcut.eq.2 .and.x.ge.0.001) take=.true.
        if (jcut.eq.3 .and.x.lt.0.001) take=.true.
        if (jcut.eq.4 .and.x.ge.0.001) take=.true.
*
        if (lp) write(6,*) 'Hz'//xxxx,
     &  ' jcut= ',jcut,' take= ',take
*
       if(take.and.evcut) then
*
*       count events in each bin for norm.
        nev(jcut)=nev(jcut)+wtx
        if(w.gt.50..and.w.lt.200.) then
         nww=nww+wtx
        endif
*
*       particle loop
        do 20 ihep=1,nhep
*
*        skip unstable particles and electron
         if (isthep(ihep).ne.1.or.ihep.eq.iel) goto 20
         th=real(HZPHMANG(PHEP(3,ihep),
     &              sqrt(PHEP(1,ihep)**2+PHEP(2,ihep)**2)))
*                                        lab plot
         if (jcut.ge.3) then
*                                        acceptance cut
          if (th*rd.gt.4.4) then
           p = real(sqrt(PHEP(1,ihep)**2+
     &                   PHEP(2,ihep)**2+PHEP(3,ihep)**2))
           pt= real(sqrt(PHEP(1,ihep)**2+PHEP(2,ihep)**2))
           et= real(PHEP(4,ihep)* pt/p)
           rap= -log(tan( th/2. ))
*
           if (lp) write(6,*) 'Hz'//xxxx,' id= ',idhep(ihep),
     &     ' lab: et,pt,rap,th= ',et,pt,rap,th*rd
*
           if (th*rd.lt.174.) then
*           get scattered quark angle
            costh=2.*ee*y/(ee*y+(q2*(1.-y)/(4.*ee*y)))
            costh=1.-costh
            rap=rap-1.*(-log(tan( acos(costh)/2. )))
            call hf1(10+jcut-1, rap, et*wtx )
           endif
*
*          calculation of energy energy correlation values
*
           phi1=real(atan2(PHEP(2,IHEP),PHEP(1,IHEP)))
           phi1=phi1+pi
*
*          eecor acceptance cut
           if(th*rd.gt.8.) then
            eta1=-log(tan(th/2.))
            do 30 j=ihep+1,nhep
             if (isthep(j).ne.1.or.j.eq.iel) goto 30
             th2=real(HZPHMANG(PHEP(3,j),
     &              sqrt(PHEP(1,j)**2+PHEP(2,j)**2)))
             if(th2*rd.gt.8.) then
              eta2=-log(tan(th2/2.))
              phi2=real(atan2(PHEP(2,j),PHEP(1,j)))
              phi2=phi2+pi
              p = real(sqrt(PHEP(1,j)**2+
     &                      PHEP(2,j)**2+PHEP(3,j)**2))
              pt= real(sqrt(PHEP(1,j)**2+PHEP(2,j)**2))
              et2= real(PHEP(4,j)* pt/p)
              deltaphi=phi1-phi2
              if(abs(deltaphi).gt.pi) then
               deltaphi=abs(abs(deltaphi)-2.*pi)
              endif
              om=sqrt((eta1-eta2)**2.+deltaphi**2.)
              wt=(et*et2)/ptel**2.
*
              if (x.lt.0.001) then
               call hf1 (14,om,wt*wtx)
               call hf1 (114,om,wt*wtx)
              else
               call hf1 (15,om,wt*wtx)
               call hf1 (115,om,wt*wtx)
              endif
             endif
*                    end of 2.particle loop
 30         continue
*                    eecor acceptance cut
           endif
*                    endif acceptance cuts
          endif
*
*      ---------------------------------------------
*
         else

*          CMS plots      -> transform in CMS
*
           Do i=1,4
            Phc(i)=PHEP(i,ihep)
           enddo
           call HZHCM(phc,pcm,ierr)
           if (ierr.eq.1) then
            write(6,*) 'HZ'//xxxx,' problem with boost to cms ! '
            return
           endif
*
*                                       acceptance cut
          if (th*rd.gt.4.4) then
*
           p      = real(sqrt(pcm(1)**2+pcm(2)**2+pcm(3)**2 ))
           pt     = real(sqrt( pcm(1)**2+pcm(2)**2 ))
           et     = real(pcm(4)) * pt / p
           th     = (acos(real(pcm(3))/p))
           th     = sign(max(abs(th),1.0e-05),th)
           rap    = -log(tan( th/2. ))
           if (lp) write(6,*) 'Hz'//xxxx,
     &     'lab: et,pt,rap,th ',et,pt,rap,th*rd
*
           call hf1(10+jcut-1, rap, et*wtx )
*
*          filling of charged part. spectra
*
           xf=2.*real(pcm(3))/w
           pt2=real(pcm(1)**2 + pcm(2)**2)
           if (IHCHRG(IHEP).ne.0) then
            if(w.gt.50..and.w.le.100.) then
              call hf1 (16,xf,wtx)
              call hf1 (116,xf,wtx)
            endif
            if(w.gt.100..and.w.le.150.) then
             call hf1 (17,xf,wtx)
             call hf1 (117,xf,wtx)
            endif
            if(w.gt.150..and.w.le.200.) then
             call hf1 (18,xf,wtx)
             call hf1 (118,xf,wtx)
            endif
* seagull
            if(w.gt.50..and.w.lt.200.) then
             call hf1 (22,xf,pt2*wtx)
             call hf1 (21,xf,wtx)
             call hf1 (122,xf,pt2*wtx)
             call hf1 (121,xf,wtx)
             call hf1 (221,xf,pt2*pt2*wtx)
            endif
           endif
*                       endif acceptance cut
          endif
*
* seagull remnant region
          xf=2.*real(pcm(3))/w
          pt2=real(pcm(1)**2 + pcm(2)**2)
          if (IHCHRG(IHEP).ne.0) then
           if(w.gt.50..and.w.lt.200.) then
            call hf1 (24,xf,pt2*wtx)
            call hf1 (23,xf,wtx)
           endif
          endif
*                  !  lab or cms
         endif
*                  ! end loop over objects
 20     continue
*                  ! endif for bins
       endif
*                  ! end loop over bins
 10   continue
*
************************************************************************
*
      Else if(iflag.eq.3) then
*      Termination: The following MUST always be done
*      (i) Move to the correct PAW subdirectory
*
       call hcdir('//PAWC/'//xxxx,' ')
*
* Histo normalization
*
       do jcut=1,ncut
        id=10+jcut-1
        call HZHINRM(id,0,nev(jcut),1)
C*TC>
        call hzhinfo(id,nev(jcut))
C*TC<
       enddo
       id=0
       do j=1,3
        id=j+15
        call HZHINRM(id,0,nw(j),1)
        call HZHINRM(id+100,0,nw(j),1)
C*TC>
        call hzhinfo(id,nw(j))
        call hzhinfo(id+100,nw(j))
C*TC<
       enddo
       call HZHINRM(14,0,neecor1,1)
       call HZHINRM(114,0,neecor1,1)
       call HZHINRM(15,0,neecor2,1)
       call HZHINRM(115,0,neecor2,1)
C*TC>
        call hzhinfo(14,neecor1)
        call hzhinfo(114,neecor1)
        call hzhinfo(15,neecor2)
        call hzhinfo(115,neecor2)
C*TC<
*
* for seagull
       Call hopera(22 ,'/',21,  19,1.,1.)
       Call hopera(24 ,'/',23,  20,1.,1.)
       Call hopera(122,'/',121,119,1.,1.)
C*TC>
        call hzhinfo(121,nww)
C*TC<
*
* correct error treatment for MC-seagull
*      sig_a**2 = <a**2> - <a>**2
*      err_a**2 = sig_a**2/n
*      a=pt2 n=121  119=<a>
*      221=<a**2>
       Call Hopera(221,'/',121,221,1.,1.)
*      321=<a>**2
       Call Hopera(119,'*',119,321,1.,1.)
*      321=<a**2> - <a>**2
       call Hopera(221,'-',321,321,1.,1.)
*      321=(<a**2> - <a>**2)/n
       Call Hopera(321,'/',121,321,1.,1.)
       Call Hunpak(321,errpts,' ',0)
       Do i=1,nxfsbin
C        write(6,*) ' errpts= ',errpts(i)
        errpts(i)= sqrt(errpts(i))
       enddo
       Call Hpake(119,errpts)
C*TC>
        call hzhinfo(119,nww)
C*TC<
*
* Add stat. and syst. errors for data
*
* energy flow  cms
       Do i=1,ncbin
        errl(i)=sqrt(els(i)**2+ely(i)**2)
        errg(i)=sqrt(egs(i)**2+egy(i)**2)
       enddo
*
* eecor low X
       Do i=1,nee1bin
        erre1(i)=sqrt(eest1(i)**2+eesys1(i)**2)
       enddo
* eecor high X
       Do i=1,nee2bin
        erre2(i)=sqrt(eest2(i)**2+eesys2(i)**2)
       enddo
* xf spectra
       Do i=1,nxfbin
        errw1(i)=sqrt(estatw1(i)**2+esysw1(i)**2)
        errw2(i)=sqrt(estatw2(i)**2+esysw2(i)**2)
        errw3(i)=sqrt(estatw3(i)**2+esysw3(i)**2)
       enddo
* seagull
       Do i=1,nxfsbin
        errpts(i)=sqrt(eptsstat(i)**2+eptssys(i)**2)
       enddo
*
*
*      Deal with data plots
* lab
       Call hpak (-12,el)
       Call hpak (-13,eg)
       Call hpake(-12,eel)
       Call hpake(-13,deg)
* cms
       Call hpak (-10,etl)
       Call hpak (-11,etg)
       Call hpake(-10,errl)
       Call hpake(-11,errg)
       Call hpak (-210,etl)
       Call hpak (-211,etg)
       Call hpake(-210,els)
       Call hpake(-211,egs)
*
* energy energy cor
*
* low X
       Call hpak (-14,omeg1)
       Call hpake(-14,erre1)
       Call hpak (-214,omeg1)
       Call hpake(-214,eest1)
*
* high X
       Call hpak (-15,omeg2)
       Call hpake(-15,erre2)
       Call hpak (-215,omeg2)
       Call hpake(-215,eest2)
*
* xf spectra
       Call hpak (-161,xfd)
       Call hpak (-162,w1)
       Call hpak (-116,w1)
       Call hpak (-216,w1)
       Call hpak (-172,w2a)
       Call hpak (-117,w2a)
       Call hpak (-217,w2a)
       Call hpak (-182,w3)
       Call hpak (-118,w3)
       Call hpak (-218,w3)
       Call hpake (-162,errw1)
       Call hpake (-172,errw2)
       Call hpake (-182,errw3)
       Call hpake (-216,estatw1)
       Call hpake (-217,estatw2)
       Call hpake (-218,estatw3)
*
* seagull

       call hpak (-191,xfs)
       call hpak (-192,pts)
       call hpake (-192,errpts)
       call hpak (-119,pts)
       call hpake (-119,errpts)
       call hpak (-219,pts)
       call hpake (-219,eptsstat)
*
*
* Evaluate chi**2
*
*energy flows
       call hzchisq(-10,10)
       call hzchisq(-11,11)
       call hzchisq(-12,12)
       call hzchisq(-13,13)
       call hzchisq(-210,10)
       call hzchisq(-211,11)
*
*  eecor
       call hzchisq(-14,114)
       call hzchisq(-15,115)
       call hzchisq(-214,114)
       call hzchisq(-215,115)
*
* xf spectra / seagull
       call hzchisq(-116,116)
       call hzchisq(-117,117)
       call hzchisq(-118,118)
       call hzchisq(-119,119)
       call hzchisq(-216,116)
       call hzchisq(-217,117)
       call hzchisq(-218,118)
       call hzchisq(-219,119)
*
* delete aux. histos
       call hdelet (21)
       call hdelet (22)
       call hdelet (23)
       call hdelet (24)
       call hdelet (121)
       call hdelet (221)
       call hdelet (321)
       call hdelet (122)
*
      Endif
*
      RETURN
      END
