*CMZ :  1.01/11 09/12/97  16.44.12  by  Tancredi Carli
*CMZ :  1.01/07 10/10/97  19.46.50  by  Tancredi Carli
*CMZ :  1.01/05 04/09/96  17.44.20  by   Tancredi Carli
*CMZ :  1.00/02 12/03/96  19.18.00  by  Tancredi Carli
*CMZ :  0.00/09 16/02/96  17.15.47  by  Tancredi Carli
*CMZ :  0.00/08 15/02/96  12.30.10  by  Tancredi Carli
*CMZ :  0.00/06 02/02/96  19.54.21  by  Tancredi Carli
*-- Author :  Tancredi Carli   10/01/96
      subroutine HZ95072(IFLAG)
****************************************************************************
* Purpose: produced histograms for:
*          the charged particle multiplicity versus Q
*          the mean and the width of the ln(1/xp) distribution vs Q
*
* Event selection:
* Eel>14 ?
*
* Running:  HERA running 1993
* Reference:
* Arguments: iflag=1 initialisation
*            iflag=1 filling
*            iflag=3 termination
*
* written by: Tancredi Carli and Renate Mohr
*             (carli@mail.desy.de mohr@mail.desy.de)
****************************************************************************
      IMPLICIT NONE
*
#include "hzfunc.inc"
#include "hzhbook.inc"
#include "hepevtp.inc"
#include "heracmn.inc"
*
      Integer iquest
      COMMON/QUEST/IQUEST(100)
*
      Integer iflag,ihep,i,j,k,l
*     DESY Preprint number
      Character*5 xxxx
*
      Real VMIN,VMAX
      integer nxpbin
      parameter (nxpbin=11)
      Integer ierr,ibeam,igam
      Double precision pbeam(4),pgam(4),pbrt(4),plab(4),ph(5)
      Integer limup,limlo
      Real xp,xpmean
      Real par(3), step(3), pmin(3),pmax(3),sigpar(3),chi2
*
      Real pi,rd,ee,eb
      Logical evcut,lp
      Integer jcut,iel,idum,id,ibin,ivec
      Parameter (pi=3.1415927,rd=180./pi,ee=26.7)
      Integer nentry
      Real nev(nxpbin)
      Data lp/.false./,nentry/0/
      Real x,y,q2,w2,enel,efwd,th
      Real xmi,xma,ymi,yma
      Integer nx,ny,nwt,loc
      Character chtitl*80
*
      real sqrtq(nxpbin+1),q2aux(nxpbin+1)
      real peak(nxpbin),width(nxpbin),epeak(nxpbin),ewidth(nxpbin)
      real mult(nxpbin),emult(nxpbin)
      real q(nxpbin),qdata(nxpbin)

      save nev

******************************************************************************
      Data xxxx/'95072'/
* Data points from plots
*
       data q2aux/12.,15.,20.,40.,60.,80.,100.,175.,250.
     &                   ,450.,1000.,8000./
       data qdata/3.59,4.11,5.25,6.93,8.28,0.,12.35,14.44,18.03,
     &                   24.90,29.28/
       do i=1,nxpbin+1
        sqrtq(i)=sqrt(q2aux(i))
       enddo
*
       data peak  /1.41,1.47,1.63,1.91,2.00,0.,2.23,2.12,2.72,2.70,2.62/
       data width /0.83,0.72,0.71,0.83,0.83,0.,1.00,1.28,1.24,0.80,0.88/
       data mult  /1.54,1.77,2.18,2.60,3.20,0.,4.05,4.73,4.75,5.43,6.27/
       data epeak /0.13,0.10,0.09,0.11,0.12,0.,0.39,0.34,0.29,0.13,0.28/
       data ewidth/0.14,0.07,0.04,0.10,0.12,0.,0.71,0.50,0.45,0.15,0.39/
       data emult /0.11,0.10,0.08,0.13,0.19,0.,0.58,0.35,0.32,0.39,1.20/

*
*******************************************************************************
*
******************************************************************************
      NENTRY=NENTRY+1
*
      IF (iflag.eq.1) then
*
*      Initialisation: The following MUST always be done
*      (i) make subdirectory in PAWC
*       - use the name as the xxxxxx in HZxxxxxx subroutine
*      (i) make subdirectory in o/p file
*
       Call hcdir('//PAWC',' ')
       call hmdir(xxxx,'S')
       Call hcdir('//HISTO',' ')
       call hmdir(xxxx,'S')
*
       Do i=1,nxpbin
        nev(i)=0.
       enddo
*
*      book your histograms  (data: ID<0)
*                                     (VZERO, VMIN, VMAX see CERNLIB F121)
*      non-equidistant binning
       call hbookb(-10,'Q vs ln(1/Xp)peak ',nxpbin,sqrtq,0.)
       call hbookb(-20,'Q vs ln(1/Xp)width',nxpbin,sqrtq,0.)
       call hbookb(-30,'Q vs nch          ',nxpbin,sqrtq,0.)
       call hbook1(-101,'x-axis peak/width',nxpbin,0.,
     & real(nxpbin+1.),0.)
*      MC Histos
       call hbookb(10,'MC  Q vs ln(1/Xp)peak ',nxpbin,sqrtq,0.)
       call hbookb(20,'MC  Q vs ln(1/Xp)width',nxpbin,sqrtq,0.)
       call hbookb(30,'MC  Q vs nch          ',nxpbin,sqrtq,0.)
       call hbookb(31,'MC  Q vs nch aux      ',nxpbin,sqrtq,0.)
*      MC auxiliary histograms
       do ibin=1,nxpbin
        call hbook1(110+ibin,'MC  dN/dln(1/Xp)',50,0.,7.,0.)
       enddo
*
*********************************************************************
*
      Else if(iflag.eq.2) then
*      Filling: The following MUST always be done
*      (i) move to the correct sub-directory in PAWC
*
       call hcdir('//PAWC/'//xxxx,' ')
*
*      Event selection
*
       q2=real(HZDISKIN(1))
       x =real(HZDISKIN(2))
       y =real(HZDISKIN(3))
       w2=real(HZDISKIN(4))
*
       if (lp) write(6,*) 'Hz'//xxxx,
     & ' x= ',x,' q2 ',q2,' y= ',y,' w2= ',w2
*
*      get position of scattered electron, energy,Pt and polar angle
*
       iel=HZIDELEC(idum)
       if (iel.eq.-1) then
        write(6,*) 'Hz'//xxxx,' electron not found '
        return
       endif
       enel=real(PHEP(4,iel))
*
*      cut on forward energy
*
       efwd=0.
       Do 5 ihep=1,nhep
        if (isthep(ihep).ne.1.or.ihep.eq.iel) goto 5
        th=real(HZPHMANG(PHEP(3,ihep),
     &              sqrt(PHEP(1,ihep)**2+PHEP(2,ihep)**2)))*rd
        if(th.gt.4.4.and.th.lt.15.) then
         efwd=real(PHEP(4,ihep))+efwd
        endif
 5     continue
*
*      cut on kinematics
*
       evcut= enel.gt.14.
       evcut= w2.ge.3000..and. evcut
       evcut= y.lt.0.6.and. evcut
       evcut=efwd.gt.0.5.and.evcut
       if (lp) write(6,*) 'Hz'//xxxx,
     &                         ' efwd= ',efwd,' evcut= ',evcut
       if (.not.evcut) return
*
*      set up Breit frame boost needed later
*
       ierr=HZIBEAM(ibeam,idum)
       if (.not.(ierr.eq.1)) then
        write(6,*) 'HZ'//xxxx,' beams not found ! '
        return
       else
        Do i=1,4
         pbeam(i)=PHEP(i,IBEAM)
        enddo
       endif
*
       eb=real(PHEP(4,idum))
       if (abs(abs(eb)-ee).gt.0.2) then
        if (nentry.lt.10) then
         write(6,*) 'HZ'//xxxx,' Electron beam not at ',ee,'  ! '
        elseif (nentry.eq.10) then
         write(6,*) 'HZ'//xxxx,' Electron beam not at ',ee,
     &   ' ...last message ! '
        endif
C        return
       endif
*
       ierr=HZIPGAM(ph)
       if (ierr.eq.-1) then
        write(6,*) 'HZ'//xxxx,' boson vector not found ! '
C        call VZERO(ph,5)
        Do i=1,5
         ph(i)=0.
        enddo
       else
        Do i=1,4
         pgam(i)=ph(i)
        enddo
       endif
*
       Call hzbrtini(pbeam,pgam,ierr)
       if (ierr.eq.1) then
        write(6,*) 'HZ'//xxxx,' problem with boost to cms ! '
        return
       endif
*
*      get bin number
*
       ibin=-1
       Do i=1,nxpbin
        if (lp) write(6,*) i,q2aux(i),' < ',q2,' < ',q2aux(i+1)
        if (q2.ge.q2aux(i).and.q2.lt.q2aux(i+1)) ibin=i
       enddo
       if (ibin.le.0) then
        if (lp) write(6,*) 'hz',xxxx,' q2 in no bin= ',q2
        return
       endif
*
       do 30 ihep = 1, nhep
        If(isthep(ihep).eq.1.and.ihchrg(ihep).ne.0
     +     .and.ihep.ne.iel) then
C        idpart=abs(idhep(jmohep(1,ihep)))
C        If(idpart.eq.310.or.idpart.eq.3122) goto 30
         do ivec=1,4
          plab(ivec) = phep(ivec,ihep)
         enddo
         Call hzbrt(plab,pbrt,ierr)
         if(real(pbrt(3)).lt.0.) then
          xp = 2.*real(sqrt(pbrt(1)**2+pbrt(2)**2+pbrt(3)**2))
     +        /sqrt(q2)
          call hfill(110+ibin,log(1./xp),0.,wtx)
          call hfill(30   ,sqrt(q2),0.,wtx)
         endif
        Endif
 30     continue
*
        call hfill(31   ,sqrt(q2),0.,wtx)
        nev(ibin)=nev(ibin)+wtx
*
************************************************************************
*
      Else if(iflag.eq.3) then
*      Termination: The following MUST always be done
*      (i) Move to the correct PAW subdirectory
*
       call hcdir('//PAWC/'//xxxx,' ')
*
* Deal with data plots
*
       Call hpak (-10,peak)
       Call hpak (-20,width)
       Call hpak (-30,mult)
       Call hpake(-10,epeak)
       Call hpake(-20,ewidth)
       Call hpake(-30,emult)
       call hpak (-101,qdata)
*
*      normalise and fit data histograms
*
       Call hopera(30,'/e',31,30,1.,1.)

*
       do ibin=1,nxpbin
        id=110+ibin
        xpmean = hstati(id,1,' ',1)
        Call hgive(id,chtitl,nx,xmi,xma,ny,ymi,yma,nwt,loc)
        call hxi(id,xpmean+1.2,limup)
        call hxi(id,xpmean-1.2,limlo)
        iquest(11) = limlo
        iquest(12) = limup
        par(1)= hmax(id)
        par(2)= xpmean
        par(3)= hstati(id,2,' ',1)
C       write(6,*) ' limup= ',limup,' limlo= ',limlo
C       write(6,*) ' par= ',par
        Call hfithn(id,'G','NQR',3,par,step,pmin,pmax,sigpar,chi2)
*
        write(6,'(a,a,a,i4,3(a,f9.3))') 'Hz',xxxx,
     &  ' id= ',id,' mean= ',par(2),' sig= ',par(3),' chi2= ',chi2
*
        call hfill(10,sqrtq(ibin)+0.1,0.,par(2)*wtx)
        call hfill(20,sqrtq(ibin)+0.1,0.,par(3)*wtx)
        call hdelet(id)
       enddo
*
       call hdelet(31)
*
       call HZchisq(-10,20)
       call HZchisq(-20,20)
       call HZchisq(-30,30)
*
      Endif
*
      RETURN
      END
