*CMZ :  2.00/03 10/05/2000  19.37.50  by  Tancredi Carli
*CMZ :  1.01/11 09/12/97  16.44.12  by  Tancredi Carli
*CMZ :  1.01/07 10/10/97  19.46.50  by  Tancredi Carli
*CMZ :  1.01/05 06/09/96  18.38.41  by   Tancredi Carli
*CMZ :  1.01/03 15/05/96  19.46.03  by  Tancredi Carli
*CMZ :  1.01/02 08/04/96  15.46.47  by  Tancredi Carli
*CMZ :  1.00/02 12/03/96  18.45.28  by  Tancredi Carli
*CMZ :  0.00/09 16/02/96  17.15.48  by  Tancredi Carli
*CMZ :  0.00/08 15/02/96  12.24.24  by  Tancredi Carli
*CMZ :  0.00/06 05/02/96  11.29.20  by  Tancredi Carli
*CMZ :  0.00/05 24/01/96  13.46.24  by  Renate Mohr
*-- Author :  Tancredi Carli   10/01/96
      subroutine HZ95108(IFLAG)
****************************************************************************
* Purpose: produce histograms for:
*           o) energy flows in cms as a fct. of x,Q**2
*           o) mean Et in cms central rapidity bin vs. x,Q2
*
* Event selection:
* Eel>12 GeV, 173.0>Thel>157.0, w2>4400 GeV**2 and cut on forward energy
*
* Running: Ee=26.7, Ep=820, no polarization, HERA running 1993
* Reference: Phys. Lett. B356 (1995) 118, DESY 95-108
* Arguments: iflag=1 initialisation
*            iflag=1 filling
*            iflag=3 termination
*
* written by: Michael Kuhlen (kuhlen@desy.de)
* Modified: add hzchisq
*           add systematic error to e-flows added (overall 10% guess!!!)
*           avoide division by zero in normalisation, if nev(ibin)=0
*                                 T. Carli May 2000 (thanks B. Levtcheko)
****************************************************************************
      IMPLICIT NONE
*
#include "hzfunc.inc"
#include "hzhbook.inc"
#include "hepevtp.inc"
#include "heracmn.inc"
*
      Integer iflag,ihep,i,j,k,l
*     DESY Preprint number
      Character*5 xxxx
      Data xxxx/'95108'/
      character*30 string
*
      Real pi,dpi,rd,ee,eb,dphi
      Logical evcut,lp
      Integer jcut,ncut,iel,idum,id
      Parameter (ncut=4,pi=3.1415927,dpi=2.*pi,rd=180./pi,ee=26.7)
      Integer nentry,nevnt(2)
      Real nev(9)
      Data nev/9*0./,lp/.false./,nentry/0/
      real etmean(9),xmean(9),q2mean(9), zeroes(9), etcent
      data etmean,xmean,q2mean,zeroes /9*0.,9*0.,9*0.,9*0/
      Real x,y,q2,w2,enel,ptel,thel,efwd,th,rap,pt,et,p,costh
      Real xmi,xma,ymi,yma
      Integer nx,ny,nwt,loc,ibin
      Character chtitl*80
*
      Integer ierr,ibeam,igam
      Double precision pbeam(4),pgam(4),pcm(4),ph(5),phc(4)
*
*
*********************************************************************
*
*                      data points from H1
*
*********************************************************************
      Real xmin,xmax
      Integer nb,nbin
      Parameter (nb=24,xmin=-6.,xmax=6.,nbin=9)
      Real et1(nb),et2(nb),et3(nb),et4(nb),et5(nb)
      Real et6(nb),et7(nb),et8(nb),et9(nb)
      Real eet1(nb),eet2(nb),eet3(nb),eet4(nb),eet5(nb)
      Real eet6(nb),eet7(nb),eet8(nb),eet9(nb)
      Real set1(nb),set2(nb),set3(nb),set4(nb),set5(nb)
      Real set6(nb),set7(nb),set8(nb),set9(nb)
*
*     energy flow data in the 9 bins
*     note: systematic errors are not included
*
      Data  et1/0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,
     &          1.746,1.993,2.010,2.221,1.986,2.036,2.209,2.199,1.922,
     &          2.022,1.893,1.021,0.515,0.150,0.000/
      Data eet1/0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,
     &          0.116,0.113,0.115,0.126,0.119,0.142,0.178,0.170,0.129,
     &          0.144,0.144,0.088,0.060,0.026,0.000/
      Data  et2/0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,
     &          1.686,1.833,2.108,2.073,1.965,1.965,2.242,1.978,2.016,
     &          1.772,1.958,0.980,0.306,0.124,0.026/
      Data eet2/0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,
     &          0.164,0.083,0.094,0.094,0.093,0.098,0.131,0.121,0.110,
     &          0.094,0.115,0.069,0.029,0.017,0.005/
      Data  et3/0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,
     &          1.696,1.841,2.043,2.278,2.073,1.983,2.181,2.282,2.251,
     &          2.158,1.687,0.951,0.392,0.112,0.032/
      Data eet3/0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,
     &          0.112,0.079,0.087,0.104,0.095,0.098,0.116,0.142,0.125,
     &          0.113,0.098,0.064,0.032,0.014,0.006/
      Data  et4/0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,
     &          0.000,1.735,1.866,2.035,1.977,2.106,1.974,2.099,2.018,
     &          1.983,1.435,0.668,0.276,0.088,0.000/
      Data eet4/0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,
     &          0.000,0.087,0.093,0.098,0.097,0.121,0.122,0.133,0.118,
     &          0.115,0.092,0.049,0.029,0.013,0.000/
      Data  et5/0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,
     &          0.000,1.667,1.880,1.877,1.993,1.915,2.074,2.011,2.045,
     &          1.742,1.058,0.454,0.156,0.038,0.000/
      Data eet5/0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,
     &          0.000,0.124,0.091,0.085,0.096,0.108,0.115,0.110,0.111,
     &          0.099,0.065,0.037,0.017,0.007,0.000/
      Data  et6/0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,
     &          0.000,0.000,1.516,1.805,2.099,1.926,1.860,2.115,1.755,
     &          1.499,0.843,0.271,0.079,0.000,0.000/
      Data eet6/0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,
     &          0.000,0.000,0.095,0.104,0.126,0.122,0.117,0.139,0.110,
     &          0.122,0.074,0.027,0.011,0.000,0.000/
      Data  et7/0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,
     &          1.764,1.870,2.024,2.212,2.062,2.188,2.319,2.392,2.309,
     &          2.367,1.655,0.797,0.325,0.129,0.000/
      Data eet7/0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,
     &          0.142,0.088,0.095,0.106,0.102,0.126,0.145,0.149,0.137,
     &          0.137,0.099,0.056,0.029,0.017,0.000/
      Data  et8/0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,
     &          0.000,1.877,1.926,2.037,2.106,2.224,2.110,2.280,2.156,
     &          1.998,1.175,0.532,0.152,0.046,0.000/
      Data eet8/0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,
     &          0.000,0.140,0.101,0.105,0.115,0.129,0.128,0.151,0.144,
     &          0.124,0.075,0.043,0.017,0.008,0.000/
      Data  et9/0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,
     &          0.000,0.000,1.485,1.965,2.183,2.169,2.091,2.445,2.233,
     &          1.405,0.709,0.205,0.082,0.000,0.000/
      Data eet9/0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,
     &          0.000,0.000,0.107,0.133,0.156,0.146,0.154,0.181,0.176,
     &          0.105,0.061,0.023,0.015,0.000,0.000/
*
      Data set1/24*0.1/
      Data set2/24*0.1/
      Data set3/24*0.1/
      Data set4/24*0.1/
      Data set5/24*0.1/
      Data set6/24*0.1/
      Data set7/24*0.1/
      Data set8/24*0.1/
      Data set9/24*0.1/
*
*     Data total Et versus x
*     note: full systematic errors included, except a 9% overall scale error
*
      Real etx(nbin),eetx(nbin),xx(nbin),qq(nbin)
      Data  etx/2.12,2.09,2.17,1.95,1.87,1.60,2.12,1.99,1.75/
      Data eetx/0.15,0.12,0.12,0.12,0.11,0.12,0.12,0.13,0.17/
      Data   xx/0.16e-3,0.3e-3,0.37e-3,0.63e-3,1.10e-3,2.30e-3,
     &          0.93e-3,2.10e-3,4.90e-3/
      Data   qq/6.8,8.6,13.1,14.2,14.0,14.5,28.8,30.9,32.6/
*
*********************************************************************
*
*                      Initialization
*
*********************************************************************
      NENTRY=NENTRY+1
*
      IF (iflag.eq.1) then
*
*
*      Initialisation: The following MUST always be done
*      (i) make subdirectory in PAWC
*       - use the name as the xxxxxx in HZxxxxxx subroutine
*      (i) make subdirectory in o/p file
*
       Call hcdir('//PAWC',' ')
       call hmdir(xxxx,'S')
       Call hcdir('//HISTO',' ')
       call hmdir(xxxx,'S')
*                                             book data et-flow histos
       Do i=1,nbin
        write(string,'(A,I2)') ' dEt/d[c] CMS bin= ',i
        call hbook1(-10-i,string,nb,xmin,xmax, 0.)
        call hbook1(   -i,string,nb,xmin,xmax, 0.)
*
        call hbook1(i,string,nb,xmin,xmax, 0.)
        write(string,'(A,I2)') ' stat dEt/d[c] CMS bin= ',i
        call hbook1(10+i,string,nb,xmin,xmax, 0.)
*
       enddo
*                                             book data mean et, x, q2
       call hbook1(-21,' <Et> ',9,1.,10., 0.)
       call hbook1(-22,' <x>  ',9,1.,10., 0.)
       call hbook1(-23,' <q2> ',9,1.,10., 0.)
*
*
*      pack data into histograms
*      pack data et/deta in the 9 bins into histograms
*
       Call hpak (-11,et1)
       Call hpake(-11,eet1)
       Call hpak (-12,et2)
       Call hpake(-12,eet2)
       Call hpak (-13,et3)
       Call hpake(-13,eet3)
       Call hpak (-14,et4)
       Call hpake(-14,eet4)
       Call hpak (-15,et5)
       Call hpake(-15,eet5)
       Call hpak (-16,et6)
       Call hpake(-16,eet6)
       Call hpak (-17,et7)
       Call hpake(-17,eet7)
       Call hpak (-18,et8)
       Call hpake(-18,eet8)
       Call hpak (-19,et9)
       Call hpake(-19,eet9)
*
*      add sytematic and statistical error
*
       Do i=1,nb

        set1(i)=et1(i)*set1(i)
        eet1(i)=sqrt(eet1(i)**2+set1(i)**2)
        set2(i)=et2(i)*set2(i)
        eet2(i)=sqrt(eet2(i)**2+set2(i)**2)
        set3(i)=et3(i)*set3(i)
        eet3(i)=sqrt(eet3(i)**2+set3(i)**2)
        set4(i)=et4(i)*set4(i)
        eet4(i)=sqrt(eet4(i)**2+set4(i)**2)
        set5(i)=et5(i)*set5(i)
        eet5(i)=sqrt(eet5(i)**2+set5(i)**2)
        set6(i)=et6(i)*set6(i)
        eet6(i)=sqrt(eet6(i)**2+set6(i)**2)
        set7(i)=et7(i)*set7(i)
        eet7(i)=sqrt(eet7(i)**2+set7(i)**2)
        set8(i)=et8(i)*set8(i)
        eet8(i)=sqrt(eet8(i)**2+set8(i)**2)
        set9(i)=et9(i)*set9(i)
        eet9(i)=sqrt(eet9(i)**2+set9(i)**2)
       enddo
*
       Call hpak (-1,et1)
       Call hpake(-1,eet1)
       Call hpak (-2,et2)
       Call hpake(-2,eet2)
       Call hpak (-3,et3)
       Call hpake(-3,eet3)
       Call hpak (-4,et4)
       Call hpake(-4,eet4)
       Call hpak (-5,et5)
       Call hpake(-5,eet5)
       Call hpak (-6,et6)
       Call hpake(-6,eet6)
       Call hpak (-7,et7)
       Call hpake(-7,eet7)
       Call hpak (-8,et8)
       Call hpake(-8,eet8)
       Call hpak (-9,et9)
       Call hpake(-9,eet9)
*                                       pack total Et against x into histos
       Call hpak (-22,xx)
       Call hpak (-21,etx)
       Call hpake(-21,eetx)
*
*                                       book your histograms  (data: ID<0)
*                                       Et flows in the 9 bins
C       call hbook1( 11,'dEt/deta CMS bin1',24,-6.,6.,0.)
C       call hbook1( 12,'dEt/deta CMS bin2',24,-6.,6.,0.)
C       call hbook1( 13,'dEt/deta CMS bin3',24,-6.,6.,0.)
C       call hbook1( 14,'dEt/deta CMS bin4',24,-6.,6.,0.)
C       call hbook1( 15,'dEt/deta CMS bin5',24,-6.,6.,0.)
C       call hbook1( 16,'dEt/deta CMS bin6',24,-6.,6.,0.)
C       call hbook1( 17,'dEt/deta CMS bin7',24,-6.,6.,0.)
C       call hbook1( 18,'dEt/deta CMS bin8',24,-6.,6.,0.)
C       call hbook1( 19,'dEt/deta CMS bin9',24,-6.,6.,0.)

*                                       <ET> in central rapidity bin

       call hbook1( 21,'<Et> vs kin. bin',9,1.,10.,0.)
       call hbook1( 22,'<x>  vs kin. bin',9,1.,10.,0.)
       call hbook1( 23,'<Q2> vs kin. bin',9,1.,10.,0.)
       call hbook1( 24,'# events vs kin. bin',9,1.,10.,0.)
*                                       correct errors
       call hbarx(21)
       call hbarx(22)
       call hbarx(23)
       call hbarx(24)
*
*********************************************************************
*
*                      Event Processing
*
*********************************************************************

      Else if(iflag.eq.2) then

*      Filling: The following MUST always be done
*      (i) move to the correct sub-directory in PAWC
*
       call hcdir('//PAWC/'//xxxx,' ')
*
*                                             Event selection
*
       q2=real(HZDISKIN(1))
       x =real(HZDISKIN(2))
       y =real(HZDISKIN(3))
       w2=real(HZDISKIN(4))
*
       if (lp) write(6,*) 'Hz'//xxxx,
     & ' x= ',x,' q2 ',q2,' y= ',y,' w2= ',w2
*
*                                             get electron variables
*
       iel=HZIDELEC(idum)
       if (iel.eq.-1) then
        write(6,*) 'Hz'//xxxx,' electron not found '
        goto 9990
       endif
       enel=real(PHEP(4,iel))
       thel=real(HZPHMANG(PHEP(3,iel),
     &               sqrt(PHEP(1,iel)**2+PHEP(2,iel)**2)))*rd
       if (lp) write(6,*) 'Hz'//xxxx,
     & ' enel= ',enel,' thel= ',thel
*
*                                             kinematic selection
*
       evcut= enel.gt.12.
       evcut= thel.gt.157. .and. thel.lt.173.0 .and. evcut
       evcut= w2.ge.4400..and. evcut
       if(.not.evcut) goto 9990
*
*                                             cut on forward energy
*
       efwd=0.
       Do ihep=1,nhep
        if (isthep(ihep).eq.1.and.ihep.ne.iel) then
         th=real(HZPHMANG(PHEP(3,ihep),
     &              sqrt(PHEP(1,ihep)**2+PHEP(2,ihep)**2)))*rd
         if(th.gt.4.4.and.th.lt.15.) then
          efwd=real(PHEP(4,ihep))+efwd
         endif
        endif
       enddo
       if (lp) write(6,*) 'Hz'//xxxx,
     & ' efwd= ',efwd,' evcut= ',evcut
       if(efwd.lt.0.5) goto 9990
*
*                                             find the kinematic bin number
       ibin = 0
       if(    q2.gt. 5..and.q2.le.10.) then
         if(x.gt.0.0001.and.x.le.0.0002) ibin=1
         if(x.gt.0.0002.and.x.le.0.0005.and.q2.gt.6.) ibin=2
       elseif(q2.gt.10..and.q2.le.20.) then
         if(x.gt.0.0002.and.x.le.0.0005) ibin=3
         if(x.gt.0.0005.and.x.le.0.0008) ibin=4
         if(x.gt.0.0008.and.x.le.0.0015) ibin=5
         if(x.gt.0.0015.and.x.le.0.0040) ibin=6
       elseif(q2.gt.20..and.q2.le.50.) then
         if(x.gt.0.0005.and.x.le.0.0014) ibin=7
         if(x.gt.0.0014.and.x.le.0.0030) ibin=8
         if(x.gt.0.0030.and.x.le.0.0100) ibin=9
       endif
*
*                                             events in 9 bins only
       if( ibin.eq.0) goto 9990
*                                             set up CMS boost needed later
*
       ierr=HZIBEAM(ibeam,idum)
       if (.not.(ierr.eq.1)) then
        write(6,*) 'HZ'//xxxx,' beams not found ! '
        goto 9990
       else
        Do i=1,4
         pbeam(i)=PHEP(i,IBEAM)
        enddo
       endif
*
       eb=real(PHEP(4,idum))
       if (abs(abs(eb)-ee).gt.0.2) then
        if (nentry.lt.10) then
         write(6,*) 'HZ'//xxxx,' Electron beam not at ',ee,'  ! '
        elseif (nentry.eq.10) then
         write(6,*) 'HZ'//xxxx,' Electron beam not at ',ee,
     &   ' ...last message ! '
        endif
C        goto 9990
       endif
*
       ierr=HZIPGAM(ph)
       if (ierr.eq.-1) then
        write(6,*) 'HZ'//xxxx,' boson vector not found ! '
C        call VZERO(ph,5)
        Do i=1,5
         ph(i)=0.
        enddo
       else
        Do i=1,4
         pgam(i)=ph(i)
        enddo
       endif
*
       call HZHCMINI(pbeam,pgam,ierr)
       if (ierr.eq.1) then
        write(6,*) 'HZ'//xxxx,' problem with boost to cms ! '
        goto 9990
       endif
*
*                                             loop over objects
*
*
*                                             et in central rapidity bin
       etcent = 0.
       do 2000 ihep=1,nhep
*                                             skip unstable particles and el.
       if (isthep(ihep).ne.1.or.ihep.eq.iel) goto 2000
*
*                                             transform in CMS
*
           Do i=1,4
            Phc(i)=PHEP(i,ihep)
           enddo
           call HZHCM(phc,pcm,ierr)
           if (ierr.eq.1) then
            write(6,*) 'HZ'//xxxx,' problem with boost to cms ! '
            goto 9990
           endif

*                                             get particle momenta

           p      = real(sqrt(pcm(1)**2+pcm(2)**2+pcm(3)**2 ))
           pt     = real(sqrt( pcm(1)**2+pcm(2)**2 ))
           if (p.eq.0.) then
            write(6,*) xxxx,' p = ',p
            goto 2000
           else
            et     = real(pcm(4)) * pt / p
            th     = (acos(real(pcm(3))/p))
            if (abs(     th*rd).lt.1.e-4 .or.
     &          abs(180.-th*rd).lt.1.e-4 ) then
C             write(6,*) xxxx,' th = ',th
             goto 2000
            else
             rap    = -log(tan( th/2. ))
*                                            check on rap=nan (e.g. pt=0)
              if (rap.ne.rap) then
               write(6,*) xxxx,'Warning:  rap = ',rap,' th= ',th*rd,
     &         ' particle skipped ! '
               goto 2000
              endif
            endif
           endif
*
           if (lp) write(6,*) 'Hz'//xxxx,
     &     'lab: et,pt,rap,th ',et,pt,rap,th*rd

*                                             fill histos
           call hf1(10+ibin, rap, et*wtx )
           call hf1(   ibin, rap, et*wtx )
*                                             accumulate Et in central rap.
           if(rap.gt.-0.5.and.rap.lt.0.5) then
              etmean(ibin) = etmean(ibin) + et
              etcent = etcent + et
           endif
*                                             end loop over objects
 2000  continue
*
*                                             count the accepted events
       nev(ibin)   = nev(ibin)+wtx
*                                             average x
       xmean(ibin) = xmean(ibin) + x
*                                             average Q2
       q2mean(ibin)= q2mean(ibin) + q2
       call hf1(21,real(ibin),etcent*wtx)
       call hf1(22,real(ibin),x*wtx)
       call hf1(23,real(ibin),q2*wtx)
*                                             norm. histo for event counting
       call hf1(24,real(ibin),wtx)
*                                              end of event processing
 9990  continue


*********************************************************************
*
*                      Termination
*
*********************************************************************

      Else if(iflag.eq.3) then

*      Termination: The following MUST always be done
*      (i) Move to the correct PAW subdirectory
*
       call hcdir('//PAWC/'//xxxx,' ')
*                                              normalize Et flow histos
       do ibin=1,9
        id=10+ibin
        Call hgive(id,chtitl,nx,xmi,xma,ny,ymi,yma,nwt,loc)
        if (nev(ibin).ne.0) then
        Call hopera(id,'+E',id,id,
     +          1./real(nev(ibin))*real(nx)/(xma-xmi),0.)
        else
         write(6,*) id,' norm nev,nx,xma,xmi ',nev(ibin),nx,xma,xmi
        endif
C
C*TC>
        call hzhinfo(id,nev(ibin))
C*TC<
        call hzchisq(-id,id)
       enddo
       do ibin=1,9
        id=ibin
        Call hgive(id,chtitl,nx,xmi,xma,ny,ymi,yma,nwt,loc)
        if (nev(ibin).ne.0) then
        Call hopera(id,'+E',id,id,
     +          1./real(nev(ibin))*real(nx)/(xma-xmi),0.)
        else
         write(6,*) id,' norm nev,nx,xma,xmi ',nev(ibin),nx,xma,xmi
        endif
C        write(6,*) id,' norm nev,nx,xma,xmi ',nev(ibin),nx,xma,xmi
C*TC>
        call hzhinfo(id,nev(ibin))
C*TC<
        call hzchisq(-id,id)
       enddo
*                                              normalize mean Et,x,q2
*                                              fill histos with that info
*                                              set errors of norm. histo 0
       call hpake(24,zeroes)
       do id=21,23
        Call hopera(id,'/E',24,id,1.,1.)
       enddo
*
       call hzchisq(-21,21)
*
       do ibin=1,9
C*TC>
        call hzhinfo(1000+ibin,nev(ibin))
C*TC<
*
        if (nev(ibin).ne.0.) then
         etmean(ibin)=etmean(ibin)/nev(ibin)
         xmean(ibin) =xmean(ibin)/nev(ibin)
         q2mean(ibin)=q2mean(ibin)/nev(ibin)
        else
         etmean(ibin)=-999.
         xmean(ibin) =-999.
         q2mean(ibin)=-999.
        endif
       enddo
       write(6,'(a)')       'hz95108: <et> in central rap. bin: '
       write(6,'(a,9f9.3)') ' <et> = ',etmean
       write(6,'(a,9f9.3)') ' <x>  = ',xmean
       write(6,'(a,9f9.3)') ' <q2> = ',q2mean

      endif
*
      RETURN
      END
