      subroutine hz96076(IFLAG)
***********************************************
* F2 data ZEUS
*
* The following is the ZEUS F2 measurement from the 1994 e+p data sample.
* They are published in the DESY pre-print 96-076 under the title
*
* "Measurement of the F2 structure function in deep-inelastic e+p
* scattering using 1994 data from the ZEUS detector at HERA"
*
***********************************************
      IMPLICIT NONE
*
      Real pi,dpi,rd,ee,eb,dphi,Qpi,qqradp,sigma_tot,xntot
      Logical lp
      data lp/.false./
*
      Character string*20
*
      real alph_em
      Parameter (alph_em=7.29927e-3)
      Real gev2nb,lum,fact

      Integer iqbin,i1,i3,idhisto,idpaw
      Parameter (gev2nb=0.389e6)
      Integer maxhi
      Parameter (maxhi=2000)
      Real nev(maxhi)
      Integer nentry
      Real n2,nall,nall2
      Real xw
      Data nall/0/
      Integer jcut,ncut,iel,idum,id,idq2,idx
      Parameter (ncut=4,pi=3.1415927,dpi=2.*pi,rd=180./pi,ee=27.5)
*
      Integer ierr,ibeam,igam
      Double precision pbeam(4),pgam(4),pcm(4),ph(5),phc(4)
*
      integer err_flag
      real x,y,w2,q2

      double precision dx,dq
      real f2pdf
      DOUBLE PRECISION XXX,QQ,UPV,DNV,USEA,DSEA,STR,CHM,BOT,TOP,GLU,
     +VAL(20)
      CHARACTER*20 PARM(20)
      Integer npdf
      DATA NPDF/0/,UPV,DNV,USEA,DSEA,STR,CHM,BOT,TOP,GLU/9*0.D0/
      LOGICAL PDFFIRST
      COMMON /W50516/PDFFIRST
*
*
* F2 data
*
      Integer nf2
      Parameter (nf2=11)
      Real xx1(2),yy1(2),eyy1(2),esy1(2)
      Real xx2(3),yy2(3),eyy2(3),esy2(3)
      Real xx3(11),yy3(11),eyy3(11),esy3(11)
      Real xx4(6),yy4(6),eyy4(6),esy4(6)
      Real xx5(10),yy5(10),eyy5(10),esy5(10)
      Real xx6(6),yy6(6),eyy6(6),esy6(6)
      Real xx7(9),yy7(9),eyy7(9),esy7(9)
      Real xx8(6),yy8(6),eyy8(6),esy8(6)
      Real xx9(10),yy9(10),eyy9(10),esy9(10)
      Real xx10(6),yy10(6),eyy10(6),esy10(6)
      Real xx11(10),yy11(10),eyy11(10),esy11(10)
      Real xx12(6),yy12(6),eyy12(6),esy12(6)
      Real xx13(9),yy13(9),eyy13(9),esy13(9)
      Real xx14(8),yy14(8),eyy14(8),esy14(8)
      Real xx15(10),yy15(10),eyy15(10),esy15(10)
      Real xx16(9),yy16(9),eyy16(9),esy16(9)
      Integer nxbin
	Parameter (nxbin=17)

      Real f2_1(nxbin),f2_2(nxbin),f2_3(nxbin)
      Real ef2_1(nxbin),ef2_2(nxbin),ef2_3(nxbin)
      Real eft_1(nxbin),eft_2(nxbin),eft_3(nxbin)
      Real f2_4(nxbin),f2_5(nxbin),f2_6(nxbin)
      Real ef2_4(nxbin),ef2_5(nxbin),ef2_6(nxbin)
      Real eft_4(nxbin),eft_5(nxbin),eft_6(nxbin)
      Real f2_7(nxbin),f2_8(nxbin),f2_9(nxbin)
      Real ef2_7(nxbin),ef2_8(nxbin),ef2_9(nxbin)
      Real eft_7(nxbin),eft_8(nxbin),eft_9(nxbin)
      Real f2_10(nxbin),f2_11(nxbin),f2_12(nxbin)
      Real ef2_10(nxbin),ef2_11(nxbin),ef2_12(nxbin)
      Real eft_10(nxbin),eft_11(nxbin),eft_12(nxbin)
      Real f2_13(nxbin),f2_14(nxbin),f2_15(nxbin),f2_16(nxbin)
      Real ef2_13(nxbin),ef2_14(nxbin),ef2_15(nxbin),ef2_16(nxbin)
      Real eft_13(nxbin),eft_14(nxbin),eft_15(nxbin),eft_16(nxbin)
	
* f2 data from ZEUS NPB 470 (1996) 3 DESY 96-076
*    f2 Q2=3.5 (bin 1)
      Data xx1/6.3e-05,1.0e-04/
      Data yy1/0.875,0.939/
      Data eyy1/0.052,0.040/
      Data esy1/0.092,0.0675/

*    f2 Q2=4.5 (bin 2)
      Data xx2/1.0e-04,1.6e-04,2.5e-04/
      Data yy2/1.030,1.038,0.932/
      Data eyy2/0.028,0.028,0.029/
      Data esy2/0.057,0.036,0.032/
*    f2 Q2=6.5 (bin 3)
      Data xx3/1.0e-04,1.6e-04,2.5e-04,4.0e-04,
     +         6.3e-04,1.0e-03,1.6e-03,2.5e-03,4.0e-03,
     +         1.6e-02,4.0e-02/
      Data yy3/1.221,1.138,1.038,0.951,0.841,0.776,
     +         0.753,0.645,0.629,0.495,0.403/
      Data eyy3/0.036,0.021,0.018,0.019,0.018,
     +          0.017,0.019,0.012,0.009,0.008,0.019/
      Data esy3/0.087,0.0425,0.0235,0.0295,0.0215,0.032,
     +          0.027,0.028,0.023,0.03,0.111/
*    f2 Q2=8.5 (bin 4)
      Data xx4/1.6e-04,2.5e-04,4.0e-04,6.3e-04,1.0e-03,1.6e-03/ 
      Data yy4/1.337,1.151,0.993,0.920,0.831,0.704/
      Data eyy4/0.037,0.024,0.021,0.019,0.018,0.017/
      Data esy4/0.0705,0.03,0.0235,0.0195,0.028,0.019/

*    f2 Q2=10 (bin 5)
      Data xx5/1.6e-04,2.5e-04,4.0e-04,6.3e-04,1.0e-03,
     +         1.6e-03,2.5e-03,6.3e-03,1.6e-02,8.1e-02/
      Data yy5/1.359,1.231,1.136,0.968,0.857,
     +         0.792,0.715,0.593,0.517,0.395/
      Data eyy5/0.075,0.032,0.026,0.022,0.021,
     +          0.021,0.018,0.008,0.007,0.010/
      Data esy5/0.096,0.043,0.026,0.0255,0.0235, 
     +          0.0215,0.031,0.0215,0.011,0.0785/

*    f2 Q2=12 (bin 6)
      Data xx6/2.5e-04,4.0e-04,6.3e-04,1.0e-03,1.6e-03,2.5e-03/
      Data yy6/1.300,1.128,1.102,0.903,0.789,0.746/
      Data eyy6/0.042,0.031,0.027,0.023,0.023,0.021/
      Data esy6/0.058,0.03,0.0285,0.03,0.0245,0.027/

*    f2 Q2=15 (bin 7)
      Data xx7/2.5e-04,4.0e-04,6.3e-04,1.0e-03,1.6e-03,
     &         2.5e-03,6.3e-03,1.6e-02,8.1e-02/
      Data yy7/1.559,1.338,1.092,0.992,0.908,
     &         0.793,0.662,0.553,0.370/
      Data eyy7/0.065,0.035,0.027,0.025,0.024,
     &          0.021,0.014,0.007,0.008/
      Data esy7/0.099,0.04,0.0295,0.0345,
     &          0.023,0.0245,0.0245,0.0145,0.0505/
     
*    f2 Q2=18 (bin 8)
      Data xx8/4.0e-04,6.3e-04,1.0e-03,1.6e-03,2.5e-03,6.3e-03/
      Data yy8/1.438,1.166,1.015,0.932,0.879,0.629/
      Data eyy8/0.041,0.031,0.028,0.026,0.024,0.013/
      Data esy8/0.048,0.0375,0.031,0.0225,0.022,0.02/
	
*    f2 Q2=22 (bin 9)
      Data xx9/4.0e-04,6.3e-04,1.0e-03,1.6e-03,2.5e-03,
     &         4.0e-03,6.3e-03,1.0e-02,2.5e-02,8.1e-02/
      Data yy9/1.507,1.324,1.081,0.930,0.906,0.749,
     &         0.701,0.601,0.490,0.338/
      Data eyy9/0.058,0.037,0.028,0.026,0.025,
     &          0.022,0.021,0.013,0.007,0.009/
      Data esy9/0.098,0.042,0.0305,0.032,0.023,
     &          0.036,0.026,0.024,0.0115,0.0585/

*    f2 Q2=27 (bin 10)
      Data xx10/6.3e-04,1.0e-03,1.6e-03,2.5e-03,4.0e-03,6.3e-03/
      Data yy10/1.460,1.194,1.140,0.928,0.765,0.674/
      Data eyy10/0.041,0.032,0.033,0.028,0.024,0.021/
      Data esy10/0.037,0.0255,0.036,0.0225,0.0275,0.02/
	
*    f2 Q2=35 (bin 11)
      Data xx11/6.3e-04,1.0e-03,1.6e-03,2.5e-03,4.0e-03,
     +          6.3e-03,1.0e-02,1.6e-02,2.5e-02,8.1e-02/
      Data yy11/1.565,1.370,1.149,1.018,0.887,
     +          0.749,0.681,0.604,0.570,0.461/
      Data eyy11/0.073,0.044,0.038,0.032,0.030,
     +           0.027,0.025,0.017,0.012,0.013/
      Data esy11/0.056,0.0285,0.0255,0.036,0.024,
     +           0.0265,0.0245,0.0195,0.016,0.0515/
*    f2 Q2=45 (bin 12)
      Data xx12/1.0e-03,1.6e-03,2.5e-03,4.0e-03,6.3e-03,1.0e-02/
      Data yy12/1.441,1.178,1.071,0.894,0.804,0.745/
      Data eyy12/0.053,0.045,0.037,0.034,0.031,0.029/
      Data esy12/0.0545,0.0405,0.0205,0.0265,0.045,0.037/
*    f2 Q2=60 (bin 13)
      Data xx13/1.0e-03,1.6e-03,2.5e-03,4.0e-03,6.3e-03,
     +          1.0e-02,1.6e-02,2.5e-02,8.1e-02/
      Data yy13/1.553,1.339,1.100,1.012,0.890,
     +          0.672,0.614,0.627,0.521/
      Data eyy13/0.073,0.050,0.040,0.039,0.035,
     +           0.028,0.029,0.020,0.019/
      Data esy13/0.0665,0.0315,0.0315,0.0315,0.032,
     +          0.0195,0.0385,0.015,0.043/
*    f2 Q2=70 (bin 14)
      Data xx14/1.6e-03,2.5e-03,4.0e-03,6.3e-03,
     +          1.0e-02,1.6e-02,2.5e-02,8.1e-02/
      Data yy14/1.318,1.228,0.917,0.887,
     +          0.774,0.697,0.607,0.484/
      Data eyy14/0.062,0.049,0.039,0.040,
     +           0.035,0.037,0.021,0.018/
      Data esy14/0.0535,0.048,0.028,0.032,
     +           0.0365,0.03,0.022,0.0275/
*    f2 Q2=90 (bin 15)
      Data xx15/1.6e-03,2.5e-03,4.0e-03,6.3e-03,1.0e-02,
     +          1.6e-02,2.5e-02,4.0e-02,8.1e-02,2.0e-01/
      Data yy15/1.363,1.275,1.068,0.974,0.845,
     +          0.619,0.556,0.526,0.453,0.255/
      Data eyy15/0.101,0.063,0.054,0.049,0.043,
     +           0.037,0.033,0.031,0.019,0.029/
      Data esy15/0.0307,0.0415,0.0385,0.0275,0.035,
     +           0.0455,0.029,0.0335,0.028,0.0585/
*    f2 Q2=120 (bin 16)
      Data xx16/2.5e-03,4.0e-03,6.3e-03,1.0e-02,
     +          1.6e-02,2.5e-02,4.0e-02,8.1e-02,2.0e-01/
      Data yy16/1.467,1.176,1.112,0.836,
     +          0.610,0.653,0.519,0.451,0.207/
      Data eyy16/0.093,0.073,0.066,0.051,
     +           0.043,0.045,0.036,0.022,0.022/
      Data esy16/0.034,0.027,0.0315,0.02,
     +           0.027,0.019,0.0145,0.019,0.052/

      Real myqbin(19)
c      Data myqbin/1.,2.,3.,4.,6.,7.,10.,14.,16.,24.,28.,40.,50.,70.,
c     +            110./
c      Data myqbin/1.,2.,3.,4.,6.,7.,10.,14.,16.,22.,28.,40.,50.,70.,
c     +110./
c       Data myqbin/3.,4.,5.,7.,9.,11.,13.,16.,20.,
c     +             24.,30.,40.,50.,65.,80.,110,140./
       Data myqbin/3.0,4.1,4.95,5.58,7.65,9.5,10.6,13.7,16.5,19.7,
     +             24.7,30.,41.5,50.,56,64.,76.,110,140./
      Real q2b(16)
      data q2b/3.5,4.5,6.5,8.5,10.,12.,15.,18.,22.,27.,35.,45.,60.,
     +	   70.,90.,120./
      Real q2binw(16)
*
      Real xcenter(0:nxbin+1),xbin(nxbin+1)
      Data  xcenter/4.0e-05,
     &              6.3e-05,1.0e-04,1.6e-04,2.5e-04,4.0e-04,
     &	        6.3e-04,1.0e-03,1.6e-03,2.5e-03,4.0e-03,
     &              6.3e-03,1.0e-02,1.6e-02,2.5e-02,4.0e-02,
     &              8.1e-02,2.0e-01,
     &              5.0e-1/

      Integer nktbin
	Parameter (nktbin=7)
	Real xktbin(nktbin+1)
	Data xktbin/0.0001,0.5,1.,1.4,4.,10.,25.,1000./
      Real conten(nxbin),contene(nxbin)
	
	Real q2bin(17)
	Real nq2bin(17)

      Real xkt1,xkt2,x1,x2
      Integer igl1,igl2

      save Qpi, qqradp, q2binw, nall, nall2, nev, q2bin, nq2bin

*
****************************************************************************
*
#include "hzfunc.inc"
#include "hzhbook.inc"
#include "hepevtp.inc"
#include "heracmn.inc"
#include "hzjetcmn.inc"
*
      Integer iflag,ihep,i,j,k,l
*     DESY Preprint number
      Character*5 xxxx
      Data xxxx/'96076'/
*
	Double precision chi
	Integer ndf
	Double precision chit
	Integer ndft
	Common/fit/chit,ndft
	double precision xsim,ykt
	common/hzbval/xsim,ykt

      real sigm,wt
      common/cwnco1/x,y,Q2,sigm,wt
	integer jqbin(18)
	data jqbin/1,2,0,3,4,5,6,7,8,9,10,11,12,0,13,14,15,16/
*
*********************************************************************
*
*                      Initialization
*
*********************************************************************
      NENTRY=NENTRY+1
*
      IF (iflag.eq.1) then
*
         write(6,*)' hz96076 my private Version'
         Qpi = 4.*atan(1.)
         qqradp = 180./qpi
*
*
*      Initialisation: The following MUST always be done
*      (i) make subdirectory in PAWC
*       - use the name as the xxxxxx in HZxxxxxx subroutine
*      (i) make subdirectory in o/p file
*
         Call hcdir('//PAWC',' ')
         call hmdir(xxxx,'S')
         Call hcdir('//HISTO',' ')
         call hmdir(xxxx,'S')
*
*
         do I = 1,nxbin+1
            xbin(i) = xcenter(i-1) + (xcenter(i)-xcenter(i-1))/2.
		write(6,*) ' xbin i ',i,xbin(i),xcenter(i-1)
         enddo

         J=0
         do i=1,18
		iqbin = jqbin(i)
		if(iqbin.ne.0) then 
		  q2binw(iqbin)=myqbin(i+1)-myqbin(i)
c		write(6,*) ' q2binw ',j,q2binw(j),myqbin(i+1),myqbin(i)
		endif
         enddo
c	   do I=1,nxbin1
c	write(6,*) ' xbinc 1',xbin1(i)+(xbin1(i+1)-xbin1(i))/2.,xcent1(i)
c	   enddo
*****************************
*  Make histograms of F2 , F2CC and F2CC/F2 for pure PDF function
*****************************
c         CALL HBNT(1999,'smallx  ',' ')
c         CALL HBNAME (1999,'kin',x,'x,y,Q2,sigm,wt')
*
         call hbook1(221,'  y     ',100,0.,1.,0.)
         call hbook1(222,'  Q2     ',100,0.,100.,0.)
*
         call hbookb( 1001,'f2 Q2=3.5 ',nxbin,xbin,0.)
         call hbookb( 1002,'f2 Q2=4.5 ',nxbin,xbin,0.)
         call hbookb( 1003,'f2 Q2=6.5 ',nxbin,xbin,0.)
         call hbookb( 1004,'f2 Q2=8.5 ',nxbin,xbin,0.)
         call hbookb( 1005,'f2 Q2=10 ',nxbin,xbin,0.)
         call hbookb( 1006,'f2 Q2=12 ',nxbin,xbin,0.)
         call hbookb( 1007,'f2 Q2=15. ',nxbin,xbin,0.)
         call hbookb( 1008,'f2 Q2=18. ',nxbin,xbin,0.)
         call hbookb( 1009,'f2 Q2=22. ',nxbin,xbin,0.)
         call hbookb( 1010,'f2 Q2=27. ',nxbin,xbin,0.)
         call hbookb( 1011,'f2 Q2=35. ',nxbin,xbin,0.)
         call hbookb( 1012,'f2 Q2=45. ',nxbin,xbin,0.)
         call hbookb( 1013,'f2 Q2=60. ',nxbin,xbin,0.)
         call hbookb( 1014,'f2 Q2=70. ',nxbin,xbin,0.)
         call hbookb( 1015,'f2 Q2=90. ',nxbin,xbin,0.)
         call hbookb( 1016,'f2 Q2=120. ',nxbin,xbin,0.)

	   do I=1001,1016
	   call hbarx(i)
	   enddo
	   
         call hbookb( 2001,'f2 Q2=3.5 pdf',nxbin,xbin,0.)
         call hbookb( 2002,'f2 Q2=4.5 pdf ',nxbin,xbin,0.)
         call hbookb( 2003,'f2 Q2=6.5 pdf ',nxbin,xbin,0.)
         call hbookb( 2004,'f2 Q2=8.5 pdf ',nxbin,xbin,0.)
         call hbookb( 2005,'f2 Q2=10 pdf ',nxbin,xbin,0.)
         call hbookb( 2006,'f2 Q2=12 pdf ',nxbin,xbin,0.)
         call hbookb( 2007,'f2 Q2=15. pdf ',nxbin,xbin,0.)
         call hbookb( 2008,'f2 Q2=18. pdf ',nxbin,xbin,0.)
         call hbookb( 2009,'f2 Q2=22. pdf ',nxbin,xbin,0.)
         call hbookb( 2010,'f2 Q2=27. pdf ',nxbin,xbin,0.)
         call hbookb( 2011,'f2 Q2=35. pdf ',nxbin,xbin,0.)
         call hbookb( 2012,'f2 Q2=45. pdf ',nxbin,xbin,0.)
         call hbookb( 2013,'f2 Q2=60. pdf ',nxbin,xbin,0.)
         call hbookb( 2014,'f2 Q2=70. pdf ',nxbin,xbin,0.)
         call hbookb( 2015,'f2 Q2=90. pdf ',nxbin,xbin,0.)
         call hbookb( 2016,'f2 Q2=120. pdf ',nxbin,xbin,0.)
         call hbookb( -1001,'f2 Q2=3.5 data stat',nxbin,xbin,0.)
         call hbookb( -1101,'f2 Q2=3.5 data tot',nxbin,xbin,0.)
         call hbookb( -1002,'f2 Q2=4.5 data stat',nxbin,xbin,0.)
         call hbookb( -1102,'f2 Q2=4.5 data tot',nxbin,xbin,0.)
         call hbookb( -1003,'f2 Q2=6.5 data stat',nxbin,xbin,0.)
         call hbookb( -1103,'f2 Q2=6.5 data tot',nxbin,xbin,0.)
         call hbookb( -1004,'f2 Q2=8.5 data stat',nxbin,xbin,0.)
         call hbookb( -1104,'f2 Q2=8.5 data tot',nxbin,xbin,0.)
         call hbookb( -1005,'f2 Q2=10 data stat',nxbin,xbin,0.)
         call hbookb( -1105,'f2 Q2=10 data tot',nxbin,xbin,0.)
         call hbookb( -1006,'f2 Q2=12 data stat',nxbin,xbin,0.)
         call hbookb( -1106,'f2 Q2=12 data tot',nxbin,xbin,0.)
         call hbookb( -1007,'f2 Q2=15. data stat',nxbin,xbin,0.)
         call hbookb( -1107,'f2 Q2=15. data tot',nxbin,xbin,0.)
         call hbookb( -1008,'f2 Q2=18. data stat',nxbin,xbin,0.)
         call hbookb( -1108,'f2 Q2=18. data tot',nxbin,xbin,0.)
         call hbookb( -1009,'f2 Q2=22. data stat',nxbin,xbin,0.)
         call hbookb( -1109,'f2 Q2=22. data tot',nxbin,xbin,0.)
         call hbookb( -1010,'f2 Q2=27. data stat',nxbin,xbin,0.)
         call hbookb( -1110,'f2 Q2=27. data tot',nxbin,xbin,0.)
         call hbookb( -1011,'f2 Q2=35. data stat',nxbin,xbin,0.)
         call hbookb( -1111,'f2 Q2=35. data tot',nxbin,xbin,0.)
         call hbookb( -1012,'f2 Q2=45. data stat',nxbin,xbin,0.)
         call hbookb( -1112,'f2 Q2=45. data tot',nxbin,xbin,0.)
         call hbookb( -1013,'f2 Q2=60. data stat',nxbin,xbin,0.)
         call hbookb( -1113,'f2 Q2=60. data tot',nxbin,xbin,0.)
         call hbookb( -1014,'f2 Q2=70. data stat',nxbin,xbin,0.)
         call hbookb( -1114,'f2 Q2=70. data tot',nxbin,xbin,0.)
         call hbookb( -1015,'f2 Q2=90. data stat',nxbin,xbin,0.)
         call hbookb( -1115,'f2 Q2=90. data tot',nxbin,xbin,0.)
         call hbookb( -1016,'f2 Q2=120. data stat',nxbin,xbin,0.)
         call hbookb( -1116,'f2 Q2=120. data tot',nxbin,xbin,0.)

        j=1
         Do i =1,nxbin
            f2_1(i)=0.
            if(j.le.2) then
               if(xcenter(i).eq.xx1(j)) then
                  f2_1(i)=yy1(j)
                  ef2_1(i)=eyy1(j)
                  eft_1(i) = sqrt(eyy1(j)**2 + esy1(j)**2)
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin 
            f2_2(i)=0.
            if(j.le.3) then
               if(xcenter(i).eq.xx2(j)) then
                  f2_2(i)=yy2(j)
                  ef2_2(i)=eyy2(j)
                  eft_2(i) = sqrt(eyy2(j)**2 + esy2(j)**2)
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin 
            f2_3(i)=0.
            if(j.le.11) then
               if(xcenter(i).eq.xx3(j)) then
                  f2_3(i)=yy3(j)
                  ef2_3(i)=eyy3(j)
                  eft_3(i) = sqrt(eyy3(j)**2 + esy3(j)**2)
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin 
            f2_4(i)=0.
            if(j.le.6) then
               if(xcenter(i).eq.xx4(j)) then
                  f2_4(i)=yy4(j)
                  ef2_4(i)=eyy4(j)
                  eft_4(i) = sqrt(eyy4(j)**2 + esy4(j)**2)
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin 
            f2_5(i)=0.
            if(j.le.10) then
               if(xcenter(i).eq.xx5(j)) then
                  f2_5(i)=yy5(j)
                  ef2_5(i)=eyy5(j)
                  eft_5(i) = sqrt(eyy5(j)**2 + esy5(j)**2)
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin 
            f2_6(i)=0.
            if(j.le.6) then
               if(xcenter(i).eq.xx6(j)) then
                  f2_6(i)=yy6(j)
                  ef2_6(i)=eyy6(j)
                  eft_6(i) = sqrt(eyy6(j)**2 + esy6(j)**2)
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin 
            f2_7(i)=0.
            if(j.le.9) then
               if(xcenter(i).eq.xx7(j)) then
                  f2_7(i)=yy7(j)
                  ef2_7(i)=eyy7(j)
                  eft_7(i) = sqrt(eyy7(j)**2 + esy7(j)**2)
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin 
            f2_8(i)=0.
            if(j.le.6) then
               if(xcenter(i).eq.xx8(j)) then
                  f2_8(i)=yy8(j)
                  ef2_8(i)=eyy8(j)
                  eft_8(i) = sqrt(eyy8(j)**2 + esy8(j)**2)
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin 
            f2_9(i)=0.
            if(j.le.10) then
               if(xcenter(i).eq.xx9(j)) then
                  f2_9(i)=yy9(j)
                  ef2_9(i)=eyy9(j)
                  eft_9(i) = sqrt(eyy9(j)**2 + esy9(j)**2)
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin 
            f2_10(i)=0.
            if(j.le.6) then
               if(xcenter(i).eq.xx10(j)) then
                  f2_10(i)=yy10(j)
                  ef2_10(i)=eyy10(j)
                  eft_10(i) = sqrt(eyy10(j)**2 + esy10(j)**2)
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin 
            f2_11(i)=0.
            if(j.le.10) then
               if(xcenter(i).eq.xx11(j)) then
                  f2_11(i)=yy11(j)
                  ef2_11(i)=eyy11(j)
                  eft_11(i) = sqrt(eyy11(j)**2 + esy11(j)**2)
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin 
            f2_12(i)=0.
            if(j.le.6) then
               if(xcenter(i).eq.xx12(j)) then
                  f2_12(i)=yy12(j)
                  ef2_12(i)=eyy12(j)
                  eft_12(i) = sqrt(eyy12(j)**2 + esy12(j)**2)
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin 
            f2_13(i)=0.
            if(j.le.9) then
               if(xcenter(i).eq.xx13(j)) then
                  f2_13(i)=yy13(j)
                  ef2_13(i)=eyy13(j)
                  eft_13(i) = sqrt(eyy13(j)**2 + esy13(j)**2)
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin 
            f2_14(i)=0.
            if(j.le.8) then
               if(xcenter(i).eq.xx14(j)) then
                  f2_14(i)=yy14(j)
                  ef2_14(i)=eyy14(j)
                  eft_14(i) = sqrt(eyy14(j)**2 + esy14(j)**2)
                  j=j+1
               endif
            endif
         enddo

         j=1
         Do i =1,nxbin 
            f2_15(i)=0.
            if(j.le.10) then
               if(xcenter(i).eq.xx15(j)) then
                  f2_15(i)=yy15(j)
                  ef2_15(i)=eyy15(j)
                  eft_15(i) = sqrt(eyy15(j)**2 + esy15(j)**2)
                  j=j+1
               endif
            endif
         enddo
         j=1
         Do i =1,nxbin 
            f2_16(i)=0.
            if(j.le.9) then
               if(xcenter(i).eq.xx16(j)) then
                  f2_16(i)=yy16(j)
                  ef2_16(i)=eyy16(j)
                  eft_16(i) = sqrt(eyy16(j)**2 + esy16(j)**2)
                  j=j+1
               endif
            endif
         enddo

         write(6,*) ' Q2 = 3.5 '
         write(6,10001)
10001  format('  bin  |     x     |   F2   | ')
         do i=1,nxbin
            if(f2_1(i).gt.0.0) then
               write(6,10002) i,xcenter(i),f2_1(i)
c		   write(6,*) eft_1(i),xbin1(i),xbin1(i+1)
            endif
         enddo
10002  format(i6,' | ',e9.4,' | ',f6.3,' |')
         write(6,*) ' Q2 = 4.5 '
         write(6,10001)
         do i=1,nxbin
            if(f2_2(i).gt.0.0) then
               write(6,10002) i,xcenter(i),f2_2(i)
c		   write(6,*) eft_2(i),xbin2(i),xbin2(i+1)
            endif
         enddo
         write(6,*) ' Q2 = 6.5 '
         write(6,10001)
         do i=1,nxbin
            if(f2_3(i).gt.0.0) then
               write(6,10002) i,xcenter(i),f2_3(i)
            endif
         enddo
         write(6,*) ' Q2 = 8.5 '
         write(6,10001)
         do i=1,nxbin
            if(f2_4(i).gt.0.0) then
               write(6,10002) i,xcenter(i),f2_4(i)
            endif
         enddo
         write(6,*) ' Q2 = 10 '
         write(6,10001)
         do i=1,nxbin
            if(f2_5(i).gt.0.0) then
               write(6,10002) i,xcenter(i),f2_5(i)
            endif
         enddo
         write(6,*) ' Q2 = 12 '
         write(6,10001)
         do i=1,nxbin
            if(f2_6(i).gt.0.0) then
               write(6,10002) i,xcenter(i),f2_6(i)
            endif
         enddo
         write(6,*) ' Q2 = 15 '
         write(6,10001)
         do i=1,nxbin
            if(f2_7(i).gt.0.0) then
               write(6,10002) i,xcenter(i),f2_7(i)
            endif
         enddo
         write(6,*) ' Q2 = 18 '
         write(6,10001)
         do i=1,nxbin
            if(f2_8(i).gt.0.0) then
               write(6,10002) i,xcenter(i),f2_8(i)
            endif
         enddo
         write(6,*) ' Q2 = 22 '
         write(6,10001)
         do i=1,nxbin
            if(f2_9(i).gt.0.0) then
               write(6,10002) i,xcenter(i),f2_9(i)
            endif
         enddo
         write(6,*) ' Q2 = 27 '
         write(6,10001)
         do i=1,nxbin
            if(f2_10(i).gt.0.0) then
               write(6,10002) i,xcenter(i),f2_10(i)
            endif
         enddo
         write(6,*) ' Q2 = 35 '
         write(6,10001)
         do i=1,nxbin
            if(f2_11(i).gt.0.0) then
               write(6,10002) i,xcenter(i),f2_11(i)
            endif
         enddo
         write(6,*) ' Q2 = 45 '
         write(6,10001)
         do i=1,nxbin
            if(f2_12(i).gt.0.0) then
               write(6,10002) i,xcenter(i),f2_12(i)
            endif
         enddo
         write(6,*) ' Q2 = 60 '
         write(6,10001)
         do i=1,nxbin
            if(f2_13(i).gt.0.0) then
               write(6,10002) i,xcenter(i),f2_13(i)
            endif
         enddo
         write(6,*) ' Q2 = 70 '
         write(6,10001)
         do i=1,nxbin
            if(f2_14(i).gt.0.0) then
               write(6,10002) i,xcenter(i),f2_14(i)
            endif
         enddo

         call hpak(-1001,f2_1)
         call hpake(-1001,ef2_1)
         call hpak(-1101,f2_1)
         call hpake(-1101,eft_1)
         call hpak(-1002,f2_2)
         call hpake(-1002,ef2_2)
         call hpak(-1102,f2_2)
         call hpake(-1102,eft_2)
         call hpak(-1003,f2_3)
         call hpake(-1003,ef2_3)
         call hpak(-1103,f2_3)
         call hpake(-1103,eft_3)
         call hpak(-1004,f2_4)
         call hpake(-1004,ef2_4)
         call hpak(-1104,f2_4)
         call hpake(-1104,eft_4)
         call hpak(-1005,f2_5)
         call hpake(-1005,ef2_5)
         call hpak(-1105,f2_5)
         call hpake(-1105,eft_5)
         call hpak(-1006,f2_6)
         call hpake(-1006,ef2_6)
         call hpak(-1106,f2_6)
         call hpake(-1106,eft_6)
         call hpak(-1007,f2_7)
         call hpake(-1007,ef2_7)
         call hpak(-1107,f2_7)
         call hpake(-1107,eft_7)
         call hpak(-1008,f2_8)
         call hpake(-1008,ef2_8)
         call hpak(-1108,f2_8)
         call hpake(-1108,eft_8)
         call hpak(-1009,f2_9)
         call hpake(-1009,ef2_9)
         call hpak(-1109,f2_9)
         call hpake(-1109,eft_9)
         call hpak(-1010,f2_10)
         call hpake(-1010,ef2_10)
         call hpak(-1110,f2_10)
         call hpake(-1110,eft_10)
         call hpak(-1011,f2_11)
         call hpake(-1011,ef2_11)
         call hpak(-1111,f2_11)
         call hpake(-1111,eft_11)
         call hpak(-1012,f2_12)
         call hpake(-1012,ef2_12)
         call hpak(-1112,f2_12)
         call hpake(-1112,eft_12)
         call hpak(-1013,f2_13)
         call hpake(-1013,ef2_13)
         call hpak(-1113,f2_13)
         call hpake(-1113,eft_13)
         call hpak(-1014,f2_14)
         call hpake(-1014,ef2_14)
         call hpak(-1114,f2_14)
         call hpake(-1114,eft_14)
         call hpak(-1115,f2_15)
         call hpake(-1115,eft_15)
         call hpak(-1116,f2_16)
         call hpake(-1116,eft_16)
	   
	   nall = 0
	   nall2 = 0
	   Do I=1,maxhi
	   nev(i) =0
	   enddo
	   Do I=1,14
	   q2bin(i) = 0
	   nq2bin(i) = 0
	   enddo
*
*
*********************************************************************
*                      Event Processing
*
*********************************************************************
*
      Else if(iflag.eq.2) then
*
         call hcdir('//PAWC/'//xxxx,' ')
*
* total number of generated events
         nall=nall+wtx
*
         ierr=HZIBEAM(ibeam,idum)
c          write(6,*) 'hz96076 ',ibeam,idum
          if (.not.(ierr.eq.1)) then
            write(6,*) 'HZ'//xxxx,' beams not found ! '
            return
         else
            Do i=1,4
               pbeam(i)=PHEP(i,IBEAM)
            enddo
         endif
*
         eb=real(PHEP(4,idum))
         if (abs(abs(eb)-ee).gt.0.1) then
            if (nentry.lt.10) then
               write(6,*) 'HZ'//xxxx,' Electron not at ',ee,' ! ',eb
            elseif (nentry.eq.10) then
               write(6,*) 'HZ'//xxxx,' Electron beam not at ',ee,
     +         ' ...last message ! '
            endif
c            return
         endif
*
         q2=real(hzdiskin(1))
         x=real(hzdiskin(2))
         y=real(hzdiskin(3))
         w2=real(hzdiskin(4))
         iqbin = -9999
         if(q2.lt.myqbin(1).or.q2.ge.myqbin(19)) return
         i=0
   50    i=i+1
         if(q2.ge.myqbin(i).and.q2.lt.myqbin(i+1)) then
         else
            goto 50
         endif
	   iqbin = jqbin(i)
c         call  HFNT (1999)
c	   if(iqbin.eq.7) return
c	   if(iqbin.gt.7) iqbin=i-1
	   if(iqbin.eq.0) return
	   q2bin(iqbin)=q2bin(iqbin)+q2
	   nq2bin(iqbin)=nq2bin(iqbin)+wtx
         call hfill(221,y,0.,wtx)
         call hfill(222,q2,0.,wtx)
* weighting with photon flux
         xw = x*q2b(iqbin)*q2b(iqbin)/(1.-y+y**2/2)
         nall2=nall2+xw
         nev(1000+iqbin)=nev(1000+iqbin)+wtx
c         write(6,*) q2,q2b(iqbin),iqbin,xw,wtx
         call hfill(1000+iqbin,x,0.,xw*wtx)
	   
*
*
*
* determine kin bin of event
*                                             get electron variables
   20    continue
*
*********************************************************************
*
*                      Termination
*
*********************************************************************
*
      Else if(iflag.eq.3) then
*
*      Termination: The following MUST always be done
*      (i) Move to the correct PAW subdirectory
*
         call hcdir('//PAWC/'//xxxx,' ')
*
* fill histos with f2 from pdf

         do i=1,14
            do j=1,nxbin

               dx = dble(xcenter(j))
               dq = dble(sqrt(q2b(i)))
               PARM(1) = 'NPTYPE'
               VAL(1) = 1.d0
               PARM(2) = 'NGROUP'
               VAL(2) = 5.d0
               PARM(3) = 'NSET'
               VAL(3) = 7.D0
               NPDF=NPDF+1
               PDFFIRST=.FALSE.
               IF(NPDF.LE.1) PDFFIRST=.TRUE.
c               CALL PDFSET(PARM,VAL)
c               CALL STRUCTM(dx,dq,UPV,DNV,USEA,DSEA,STR,CHM,BOT,TOP,
c     +         GLU)
               f2pdf=real(4./9.*(upv+usea) + 1./9.*(dnv+dsea) + 8./9.*
     +         (chm+top) + 2./9.*(str+bot) +
     +         4./9.*usea + 1./9.*dsea)
c                write(6,*) ' f2pdf ',xcenter(j),f2pdf
               call hfill(2000+i,xcenter(j),0.,f2pdf)
            enddo
         enddo
         if (lp) then
*
*
* Obtain total cross-section
            write(6,*) ' Total Cross section ',xsec,nall
*
            write(6,*)'      '
         endif
*
         lum=999999999.
         if (xsec.ne.0.) then
            lum=real(nall)/real(xsec)
         else
            write(6,*) 'hz',xxxx,' xsec=0 ! '
         endif

*      normalize the histos
         if(nall2.gt.1) then
* now do the cross section normalisation
            do i1=1,16
c		   write(6,*)' q2 bins ',i1,q2bin(i1)/nq2bin(i1),
c     &		   q2bin(i1),nq2bin(i1)
               idhisto= 1000 +i1
		   idpaw = idhisto
               call hzhinfo(idpaw,int(nev(idhisto)))
               if(nev(idhisto).gt.1) then

c		      write(6,*) ' hz96076 norm in bin i1: ',i1,nev(idhisto)
                  fact=1./(4.*pi*alph_em**2)
                  fact=fact/1000./gev2nb/lum /q2binw(i1)
                  call hzhinrm( idpaw, 0, 1., 1 )
                  call hopera(idpaw,'+E',idpaw,idpaw,fact,0.)

c                  if(i1.ge.4) then
c                     call mychisq(-idhisto-100,idhisto,chi,ndf)
c			   chit = chit + chi
c			   ndft = ndft + ndf
c			write(6,*) ' hz... ',chi,ndf,-idhisto-100,idhisto
c			endif
                  call hzchisq(-idhisto-100,idhisto)
               endif 
		   
            enddo
         endif
*
*
*
      endif
      RETURN
      END
