*CMZ :  2.00/06 02/05/2002  14.23.52  by  Tancredi Carli
*-- Author :
* eof
*CMZ :  1.02/00 04/10/98  22.30.18  by  Tancredi Carli
*CMZ :  1.01/15 14/04/98  21.07.48  by  Tancredi Carli
*CMZ :  1.01/13 23/03/98  18.10.19  by  Tancredi Carli
*CMZ :  1.01/11 09/12/97  16.44.12  by  Tancredi Carli
*CMZ :  1.01/07 15/10/97  16.34.09  by  Tancredi Carli
*CMZ :  1.00/02 12/03/96  19.18.00  by  Tancredi Carli
*CMZ :  0.00/09 16/02/96  17.15.47  by  Tancredi Carli
*CMZ :  0.00/08 15/02/96  12.30.10  by  Tancredi Carli
*CMZ :  0.00/06 02/02/96  19.54.21  by  Tancredi Carli
*-- Author :  Dave Kant   01/07/97
      subroutine HZ97108(IFLAG)
****************************************************************************
* Purpose: produced histograms for:
*          the charged particle multiplicity versus Q
*          the mean and the width of the ln(1/xp) distribution vs Q
*
* Event selection:
* Eel>14, W2>4400, 0.05<y<0.6, rapidity gap events EXCLUDED
*
* Running:  HERA running 1994
* Reference:
* Arguments: iflag=1 initialisation
*            iflag=1 filling
*            iflag=3 termination
*
* written by: Dave Kant (d.kant@qmw.ac.uk) and based on HZ95072 written by
*             Tancredi Carli and Renate Mohr (carli@mail.desy.de
*                                             mohr@mail.desy.de  )
* Modified: April 98 angles were in radiant
*                    introduced *rd (???) Did it ever work ???
****************************************************************************
      IMPLICIT NONE
*
#include "hzfunc.inc"
#include "hzhbook.inc"
#include "hepevtp.inc"
#include "heracmn.inc"
*
      Integer iquest
      COMMON/QUEST/IQUEST(100)
*
      Integer iflag,ihep,i,j,k,l
*     DESY Preprint number
      Character*5 xxxx
*
      Real VMIN,VMAX
      integer nxpbin
      parameter (nxpbin=11)
      Integer ierr,ibeam,igam
      Double precision pbeam(4),pgam(4),pbrt(4),plab(4),ph(5)
      Integer limup,limlo
      Real xp,xpmean,xi
      Real par(3), step(3), pmin(3),pmax(3),sigpar(3),chi2
*
      Real pi,rd,ee,eb
      Logical evcut,lp
      Integer jcut,iel,idum,id,ibin,ivec
      Parameter (pi=3.1415927,rd=180./pi,ee=27.6)
      Integer nentry
      Real nev(nxpbin)
      Data lp/.false./,nentry/0/
      Real x,y,q2,w2,enel,efwd,th
      Real xmi,xma,ymi,yma
      Integer nx,ny,nwt,loc
      Character chtitl*80
*
      real sqrtq(nxpbin+1),q2aux(nxpbin+1)
      real peak(nxpbin),width(nxpbin),epeak(nxpbin),ewidth(nxpbin)
      real mult(nxpbin),emult(nxpbin)
      real q(nxpbin),qdata(nxpbin)
*
      real xp1(15),xp2(15),dxp1(15),dxp2(15)
      real xi1(40),xi2(40),dxi1(40),dxi2(40)
      real pn1(12),pn2(12),pn3(12),pn4(12),pn5(12),pn6(12)
      real dpn1(12),dpn2(12),dpn3(12),dpn4(12),dpn5(12),dpn6(12)
      real c1,c2,cos_thel,thel,coth,thq
      real pbreit(4),costheta_bf
      integer nlow,nhig,ntrk,id1,id2
      Real  nnum(6),n2num(3)
*
******************************************************************************
      Data xxxx/'97108'/
*.... data points from plots

       data q2aux/12.,15.,20.,40.,60.,80.,100.,175.,250.,
     +            450.,1000.,8000./
       data qdata/3.63,4.12,5.23,6.90,8.20,9.32,12.5,14.6,
     +            17.9,25.0,41.2/

       do i=1,nxpbin+1
        sqrtq(i)=sqrt(q2aux(i))
       enddo
*.... initialise event counters for normalisation in step 3
       data nev   /0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0./
       data nnum  /0.,0.,0.,0.,0.,0./
       data n2num /0.,0.,0./

*.... TOTAL CURRENT HEMISPHERE
       data peak  /1.52,1.53,1.72,1.84,1.97,2.04,2.26,2.43,
     +             2.51,2.77,3.02/
       data width /0.80,0.74,0.75,0.78,0.90,0.87,1.09,1.05,
     +             0.97,1.08,1.26/
       data mult  /1.18,1.38,1.62,2.19,2.59,3.16,3.65,4.13,
     +             4.05,5.23,7.32/
       data epeak /0.05,0.04,0.03,0.04,0.08,0.10,0.11,0.08,
     +             0.06,0.08,0.14/
       data ewidth/0.06,0.05,0.03,0.04,0.10,0.12,0.18,0.13,
     +             0.09,0.14,0.23/
       data emult /0.07,0.08,0.08,0.12,0.16,0.25,0.32,0.34,
     +             0.34,0.43,0.65/

*.... Figure 1(a) - 1/N dn/dxp
*.... distributions for 12<Q2<100 (xp1 and error dxp1) and
*     100<Q2<8000 (xp2 and dxp2) GeV2

       data xp1 /3.322,6.232,5.082,3.429,2.227,1.637,1.026,
     +           0.647,0.427,0.328,0.190,0.108,0.097,0.067,
     +           0.020/
       data xp2 /29.05,17.88,8.709,4.309,2.766,1.579,1.056,
     +           0.736,0.466,0.258,0.132,0.147,0.057,0.024,
     +           0.010/
       data dxp1/0.125,0.164,0.147,0.120,0.095,0.085,0.066,
     +           0.053,0.044,0.041,0.033,0.027,0.027,0.026,
     +           0.021/
       data dxp2/0.704,0.539,0.382,0.262,0.220,0.161,0.138,
     +           0.114,0.091,0.065,0.047,0.053,0.037,0.025,
     +           0.021/

*.... Figure 1(b) - 1/N dn/dln(1/xp)
*.... distributions for 12<Q2<100 (xi1 and error dxi1) and
*     100<Q2<8000 (xi2 and dxi2) GeV2

       data xi1 /0.000,0.000,0.000,0.003,0.021,0.050,0.104,
     +           0.222,0.339,0.482,0.632,0.730,0.800,0.864,
     +           0.819,0.738,0.654,0.489,0.425,0.280,0.209,
     +           0.145,0.119,0.093,0.050,0.026,0.000,0.000,
     +           0.000,0.000,0.000,0.000,0.000,0.000,0.000,
     +           0.000,0.000,0.000,0.000,0.000/
       data dxi1/0.000,0.000,0.000,0.020,0.020,0.021,0.021,
     +           0.023,0.026,0.029,0.032,0.035,0.037,0.038,
     +           0.040,0.039,0.038,0.037,0.033,0.032,0.028,
     +           0.026,0.025,0.026,0.028,0.024,0.000,0.000,
     +           0.000,0.000,0.000,0.000,0.000,0.000,0.000,
     +           0.000,0.000,0.000,0.000,0.000/
       data xi2 /0.000,0.000,0.000,0.001,0.005,0.020,0.102,
     +           0.215,0.367,0.448,0.719,0.918,0.988,1.369,
     +           1.505,1.635,1.590,1.893,1.697,1.696,1.357,
     +           1.509,1.252,0.787,0.765,0.425,0.335,0.306,
     +           0.168,0.122,0.061,0.055,0.014,0.013,0.000,
     +           0.000,0.000,0.000,0.000,0.000/
       data dxi2/0.000,0.000,0.000,0.020,0.020,0.020,0.022,
     +           0.030,0.040,0.050,0.054,0.066,0.075,0.074,
     +           0.091,0.093,0.097,0.094,0.104,0.097,0.099,
     +           0.089,0.096,0.086,0.069,0.067,0.052,0.047,
     +           0.050,0.039,0.037,0.030,0.030,0.025,0.000,
     +           0.000,0.000,0.000,0.000,0.000/


*.... Figure 8 - 1/N dN/dn
*     Pn spectra in the following Q2 and x bins
*     12<Q2<30 GeV2 and 6.E-4<x<2.E-3
       data pn1 /0.312,0.309,0.219,0.116,0.031,0.005,0.0012,
     +           0.000,0.000,0.000,0.000,0.000/
       data dpn1/0.025,0.016,0.027,0.009,0.005,0.001,0.0006,
     +           0.000,0.000,0.000,0.000,0.000/
*     12<Q2<30 GeV2 and 2.E-03<x<1.E-2
       data pn2 /0.246,0.281,0.233,0.133,0.055,0.030,0.0012,
     +           0.000,0.000,0.000,0.000,0.000/
       data dpn2/0.070,0.025,0.042,0.031,0.011,0.012,0.0020,
     +           0.000,0.000,0.000,0.000,0.000/
*     30<Q2<80 GeV2 and 6.E-4<x<2.E-3
       data pn3 /0.194,0.250,0.205,0.182,0.079,0.036,0.031,
     +           0.000,0.000,0.000,0.000,0.000/
       data dpn3/0.023,0.026,0.025,0.023,0.017,0.011,0.018,
     +           0.000,0.000,0.000,0.000,0.000/
*     30<Q2<80 GeV2 and 2.E-03<x<1.E-2
       data pn4 /0.150,0.195,0.229,0.199,0.116,0.049,0.023,
     +           0.007,0.003,0.000,0.000,0.000/
       data dpn4/0.031,0.013,0.025,0.020,0.026,0.012,0.006,
     +           0.004,0.003,0.000,0.000,0.000/
*     100<Q2<500 GeV2 and 2.E-3<x<1.E-2
       data pn5 /0.041,0.083,0.119,0.236,0.169,0.124,0.106,
     +           0.035,0.030,0.017,0.000,0.000/
       data dpn5/0.009,0.019,0.024,0.049,0.024,0.024,0.027,
     +           0.017,0.017,0.011,0.000,0.000/
*     100<Q2<500 GeV2 and 1.E-2<x<2.E-1
       data pn6 /0.020,0.052,0.093,0.171,0.184,0.151,0.135,
     +           0.075,0.048,0.021,0.018,0.007/
       data dpn6/0.011,0.014,0.018,0.031,0.026,0.032,0.029,
     +           0.026,0.022,0.010,0.013,0.005/

******************************************************************************
      NENTRY=NENTRY+1
*
      IF (iflag.eq.1) then
*
*      Initialisation: The following MUST always be done
*      (i) make subdirectory in PAWC
*       - use the name as the xxxxxx in HZxxxxxx subroutine
*      (i) make subdirectory in o/p file
*
       Call hcdir('//PAWC',' ')
       call hmdir(xxxx,'S')
       Call hcdir('//HISTO',' ')
       call hmdir(xxxx,'S')
*
       Do i=1,nxpbin
        nev(i)=0.
       enddo
*
*      book your histograms  (data: ID<0)
*                                     (VZERO, VMIN, VMAX see CERNLIB F121)
*      non-equidistant binning
       call hbookb(-10,'Q vs ln(1/xp)peak ',nxpbin,sqrtq,0.)
       call hbookb(-20,'Q vs ln(1/xp)width',nxpbin,sqrtq,0.)
       call hbookb(-30,'Q vs nch          ',nxpbin,sqrtq,0.)
       call hbook1(-101,'x-ax peak/width',nxpbin,0.,real(nxpbin+1.),0.)
*
       call hbook1(-200,'1/N dn/dxp vs xp               Q2(12,100)  ',
     + 15,0.,1.,0.)
       call hbook1(-201,'1/N dn/dxp vs xp               Q2(100,8000)',
     + 15,0.,1.,0.)
       call hbook1(-300,'1/N dn/dln(1/xp) vs ln(1/xp)   Q2(12,100)  ',
     + 40,-1.,7.,0.)
       call hbook1(-301,'1/N dn/dln(1/xp) vs ln(1/xp)   Q2(100,8000)',
     + 40,-1.,7.,0.)

       call hbook1(-400,
     + '1/N dN/dn vs n     Q2(12,30) and xbj(6E-4,2E-3)',
     + 12,-0.5,11.5,0.)
       call hbook1(-401,
     + '1/N dN/dn vs n     Q2(12,30) and xbj(2E-3,1E-2)',
     + 12,-0.5,11.5,0.)
       call hbook1(-402,
     + '1/N dN/dn vs n     Q2(30,80) and xbj(6E-4,2E-3)',
     + 12,-0.5,11.5,0.)
       call hbook1(-403,
     + '1/N dN/dn vs n     Q2(30,80) and xbj(2E-3,1E-2)',
     + 12,-0.5,11.5,0.)
       call hbook1(-404,
     + '1/N dN/dn vs n   Q2(100,500) and xbj(2E-3,1E-2)',
     + 12,-0.5,11.5,0.)
       call hbook1(-405,
     + '1/N dN/dn vs n   Q2(100,500) and xbj(1E-2,2E-1)',
     + 12,-0.5,11.5,0.)

*
*      MC Histos
*
       call hbookb(10,'MC  Q vs ln(1/xp)peak ',nxpbin,sqrtq,0.)
       call hbookb(20,'MC  Q vs ln(1/xp)width',nxpbin,sqrtq,0.)
       call hbookb(30,'MC  Q vs nch          ',nxpbin,sqrtq,0.)
       call hbookb(31,'MC  Q vs nch aux      ',nxpbin,sqrtq,0.)

*      MC auxiliary histograms
       do ibin=1,nxpbin
        call hbook1(110+ibin,'MC  dn/dln(1/xp)',50,0.,7.,0.)
       enddo
*
       call hbook1(200,'MC 1/N dn/dxp vs xp               Q2(12,100)  ',
     + 15,0.,1.,0.)
       call hbook1(201,'MC 1/N dn/dxp vs xp               Q2(100,8000)',
     + 15,0.,1.,0.)
       call hbook1(300,'MC 1/N dn/dln(1/xp) vs ln(1/xp)   Q2(12,100)  ',
     + 40,-1.,7.,0.)
       call hbook1(301,'MC 1/N dn/dln(1/xp) vs ln(1/xp)   Q2(100,8000)',
     + 40,-1.,7.,0.)
*
       call hbook1(400,
     + 'MC 1/N dN/dn vs n     Q2(12,30) and xbj(6E-4,2E-3)',
     + 12,-0.5,11.5,0.)
       call hbook1(401,
     + 'MC 1/N dN/dn vs n     Q2(12,30) and xbj(2E-3,1E-2)',
     + 12,-0.5,11.5,0.)
       call hbook1(402,
     + 'MC 1/N dN/dn vs n     Q2(30,80) and xbj(6E-4,2E-3)',
     + 12,-0.5,11.5,0.)
       call hbook1(403,
     + 'MC 1/N dN/dn vs n     Q2(30,80) and xbj(2E-3,1E-2)',
     + 12,-0.5,11.5,0.)
       call hbook1(404,
     + 'MC 1/N dN/dn vs n   Q2(100,500) and xbj(2E-3,1E-2)',
     + 12,-0.5,11.5,0.)
       call hbook1(405,
     + 'MC 1/N dN/dn vs n   Q2(100,500) and xbj(1E-2,2E-1)',
     + 12,-0.5,11.5,0.)
*
       call hbook1(600,
     + 'MC 1/N dN/dn vs n   Q2(12,30) and xbj(6E-4,1E-2)',
     + 12,-0.5,11.5,0.)
       call hbook1(601,
     + 'MC 1/N dN/dn vs n   Q2(30,80) and xbj(6E-4,1E-2)',
     + 12,-0.5,11.5,0.)
       call hbook1(602,
     + 'MC 1/N dN/dn vs n   Q2(100,500) and xbj(1E-2,2E-1)',
     + 12,-0.5,11.5,0.)
*
       call hbook2(800,
     + 'E/Q vs COS Theta BF   Q2(12,100)',
     + 25,-1.1,0.1,25,-0.25,1.605,0.0)
       call hbook2(801,
     + 'E/Q vs COS Theta BF   Q2(100,8000)',
     + 25,-1.1,0.1,25,-0.25,1.605,0.0)
*********************************************************************
*
      Else if(iflag.eq.2) then
*      Filling: The following MUST always be done
*      (i) move to the correct sub-directory in PAWC
*
       call hcdir('//PAWC/'//xxxx,' ')
*
*      Event selection
*
       q2=real(HZDISKIN(1))
       x =real(HZDISKIN(2))
       y =real(HZDISKIN(3))
       w2=real(HZDISKIN(4))
*
       if (lp) write(6,*) 'Hz'//xxxx,
     & ' x= ',x,' q2 ',q2,' y= ',y,' w2= ',w2
*
*      get position of scattered electron, energy,Pt and polar angle
*
       iel=HZIDELEC(idum)
       if (iel.eq.-1) then
        write(6,*) 'Hz'//xxxx,' electron not found '
        return
       endif

*.... attributes of scattered electron
       enel     = real(PHEP(4,iel))
       cos_thel = real( PHEP(3,iel)/
     +            sqrt(PHEP(1,iel)**2+PHEP(2,iel)**2+PHEP(3,iel)**2))
            If (cos_thel.lt.-1.OR.cos_thel.gt.1.) then
             write (6,*) 'no electron angle could be calculated'
             return
            Endif
       thel     = acos(cos_thel)*rd  ! theta in degrees

*.... get beam properties
       ierr=HZIBEAM(ibeam,idum)
       if (.not.(ierr.eq.1)) then
        write(6,*) 'HZ'//xxxx,' beams not found ! '
        return
       else
        Do i=1,4
         pbeam(i)=PHEP(i,IBEAM)
        enddo
       endif
*
       eb=real(PHEP(4,idum))
       if (abs(abs(eb)-ee).gt.0.2) then
        if (nentry.lt.10) then
         write(6,*) 'HZ'//xxxx,' Electron beam not at ',ee,'  ! '
        elseif (nentry.eq.10) then
         write(6,*) 'HZ'//xxxx,' Electron beam not at ',ee,
     &   ' ...last message ! '
        endif
C        return
       endif
*
*.... scattered quark angle
           coth= real( 1.-2.*y*eb/ (y*eb + Q2*(1.-y)/(4.*eb*y)) )
            If (coth.lt.-1.OR.coth.gt.1.) then
             write (6,*) 'no quark angle could be calculated'
             return
            Endif
           thq = acos(coth)*rd

*.... cut on forward energy
       efwd=0.
       Do 5 ihep=1,nhep
        if (isthep(ihep).ne.1.or.ihep.eq.iel) goto 5
        th=real(HZPHMANG(PHEP(3,ihep),
     &              sqrt(PHEP(1,ihep)**2+PHEP(2,ihep)**2)))*rd
        if(th.gt.4.4.and.th.lt.15.) then
         efwd=real(PHEP(4,ihep))+efwd
        endif
 5     continue

*
*      cut on kinematics
*
       evcut= ( ((thel.gt.157.).and.(thel.lt.172.5)).or.
     +          ((thel.gt.10. ).and.(thel.lt.150. )) )
       evcut= (thq.gt.10. ) .and. evcut
       evcut= (thq.lt.150.) .and. evcut
       evcut= (enel.gt.14.) .and. evcut
       evcut= (w2.ge.4400.) .and. evcut
       evcut= (y.lt.0.6   ) .and. evcut
       evcut= (y.gt.0.05  ) .and. evcut
       evcut= (efwd.gt.0.5) .and. evcut

       If (.not.(evcut)) then
        return
       Endif

       if (lp) write(6,*) 'Hz'//xxxx,
     &                         ' efwd= ',efwd,' evcut= ',evcut
*
*      set up Breit frame boost needed later
*
       ierr=HZIPGAM(ph)
       if (ierr.eq.-1) then
        write(6,*) 'HZ'//xxxx,' boson vector not found ! '
C        call VZERO(ph,5)
        Do i=1,5
         ph(i)=0.
        enddo
       else
        Do i=1,4
         pgam(i)=ph(i)
        enddo
       endif
*
       Call hzbrtini(pbeam,pgam,ierr)
       if (ierr.eq.1) then
        write(6,*) 'HZ'//xxxx,' problem with boost to cms ! '
        return
       endif
*
*      get bin number
*
       ibin=-1
       Do i=1,nxpbin
        if (lp)   write(6,*) i,q2aux(i),' < ',q2,' < ',q2aux(i+1)
        if (q2.ge.q2aux(i).and.q2.lt.q2aux(i+1)) ibin=i
       enddo
       if (ibin.le.0) then
        if (lp) write(6,*) 'hz',xxxx,' q2 in no bin= ',q2
        return
       endif
*
*.... calculate E/Q and cos_theta_bf for all hadrons in the
*     current region of the breit frame

*.... initialise plab, and pbreit as these shall be used later
      do ivec=1,4
       costheta_bf  = 0.05
       pbreit(ivec) = 0.0
        plab(ivec)  = 0.0
      enddo

      do 60 ihep = 1, nhep
        If(isthep(ihep).eq.1.and.ihep.ne.iel) then
         do ivec=1,4
          plab(ivec) = phep(ivec,ihep)
         enddo
         Call hzbrt(plab,pbrt,ierr)
         if(real(pbrt(3)).lt.0.) then
          do ivec=1,4  ! vector sum
           pbreit(ivec) = pbreit(ivec) + real(pbrt(ivec))
          enddo
         endif
        Endif
 60     continue

*.... events with no energy in this hemisphere have no definable
*     direction. These events are not included in histograms 800
*     and 801.

       If (pbreit(4).gt.0) then
         costheta_bf = real(pbreit(3)/
     +sqrt(pbreit(1)**2+pbreit(2)**2+pbreit(3)**2))
        if (ibin.lt.7) then
         call hfill(800,real(costheta_bf),
     +real(pbreit(4)/sqrt(q2)),wtx)
        else
         call hfill(801,real(costheta_bf),
     +real(pbreit(4)/sqrt(q2)),wtx)
        endif
       Endif

*.... initialise plab
       do ivec=1,4
        plab(ivec) = 0.0
       enddo

*.... initialise number of tracks per event
       ntrk = 0
       do 30 ihep = 1, nhep
        If(isthep(ihep).eq.1.and.ihchrg(ihep).ne.0
     +     .and.ihep.ne.iel) then
C        idpart=abs(idhep(jmohep(1,ihep)))
C        If(idpart.eq.310.or.idpart.eq.3122) goto 30
         do ivec=1,4
          plab(ivec) = phep(ivec,ihep)
         enddo
         Call hzbrt(plab,pbrt,ierr)
         if(real(pbrt(3)).lt.0.) then
          xp = 2.*real(sqrt(pbrt(1)**2+pbrt(2)**2+pbrt(3)**2))
     +        /sqrt(q2)
          xi = log(1./xp)

          call hfill(110+ibin,log(1./xp),0.,wtx)
          call hfill(30   ,sqrt(q2),0.,wtx)

          if (ibin.lt.7) then  ! low q2 data set
           call hfill(200,xp,0.,wtx)
           call hfill(300,real(xi),0.,wtx)
          else                 ! high q2 data set
           call hfill(201,xp,0.,wtx)
           call hfill(301,real(xi),0.,wtx)
          endif

*.... number of charged tracks for this event
         ntrk = ntrk + 1
         endif
        Endif
 30     continue
*
        call hfill(31   ,sqrt(q2),0.,wtx)

*.... number of events in each bin
        nev(ibin)=nev(ibin)+wtx
*
*
*.... fill pn bins (n1,n2... are counters for normailisation)
        If ((q2.ge.12).and.(q2.lt.30)) then
          if ((x.gt.6.E-4).and.(x.lt.1.E-2)) then
           n2num(1) = n2num(1) + wtx
           call hfill(600,real(ntrk),0.,wtx)
          endif
          if ((x.gt.6.E-4).and.(x.lt.2.E-3)) then
            nnum(1) = nnum(1) + wtx
            call hfill(400,real(ntrk),0.,wtx)
          elseif ((x.ge.2.E-3).and.(x.lt.1.E-2))  then
            nnum(2) = nnum(2) + wtx
            call hfill(401,real(ntrk),0.,wtx)
          endif
        Endif
*
        If ((q2.ge.30).and.(q2.lt.80)) then
          if ((x.gt.2.E-3).and.(x.lt.1.E-2)) then
           n2num(2) = n2num(2) + wtx
           call hfill(601,real(ntrk),0.,wtx)
          endif
          if ((x.gt.6.E-4).and.(x.lt.2.E-3)) then
            nnum(3) = nnum(3) + wtx
            call hfill(402,real(ntrk),0.,wtx)
          elseif ((x.ge.2.E-3).and.(x.lt.1.E-2)) then
            nnum(4) = nnum(4) + wtx
            call hfill(403,real(ntrk),0.,wtx)
          endif
        Endif
*
        If ((q2.ge.100).and.(q2.lt.500)) then
          if ((x.gt.2.E-3).and.(x.lt.2.E-1)) then
           n2num(3) = n2num(3) + wtx
           call hfill(602,real(ntrk),0.,wtx)
          endif
          if ((x.gt.2.E-3).and.(x.lt.1.E-2)) then
            nnum(5) = nnum(5) + wtx
            call hfill(404,real(ntrk),0.,wtx)
          elseif ((x.ge.1.E-2).and.(x.lt.2.E-1)) then
            nnum(6) = nnum(6) + wtx
            call hfill(405,real(ntrk),0.,wtx)
          endif
        Endif
************************************************************************
*
      Else if(iflag.eq.3) then
*      Termination: The following MUST always be done
*      (i) Move to the correct PAW subdirectory
*
       call hcdir('//PAWC/'//xxxx,' ')
*
* Deal with data plots
*
       Call hpak (-10,peak)
       Call hpak (-20,width)
       Call hpak (-30,mult)
       Call hpake(-10,epeak)
       Call hpake(-20,ewidth)
       Call hpake(-30,emult)
       call hpak (-101,qdata)
*.... L(xp) distributions
       call hpak (-200,xp1)
       call hpake(-200,dxp1)
       call hpak (-201,xp2)
       call hpake(-201,dxp2)
*....D(ln(1/xp)) distributions
       call hpak (-300,xi1)
       call hpake(-300,dxi1)
       call hpak (-301,xi2)
       call hpake(-301,dxi2)
*.... pn distributions
       call hpak (-400,pn1)
       call hpake(-400,dpn1)
       call hpak (-401,pn2)
       call hpake(-401,dpn2)
       call hpak (-402,pn3)
       call hpake(-402,dpn3)
       call hpak (-403,pn4)
       call hpake(-403,dpn4)
       call hpak (-404,pn5)
       call hpake(-404,dpn5)
       call hpak (-405,pn6)
       call hpake(-405,dpn6)

*
*      normalise and fit data histograms
*
*.... get number of events in low and high q2 sample
       nlow = 0
       nhig = 0
       do i=1,nxpbin
        if (i.lt.7) then
         nlow = nev(i) + nlow
        else
         nhig = nev(i) + nhig
        endif
       enddo

*.... get normalisation factors (account for the bin width)
       c1 = (15/(1.-0.))/nlow
       c2 = (15/(1.-0.))/nhig
       call hopera(200,'+e',200,200,c1,0.0)
       call hopera(201,'+e',201,201,c2,0.0)

       c1 = (40/(7.- (-1.)))/nlow
       c2 = (40/(7.- (-1.)))/nhig
       call hopera(300,'+e',300,300,c1,0.0)
       call hopera(301,'+e',301,301,c2,0.0)

*.... normalise pn distributions
       id1=400
       Do i=1,6
         If (nnum(i).gt.0.) then
          call hopera(id1,'+e',id1,id1,1./nnum(i),0.0)
         Endif
        id1=id1+1
       Enddo

*.... normalise pn distributions
       id1=600
       Do i=1,3
         If (n2num(i).gt.0.) then
          call hopera(id1,'+e',id1,id1,1./n2num(i),0.0)
         Endif
        id1=id1+1
       Enddo
*
*.... calculated as a ratio of #charged tracks/#events
       Call hopera(30,'/e',31,30,1.,1.)
*
       do ibin=1,nxpbin
        id=110+ibin
        xpmean = hstati(id,1,' ',1)
        Call hgive(id,chtitl,nx,xmi,xma,ny,ymi,yma,nwt,loc)
        call hxi(id,xpmean+1.2,limup)
        call hxi(id,xpmean-1.2,limlo)
        iquest(11) = limlo
        iquest(12) = limup
        par(1)= hmax(id)
        par(2)= xpmean
        par(3)= hstati(id,2,' ',1)
C       write(6,*) ' limup= ',limup,' limlo= ',limlo
C       write(6,*) ' par= ',par
        Call hfithn(id,'G','NQR',3,par,step,pmin,pmax,sigpar,chi2)
*
        write(6,'(a,a,a,i4,3(a,f9.3))') 'Hz',xxxx,
     &  ' id= ',id,' mean= ',par(2),' sig= ',par(3),' chi2= ',chi2
*
        call hfill(10,sqrtq(ibin)+0.1,0.,wtx*par(2))
        call hfill(20,sqrtq(ibin)+0.1,0.,wtx*par(3))
        call hdelet(id)
       enddo
*
       call hdelet(31)
*
       call HZchisq(-10,20)
       call HZchisq(-20,20)
       call HZchisq(-30,30)
       call HZchisq(-201,201)
       call HZchisq(-200,200)
       call HZchisq(-301,301)
       call HZchisq(-300,300)
       call HZchisq(-401,401)
       call HZchisq(-401,401)
       call HZchisq(-402,402)
       call HZchisq(-403,403)
       call HZchisq(-404,404)
       call HZchisq(-405,405)
*
      Endif
*
      RETURN
      END
