*CMZ :  1.01/14 24/03/98  09.56.35  by  Tancredi Carli
*CMZ :  1.01/13 20/03/98  16.58.18  by  Tancredi Carli
*-- Author :
************************************************************************
      Subroutine hz97183(iflag)
************************************************************************
* Subroutine hz97183                                                   *
* ==================                                                   *
*                                                                      *
* Author: Nick Brook (n.brook@physics.gla.ac.uk)                       *
*                                                                      *
* This routine plots the xp distbns                                    *
* in the current region of the Breit frame.                            *
* The distbn are corrected for particles coming from K0s and Lambdas   *
*                                                                      *
*                                                                      *
* Reference: Phys Lett B414(1997) 428.                                 *
*            DESY 97-183                                               *
*                                                                      *
************************************************************************
*
* HERA tuning defined commons
*
      Implicit Double Precision(A-H,O-Z)
#include "hepevtp.inc"
#include "heracmn.inc"
#include "hzfunc.inc"
#include "hzhbook.inc"
*
      COMMON/QUEST/IQUEST(100)
*
* Set up local variables
*
      Integer idum,ierr,nentry
      Character xxxx*5
      Real eb,ee
      Parameter (ee=27.5)
      Character*80 chtitl
      Character*2 cid
      Dimension plab(4), pbrt(4), pbeam(4), pgam(4), pgam5(5)
      Dimension qbins(8), xbins(5), qmean(11)
      Real chmean(10), chsig(10), xpmean
C*TC  Integer ids(11), Nacc(11),id, ncx
      Integer ids(11),id, ncx
      Real Nacc(11)
      Character*8 Tags(9)
      Real event(9)
      Integer iqu, iql, ixu, ixl
*
      Parameter(ncx=8)
      Real datx(8,11), datxe(8,11), datxsu(8,11), datxsl(8,11)
      Real logx(8), logxe(8), logxsu(8), logxsl(8)
      Real qdat(11)
      Real xpbins(9)
*
      Integer inbins
      Parameter(inbins=8)
      COMMON /ancmn/ meanq,lowq2,hiq2,lowxbj,highxbj,xp,xpstat,
     +                xpusys,xplsys
      Real  meanq, lowq2, hiq2,lowxbj,highxbj
      Real xp(8),xpstat(8),xpusys(8),xplsys(8)
      Real errtmp(8)
*
      Data nentry/0/
      Data xxxx/'97183'/
      data ids/12,13,23,33,24,34,44,54,65,75,55/
      Data xpbins/.02,.05,.1,.2,.3,.4,.5,.7,1./
      data Nacc /11*0./
*
* Data points from plots
*
      data qdat/14.4,14.7,28.1,54.7,29.2,56.7,
     +          110.,212.,440.,855.,222./
      data datx/1.49,2.83,3.58,2.79,1.68,.959,.389,.112,
     +          1.51,3.12,3.88,2.87,1.68,1.04,.438,.117,
     1          3.22,6.02,5.83,3.37,1.94,1.00,.428,.0941,
     2          7.98,10.7,7.27,3.80,1.78,.847,.387,.0793,
     3          3.53,6.55,6.16,3.66,1.95,1.07,.449,.107,
     4          8.14,10.8,8.29,4.08,1.99,.978,.389,.0801,
     5          15.5,16.8,9.33,4.03,1.73,.895,.391,.0658,
     6          26.8,21.4,10.2,3.69,1.86,.960,.280,.0912,
     7          41.4,25.6,9.68,3.69,1.35,.777,.374,.0498,
     8          52.0,28.1,9.15,4.11,1.95,.752,.297,.0162,
     9          26.8,24.2,10.5,4.25,1.94,.942,.284,.0638/
      data datxe/.103,.0952,.0734,.0644,.0488,.0361,.0152,.00649,
     +           .109,.111,.0809,.0667,.0491,.0382,.0165,.00647,
     1           .189,.188,.129,.0940,.0723,.0507,.0227,.00812,
     2           .414,.345,.197,.146,.0964,.0640,.0311,.0111,
     3           .185,.182,.121,.0899,.0642,.0467,.0207,.00775,
     4           .299,.246,.153,.106,.0732,.0503,.0221,.00763,
     5           .560,.439,.226,.151,.0935,.0669,.0326,.0105,
     6           1.31,.873,.436,.250,.184,.136,.0461,.0267,
     7           2.12,1.28,.548,.337,.191,.142,.0813,.0209,
     8           3.49,2.11,.801,.567,.415,.224,.0988,.0181,
     9           1.14,.868,.392,.254,.172,.116,.0402,.0151/
      data datxsu/.327,.337,.236,.136,.0742,.0256,.0751,.0328,
     +            .279,.108,.204,.282,.146,.0915,.0796,.0384,
     1            .659,.337,.184,.495,.175,.191,.0700,.0376,
     2            .547,.629,.559,.265,.146,.0747,.0643,.0256,
     3            .292,.618,.596,.275,.170,.271,.0774,.0429,
     4            .336,.856,.607,.462,.139,.203,.0459,.0253,
     5            .360,1.15,.664,.122,.210,.0547,.0458,.0157,
     6            1.63,1.69,.176,.128,.155,.000,.0925,.0291,
     7            1.63,1.34,.178,.0792,.118,.242,.000496,.0502,	
     8            1.31,1.08,.195,.664,.166,.215,.136,.0223,
     9            1.68,.796,.612,.113,.113,.211,.0922,.0254/
      data datxsl/.315,.232,.294,.242,.117,.128,.00106,.00596,
     +            .321,.359,.453,.416,.187,.171,.0519,.00572,
     1            .198,.973,.621,.437,.228,.0790,.0390,.00004,
     2            .778,1.02,.794,.0646,.0005,.0698,.0113,.00002,
     3            .411,.824,.985,.460,.224,.194,.0389,.0136,
     4            .550,1.09,.738,.358,.178,.104,.0274,.0126,
     5            1.92,.572,.424,.387,.110,.0611,.0252,.00531,
     6            2.12,.881,.528,.174,.0306,.235,.0242,.0235,
     7            1.57,1.11,.972,.304,.0573,.0332,.0843,.0219,
     8            2.67,3.01,.274,.243,.554,.158,.0478,.0184,
     9            2.03,2.44,.971,.447,.444,.135,.0593,.00043/

      save qbins, xbins

*
      If(iflag.eq.1) then
*
* Initialisation: The following MUST always be done
* (i) make subdirectory in PAWC
*      - use the name as the xxxxxx in HZxxxxxx subroutine
* (i) make subdirectory in o/p file
*
        Call hcdir('//PAWC',' ')
        call hmdir('97183','S')
        Call hcdir('//HISTO',' ')
        call hmdir('97183','S')
*
* book your histograms
*
        Do kd = 1, 11
          write(cid,'(I2)') ids(kd)
          call hbookb(ids(kd),' xp ('//cid//')',
     +                ncx,xpbins,0.)
*         call hbookb(-ids(kd),' xp ('//cid//')',
*    +                ncx,xpbins,0.)
*         call hbookb(-1000-ids(kd),' xp ('//cid//')',
*    +                ncx,xpbins,0.)
        Enddo
        Call hbnt(1000,'Monte Carlo',' ')
        Call Hbname(1000,'MC',meanq,'meanq:r,lowq2:r,hiq2:r'
     + //',lowxbj:r,highxbj:r,xp(8):r,xpstat(8):r')
        Call hbnt(2000,'Data',' ')
        Call Hbname(2000,'DAT',meanq,'meanq:r,lowq2:r,hiq2:r,'
     + //'lowxbj:r,highxbj:r,xp(8):r,xpstat(8):r,'
     1 //'xpusys(8):r,xplsys(8):r')
*
* set your plot/paper specific cuts
*
        qbins(1) = 10.
        qbins(2) = 20.
        qbins(3) = 40.
        qbins(4) = 80.
        qbins(5) = 160.
        qbins(6) = 320.
        qbins(7) = 640.
        qbins(8) = 1280.
        xbins(1) = 6.0e-04
        xbins(2) = 1.2e-03
        xbins(3) = 2.4e-03
        xbins(4) = 1.0e-02
        xbins(5) = 5.0e-02
*
      Else if(iflag.eq.2) then
* Filling: The following MUST always be done
* (i) move to the correct sub-directory in PAWC
*
        call hcdir('//PAWC/97183',' ')
        q2  = hzdiskin(1)
        xbj = hzdiskin(2)
        If(q2.ge.qbins(1).and.q2.lt.qbins(2).and.
     +     xbj.ge.xbins(1).and.xbj.lt.xbins(2)) then
           id = 12
           Nacc(1) = Nacc(1) + wtx
           qmean(1) = qmean(1) + q2
        Else If(q2.ge.qbins(1).and.q2.lt.qbins(2).and.
     +     xbj.ge.xbins(2).and.xbj.lt.xbins(3)) then
           id = 13
           Nacc(2) = Nacc(2) + wtx
           qmean(2) = qmean(2) + q2
        Else If(q2.ge.qbins(2).and.q2.lt.qbins(3).and.
     +     xbj.ge.xbins(2).and.xbj.lt.xbins(3)) then
           id = 23
           Nacc(3) = Nacc(3) + wtx
           qmean(3) = qmean(3) + q2
        Else If(q2.ge.qbins(3).and.q2.lt.qbins(4).and.
     +     xbj.ge.xbins(2).and.xbj.lt.xbins(3)) then
           id = 33
           Nacc(4) = Nacc(4) + wtx
           qmean(4) = qmean(4) + q2
        Else If(q2.ge.qbins(2).and.q2.lt.qbins(3).and.
     +     xbj.ge.xbins(3).and.xbj.lt.xbins(4)) then
           id = 24
           Nacc(5) = Nacc(5) + wtx
           qmean(5) = qmean(5) + q2
        Else If(q2.ge.qbins(3).and.q2.lt.qbins(4).and.
     +     xbj.ge.xbins(3).and.xbj.lt.xbins(4)) then
           id = 34
           Nacc(6) = Nacc(6) + wtx
           qmean(6) = qmean(6) + q2
        Else If(q2.ge.qbins(4).and.q2.lt.qbins(5).and.
     +     xbj.ge.xbins(3).and.xbj.lt.xbins(4)) then
           id = 44
           Nacc(7) = Nacc(7) + wtx
           qmean(7) = qmean(7) + q2
        Else If(q2.ge.qbins(5).and.q2.lt.qbins(6).and.
     +     xbj.ge.xbins(3).and.xbj.lt.xbins(4)) then
           id = 54
           Nacc(8) = Nacc(8) + wtx
           qmean(8) = qmean(8) + q2
        Else If(q2.ge.qbins(6).and.q2.lt.qbins(7).and.
     +     xbj.ge.xbins(4).and.xbj.lt.xbins(5)) then
           id = 65
           Nacc(9) = Nacc(9) + wtx
           qmean(9) = qmean(9) + q2
        Else If(q2.ge.qbins(7).and.q2.lt.qbins(8).and.
     +     xbj.ge.xbins(4).and.xbj.lt.xbins(5)) then
           id = 75
           Nacc(10) = Nacc(10) + wtx
           qmean(10) = qmean(10) + q2
        Else If(q2.ge.qbins(5).and.q2.lt.qbins(6).and.
     +     xbj.ge.xbins(4).and.xbj.lt.xbins(5)) then
           id = 55
           Nacc(11) = Nacc(11) + wtx
           qmean(11) = qmean(11) + q2
        Else
           Return
        Endif
*
* Fill your histograms
*
          jel = hzidelec(idum)
          if(jel.lt.0) Return
          if(hzipgam(pgam5).lt.0) Return
          if(hzibeam(ip,il).ne.1) Return
* check on electron beam energy
          nentry=nentry+1
          ierr=HZIBEAM(ibeam,idum)
          if (.not.(ierr.eq.1)) then
           write(6,*) 'HZ'//xxxx,' beams not found ! '
           return
          endif
*
          eb=real(PHEP(4,idum))
          if (abs(abs(eb)-ee).gt.0.3) then
           if (nentry.lt.10) then
            write(6,*) 'HZ'//xxxx,' Electron beam not at ',ee,'  ! '
           elseif (nentry.eq.10) then
            write(6,*) 'HZ'//xxxx,' Electron beam not at ',ee,
     &      ' ...last message ! '
           endif
           return
          endif

          do ivec = 1, 4
            pbeam(ivec) = phep(ivec,ip)
            pgam(ivec) = pgam5(ivec)
          enddo
          Call hzbrtini(pbeam,pgam,ierr)
          do 30 ihep = 1, nhep
            If(isthep(ihep).eq.1.and.ihchrg(ihep).ne.0
     +         .and.ihep.ne.jel) then
             idpart=abs(idhep(jmohep(1,ihep)))
             If(idpart.eq.310.or.idpart.eq.3122) goto 30
             do ivec=1,4
               plab(ivec) = phep(ivec,ihep)
             enddo
             Call hzbrt(plab,pbrt,ierr)
             if(pbrt(3).lt.0.) then
               xpp = 2.*sqrt(pbrt(1)**2+pbrt(2)**2+pbrt(3)**2)
     +               /sqrt(q2)
               call hfill(id,real(xpp),0.,wtx)
             endif
            Endif
 30       continue
*
      Else if(iflag.eq.3) then
* Termination: The following MUST always be done
* (i) Move to the correct PAW subdirectory
*
        call hcdir('//PAWC/97183',' ')
*
* Histo manipulation
* Deal with data plots
*
        Do kd = 1, 11
*
          if(kd.eq.1) then
            iql = 1
            iqu = 2
            ixl = 1
            ixu = 2
          else if(kd.eq.2) then
            iql = 1
            iqu = 2
            ixl = 2
            ixu = 3
          else if(kd.eq.3) then
            iql = 2
            iqu = 3
            ixl = 2
            ixu = 3
          else if(kd.eq.4) then
            iql = 3
            iqu = 4
            ixl = 2
            ixu = 3
          else if(kd.eq.5) then
            iql = 2
            iqu = 3
            ixl = 3
            ixu = 4
          else if(kd.eq.6) then
            iql = 3
            iqu = 4
            ixl = 3
            ixu = 4
          else if(kd.eq.7) then
            iql = 4
            iqu = 5
            ixl = 3
            ixu = 4
          else if(kd.eq.8) then
            iql = 5
            iqu = 6
            ixl = 3
            ixu = 4
          else if(kd.eq.9) then
            iql = 6
            iqu = 7
            ixl = 4
            ixu = 5
          else if(kd.eq.10) then
            iql = 7
            iqu = 8
            ixl = 4
            ixu = 5
          else if(kd.eq.11) then
            iql = 5
            iqu = 6
            ixl = 4
            ixu = 5
          Endif
          lowq2 = sngl(qbins(iql))
          hiq2 = sngl(qbins(iqu))
          lowxbj = sngl(xbins(ixl))
          highxbj = sngl(xbins(ixu))
          nacc(kd) = max(1.,nacc(kd))
          qmean(kd) = qmean(kd)/dble(nacc(kd))
          meanq = sngl(qmean(kd))
          Call hzhinrm(ids(kd),0,nacc(kd),1)
          call hzhinfo(ids(kd),nacc(kd))
          Call hunpak(ids(kd),xp,' ',0)
          Call hunpke(ids(kd),xpstat,' ',0)
          Call hfnt(1000)
          id=-1000-ids(kd)
          call hbookb(id,' xp ',ncx,xpbins,0.)
          Call ucopy(datx(1,kd),logx,8)
          Call ucopy(datxe(1,kd),logxe,8)
          Call hpak(id,logx)
          Call hpake(id,logxe)
          meanq = qdat(kd)
          call ucopy(logx,xp,8)
          call ucopy(logxe,xpstat,8)
          Call ucopy(datxsu(1,kd),xpusys,8)
          Call ucopy(datxsl(1,kd),xplsys,8)
          do kerr = 1, 8
            errtmp(kerr) = sqrt(xpstat(kerr)**2+xpusys(kerr)**2)
          enddo
          id=-ids(kd)
          call hbookb(id,' xp ',ncx,xpbins,0.)
          call hpak(id,xp)
          Call hpake(id,errtmp)
          do kerr = 1, 8
            errtmp(kerr) = sqrt(xpstat(kerr)**2+xplsys(kerr)**2)
          enddo
          id1=-2000-ids(kd)
          call hbookb(id1,' xp ',ncx,xpbins,0.)
          call hpak(id1,xp)
          Call hpake(id1,errtmp)
*         Write(6,*) 'logx,xp: ',logx,xp
          Call hfnt(2000)
*
          call HZCHISQ(-1000-ids(kd),ids(kd))
          Call hzchisqa(id,id1,ids(kd))
          Call hdelet(id)
          Call hdelet(id1)
        Enddo

      Endif
*
      Return
 1001 Format(/,1X,' bin # ',I2,' Mean Q = ',F4.1)
 1002 Format(A,F4.2,A,F4.2)
 1003 Format(A,F4.2,A,F4.2,A,F4.2)
      End
