*CMZ :  1.02/06 04/02/99  11.23.04  by  Tancredi Carli
*CMZ :  1.02/00 04/10/98  22.18.08  by  Tancredi Carli
*CMZ :  1.01/15 03/09/98  19.46.00  by  Tancredi Carli
*-- Author :    Hannes Jung   13/03/98
      subroutine HZ98029(IFLAG)
****************************************************************************
* Purpose: diffractive hadron production in DIS
*
*
* Event selection:
*
* Running:
*
* Arguments: iflag=1 initialisation
*            iflag=1 filling
*            iflag=3 termination
*
* written by:
****************************************************************************
      IMPLICIT NONE
#include "hzfunc.inc"
#include "hzhbook.inc"
#include "hepevtp.inc"
#include "heracmn.inc"
*
* common that gives the position of particles in X and Y system
      integer nxobj,nyobj,nxgag,nygag
      double precision pom
      common /diffhad/pom(5),nxobj(5000),nyobj(5000),nxgag,nygag
*
      Integer numjet
      Parameter (numjet=50)
      Double precision pj(numjet,8)
      Double precision pbeam(4),pgam(4),pcm(4),ph(5),plab(5,NMXHEP)
*
      Integer i,iflag,ihep
      Character*5 xxxx
*
      Real pi,rd,eb,ee
      Parameter (ee=27.5)
      Integer iel,idum,ibeam
      Parameter (pi=3.1415927,rd=180./pi)
      Integer nentry
      Real x,y,q2,enel,thel,efwd,th,lx,lxj
*
      Integer ierr
      Integer maxhi,modjet,maxjet
      Parameter (maxhi=2000,modjet=2,maxjet=30)
      Real  selj(maxjet,4),help,empz,empzh,xg,empzl,empzhl,xgl
      Integer ipjet(maxjet),l,k
      Real nev(maxhi),lum,xw,nev2(maxhi)
      Real deta,ptj2,thj
      Real xpom, x_pom,beta,xgluon,shat,p_sh(4),p_mx(4),mx2,mx
      Real xmas,ymas,t
      Real pj1,pj2,pr
      Integer njet,nj,nsel,ij,idhe,nhst,iy
      Double precision rcone
      Parameter (rcone=1.)
      Logical lp,twojet,hadpro
      Data lp/.false./
*********************************************************************
      Integer nx
      Real n2,nall,nall2,nall3
      Real xmin,xmax
      save xxxx,nev,nall
      Data xxxx/'98029'/,NENTRY/0/
      Real nmx(3),npt2,nxf
      Integer npt2bin,nxfbin,nxptbin,iprot
      parameter (npt2bin=6)
      parameter (nxfbin=14)
      parameter (nxptbin=14)
      Real pt2,pt2bin(npt2bin+1),ptl,xf,xfbin(nxfbin+1)
      Real xptbin(nxptbin+1),eta

      save npt2, nxf


      Data pt2bin/0.0,0.5,1.,1.5,2.,2.5,4.0/
      Data xfbin/-1.,-0.61,-0.35,-0.2,-0.11,-0.06,-0.03,0.0,
     +            0.03,0.06,0.11,0.2,0.35,0.61,1./

      Data xptbin/-1.,-0.61,-0.35,-0.2,-0.11,-0.06,-0.03,0.0,
     +            0.03,0.06,0.11,0.2,0.35,0.61,1./
*
* xf data points
      Real xfdat(14)
      data xfdat /0.0          ,0.6128334,2.502780,
     +            6.722888     ,14.35409 ,25.47832,
     +            38.97226     ,41.50776 ,25.50608,
     +            15.86608     ,7.249624 ,2.898936,
     +            0.6434051    ,0.3205689E-01/
      Real xfdate(14)
      data xfdate/0.0          ,0.1639854,0.3604059,
     +            0.8731437    ,1.864209 ,3.442043 ,
     +            4.914548     ,4.464791 ,2.808532 ,
     +            1.886804     ,1.006006 ,0.4336618,
     +            0.1044459    ,0.6333744E-02/

* seagull data points
*
      Real seag(14)
      data seag  /0.0          ,0.6129190,0.4426591,
     +            0.4094211    ,0.2504560,0.1961280,
     +            0.1547809    ,0.1507783,0.2177576,
     +            0.2894962    ,0.3887810,0.5986921,
     +            0.9272553    ,0.0/
      Real seage(14)
      data seage /0.0          ,0.2672890    ,0.1001036    ,
     +            0.7536040E-01,0.4259405E-01,0.3402222E-01,
     +            0.2724520E-01,0.2423158E-01,0.3575291E-01,
     +            0.4611826E-01,0.6093225E-01,0.1087604    ,
     +            0.2259952    ,0.0/
*
* Pt2 points
*
      Real pt2dat(6)
      Data pt2dat /0.6894866    ,0.1620546    ,0.5348691E-01,
     +             0.2778080E-01,0.2245054E-01,0.6371100E-02/
      Real pt2date(6)
      Data pt2date/0.1251314    ,0.4664608E-01,0.1258624E-01,
     +             0.1053530E-01,0.1044376E-01,0.2364720E-02/
*
* energyflow points
*---------------------------------------------------
*eta       3<Mx<8
*----------------------------------------------------
      real efmx1(24)
      data efmx1/0.0          ,0.0          ,0.0          ,
     +           0.0          ,0.0          ,0.0          ,
     +           0.2319668    ,0.4187408    ,0.6852522    ,
     +           0.9642797    ,1.237603     ,1.440106     ,
     +           1.714669     ,1.433049     ,0.9741630    ,
     +           0.5792634    ,0.3224706    ,0.0          ,
     +           0.0          ,0.0          ,0.0          ,
     +           0.0          ,0.0          ,0.0          /
*---------------------------------------------------
*eta       8<Mx<18
*----------------------------------------------------
      real efmx2(24)
      data efmx2/0.0          ,0.0          ,0.0          ,
     +           0.0          ,0.0          ,0.2670097    ,
     +           0.7485002    ,1.604767     ,1.990809     ,
     +           2.205431     ,1.873415     ,1.597115     ,
     +           2.063725     ,2.324681     ,2.757001     ,
     +           2.329961     ,1.149755     ,0.6476511    ,
     +           0.3185704    ,0.0          ,0.0          ,
     +           0.0          ,0.0000000E+00,0.0          /

*---------------------------------------------------
*eta       18>Mx
*----------------------------------------------------
      real efmx3(24)
      data efmx3/0.0          ,0.0          ,0.0          ,
     +           0.0          ,0.0          ,0.6814263    ,
     +           2.567204     ,3.731685     ,4.114427     ,
     +           3.002993     ,2.170356     ,1.912852     ,
     +           2.107126     ,2.985842     ,4.156892     ,
     +           5.070118     ,3.515426     ,2.059493     ,
     +           1.000870     ,0.0          ,0.0          ,
     +           0.0          ,0.0          ,0.0          /

*Energy Flow Errors
*
*---------------------------------------------------
*eta       3<Mx<8
*----------------------------------------------------
      real efmx1e(24)
      data efmx1e/0.0          ,0.0          ,0.0          ,
     +            0.0          ,0.0          ,0.0          ,
     +            0.7838635E-01,0.1610065    ,0.2110434    ,
     +            0.2595083    ,0.1390658    ,0.1493511    ,
     +            0.1886857    ,0.2149692    ,0.2015068    ,
     +            0.1189617    ,0.6361540E-01,0.0          ,
     +            0.0          ,0.0          ,0.0          ,
     +            0.0          ,0.0          ,0.0          /

*---------------------------------------------------
*eta       8<Mx<18
*----------------------------------------------------
      real efmx2e(24)
      data efmx2e/0.0          ,0.0          ,0.0          ,
     +            0.0          ,0.0          ,0.1448712    ,
     +            0.1818503    ,0.6667079E-01,0.1105839    ,
     +            0.1221576    ,0.1314093    ,0.1032115    ,
     +            0.1336651    ,0.1858400    ,0.2905588    ,
     +            0.2857165    ,0.1343448    ,0.1143797    ,
     +            0.9657340E-01,0.0          ,0.0          ,
     +            0.0          ,0.0          ,0.0          /

*---------------------------------------------------
*eta       18>Mx
*----------------------------------------------------
      real efmx3e(24)
      data efmx3e/0.0          ,0.0          ,0.0          ,
     +            0.0          ,0.0          ,0.2279920    ,
     +            0.4425851    ,0.5789824    ,0.5070215    ,
     +            0.2493457    ,0.2377237    ,0.1537880    ,
     +            0.2004447    ,0.2493169    ,0.4504904    ,
     +            0.7132304    ,0.6227964    ,0.4177885    ,
     +            0.1989908    ,0.0          ,0.0          ,
     +            0.0          ,0.0          ,0.0          /


*********************************************************************
*
*                      Initialization
*
*********************************************************************
      NENTRY=NENTRY+1
*
      IF (iflag.eq.1) then
*
         nall=0.
         nall2=0.
         nall3=0.
         n2=0.
         npt2=0.
         nxf=0.
         call Vzero(nev,maxhi)
         call Vzero(nev2,maxhi)
         call Vzero(nmx,3)
*
*
* Initialisation: The following MUST always be done
* (i) make subdirectory in PAWC
* - use the name as the xxxxxx in HZxxxxxx subroutine
* (i) make subdirectory in o/p file
*
         Call hcdir('//PAWC',' ')
         call hmdir(xxxx,'S')
         Call hcdir('//HISTO',' ')
         call hmdir(xxxx,'S')
*
* book histos
*
         nx=6
         xmin=0.05e-2
         xmax=0.35e-02
*
         call hbook1(221,'  y     ',100,0.,1.,0.)
         call hbook1(222,'  Q2     ',100,0.,100.,0.)
         call hbook1(223,'  xpom    ',100,0.,0.1,0.)
         call hbook1(224,'  M_x  0-20  ',100,0.,20.,0.)
         call hbook1(225,'  M_x  0-100  ',100,0.,100.,0.)
         call hbook1(226,'  z ',100,0.,1.,0.)
         call hbook1(227,'  pt ',100,0.,50.,0.)
         call hbook1(228,'  M_y  0-20  ',100,0.,20.,0.)
         call hbook1(229,'  M_y  0-100  ',100,0.,100.,0.)


*
* pack data into histograms
*
*         Call hpak (-122,secpt)
*         Call hpake(-122,stapt)

* histos for hadron production
         call hbook1(1001,'  eta* 3<mx<8      ',24,-6.,6.,0.)
         call hbook1(1002,'  eta* 8<mx<18     ',24,-6.,6.,0.)
         call hbook1(1003,'  eta* 18<mx<30    ',24,-6.,6.,0.)
         call hbookb(1010,'  pt2 8<mx<18    ',npt2bin,pt2bin,0.)
         call hbookb(1011,'  xf 8<mx<18    ',nxfbin,xfbin,0.)
         call hbookb(1012,'  pt2mean 8<mx<18    ',nxptbin,xptbin,0.)
         call hbook1(-1001,' data  eta* 3<mx<8      ',24,-6.,6.,0.)
         call hbook1(-1002,' data  eta* 8<mx<18     ',24,-6.,6.,0.)
         call hbook1(-1003,' data  eta* 18<mx<30    ',24,-6.,6.,0.)
         call hbookb(-1010,' data pt2 8<mx<18    ',npt2bin,pt2bin,0.)
         call hbookb(-1011,' data xf 8<mx<18    ',nxfbin,xfbin,0.)
         call hbookb(-1012,' data pt2mean 8<mx<18    '
     +     ,nxptbin,xptbin,0.)
* pack data into histograms
*
         Call hpak (-1001,efmx1)
         Call hpake(-1001,efmx1e)
         Call hpak (-1002,efmx2)
         Call hpake(-1002,efmx2e)
         Call hpak (-1003,efmx3)
         Call hpake(-1003,efmx3e)
         Call hpak (-1011,xfdat)
         Call hpake(-1011,xfdate)
         Call hpak (-1010,pt2dat)
         Call hpake(-1010,pt2date)
         Call hpak (-1012,seag)
         Call hpake(-1012,seage)
         write(6,*) ' in hz98029 '
*
*********************************************************************
*
*                      Event Processing
*
*********************************************************************
      Else if(iflag.eq.2) then
*
* Filling: The following MUST always be done
* (i) move to the correct sub-directory in PAWC
*
         call hcdir('//PAWC/'//xxxx,' ')
*
         xw=wtx
         nall=nall+xw
*
         ierr=HZIBEAM(ibeam,idum)
         if (.not.(ierr.eq.1)) then
            write(6,*) 'HZ'//xxxx,' beams not found ! '
            return
         else
            Do i=1,4
               pbeam(i)=PHEP(i,IBEAM)
            enddo
         endif
*
         eb=real(PHEP(4,idum))
         if (abs(abs(eb)-ee).gt.0.1) then
            if (nentry.lt.10) then
               write(6,*) 'HZ'//xxxx,' Electron not at ',ee,' ! ',eb
            elseif (nentry.eq.10) then
               write(6,*) 'HZ'//xxxx,' Electron beam not at ',ee,
     +         ' ...last message ! '
            endif
            return
         endif
         ierr=HZIPGAM(ph)
         if (ierr.eq.-1) then
            write(6,*) 'HZ'//xxxx,' boson vector not found ! '
C           call VZERO(ph,5)
            Do i=1,5
             ph(i)=0.
            enddo
         else
            Do i=1,4
               pgam(i)=ph(i)
            enddo
         endif
*
* Event selection
*
         q2=real(HZDISKIN(1))
         x =real(HZDISKIN(2))
         y =real(HZDISKIN(3))

         deta = -999.
         njet = 0
*
         if (lp) then
            write(*,*) 'Hz'//xxxx,' x y q2=',x,y,q2
         endif
*
* get electron variables for kinematic selection
*
         iel=HZIDELEC(idum)
         if (iel.eq.-1) then
            write(*,*) 'Hz'//xxxx,' electron not found '
            return
         endif
         enel=real(PHEP(4,iel))
         thel=real(HZPHMANG(PHEP(3,iel), sqrt(PHEP(1,iel)**2+PHEP(2,
     +   iel)**2)))*rd
*
*
*  do diffractive selection
         x_pom=1.
         xpom=999.
         do i=1,4
            p_mx(i)=0.
         enddo
         Do 10   ihep=1,nhep
* do not count scattered electron
            if(ihep.eq.iel) goto 10
            idhe=idhep(ihep)
*  proton tag

            if ( abs(idhe).eq.2212.and.jmohep(1,ihep).eq.2 ) then
               iprot = ihep
               goto 11
            endif
   10    continue
   11    continue
         call hzhadgap(xmas,ymas,xpom,t)
         do i=1,4
            pbeam(i)=pom(i)
         enddo
         mx2=xmas**2
         if( xpom.le.x_pom) x_pom=xpom
         if (lp) then
            write(6,*) 'Hz'//xxxx,' enel= ',enel,' thel= ',thel
            write(6,*) 'Hz'//xxxx,' y= ',y,' q2= ',q2
            write(6,*) 'Hz'//xxxx,' x_pom= ',x_pom,' m_x ',sqrt(mx2)
         endif
         if(x_pom.lt.x) then
            if(lp) then
               write(6,*) ' hz98029: x < x_pom = '
               write(6,*) ' hz98029: x = ',x,' x_pom = ',xpom,' t = ',t
               write(6,*) ' hz98029: xmas = ',xmas,' ymas = ',ymas
               write(6,*) ' hz98029: q2 = ',q2,' y = ',y
               write(6,*) 'Hz'//xxxx,' nxgag,nygag ',nxgag,nygag
               write(6,*) 'Hz'//xxxx,' nxobj ',(nxobj(i),i=1,nxgag)
               write(6,*) 'Hz'//xxxx,' nyobj ',(nyobj(i),i=1,nygag)
C               call hzlulist(1)
            endif
            return
         endif

         hadpro=.true.

         if (y.lt.0.05) hadpro=.false.
         if (y.gt.0.6) hadpro=.false.
         if (q2.lt.7.5) hadpro=.false.
         if (q2.gt.100.) hadpro=.false.
         if (x_pom.gt.0.025) hadpro=.false.
         if (ymas.gt.1.6) hadpro=.false.
         if (abs(t).gt.1.0) hadpro=.false.
*
*  hadron production
         if(hadpro) then
            nall3 = nall3 + xw
            mx=sqrt(amax1(0.,mx2))
            if(mx.ge.3.0.and.mx.lt.8.0) then
               nmx(1)=nmx(1)+xw
            elseif(mx.ge.8.0.and.mx.lt.18.0) then
               nmx(2)=nmx(2)+xw
            elseif(mx.ge.18.0.and.mx.lt.30.0) then
               nmx(3)=nmx(3)+xw
            endif
            if(mx.ge.8.0.and.mx.lt.18.0) then
               npt2=npt2+xw
               nxf=nxf+xw
            endif
            ierr=HZIPGAM(ph)
            if (ierr.eq.-1) then
               write(6,*) 'HZ'//xxxx,' boson vector not found ! '
C              call VZERO(ph,5)
               Do i=1,5
                ph(i)=0.
               enddo
            else
               Do i=1,4
                  pgam(i)=ph(i)
               enddo
            endif
*
            call HZHCMINI(pbeam,pgam,ierr)
            if (ierr.eq.1) then
               write(6,*) 'HZ'//xxxx,' problem with boost to cms ! '
               return
            endif
*
*       loop and boost
*
            nhst = 1
            do ihep=nhst,nhep
               Do i=1,4
                  Ph(i)=PHEP(i,ihep)
                  Plab(i,ihep)=PHEP(i,ihep)
                  phep(i,ihep)=0.0
               enddo
*
               call HZHCM(ph,pcm,ierr)
               if (ierr.eq.1) then
                  write(6,*) 'HZ'//xxxx,' problem with boost to cms '
     +            //'! '
                  return
               endif
*

               if (isthep(ihep).ne.1.or.ihep.eq.iel) then
                  th=real(HZPHMANG(PHEP(3,ihep), sqrt(PHEP(1,ihep)**
     +            2+PHEP(2,ihep)**2)))*rd
               endif
*
               Do i=1,4
                  PHEP(i,ihep)=Pcm(i)
               enddo
* do not count particles assigned to Y system
*                  write(6,*) ' hz98029 nyobj(iy) ',(nyobj(iy),iy=1,nygag)
               do iy=1,nygag
                  if(ihep.eq.nyobj(iy)) goto 30
               enddo
               if(ihep.ne.iel) then
                  if(isthep(ihep).eq.1.and.phep(4,ihep).ne.0.0) then
                     eta= real(phep(4,ihep)+phep(3,ihep))/(phep(4,ihep)
     +               - phep(3,ihep))
                     eta = 0.5*log(eta)
                     pr = real(phep(1,ihep)**2 + phep(2,ihep)**2)
                     eta = sign(log(min((sqrt(pr + real(phep(3,ihep))**
     +               2) - abs(real(phep(3,ihep))))/sqrt(pr),1e20)),
     +               real(phep(3, ihep)))

                     if(mx.ge.3.0.and.mx.lt.8.0) then
                        call hfill(1001,eta,0.,sngl(phep(4,ihep)*xw)
     +                  )
                     elseif(mx.ge.8.0.and.mx.lt.18.0) then
                        call hfill(1002,eta,0.,sngl(phep(4,ihep)*xw)
     +                  )
                     elseif(mx.ge.18.0.and.mx.lt.30.0) then
                        call hfill(1003,eta,0.,sngl(phep(4,ihep)*xw)
     +                  )
                     endif
                     if(mx.ge.8.0.and.mx.lt.18.0.and.ihchrg(ihep)
     +               .ne.0) then
                        pt2=real(phep(1,ihep)**2 + phep(2,ihep)**
     +                  2)
                        xf = 2.*real(phep(3,ihep))/mx
                        if(xf.ge.0.2.and.xf.lt.0.4) call hfill(1010,
     +                  pt2,0.,xw)
                        call hfill(1011,xf,0.,xw)
                        call hfill(1012,xf,0.,pt2*xw)
                     endif
                  endif
               endif
   30          continue
            enddo
* fill original PHEP vectors
            do ihep=nhst,nhep
               Do i=1,4
                  PHEP(i,ihep)= Plab(i,ihep)
               enddo
            enddo
         endif
*

*********************************************************************
*
*                      Termination
*
*********************************************************************

      Else if(iflag.eq.3) then

* Termination: The following MUST always be done
* (i) Move to the correct PAW subdirectory
*
         call hcdir('//PAWC/'//xxxx,' ')
*
         lum=999999999.
         if (xsec.ne.0.) then
            lum=real(nall)/real(xsec)
         else
            write(6,*) 'hz',xxxx,' xsec=0 ! '
         endif
*
         write(6,*) 'hzhad: Total Cross= ', real(xsec),' nall= ',nall
*
*
*      normalize the histos
*
*

* now the hadron production
         if(nall3.gt.1) then
            do i=1,3
               call hzhinrm( 1000+i, 0, nmx(i), 1 )
               call hzchisq(-1*(1000+i),1000+i)
            enddo
            call hzhinrm( 1010, 0, npt2, 1 )
            call hzchisq(-1010,1010)
            call hopera(1012,'/',1011,1012,1.,1.)
            call hzhinrm( 1011, 0, nxf, 1 )
            call hzchisq(-1011,1011)
         endif
      endif
*
      RETURN
      END
