      subroutine hz98204(IFLAG)
***********************************************
* D*-data h1 photoproduction
* Cuts :    Q2 < 0.01
*        0.29< y_bj <0.62
*-- Author :  H. Jung
*
***********************************************
      IMPLICIT NONE
*
      real enel,thel
      Real pi,dpi,rd,ee,eb,dphi
      Real xpt1,xpt2,xxd1,xxd2
      Logical evcut,lp,lctag,lstag
      data lp/.false./
*
      Character string*20
*
      Integer nev,nentry,nd0,ndplus,ndminus
      Real Qpi,qqradp,xntot,q2,x,y,w2
      data xntot/0/
      Real ptl,pth,wl,wh,etal,etah
      Integer nbpt,nbw,nbeta
      Data nev/0/
      Integer ncut
      Parameter (ncut=4,pi=3.1415927,dpi=2.*pi,rd=180./pi,ee=27.5)
*
      Integer ierr,ibeam,igam,iel,idum,idhe,idmo1,idmo2
      Double precision pbeam(4),pgam(4),pcm(4),ph(5),phc(4)
*
      integer err_flag
      real xnd0,alphem,sigma_tot,x_d,p,pt,et,th,phdum,rap
      real lum,lum1,binw
      data xnd0/0./
*
#include "hzfunc.inc"
#include "hzhbook.inc"
#include "hepevtp.inc"
#include "heracmn.inc"
#include "hzjetcmn.inc"
*
      Integer iflag,ihep,i,j,k,l,idhisto,ndstare
	Integer nc,ncb,ndstar,ndstarb
      Real brdstar,xw,xnorm
*     DESY Preprint number
      Character*5 xxxx
      Data xxxx/'98204'/
      Integer nbs
      Data nbs/5/
      Real ptbs(6)
      Data ptbs/2.5,3.,4.,5.,7.,10.5/
      Real etabs(6)
      Data etabs/-1.5,-1.,-0.5,0.0,0.5,1.5/
      Integer nbptd
      Data nbptd/3/
      Real ptbd(4)
      Data ptbd/2.5,3.,5.,10.5/
      Integer nbetad
      Data nbetad/4/
      real etabd(5)
      Data etabd/-1.5,-1.,-0.25,0.5,1.5/
* data points single differential
*     pt
      Real ccmpt(5),ccmpte(5)
      Data ccmpt/0.356559,0.203777,0.0866028,0.019452,0.00242447/
      Data ccmpte/0.104116,0.0330405,0.015937,0.00550734,0.00136206/
* eta
      Real ccmeta(5),ccmetae(5)
      Data ccmeta/0.23457,0.251828,0.179626,0.17642,0.0971739/
      Data ccmetae/0.0464962,0.041095,0.0424688,0.0450551,0.0367309/
* data points double differential

* eta in bins of pt
      Real c1eta(4),c1etae(4)
      Data c1eta/0.109304,0.0564606,0.054755,0.0164108/
      Data c1etae/0.0253123,0.0149244,0.0174865,0.0190817/
      Real c2eta(4),c2etae(4)
      Data c2eta/12.380,31.150,19.9137,12.7009/
      Data c2etae/4.61188,5.8558,5.29339,4.86485/
      Real c3eta(4),c3etae(4)
      Data c3eta/0.767354,1.97519,1.58347,1.55159/
      Data c3etae/0.617323,0.649028,0.800015,0.670103/
      Real bw(7)
      Data bw/0.5,0.75,0.75,1.,1.,1.5,5.5/

*
*
*********************************************************************
*
*                      Initialization
*
*********************************************************************
      NENTRY=NENTRY+1
*
      IF (iflag.eq.1) then
*
         nd0=0
         ndplus=0
         write(6,*)' hz98204 D* Version'
         Qpi = 4.*atan(1.)
         qqradp = 180./qpi
*
*
*      Initialisation: The following MUST always be done
*      (i) make subdirectory in PAWC
*       - use the name as the xxxxxx in HZxxxxxx subroutine
*      (i) make subdirectory in o/p file
*
         Call hcdir('//PAWC',' ')
         call hmdir(xxxx,'S')
         Call hcdir('//HISTO',' ')
         call hmdir(xxxx,'S')
c         call hbook1(9901,'pt d*    ',16,2.5,10.5,0.)
c         call hbook1(9902,'eta d*   ',6,-1.5,1.5,0.)
c         call hbook1(9951,'pt d*  -1.5<eta<-1   ',8,2.5,10.5,0.)
c         call hbook1(9952,'pt d*  -1  <eta<0.25 ',8,2.5,10.5,0.)
c         call hbook1(9953,'pt d*  0.25<eta<0.5  ',8,2.5,10.5,0.)
c         call hbook1(9954,'pt d*  0.5 <eta<1.5  ',8,2.5,10.5,0.)

         call hbook1(9955,'eta d*  2.5<pt<3.5  ',18,-1.5,1.5,0.)
         call hbook1(9956,'eta d*  3.5<pt<5    ',18,-1.5,1.5,0.)
         call hbook1(9957,'eta d*    5<pt<10.5 ',18,-1.5,1.5,0.)

c data histos

c         call hbookb(-9901,'pt d*    ',nbs,ptbs,0.)
c         call hbookb(-9902,'eta d*   ',nbs,etabs,0.)
c         call hbookb(-9951,'pt d*  -1.5<eta<-1   ',nbptd,ptbd,0.)
c         call hbookb(-9952,'pt d*  -1  <eta<0.25 ',nbptd,ptbd,0.)
c         call hbookb(-9953,'pt d*  0.25<eta<0.5  ',nbptd,ptbd,0.)
c         call hbookb(-9954,'pt d*  0.5 <eta<1.5  ',nbptd,ptbd,0.)

         call hbookb(-9955,'eta d*  2.5<pt<3.5  ',nbetad,etabd,0.)
         call hbookb(-9956,'eta d*  3.5<pt<5    ',nbetad,etabd,0.)
         call hbookb(-9957,'eta d*    5<pt<10.5 ',nbetad,etabd,0.)

c         call hpak(-9901,ccmpt)
c         call hpake(-9901,ccmpte)
c         call hpak(-9902,ccmeta)
c         call hpake(-9902,ccmetae)
c         call hpak(-9951,c1pt)
c         call hpake(-9951,c1pte)
c         call hpak(-9952,c2pt)
c         call hpake(-9952,c2pte)
c         call hpak(-9953,c3pt)
c         call hpake(-9953,c3pte)
c         call hpak(-9954,c4pt)
c         call hpake(-9954,c4pte)
         call hpak(-9955,c1eta)
         call hpake(-9955,c1etae)
         call hpak(-9956,c2eta)
         call hpake(-9956,c2etae)
         call hpak(-9957,c3eta)
         call hpake(-9957,c3etae)


         nc = 0
	   ncb = 0
	   ndstar = 0
	   ndstarb = 0
*
*
*********************************************************************
*                      Event Processing
*
*********************************************************************
*
      Else if(iflag.eq.2) then
*
         call hcdir('//PAWC/'//xxxx,' ')
*
* total number of generated events
         xntot=xntot+1
         xw = wtx
*
         q2=hzphokin(1)
         IF (q2.eq.-1) THEN
            PRINT*,'HZn653: HZPHOKIN returns error for Q2'
         ELSEIF (q2.lt.0) THEN
            q2=abs(q2)
         ENDIF
         y=hzphokin(3)
         IF (y.eq.-1) THEN
            PRINT*,'HZn653: HZPHOKIN returns error for y'
         ENDIF
         ierr=HZIBEAM(ibeam,idum)
         if (.not.(ierr.eq.1)) then
            write(6,*) 'HZ'//xxxx,' beams not found ! '
            goto 20
         endif
         w2 = y*4.*PHEP(4,idum)*PHEP(4,ibeam)
c define the cuts here
c         if(sqrt(w2).lt.115.0.or.sqrt(w2).gt.280.0) then
c            goto 20
c         endif
         if(q2.gt.0.01) then
            goto 20
         endif
         if(y.lt.0.29.or.y.gt.0.62) then
            goto 20
         endif

*
*
*
         iel=HZIDELEC(idum)
         if (iel.eq.-1) then
            write(6,*) 'Hz'//xxxx,' electron not found '
            goto 20
         endif
         enel=real(PHEP(4,iel))
         thel=real(HZPHMANG(PHEP(3,iel), sqrt(PHEP(1,iel)**2+PHEP(2,
     +   iel)**2)))*rd
         if (lp) write(6,*) 'Hz'//xxxx, ' enel= ',enel,' thel= ',thel
*
         ierr=HZIBEAM(ibeam,idum)
         if (.not.(ierr.eq.1)) then
            write(6,*) 'HZ'//xxxx,' beams not found ! '
            goto 20
         else
            Do i=1,4
               pbeam(i)=PHEP(i,IBEAM)
            enddo
         endif
*
         eb=real(PHEP(4,idum))
         if (abs(abs(eb)-ee).gt.0.1) then
            if (nentry.lt.10) then
               write(6,*) 'HZ'//xxxx,' Electron beam not at ',ee,'  ! '
            elseif (nentry.eq.10) then
               write(6,*) 'HZ'//xxxx,' Electron beam not at ',ee,
     +         ' ...last message ! '
            endif
            goto 20
         endif
*
         ierr=HZIPGAM(ph)
         if (ierr.eq.-1) then
            write(6,*) 'HZ'//xxxx,' boson vector not found ! '
            call VZERO(ph,5)
         else
            Do i=1,4
               pgam(i)=ph(i)
            enddo
         endif
*
         call HZHCMINI(pbeam,pgam,ierr)
         if (ierr.eq.1) then
            write(6,*) 'HZ'//xxxx,' problem with boost to cms ! '
            goto 20
         endif

*
         lctag=.false.
         xnd0=0
         nev=nev+1
         ndstare = 0
	
         Do 10 ihep=1,nhep
            idhe=idhep(ihep)
*
            if ( abs(idhe).eq.4 ) lctag=.true.
            if ( abs(idhe).eq.311 ) lstag=.true.

		if(idhe.eq. 4.and.isthep(ihep).eq.2) nc  = nc  + 1
		if(idhe.eq.-4.and.isthep(ihep).eq.2) ncb = ncb + 1
c		write(6,*) nc,ncb,ihep,idhe
            if (idhe .eq. 423 ) ndstar = ndstar + 1
            if (idhe .eq. -423 ) ndstarb = ndstarb + 1
*
*     look for D*
            if ( abs(idhe) .eq. 423 ) then
               ndstare = ndstare + 1
               Do i=1,4
                  Phc(i)=PHEP(i,ihep)
               enddo
		
* pcm in had cms
               call HZHCM(phc,pcm,ierr)
               if (ierr.eq.1) then
                  write(6,*) 'HZ'//xxxx,' problem with boost to cms ! '
                  goto 20
               endif
*
*                                             get particle momenta
*
*
               idmo1=jmohep(1,ihep)
               idmo2=idhep(idmo1)
*          write(6,*)' D0 found ',xntot,lctag,idmo1,idmo2
* LAB variables
               call hzgetvar(phc,p,pt,et,th,phdum,rap,err_flag)
               if ( err_flag.ne.0 ) goto 10
* CMS variables
*           call hzgetvar(pcm,p,pt,et,th,phdum,rap,err_flag)
*           if ( err_flag.ne.0 ) goto 2000
*
               rap = -0.5*log((phc(4)-phc(3))/(phc(4)+phc(3)))
               if(ndstare.eq.1) then
                  if(rap.ge.-1.5.and.rap.le.1.5.and.
     +            pt.ge.2.5.and.pt.le. 10.5) then
                     call hfill(9901,pt,1.,xw)
                     call hfill(9902,rap,1.,xw)
                     if(rap.ge.-1.5.and.rap.le.-1.0) call hfill(9951,
     +               pt, 1.,xw)
                     if(rap.ge.-1.0.and.rap.le.-.25) call hfill(9952,
     +               pt, 1.,xw)
                     if(rap.ge.-0.25.and.rap.le.0.5) call hfill(9953,
     +               pt, 1.,xw)
                     if(rap.ge.0.5.and.rap.le.1.5) call hfill(9954,pt,
     +               1.,xw)

                     if(pt.gt.2.5.and.pt.lt.3.5) call hfill(9955,rap,
     +               1., xw)
                     if(pt.gt.3.5.and.pt.lt.5.0) call hfill(9956,rap,
     +               1., xw)
                     if(pt.gt.5.0.and.pt.lt.10.5) call hfill(9957,rap,
     +               1., xw)
                  endif
               endif
            endif
   10    continue
*
*
*
*
*
   20    continue
*
*********************************************************************
*
*                      Termination
*
*********************************************************************
*
      Else if(iflag.eq.3) then
*
*      Termination: The following MUST always be done
*      (i) Move to the correct PAW subdirectory
*
         call hcdir('//PAWC/'//xxxx,' ')
*
         lum=999999999.
* x section in nb
* x section in nb
         sigma_tot=xsec/1000.
         if (sigma_tot.ne.0.) then
            lum=real(xntot)/real(sigma_tot)
            lum1=real(xntot)*1000./real(sigma_tot)
         else
            write(6,*) 'hz',xxxx,' sigma_tot=0 ! '
         endif
*
* Obtain total cross-section
         write(6,*) ' Total Cross section ',sigma_tot,xntot
         write(6,*) ' ep to gamma p = 1./0.0128 '
	
	   write(6,*) ' Nr charm = ',nc,' c_bar = ', ncb
	   write(6,*) ' Nr D* = ',ndstar,' D*_b = ',ndstarb
	   write(6,*) ' c -> D*  BR = ',real(ndstar)/max(real(nc),1.)
*
         write(6,*)'      '
*
         idhisto = 9955
         write(6,*) ' idhisto ',idhisto,' bw ',bw
         call hzhinrm( idhisto, 0, 1. , 1 )
         xnorm = 1./lum1/bw(5)/0.0128
         call hopera(idhisto,'+E',idhisto,idhisto,xnorm,0.)
         idhisto = 9956
         call hzhinrm( idhisto, 0, 1. , 1 )
         xnorm = 1./lum/bw(6)/0.0128
         call hopera(idhisto,'+E',idhisto,idhisto,xnorm,0.)
         idhisto = 9957
         call hzhinrm( idhisto, 0, 1. , 1 )
         xnorm = 1./lum/bw(7)/0.0128
         call hopera(idhisto,'+E',idhisto,idhisto,xnorm,0.)
c            call hopera(idhisto,'+E',idhisto,idhisto,brdstar/lum,0.)
c         idhisto = 9901
cc         call hzhinrm( idhisto, 0, 1.*brdstar, 1 )
c         call hopera(idhisto,'+E',idhisto,idhisto,1./lum,0.)
c         call hopera(idhisto,'+E',idhisto,idhisto,brdstar/lum,0.)
c         idhisto = 9902
c         call hzhinrm( idhisto, 0, 1.*brdstar, 1 )
c         call hopera(idhisto,'+E',idhisto,idhisto,1./lum,0.)
c         call hopera(idhisto,'+E',idhisto,idhisto,brdstar/lum,0.)
      endif
      RETURN
      END
