*CMZ :          31/07/2001  14.17.37  by   H. Jung
*-- Author :
      subroutine HZ98205(IFLAG)
****************************************************************************
* Purpose: produced histograms for the inclusive jet cross-section
*          Reference: DESY 98-205
* Arguments: iflag=1 initialisation
*            iflag=1 filling
*            iflag=3 termination
*
****************************************************************************
      IMPLICIT NONE
*
#include "hzfunc.inc"
#include "hzhbook.inc"
#include "hepevtp.inc"
#include "heracmn.inc"
#include "hzjetcmn.inc"



      Integer Nacc,ihep,iflag,ibin,iloop,ierr,iel,idum, njets, nsjets
      integer loop,i,j,k,id
      integer jgam, jbeam, ilep, ipro, npart, mjet(2048)
      double precision pgam(5), ppro(4),ppho(4),pcms(4),ph(5)
      double precision plab(5,NMXHEP)
      Integer nq2bins,nybins,nxgbins,netbins
      Parameter (nq2bins=4,nybins=5,nxgbins=5,netbins=4)
      Real q2, ykin, ycut(2), q2bins(nq2bins+1)
      Real xgbins(nxgbins+1),et2mean(netbins+1)
c      real jetp, ptjet, etjet, rapjet,
      Real binwid,bwidq2
      real etjet, rapjet,eppzj,eppz
      Integer chjet
      SAVE chjet
C --- choose same jet finder as in the paper --- KTCLUS
      DATA chjet/3/
      CHARACTER*6 jetf
      Integer ktmode
C --- information returned by jet finder
      INTEGER NJET
      DOUBLE PRECISION Jetsi(maxhzjets,8)
      DOUBLE PRECISION CONER
      SAVE CONER
      Double Precision rapj(50),Etj(50),phij(50),Ej(50),pzj(50)
      Integer njrap
      Real rapm,etm
      Real xgam
C --- cuts arrays
      DOUBLE PRECISION rapcut(2)
      DATA rapcut/-3.0d0,-0.5d0/
      real invlumi
      Real eb,ee,pbeam(4)
      Parameter (ee=27.5)
      Integer ibeam,nentry
      Data ycut/0.1,0.7/
      data et2mean/30.,45.0,65.0,150.0,300.0/
      Data q2bins/1.6, 3.5, 8. , 25. , 80.0/
      Data xgbins/0.15,0.3,0.45,0.6,0.75,1./

      Double Precision Et2,rap
      Character string*80

*     DESY Preprint number
      Character*5 xxxx
      Data xxxx/'98205'/
	Real dat(4,4,5),err(4,4,5), input(5),inpute(5)
*
*
* Data points from plots
      Real xsec1(5),est1(5) ! 1.6 < q2 < 3.5, 30 < et2 < 45
	Data xsec1/7.5, 5.98, 8.34, 12.0, 18.76/
      Data est1 /0.18,0.15, 0.21, 0.25, 0.30/
      Real xsec2(5),est2(5) ! 1.6 < q2 < 3.5, 45 < et2 < 65
	Data xsec2/ 2.81, 2.20, 2.62, 4.58, 9.22/
	Data est2/  0.11, 0.09, 0.08, 0.11, 0.19/
      Real xsec3(5),est3(5) ! 1.6 < q2 < 3.5, 65 < et2 < 130
	Data xsec3/0.0, 0.33, 0.58, 0.81, 2.40/
	Data est3/ 0.0, 0.02, 0.03, 0.03, 0.05/
      Real xsec4(5),est4(5) ! 1.6 < q2 < 3.5, 130 < et2 < 300
	Data xsec4/0.0, 0.0, 0.0, 0.0, 0.27/
	Data est4/ 0.0, 0.0, 0.0, 0.0, 0.01/

      Real xsec5(5),est5(5) ! 3.5 < q2 < 8, 30 < et2 < 45
	Data xsec5/1.88, 1.95, 3.46, 5.18, 7.38/
      Data est5 /0.05, 0.05, 0.07, 0.09, 0.12/
      Real xsec6(5),est6(5) ! 3.56 < q2 < 8, 45 < et2 < 65
	Data xsec6/0.75, 0.81, 1.27, 1.72, 3.80/
	Data est6/ 0.03, 0.02, 0.04, 0.05, 0.07/
      Real xsec7(5),est7(5) ! 3.5 < q2 < 8, 65 < et2 < 130
	Data xsec7/0.0, 0.21, 0.21, 0.34, 0.98/
	Data est7/ 0.0, 0.01, 0.01, 0.01, 0.02/
      Real xsec8(5),est8(5) ! 3.5 < q2 < 8, 130 < et2 < 300
	Data xsec8/0.0, 0.0, 0.0, 0.0, 0.11/
	Data est8/ 0.0, 0.0, 0.0, 0.0, 0.01/
	
      Real xsec9(5),est9(5) ! 8 < q2 < 25, 30 < et2 < 45
	Data xsec9/0.27, 0.67, 0.67, 1.58, 2.13/
      Data est9 /0.01, 0.02, 0.01, 0.03, 0.03/
      Real xsec10(5),est10(5) ! 8 < q2 < 25, 45 < et2 < 65
	Data xsec10/0.11, 0.23, 0.31, 0.54, 1.09/
	Data est10/ 0.01, 0.01, 0.01, 0.01, 0.02/
      Real xsec11(5),est11(5) ! 8 < q2 < 25, 65 < et2 < 130
	Data xsec11/0.0, 0.047, 0.074, 0.091, 0.298/
	Data est11/ 0.0, 0.002, 0.003, 0.003, 0.005 /
      Real xsec12(5),est12(5) ! 8 < q2 < 25, 130 < et2 < 300
	Data xsec12/0.0, 0.0, 0.0, 0.0, 0.039 /
	Data est12/ 0.0, 0.0, 0.0, 0.0, 0.001/

      Real xsec13(5),est13(5) ! 25 < q2 < 80, 30 < et2 < 45
	Data xsec13/0.021, 0.065, 0.114, 0.236, 0.433/
      Data est13 /0.001, 0.005, 0.006, 0.007, 0.007/
      Real xsec14(5),est14(5) ! 25  < q2 < 80, 45 < et2 < 65
	Data xsec14/0.018, 0.055, 0.051, 0.120, 0.220/
	Data est14/ 0.001, 0.005, 0.003, 0.005, 0.004/
      Real xsec15(5),est15(5) ! 25 < q2 < 80, 65 < et2 < 130
	Data xsec15/0.0, 0.01, 0.024, 0.020, 0.060/
	Data est15/ 0.0, 0.001,0.001, 0.001, 0.001/
      Real xsec16(5),est16(5) ! 25 < q2 < 80, 130 < et2 < 300
	Data xsec16/0.0, 0.0, 0.0, 0.0, 0.012 /
	Data est16/ 0.0, 0.0, 0.0, 0.0, 0.001/
	
      Integer nev
      
      save Nacc, nev

      IF (iflag.eq.1) then
*
*      Initialisation: The following MUST always be done
*      (i) make subdirectory in PAWC
*       - use the name as the xxxxxx in HZxxxxxx subroutine
*      (i) make subdirectory in o/p file
*
         Nacc= 0
         Call hcdir('//PAWC',' ')
         call hmdir(xxxx,'S')
         Call hcdir('//HISTO',' ')
         call hmdir(xxxx,'S')
*
*      book your histograms
*
        Do i=1,nq2bins
	   Do j=1,netbins
	    do k=1,nxgbins
	    if(i.eq.1) then
	      if(j.eq.1) then
	       dat(i,j,k) = xsec1(k)
	       err(i,j,k) = est1(k)
	      elseif(j.eq.2) then
	       dat(i,j,k) = xsec2(k)
	       err(i,j,k) = est2(k)
	      elseif(j.eq.3) then
	       dat(i,j,k) = xsec3(k)
	       err(i,j,k) = est3(k)
	      elseif(j.eq.4) then
	       dat(i,j,k) = xsec4(k)
	       err(i,j,k) = est4(k)
		endif
	    elseif(i.eq.2) then
	      if(j.eq.1) then
	       dat(i,j,k) = xsec5(k)
	       err(i,j,k) = est5(k)
	      elseif(j.eq.2) then
	       dat(i,j,k) = xsec6(k)
	       err(i,j,k) = est6(k)
	      elseif(j.eq.3) then
	       dat(i,j,k) = xsec7(k)
	       err(i,j,k) = est7(k)
	      elseif(j.eq.4) then
	       dat(i,j,k) = xsec8(k)
	       err(i,j,k) = est8(k)
		endif
	    elseif(i.eq.3) then
	      if(j.eq.1) then
	       dat(i,j,k) = xsec9(k)
	       err(i,j,k) = est9(k)
	      elseif(j.eq.2) then
	       dat(i,j,k) = xsec10(k)
	       err(i,j,k) = est10(k)
	      elseif(j.eq.3) then
	       dat(i,j,k) = xsec11(k)
	       err(i,j,k) = est11(k)
	      elseif(j.eq.4) then
	       dat(i,j,k) = xsec12(k)
	       err(i,j,k) = est12(k)
		endif
	    elseif(i.eq.4) then
	      if(j.eq.1) then
	       dat(i,j,k) = xsec13(k)
	       err(i,j,k) = est13(k)
	      elseif(j.eq.2) then
	       dat(i,j,k) = xsec14(k)
	       err(i,j,k) = est14(k)
	      elseif(j.eq.3) then
	       dat(i,j,k) = xsec15(k)
	       err(i,j,k) = est15(k)
	      elseif(j.eq.4) then
	       dat(i,j,k) = xsec16(k)
	       err(i,j,k) = est16(k)
		endif
	    endif
	    enddo
	    enddo
	    enddo


*      bins in q2
         do I=1,nq2bins
            do J=1,netbins
               id=100+10*I+J
               write(string,'(a,f5.2,a,f5.2,a,f5.1,a,f5.1)') 'd(sigma)/'
     +         //'d(xg): ',q2bins(i),'.lt.Q2.lt.',q2bins(i+1), ';',
     +         et2mean(j),' .lt.Et2.lt. ',et2mean(j+1)
               CALL HBOOKB(id,string,nxgbins,xgbins,0.)
               write (6,*) string
               write(string,'(a,f5.2,a,f5.2,a,f5.1,a,f5.1)') 'd(sigma)/'
     +         //'d(xg) dat: ',q2bins(i),'.lt.Q2.lt.',q2bins(i+1), ';',
     +         et2mean(j),' .lt.Et2.lt. ',et2mean(j+1)
               CALL HBOOKB(-id,string,nxgbins,xgbins,0.)
		   do k=1,nxgbins
		   input(k)= dat(i,j,k)
		   inpute(k) = err(i,j,k)
		   enddo
		   call hpak( -id,input)
		   call hpake( -id,inpute)

            enddo
            do j=1,nxgbins
               id=200+10*I+J
               write(string,'(a,f5.2,a,f5.2,a,f5.2,a,f5.2)') 'd(sigma)/'
     +         //'dEt: ',q2bins(i),'.lt.Q2.lt.',q2bins(i+1), ';',
     +         xgbins(j),' .lt.xgam.lt. ',xgbins(j+1)
               CALL HBOOKB(id,string,netbins,et2mean,0.)
               write (6,*) string
               write(string,'(a,f5.2,a,f5.2,a,f5.2,a,f5.2)') 'd(sigma)/'
     +         //'dEt dat: ',q2bins(i),'.lt.Q2.lt.',q2bins(i+1), ';',
     +         xgbins(j),' .lt.xgam.lt. ',xgbins(j+1)
               CALL HBOOKB(-id,string,netbins,et2mean,0.)
		
		   do k=1,netbins
		   input(k)= dat(i,k,j)
		   inpute(k) = err(i,k,j)
		   enddo
		   call hpak( -id,input)
		   call hpake( -id,inpute)
            enddo
         enddo
         do I=1,netbins
            do j=1,nxgbins
               id=300+10*I+J
               write(string,'(a,f5.2,a,f5.2,a,f5.2,a,f5.2)') 'd(sigma)/'
     +         //'dQ2: ',et2mean(i),'.lt.Q2.lt.',et2mean(i+1), ';',
     +         xgbins(j),' .lt.xgam.lt. ',xgbins(j+1)
               CALL HBOOKB(id,string,nq2bins,q2bins,0.)
               write (6,*) string
               write(string,'(a,f5.2,a,f5.2,a,f5.2,a,f5.2)') 'd(sigma)/'
     +         //'dQ2 dat: ',et2mean(i),'.lt.Q2.lt.',et2mean(i+1), ';',
     +         xgbins(j),' .lt.xgam.lt. ',xgbins(j+1)
               CALL HBOOKB(-id,string,nq2bins,q2bins,0.)
 		
		   do k=1,nq2bins
		   input(k)= dat(k,i,j)
		   inpute(k) = err(k,i,j)
		   enddo
		   call hpak( -id,input)
		   call hpake( -id,inpute)
           enddo
         enddo
 	
C --- standard cone radius is 1.0
         CALL HZJETRAD(2,CONER)
         IF (CONER.lt.0.0) THEN
            CONER=1.0
         ENDIF
         CALL HZJTNAME(chjet,jetf)

         WRITE(6,*)'**********************************************'
         WRITE(6,*)'* HZ98205 called, histograms will be output. *'
         WRITE(6,*)'*     Jet finder selected : ',jetf,'           *'
         WRITE(6,1001)'*        with cone radius : ',CONER,'   *'
         WRITE(6,*)'**********************************************'

 1001     FORMAT(A29,F5.2,A13)

      Else if(iflag.eq.2) then
*      Filling: The following MUST always be done
*      (i) move to the correct sub-directory in PAWC
*
         call hcdir('//PAWC/'//xxxx,' ')

         ierr=HZIBEAM(ibeam,idum)
         if (.not.(ierr.eq.1)) then
            write(6,*) 'HZ'//xxxx,' beams not found ! '
            return
         else
            Do i=1,4
               pbeam(i)=PHEP(i,IBEAM)
            enddo
         endif
*
         eb=real(PHEP(4,idum))

ccccc         write(6,*) 'HZ'//xxxx,' Electron  at ',ee,'  ',eb
         if (abs(abs(eb)-ee).gt.0.1) then
            if (nentry.lt.10) then
               write(6,*) 'HZ'//xxxx,' Electron not at ',ee,' ! ',eb
            elseif (nentry.eq.10) then
               write(6,*) 'HZ'//xxxx,' Electron beam not at ',ee,
     +         ' ...last message ! '
            endif
            return
         endif


         q2 = real(hzdiskin(1))
         ykin = real(hzdiskin(3))

         nev = nev + 1
C--Sort out the binning first

         ibin = 0
         IF ((ykin.gt.ycut(1)).and.(ykin.lt.ycut(2))) then
            DO ILoop=1,nq2bins,1
               IF ((q2.ge.q2bins(ILoop)).and. (q2.lt.q2bins(ILoop+1)))
     +         then
                  ibin = iloop
                  bwidq2 = q2bins(ILoop+1) - q2bins(ILoop)
                  goto 10
               endif
            enddo
         ENDIF

   10    continue
         if (ibin.eq.0) then
            goto 50
         endif



C--Find the proton and photon

         IF (gen(1:3).eq.'HRW') then
            jgam = hzipgamn(pgam)
         else
            jgam = hzipgam(pgam)
         endif

         if (jgam.ne.1) then
            write(6,*) 'ERROR: No photon found'
            goto 50
         endif

         jbeam = hzibeam(ipro,ilep)

         if (jbeam.ne.1) then
            write(6,*) 'ERROR: Problem finding beams'
            goto 50
         endif

         do iloop=1,4
            ppro(iloop) = phep(iloop,ipro)
            ppho(iloop) = pgam(iloop)
         enddo

C--set up the boost

         call hzhcmini(ppro,ppho,ierr)

         if (ierr.eq.1) then
            write(6,*) 'ERROR: Problem with boost'
            goto 50
         endif

C--Find the scattered electron

         iel=HZIDELEC(idum)
         if (iel.eq.-1) then
            write(6,*) 'Hz'//xxxx,' electron not found '
            goto 50
         endif

C---Sort out all the stable particles and boost them


         npart = 0
         eppz=0.
c		write(6,*) 'electron in labe ', (phep(i,1),i=1,4)
c		write(6,*) 'proton in lab   ', (phep(i,2),i=1,4)
         do 20 ihep=1,nhep
            npart = npart + 1
            Do i=1,4
               Ph(i)=PHEP(i,ihep)
               Plab(i,ihep)=PHEP(i,ihep)
               phep(i,ihep)=0.0
            enddo
*     skip unstable particles and electron
            if (isthep(ihep).ne.1.or.ihep.eq.iel) goto 20
c            if (ihep.eq.iel) goto 20
            call HZHCM(ph,pcms,ierr)
            Do i=1,4
               PHEP(i,ihep)=Pcms(i)
               if(i.eq.3) PHEP(i,ihep)=-Pcms(i)
            enddo
            eppz = eppz + phep(4,ihep) - phep(3,ihep)
            if (ierr.eq.1) then
               write(6,*) 'HZ'//xxxx,' problem with boost to cms ! '
               goto 17
            endif
   20    continue

c		write(6,*) 'electron in cms ', (phep(i,1),i=1,4)
c		write(6,*) 'proton in cms   ', (phep(i,2),i=1,4)

         xgam = -1.
*
c         ktmode = 4212
c         CALL hzjtfmy(chjet,CONER,ktmode,NJET,Jetsi)
         CALL hzjtfind(chjet,CONER,NJET,Jetsi)

         IF (NJET.ge.2) THEN
            njrap = 0


            DO loop=1,2
                  njrap = njrap + 1
                  Etj(njrap)=Jetsi(loop,3)
                  rapj(njrap)=Jetsi(loop,1)
                  phij(njrap) = Jetsi(loop,2)
                  Ej(njrap) = Jetsi(loop,4)
                  Pzj(njrap) = Jetsi(loop,7)
            ENDDO
c            write(6,*) ' jets found Etj ',njrap,Etj(1),Etj(2)
c            write(6,*) ' rapj ',rapj(1),rapj(2)
		
            if(abs(rapj(1)-rapj(2)).gt.1.) goto 17
            rapm=(rapj(1)+rapj(2))/2.
            if(rapm.lt.-3..or.rapm.gt.-0.5) goto 17
            etm=(Etj(1)+Etj(2))/2.
            if(abs(Etj(1)-Etj(2))/etm.gt.0.5) goto 17
            if(etm**2.lt.30.0) goto 17
*
* No, there are no two jets in the eta range
*
*
* Yes, there are two jets in the eta range
*
   13       continue
c            write(6,*) ' jets found ',njrap,Etj(1),Etj(2),ibin
*
            Nacc = Nacc + 1
c               xgam=(Etj(1)*exp(-1*rapj(1))+Etj(2)*exp(-1*rapj(2)))
c     +         /(2*ykin*PHEP(4,idum))
            eppzj=Ej(1) - pzj(1) + Ej(2) - pzj(2)
            if (eppz.ne.0.) then
               xgam=eppzj/eppz
            else
               xgam=-999.
            endif

            Et2 = ((Etj(1) + Etj(2))/2.)**2
            rap = (rapj(1) + rapj(2))/2.
c            write(6,*) ' Et2, xgma, y ',Et2,xgam,ykin
            do i=1,netbins
               if(Et2.ge.et2mean(i).and.Et2.lt.et2mean(i+1)) then
c                  write(6,*) ' Et2, xgma, y ',Et2,xgam,ykin
                  binwid = (et2mean(i+1)- et2mean(i)) * bwidq2
                  id=100 +10*ibin + i
c                  write(6,*) ' bwid ', binwid,id
                  call hfill(id,Real(xgam),0.,Real(1./binwid))
               endif
            enddo
            do i=1,nxgbins
               if(xgam.ge.xgbins(i).and.xgam.lt.xgbins(i+1)) then
c                  write(6,*) ' xgma, y ',Et2,xgam,ykin
                  binwid = (xgbins(i+1)- xgbins(i)) * bwidq2
                  id=200 +10*ibin + i
c                  write(6,*) ' bwid ', binwid,id
                  call hfill(id,Real(Et2),0.,Real(1./binwid))
                  do j=1,netbins
                     if(Et2.ge.et2mean(j).and.Et2.lt.et2mean(j+1))
     +               then
c                        write(6,*) ' Et2, xgma, y ',Et2,xgam,ykin
                        binwid = (et2mean(j+1)- et2mean(j)) * (xgbins(i
     +                  +1)- xgbins(i))
c                        write(6,*) ' bwid ', binwid
                        id=300 +10*j + i
                        call hfill(id,Real(q2),0.,Real(1./binwid))
                     endif
                  enddo
               endif
            enddo

*! NJET.ge.2
         ENDIF
*
   17    continue



         do ihep=1,nhep
            Do i=1,4
               PHEP(i,ihep)= Plab(i,ihep)
            enddo
         enddo
   50    continue
      Else if(iflag.eq.3) then
*      Termination: The following MUST always be done
*      (i) Move to the correct PAW subdirectory
*
         call hcdir('//PAWC/'//xxxx,' ')
*
*      Pack the data
*

*     Normalise the histograms by the luminosity

****       invlumi = xsec/real(ntot)
         invlumi = xsec/real(nev)

         write(6,*) 'hz',xxxx,' sigma_tot =  ',xsec*0.001, Nacc

         If(Nacc.ge.1) then
            do i = 1,nq2bins
               do j = 1,netbins
                  id=100+10*I+J
                  call hzhinrm( id, 0, 1., 1 )
                  call hopera(id,'+E',id,id,invlumi,0.)
               enddo
               do j=1,nxgbins
                  id=200+10*I+J
                  call hzhinrm( id, 0, 1., 1 )
                  call hopera(id,'+E',id,id,invlumi,0.)
               enddo
            enddo
            do i = 1,netbins
               do j=1,nxgbins
                  id=300 +10*i + j
                  call hzhinrm( id, 0, 1., 1 )
                  call hopera(id,'+E',id,id,invlumi,0.)
               enddo
            enddo
         endif

         Write(6,*) 'xz'//xxxx,' X-section is',xsec
      Endif
*
      RETURN
*
      END
