      subroutine hzh0508055(IFLAG)
*M.Hansson, A.Knutsson
****************************************************************************
* Purpose: histograms for the fwd jet analysis
*
*
*
* Arguments: iflag=1 initialisation
*            iflag=2 filling
*            iflag=3 termination
*


      IMPLICIT NONE
* Function declarations for Hztool functions
#include "hepevtp.inc"
#include "heracmn.inc"
#include "hzfunc.inc"
#include "hzhbook.inc"
#include "hznlo.inc"
#include "hzjetcmn.inc"
	Integer plist(nmxhep),npart
*
      Integer numjet
c      Parameter (numjet=50)
      Double precision pj(MAXHZJETS,8),pjbr(MAXHZJETS,8)
      Double precision pbeam(4),pgam(4),pcm(4),ph(5),pbr(5)
      Double precision plab(5,NMXHEP)
      
      Integer NLOJET
*
      Integer i,iflag,ihep,nj1
      Character*8 xxxx
      save xxxx
      Integer nentry
      Data xxxx/'h0508055'/,NENTRY/0/

      Real Npass
      Real ptpi,thpi,xpi
*
      Real pi,rd
      Integer iel,idum,ibeam
      Parameter (pi=3.1415927,rd=180./pi)
      Real x,y,q2
      Integer nj,ij
*
      Integer ierr
      Integer maxhi,modjet,maxjet
c for ktalgo use modjet = 3
      Parameter (maxhi=100,modjet=3,maxjet=30)
c for selecting only partons use modjet = 9
      Real lumnb,lumpb
      Double precision rcone
      Parameter (rcone=1.d0)


*** Define bins for xbj histograms ***
      real bx(7)
      data bx/0.0001,0.0005,0.001,0.0015,0.002,0.003,0.004/

*** Binwidths in Q2 and pt2, needed for normalization
      real q2w(3)
      data q2w/5.0, 10.0, 65.0/
      real pt2w(3)
      data pt2w/22.75, 60.0, 305.0/
      real p2q2w, nfac

*** Define Variables ***
*
* Nevt -> number of events
* Njet -> number of jets
* Nfwd -> number of FWD jets
* Nmue -> number of Mueller jets
      real Nevt, Njet, Nfwd, Nfwd2, Nmue
      save Nevt, Njet, Nfwd, Nfwd2, Nmue
* Ee -> electron energy
* The -> electron theta
* Phe -> electron phi
* Ej ->  jet energy
* Thj -> jet theta
* Phj -> jet phi
* Ptj -> jet pt
      real Ee, The, Phe, Ej, Thj, Phj, Ptj
      real pt2q2,xjet

*** Define cut parameters for fwd jets ***

      real ylow, xlow, xmed, xhigh, eelow, thelow, thehigh
      real etajflow,etajfhigh
      real ejlow, ptjlow,ptjhigh,thjlow, thjhigh, pt2q2low, pt2q2high
      real ymax,q2low,q2max,xjetcut
      parameter(ylow=0.1)
      parameter(ymax=0.7)
      parameter(q2low=5.)
      parameter(q2max=85.)
      parameter(xlow=0.0001)
      parameter(xmed=0.001)
      parameter(xhigh=0.004)
      parameter(eelow=10.)
      parameter(thelow=2.722)  ! 156 deg
      parameter(thehigh=3.054) ! 175 deg
      parameter(ejlow=28.7)
      parameter(xjetcut=0.035)
      parameter(ptjlow=3.5)
      parameter(etajflow=1.735)
      parameter(etajfhigh=2.79)
      parameter(pt2q2low=0.5)
      parameter(pt2q2high=5.)
      
      logical fjet,fpi
      data fjet/.true./,fpi/.true./ 
	
      Real etajf,etajet,etae,ptjet,deltaeta, deltaeta2, deltaphi
      Real etajf2
      Integer njeth(100),nhard

*** Define H1 data ***
* buffert:
	real cs(6), csse(6), cstem(6), cstep(6), cssym(6), cssyp(6)
	real cs3(3), csse3(3)
	real cstem3(3), cstep3(3), cssym3(3), cssyp3(3), beta(4)
	integer ih, ih1, ih2, ih3, ih4, n 

* cross section vs x (data, stat error, energy band syst err) pt>3.5
      real csx(6),csxse(6),csxtep(6),csxtem(6),csxsyp(6),csxsym(6)
      data csx/924.6,541.12,263.8,152.9,74.5,36.7/ !xsec -  nb
      data csxse/16.7,11.6,7.6,5.8,3.01,2.02/ !stat err - nb
      data csxtem/99.7,55.8,28.5,15.7,8.0,5.7/ !energy dep syst err - nb (-)
      data csxtep/109.6,54.5,30.5,18.9,10.7,2.1/!energy dep syst err - nb (+)	
      data csxsym/76.7,23.9,11.0,8.2,1.8,2.4/!remaining syst err - nb (-)	
      data csxsyp/77.1,23.4,11.2,7.7,1.9,2.3/!remaining syst err - nb (+)		


* triple differential  cross-section (x, Q2, pt2)
*Q2 notation binnr:10, 20, 30 (horizontal)
*pt2 notation binnr:1, 2, 3 (vertical)

* 11 21 31
* 12 22 32
* 13 23 33


*dsigma/dxdQ2dpt2 xsec:
      real xqpcs11(6), xqpcs12(6), xqpcs13(6)
      real xqpcs21(6), xqpcs22(6), xqpcs23(6)
      real xqpcs31(6), xqpcs32(6), xqpcs33(6)
      data xqpcs11/5.097,1.128,0.0,0.0,0.0,0.0/ !nb
      data xqpcs12/1.689,0.381,0.0,0.0,0.0,0.0/ !nb
      data xqpcs13/0.110,0.271E-01,0.0,0.0,0.0,0.0/ !nb
      data xqpcs21/0.840,0.531,0.281,0.667E-01,0.0,0.0/ !nb
      data xqpcs22/0.311,0.236,0.113,0.281E-01,0.0,0.0/ !nb
      data xqpcs23/0.229E-01,0.184E-01,0.783E-02,0.270E-02,0.0,0.0/ !nb
      data xqpcs31/0.0,0.0,0.411E-01,0.338E-01,0.207E-01,0.903E-02/ !nb
      data xqpcs32/0.0,0.0,0.197E-01,0.167E-01,0.104E-01,0.545E-02/ !nb
      data xqpcs33/0.0,0.0,0.198E-02,0.163E-02,0.964E-03,0.517E-03/ !nb

*dsigma/dxdQ2dpt2 statistical errors:
      real xqpse11(6), xqpse12(6), xqpse13(6)
      real xqpse21(6), xqpse22(6), xqpse23(6)
      real xqpse31(6), xqpse32(6), xqpse33(6)
      data xqpse11/0.120,0.523E-01,0.0,0.0,0.0,0.0/ !nb
      data xqpse12/0.420E-01,0.176E-01,0.0,0.0,0.0,0.0/ !nb
      data xqpse13/0.482E-02,0.224E-02,0.0,0.0,0.0,0.0/ !nb
      data xqpse21/0.310E-01,0.244E-01,0.161E-01,0.731E-02,0.0,0.0/ !nb
      data xqpse22/0.127E-01,0.903E-02,0.618E-02,0.329E-02,0.0,0.0/ !nb
      data xqpse23/0.158E-02,0.114E-02,0.741E-03,0.445E-03,0.0,0.0/ !nb
      data xqpse31/0.0,0.0,0.241E-02,0.206E-02,0.124E-02,0.794E-03/ !nb
      data xqpse32/0.0,0.0,0.103E-02,0.979E-03,0.553E-03,0.394E-03/ !nb
      data xqpse33/0.0,0.0,0.144E-03,0.133E-03,0.703E-04,0.487E-04/ !nb

*dsigma/dxdQ2dpt2 energy scale syst error(+):
      real xqpep11(6), xqpep12(6), xqpep13(6)
      real xqpep21(6), xqpep22(6), xqpep23(6)
      real xqpep31(6), xqpep32(6), xqpep33(6)
      data xqpep11/0.461033,0.160473,0.0,0.0,0.0,0.0/ !nb
      data xqpep12/0.144,0.509E-01,0.0,0.0,0.0,0.0/ !nb
      data xqpep13/0.109E-01,0.349E-02,0.0,0.0,0.0,0.0/ !nb
      data xqpep21/0.641E-01,0.389E-01,0.323E-01,0.375E-02,0.0,0.0/ !nb
      data xqpep22/0.215E-01,0.201E-01,0.119E-01,0.495E-02,0.0,0.0/ !nb
      data xqpep23/0.155E-02,0.157E-02,0.873E-03,0.455E-03,0.0,0.0/ !nb
      data xqpep31/0.0,0.0,0.3749455E-02,0.383E-02,0.165E-02,0.137E-02/ !nb
      data xqpep32/0.0,0.0,0.1150790E-02,0.111E-02,0.805E-03,0.463E-03/ !nb
      data xqpep33/0.0,0.0,0.1451210E-03,0.150E-03,0.115E-03,0.406E-04/ !nb

*dsigma/dxdQ2dpt2 energy scale syst error(-):
      real xqpem11(6), xqpem12(6), xqpem13(6)
      real xqpem21(6), xqpem22(6), xqpem23(6)
      real xqpem31(6), xqpem32(6), xqpem33(6)
      data xqpem11/0.440,0.657E-01,0.0,0.0,0.0,0.0/ !nb
      data xqpem12/0.145,0.331E-01,0.0,0.0,0.0,0.0/ !nb
      data xqpem13/0.791E-02,0.334E-02,0.0,0.0,0.0,0.0/ !nb
      data xqpem21/0.622E-01,0.338E-01,0.289E-01,0.651E-02,0.0,0.0/ !nb
      data xqpem22/0.175E-01,0.184E-01,0.135E-01,0.191E-02,0.0,0.0/ !nb
      data xqpem23/0.146E-02,0.128E-02,0.752E-03,0.267E-03,0.0,0.0/ !nb
      data xqpem31/0.0,0.0,0.299E-02,0.294E-02,0.128E-02,0.123E-03/ !nb
      data xqpem32/0.0,0.0,0.113E-02,0.984E-03,0.957E-03,0.245E-03/ !nb
      data xqpem33/0.0,0.0,0.204E-03,0.131E-03,0.135E-03,0.801E-04/ !nb

*dsigma/dxdQ2dpt2 rest of syst err (sqrt(mod^2+thele^2))(+):
      real xqpyp11(6), xqpyp12(6), xqpyp13(6)
      real xqpyp21(6), xqpyp22(6), xqpyp23(6)
      real xqpyp31(6), xqpyp32(6), xqpyp33(6)
      data xqpyp11/0.584,0.167,0.0,0.0,0.0,0.0/ !nb
      data xqpyp12/0.107,0.125E-01,0.0,0.0,0.0,0.0/ !nb
      data xqpyp13/0.500E-02,0.255E-02,0.0,0.0,0.0,0.0/ !nb
      data xqpyp21/0.667E-01,0.218E-01,0.361E-01,0.942E-03,0.0,0.0/ !nb
      data xqpyp22/0.211E-01,0.141E-01,0.256E-02,0.265E-02,0.0,0.0/ !nb
      data xqpyp23/0.765E-03,0.413E-03,0.831E-03,0.353E-03,0.0,0.0/ !nb
      data xqpyp31/0.0,0.0,0.121E-02,0.342E-02,0.637E-03,0.441E-03/ !nb
      data xqpyp32/0.0,0.0,0.575E-03,0.867E-03,0.490E-03,0.456E-03/ !nb
      data xqpyp33/0.0,0.0,0.105E-03,0.204E-03,0.666E-05,0.586E-05/ !nb

*dsigma/dxdQ2dpt2 rest of syst err (sqrt(mod^2+thele^2))(-):
      real xqpym11(6), xqpym12(6), xqpym13(6)
      real xqpym21(6), xqpym22(6), xqpym23(6)
      real xqpym31(6), xqpym32(6), xqpym33(6)
      data xqpym11/0.586,0.167,0.0,0.0,0.0,0.0/ !nb
      data xqpym12/0.110,0.104E-01,0.0,0.0,0.0,0.0/ !nb
      data xqpym13/0.529E-02,0.260E-02,0.0,0.0,0.0,0.0/ !nb
      data xqpym21/0.664E-01,0.219E-01,0.365E-01,0.810E-03,0.0,0.0/ !nb
      data xqpym22/0.208E-01,0.146E-01,0.254E-02,0.225E-02,0.0,0.0/ !nb
      data xqpym23/0.656E-03,0.512E-03,0.786E-03,0.390E-03,0.0,0.0/ !nb
      data xqpym31/0.0,0.0,0.1214435E-02,0.336E-02,0.650E-03,0.440E-03/ !nb
      data xqpym32/0.0,0.0,0.5439266E-03,0.878E-03,0.485E-03,0.457E-03/ !nb
      data xqpym33/0.0,0.0,0.1054306E-03,0.203E-03,0.710E-05,0.287E-05/ !nb

**


*2+forward cross-section (\Delta \eta_2)

*2+fwd xsec:
      real tpfcs1(3), tpfcs2(3), tpfcs3(3) 
      data tpfcs1/0.406E-01,0.379E-01,0.116E-01/ !nb
      data tpfcs2/0.127E-01,0.188E-01,0.929E-02/ !nb
      data tpfcs3/0.279E-01,0.190E-01,0.336E-02/ !nb

*2+fwd stat err:
      real tpfse1(3), tpfse2(3), tpfse3(3) 
      data tpfse1/0.275E-02,0.229E-02,0.989E-03/ !nb
      data tpfse2/0.138E-02,0.153E-02,0.884E-03/ !nb
      data tpfse3/0.240E-02,0.172E-02,0.630E-03/ !nb
     
*2+fwd energy uncert (-):   
      real tpfem1(3), tpfem2(3), tpfem3(3) 
      data tpfem1/0.435E-02,0.442E-02,0.148E-02/ !nb
      data tpfem2/0.131E-02,0.190E-02,0.103E-02/ !nb
      data tpfem3/0.303E-02,0.256E-02,0.616E-03/ !nb

*2+fwd energy uncert (+):   
      real tpfep1(3), tpfep2(3), tpfep3(3) 
      data tpfep1/0.476E-02,0.426E-02,0.197E-02/ !nb
      data tpfep2/0.152E-02,0.143E-02,0.162E-02/ !nb
      data tpfep3/0.321E-02,0.303E-02,0.535E-03/ !nb
     
*2+fwd rest of syst err (-):   
      real tpfym1(3), tpfym2(3), tpfym3(3) 
      data tpfym1/0.217E-02,0.225E-02,0.197E-03/ !nb
      data tpfym2/0.366E-03,0.367E-03,0.306E-03/ !nb
      data tpfym3/0.206E-02,0.187E-02,0.482E-03/ !nb

*2+fwd rest of syst err (+):   
      real tpfyp1(3), tpfyp2(3), tpfyp3(3) 
      data tpfyp1/0.212E-02,0.222E-02,0.204E-03/ !nb
      data tpfyp2/0.299E-03,0.370E-03,0.306E-03/ !nb
      data tpfyp3/0.206E-02,0.184E-02,0.483E-03/ !nb

*** Sudakov checks ***
      Integer ihist
      Integer ngl_tot,nsreg
      Real zgen,zminus,qp,qm,ktqt
      common /myzval/zgen(500),zminus(500),qp(500),qm(500),
     +   nsreg(500),ngl_tot,ktqt(500)
      real qplus,qminus

      real sigm,wt
      common/cwnco1/x,y,Q2,sigm,wt
      Integer maxglu,nglu,ifjet
      parameter (maxglu=100)
      real zp,zm,xkt,xqt,xglu
      common/cwnco2/nglu,zp(maxglu),zm(maxglu),xkt(maxglu),xqt(maxglu),
     +   xglu(maxglu),ifjet(maxglu)
      Integer nfj,nfj2,ii,iglu,ifl
      Real Pold
	
      Real etabins1(4),etabins2(4),etabins3(4)
      Real etabins4(4),etabins14(4),etabins24(4)
      Data etabins1/-2., 0., 1., 2.79/
      Data etabins2/-1., 0., 0.8, 2.79/	
      Data etabins3/1.735, 2.0, 2.35, 2.79/
      Data etabins4/0.0, 0.6, 1.4, 3.0/
      Data etabins14/0.0, 0.6, 1.4, 3.0/
      Data etabins24/0.0, 0.6, 1.4, 2.5/
      
      Real pt2xv(4),q2xv(4)
      Data pt2xv/12.25, 35., 95., 400./
      Data q2xv/5.0, 10., 20., 85./
      Integer iq2,ipt,ihisto, ihisto2
      Logical breit	
c     Data breit/.false./
      Data breit/.true./
        
*** Counting parameters ***
      
      Integer Nmuejet
      integer myDIS, myFWD, myMUE, myTWO
* myDIS -> Number of DIS events
* myFWD -> Number of events with forward jets 
* myMUE -> Number of events with a Mueller jet	
* myTWO -> Number of events with 2+forward jets
	
      integer myY, myQ2, myTHETALOW, myX, myE
* myY         -> Number of events passing y cut (DIS)
* myQ2        -> Number of events passing Q2 cut (DIS)
* myX         -> Number of events passing x cut (DIS)
* myE         -> Number of events passing E cut (DIS)
* myTHETALOW  -> Number of events passing lower theta cut (DIS)
* Number of events passing higher theta cut are counted by myDIS (checked)

      integer myPTev, myXJETev, myETAJLev
* myPTev    -> Number of events passing Pt cut (fwd jet)
* myXJETev  -> Number of events passing xjet cut (fwd jet)
* myETAJLev -> Number of events passing lower eta cut (fwd jet)
* Number of events passing higher eta cut counted by myFWD

      integer myPT, myXJET, myETAJH, myETAJL
* myPT    -> Number of jets (in all events) passing Pt cut (fwd jet)
* myXJET  -> Number of jets (in all events) passing xjet cut (fwd jet)
* myETAJL -> Number of jets (in all events)passing lower eta cut (fwd jet)
* Number of jets passing higher eta cut counted by myFWD

      logical XJETev, ETAJLev, PTev
      Data XJETev/.false./, ETAJLev/.false./, PTev/.false./
* XJETev  -> flags if at least one jet in the event passed xjet cut
* ETAJLev -> flags if at least one jet in the event passed lower eta cut
* PTev    -> flags if at least one jet in the event passed Pt cut
* Events where at least one jet passed all fwd cuts are flagged with (Nfwd.gt.0)
* Events where at least one jet passed the Mueller cut are flagged with (Nmue.gt.0)
        
*** My sorting *****
      integer j,k,place,count
      double precision sort(MAXHZJETS,8)
      integer IJETNO2(NMXHEP)
      real sorti, sortj

      real dum
      double precision jetvec(8), jetvec2(8)

       
         
*********************************************************************
*
*                      Initialization
*
*********************************************************************
	numjet=MAXHZJETS
	
      NENTRY=NENTRY+1
      
      wt=wtx
    
      IF (iflag.eq.1) then
      
        write(6,*)'Version 6.1'
        
        NLO=0
        NLOJET=0
        
        Nevt=0
        Npass=0
        Nmuejet = 0
         
* nbr of events passing cuts

	myDIS=0
	myFWD=0
	myMUE=0
	myTWO=0

* nbr of events passing DIS cuts

	myY=0
	myQ2=0
	myTHETALOW=0
	myX=0
	myE=0

* nbr of jets passing fwd jet cuts

	myPT=0 
	myXJET=0 
	myETAJH=0
	myETAJL=0

* nbr of events passing fwd jet cuts

	myPTev=0 
	myXJETev=0 
	myETAJLev=0
         
*        
* Initialisation: The following MUST always be done
* (i) make subdirectory in PAWC
* - use the name as the xxxxxx in HZxxxxxx subroutine
* (i) make subdirectory in o/p file
*
        Call hcdir('//PAWC',' ')
        call hmdir(xxxx,'S')
        Call hcdir('//HISTO',' ')
        call hmdir(xxxx,'S')
         
*** Book histos ***

* histos for events after DIS cuts
        call hbook1(101,'x_bj Dis fwd jet',20,0.,0.0041,0.)
        call hbook1(102,'y Dis fwd jet',50,0.05,0.7,0.)
        call hbook1(103,'Q2 Dis fwd jet',50,0.,80.,0.)
        call hbook1(104,'Ee Dis fwd jet',30,9.,26.,0.)
        call hbook1(105,'The Dis fwd jet',25,2.7,3.01,0.)
* histos for fwd jets
        call hbookb(301,'x_bj fwd jet',6,bx,0.0)
        
        call hbookb(511,'x_bj 5<Q2<10, pt1',6,bx,0.0)
        call hbookb(512,'x_bj 5<Q2<10, pt2',6,bx,0.0)
        call hbookb(513,'x_bj 5<Q2<10, pt3',6,bx,0.0)
        
        call hbookb(521,'x_bj 10<Q2<20, pt1 ',6,bx,0.0)
        call hbookb(522,'x_bj 10<Q2<20, pt2 ',6,bx,0.0)
        call hbookb(523,'x_bj 10<Q2<20, pt3',6,bx,0.0)
	   
        call hbookb(531,'x_bj 20<Q2<85, pt1 ',6,bx,0.0)
        call hbookb(532,'x_bj 20<Q2<85, pt2 ',6,bx,0.0)
        call hbookb(533,'x_bj 20<Q2<85, pt3 ',6,bx,0.0)
	                   
        call hbookb(604,' deltaeta2 all  ',3,etabins4,0.)
        call hbookb(614,' deltaeta2 delta<1  ',3,etabins14,0.)
        call hbookb(624,' deltaeta2 delta>1  ',3,etabins24,0.)
        

***** data histos
* cross section vs x (data stat error, syst error)
        call hbookb(-301,'H1 cs vs x (stat err)',6,bx,0.)
        call hpak(-301,csx)
        call hpake(-301,csxse)
        call hbookb(-1301,'H1 cs vs x (E sys err, -)',6,bx,0.)
        call hpak(-1301,csx)
        call hpake(-1301,csxtem)
        call hbookb(-1302,'H1 cs vs x (E sys err, +)',6,bx,0.)
        call hpak(-1302,csx)
        call hpake(-1302,csxtep)
        call hbookb(-1303,'H1 cs vs x (rem sys err, -)',6,bx,0.)
        call hpak(-1303,csx)
        call hpake(-1303,csxsym)
        call hbookb(-1304,'H1 cs vs x (rem sys err, +)',6,bx,0.)
        call hpak(-1304,csx)
        call hpake(-1304,csxsyp)

* cross section vs x, bins of Q2 and pt2
* Q2 notation binnr:10, 20, 30
* pt2 notation binnr:1, 2, 3
	do i=1,3
	  do j=1,3 
	    k=i*10+j
	    if (k.eq.11) then
	      do n=1,6 !cs=xqpcs11 (how to loop??? integer -> letter?)
	       cs(n)=xqpcs11(n)
	       csse(n)=xqpse11(n)
	       cstem(n)=xqpem11(n)
	       cstep(n)=xqpep11(n)
	       cssym(n)=xqpym11(n)
	       cssyp(n)=xqpyp11(n)
	      enddo   
	    elseif (k.eq.12) then	    
	      do n=1,6 
	       cs(n)=xqpcs12(n)
	       csse(n)=xqpse12(n)
	       cstem(n)=xqpem12(n)
	       cstep(n)=xqpep12(n)
	       cssym(n)=xqpym12(n)
	       cssyp(n)=xqpyp12(n)
	      enddo   
	    elseif (k.eq.13) then	    
	      do n=1,6 
	       cs(n)=xqpcs13(n)
	       csse(n)=xqpse13(n)
	       cstem(n)=xqpem13(n)
	       cstep(n)=xqpep13(n)
	       cssym(n)=xqpym13(n)
	       cssyp(n)=xqpyp13(n)
	      enddo   
	    elseif (k.eq.21) then	    
	      do n=1,6 
	       cs(n)=xqpcs21(n)
	       csse(n)=xqpse21(n)
	       cstem(n)=xqpem21(n)
	       cstep(n)=xqpep21(n)
	       cssym(n)=xqpym21(n)
	       cssyp(n)=xqpyp21(n)
	      enddo   
	    elseif (k.eq.22) then	    
	      do n=1,6 
	       cs(n)=xqpcs22(n)
	       csse(n)=xqpse22(n)
	       cstem(n)=xqpem22(n)
	       cstep(n)=xqpep22(n)
	       cssym(n)=xqpym22(n)
	       cssyp(n)=xqpyp22(n)
	      enddo   
	    elseif (k.eq.23) then	    
	      do n=1,6 
	       cs(n)=xqpcs23(n)
	       csse(n)=xqpse23(n)
	       cstem(n)=xqpem23(n)
	       cstep(n)=xqpep23(n)
	       cssym(n)=xqpym23(n)
	       cssyp(n)=xqpyp23(n)
	      enddo   
	    elseif (k.eq.31) then	    
	      do n=1,6 
	       cs(n)=xqpcs31(n)
	       csse(n)=xqpse31(n)
	       cstem(n)=xqpem31(n)
	       cstep(n)=xqpep31(n)
	       cssym(n)=xqpym31(n)
	       cssyp(n)=xqpyp31(n)
	      enddo   
	    elseif (k.eq.32) then
	      do n=1,6 
	       cs(n)=xqpcs32(n)
	       csse(n)=xqpse32(n)
	       cstem(n)=xqpem32(n)
	       cstep(n)=xqpep32(n)
	       cssym(n)=xqpym32(n)
	       cssyp(n)=xqpyp32(n)
	      enddo   
	    elseif (k.eq.33) then	    
	      do n=1,6 
	       cs(n)=xqpcs33(n)
	       csse(n)=xqpse33(n)
	       cstem(n)=xqpem33(n)
	       cstep(n)=xqpep33(n)
	       cssym(n)=xqpym33(n)
	       cssyp(n)=xqpyp33(n)
	      enddo   
	    endif
	  
	    ih=-500-k
	    ih1=-15100-k
 	    ih2=-15200-k
	    ih3=-15300-k
 	    ih4=-15400-k
	    	    
          call hbookb(ih,'H1 vs x,Q2,pt2 (stat err)',6,bx,0.)
          call hpak(ih,cs)
          call hpake(ih,csse)
          call hbookb(ih1,'H1 vs x,Q2,pt2 (E sys err -)',6,bx,0.)
          call hpak(ih1,cs)
          call hpake(ih1,cstem)
          call hbookb(ih2,'H1 vs x,Q2,pt2 (E sys err +)',6,bx,0.)
          call hpak(ih2,csx)
          call hpake(ih2,cstep)
          call hbookb(ih3,'H1 vs x,Q2,pt2 (rem sys err -)',6,bx,0.)
          call hpak(ih3,cs)
          call hpake(ih3,cssym)
          call hbookb(ih4,'H1 vs x,Q2,pt2 (rem sys err +)',6,bx,0.)
          call hpak(ih4,csx)
          call hpake(ih4,cssyp)
	  enddo
	enddo
	
	
	do i=0,2
	    if (i.eq.0) then
	      do n=1,4 
	       beta(n)=etabins4(n)
	      enddo
	      do n=1,3 
	       cs3(n)=tpfcs1(n)
	       csse3(n)=tpfse1(n)
	       cstem3(n)=tpfem1(n)
	       cstep3(n)=tpfep1(n)
	       cssym3(n)=tpfym1(n)
	       cssyp3(n)=tpfyp1(n)
	      enddo
	    elseif (i.eq.1) then	    
	      do n=1,4 
	       beta(n)=etabins14(n)
	      enddo
	      do n=1,3 
	       cs3(n)=tpfcs2(n)
	       csse3(n)=tpfse2(n)
	       cstem3(n)=tpfem2(n)
	       cstep3(n)=tpfep2(n)
	       cssym3(n)=tpfym2(n)
	       cssyp3(n)=tpfyp2(n)
	      enddo
	    elseif (i.eq.2) then	    
	      do n=1,4 
	       beta(n)=etabins24(n)
	      enddo
	      do n=1,3 
	       cs3(n)=tpfcs3(n)
	       csse3(n)=tpfse3(n)
	       cstem3(n)=tpfem3(n)
	       cstep3(n)=tpfep3(n)
	       cssym3(n)=tpfym3(n)
	       cssyp3(n)=tpfyp3(n)
	      enddo
	    endif
	  
	
	    ih=-604-i*10
	    ih1=-16041-i*100
	    ih2=-16042-i*100
	    ih3=-16043-i*100
	    ih4=-16044-i*100
            call hbookb(ih,'H1 vs d(eta2), (stat err)',3,beta,0.)
            call hpak(ih,cs3)
            call hpake(ih,csse3)
            call hbookb(ih1,'H1 vs d(eta2), (E sys err -)',3,beta,0.)
            call hpak(ih1,cs3)
            call hpake(ih1,cstem3)
            call hbookb(ih2,'H1 vs d(eta2), (E sys err +)',3,beta,0.)
            call hpak(ih2,cs3)
            call hpake(ih2,cstep3)
            call hbookb(ih3,'H1 vs d(eta2), (rem sys err -)',3,beta,0.)
            call hpak(ih3,cs3)
            call hpake(ih3,cssym3)
            call hbookb(ih4,'H1 vs d(eta2), (rem sys err +)',3,beta,0.)
            call hpak(ih4,cs3)
            call hpake(ih4,cssyp3)
	  enddo
	
	
        write(6,*) 'Hz'//xxxx,' jets are found in breit frame ',breit

*********************************************************************
*
*                      Event Processing
*
*********************************************************************
      Else if(iflag.eq.2) then

c   	print*,'hzfjet15.F'

   
        do i=1,numjet
	  do j=1,8
	    pj(i,j)=0.d0
	    pjbr(i,j)=0.d0
	    sort(i,j)=0.d0
	    jetvec(j)=0.d0
          enddo
	enddo        
        
        do i=1,NMXHEP
          ijetno2(i)=0 
        enddo 
        dum=0.
*               
* Filling: The following MUST always be done
* (i) move to the correct sub-directory in PAWC
*
        call hcdir('//PAWC/'//xxxx,' ')

        XJETev=.false.
	ETAJLev=.false.
	PTev=.false.
        
*       Nevt = Nevt + 1.
        
        IF(NLO.eq.1.and.TOT.ne.1) GoTo 11112        
        Nevt = Nevt + wtx
*        write(6,*) 'Nevt', Nevt, 'wtx', wtx
11112   Continue
        NLOJET = DIJET + TRIPJET + QUADJET
        
c        write(6,*) ' NLOJET ',NLOJET, DIJET , TRIPJET , QUADJET
        
        Njet=0
        Nmue = 0
        Nfwd = 0
        Nfwd2 = 0
        nfj = 0
        nfj2=0 
        ierr=HZIBEAM(ibeam,idum)


* get kinematics

        q2=real(HZDISKIN(1))
        x =real(HZDISKIN(2))
        y =real(HZDISKIN(3))

* get electron

        iel=HZIDELEC(idum)
        if (iel.eq.-1) then
          write(*,*) 'Hz'//xxxx,' electron not found '
          return
        endif
        Ee=real(PHEP(4,iel))
	The=real(HZPHMANG(PHEP(3,iel), sqrt(PHEP(1,iel)**2+PHEP(2,iel)
     +  **2)))
        Phe = HZPHMANG(PHEP(1,iel),PHEP(2,iel))
	etae=real(HZETA(iel))

* select DIS events for fwd jets

        fjet=.true.
        if (ylow.gt.y) fjet=.false.
        if (ymax.lt.y) fjet=.false.
        if (fjet) myY=myY+1
         
        if (q2low.gt.q2) fjet=.false.
        if (q2max.lt.q2) fjet=.false.
        if (fjet) myQ2=myQ2+1
         
        if (xlow.gt.x.or.xhigh.lt.x) fjet=.false.
        if (fjet) myX=myX+1
*        if (fjet) write(6,*) 'Nevt', Nevt,' Ee', Ee , '  eelow', eelow
        if (eelow.gt.Ee) fjet=.false.
	if (fjet) myE=myE+1
*	if (fjet) write(6,*) ' Nevt', Nevt
	if (thelow.gt.The) fjet=.false.
	if (fjet) myTHETALOW=myTHETALOW+1
           
     	if (thehigh.lt.The) fjet=.false.
         
* fill Dis histos
        if(fjet) then
          call hfill(101,real(x),0.,wtx)
          call hfill(102,real(y),0.,wtx)
          call hfill(103,real(q2),0.,wtx)
          call hfill(104,real(Ee),0.,wtx)
          call hfill(105,real(The),0.,wtx)
          myDIS=myDIS+1
        endif
                  
        IF(fjet)THEN

* find jets

          ierr=HZIBEAM(ibeam,idum)
          
          if (.not.(ierr.eq.1)) then
            write(6,*) 'HZ'//xxxx,' beams not found ! '
            goto 20
          else
            Do i=1,4
              pbeam(i)=PHEP(i,IBEAM)
            enddo
          endif
          
          ierr=HZIPGAM(ph)
            
          if (ierr.eq.-1) then
            write(6,*) 'HZ'//xxxx,' boson vector not found ! '
            call VZERO(ph,5)
          else
            Do i=1,4
              pgam(i)=ph(i)
            enddo
          endif
         
          call HZBRTINI(pbeam,pgam,ierr)
          
          if (ierr.eq.1) then
            write(6,*) 'HZ'//xxxx,' problem with boost to cms ! '
            goto 20
          endif
             
          DO ihep=5,nhep
            Do i=1,4
              Ph(i)=PHEP(i,ihep)
              Plab(i,ihep)=PHEP(i,ihep)
              phep(i,ihep)=0.0
            enddo
                             
* Boost jet in the breit frame

            if(breit) then                
              call HZBRT(ph,pbr,ierr)
              Do i=1,4
                PHEP(i,ihep)=Pbr(i)
              enddo
            else
              Do i=1,4
                PHEP(i,ihep)=Plab(i,ihep)
              enddo		     
	    endif
          ENDDO
               
          if(breit) then 
c            call hzjtfmy(modjet,rcone,ktmode,nj1,pjbr)
            call hzjtfind(modjet,rcone,nj1,pjbr)
            call hzbrtola(nj1,pjbr,pj)
          else
c	    call hzjtfmy(modjet,rcone,ktmode,nj1,pj)
            call hzjtfind(modjet,rcone,nj1,pj)
	  endif

	  nj = nj1
          Do ihep=5,nhep
            do i=1,4
              PHEP(i,ihep)= Plab(i,ihep)
            enddo
          Enddo  

* Redefine eta, to be consistent with h1phan           
          do i=1,nj
            thj =real(HZPHMANG(pj(i,7),sqrt(pj(i,5)**2 + pj(i,6)**2)))
            pj(i,1)=-real(log(tan(thj/2)))
          enddo       
                                                           
          if (nj.le.0) return
          if (nj.gt.numjet) then
            write(6,*) 'hz',xxxx,' too many jets found ! '
            return
          endif

* Sort jets in pt
* (If two pt are the same, IJETNO will not work)            	  
          do i=1,NHEP
            IJETNO2(i)=IJETNO(i) 
          enddo

          DO i=1,nj
            place=1
            count=0
            sorti = dble(sqrt(pj(i,5)**2 + pj(i,6)**2)) ! Sort in pt	  
            Do j=1,nj
              sortj =dble(sqrt(pj(j,5)**2 + pj(j,6)**2)) ! Sort in pt
              if (sorti.lt.sortj) place=place+1
              if (sorti.eq.sortj) count=count+1
            Enddo
            Do k=1,count
              do j=1,8
                sort(place+k-1,j)=pj(i,j)                
              enddo
              do j=1,NHEP
                if (IJETNO(j).eq.i) IJETNO2(j)=place+k-1 
              enddo
            Enddo            
          ENDDO
	  
          do i=1,NHEP
            IJETNO(i)=IJETNO2(i) 
          enddo
          
          do i= 1,nj
            do j=1,8
              pj(i,j)=sort(i,j)
            enddo    
          enddo
	
* End sorting
                                            
* Look for fwd jets, it is assumed that in pj they are ordered in pt
            
          nfj = 0
          nfj2=0  
          DO 10   ij=1,nj
            ej=real(pj(ij,4))
            xjet = real(ej/820.)
            ptj=real(sqrt(pj(ij,5)**2+pj(ij,6)**2))
            Phj =real(HZPHMANG(pj(ij,5),pj(ij,6)))
            etajf = real(pj(ij,1))
            
             if (ptj.lt.ptjlow) goto 10
            
             myPT=myPT+1
            Njet=Njet+1
            PTev=.true.
               
            if (xjet.gt.xjetcut) then
              myXJET=myXJET+1
              XJETev=.true.
              
              if (etajf.gt.etajflow) then 
                myETAJL=myETAJL+1
                ETAJLev=.true.
		
                if (etajf.lt.etajfhigh) then
               
* You got a fwd jet!
                  myETAJH=myETAJH+1
                  Nfwd = Nfwd + 1

                  if(ptj.gt.6.0) then
		    etajf2=real(pj(ij,1))
		    Nfwd2=Nfwd2+1
		  endif
		  
* If more than one forward jet, use the most forward one (largest eta)
		  
		  If(Nfwd.eq.1)then
                    Do i=1,8
                      jetvec(i)=pj(ij,i)
                    Enddo
                  Elseif(Nfwd.gt.1)then
                    if(jetvec(1).lt.etajf)then
                      Do i=1,8
                        jetvec(i)=pj(ij,i)
                      Enddo
                    endif
                  Endif

                  If(Nfwd2.eq.1)then
                    Do i=1,8
                      jetvec2(i)=pj(ij,i)
                    Enddo
                    nfj2=ij
                  Elseif(Nfwd2.gt.1)then
                    if(jetvec2(1).lt.etajf2)then
                      Do i=1,8
                        jetvec2(i)=pj(ij,i)
                      Enddo
                      nfj2=ij
                    endif
                  Endif


* Mueller jets
                  pt2q2=Ptj**2/q2
                  if (pt2q2.gt.pt2q2low.and.pt2q2.lt.pt2q2high) then
                    Nmue = Nmue+1
                    Nmuejet = Nmuejet + 1

* If more than one Mueller jet, use the most forward one (largest eta)
                    
                    If(Nmue.eq.1)then
                        nfj=ij
                    Elseif(Nmue.gt.1)then
                      if(pj(nfj,1).lt.etajf)then
                          nfj=ij
                      endif
                    Endif
                  Endif         !Mueller jets
*                 endif         !fwd jet selection
                endif           !etajfhigh
              endif             !etajflow
            endif               !xjet
               
 10       CONTINUE

          If(Nmue.ge.1)Then
            IF((NLO.eq.1).AND.(NLOJET.eq.0)) goto 11114	    	    	    
            ptj=real(sqrt(pj(nfj,5)**2+pj(nfj,6)**2))
            xjet = real(pj(nfj,4)/820.)    
            call hfill(301,x,0.,wtx)
11114       continue
          endif
            
         ptj=real(sqrt(jetvec(5)**2+jetvec(6)**2))
            ipt=0
            if(ptj**2.gt.pt2xv(1).and.ptj**2.lt.pt2xv(2)) then 
              ipt=1
            elseif(ptj**2.gt.pt2xv(2).and.ptj**2.lt.pt2xv(3)) then
              ipt=2
            elseif(ptj**2.gt.pt2xv(3).and.ptj**2.lt.pt2xv(4)) then
              ipt=3
            endif
                  
            iq2=0
            if(q2.gt.q2xv(1).and.q2.lt.q2xv(2)) then 
              iq2=1
            elseif(q2.gt.q2xv(2).and.q2.lt.q2xv(3)) then 
              iq2=2
            elseif(q2.gt.q2xv(3).and.q2.lt.q2xv(4)) then 
              iq2=3
            endif
                                
           pt2q2=ptj**2/q2
             if(ipt.ne.0.and.iq2.ne.0) then
	     ihisto=500+iq2*10+ipt
               IF((NLO.eq.1).AND.(NLOJET.eq.0)) goto 11115
                  call hfill(ihisto,real(x),0.,wtx) 
11115		continue
            endif  

** pt2/Q2 plot            
            pt2q2=ptj**2/q2
            IF((NLO.eq.1).AND.(NLOJET.eq.0)) goto 11120
ccc               call hfill(99,real(pt2q2),0.,wtx)  ! histogram not defined 
11120       continue
 
            
* 2+fwd jets
          If(nfj2.ne.0)Then
	  
            etajf = real(pj(nfj2,1))                                
            nhard = 0
            do 11   ij=1,nj
              if(ij.eq.nfj2) goto 11		   
              ptjet=real(sqrt(pj(ij,5)**2+pj(ij,6)**2))
              etajet = real(pj(ij,1))
              if(ptjet.gt.6.0) then 
                if(etajet.gt.etae.and.etajet.lt.etajf2) then
                  nhard = nhard + 1
                  njeth(nhard) = ij
                endif 
              endif
 11         continue
                              
            if(nhard.ge.2) then
* Decide which one is hard1 and hard2               
              if(pj(njeth(1),1).gt.pj(njeth(2),1)) then
                k=njeth(1)
                njeth(1)=njeth(2)
                njeth(2)=k
              endif   
              call hfill(666,x,0.,wtx)
            
              deltaeta= abs(real(pj(njeth(2),1))-real(pj(njeth(1),1)))
              deltaeta2=abs(real(pj(nfj2,1))-real(pj(njeth(2),1)))
              deltaphi=abs(real(HZPHMANG(pj(njeth(1),5),pj(njeth(1),6)))
     &             -real(HZPHMANG(pj(njeth(2),5),pj(njeth(2),6))))
              if (deltaphi.gt.pi) deltaphi=2*pi-deltaphi
              
              
              IF((NLO.eq.1).AND.(NLOJET.eq.0)) goto 11116
              call hfill(604,real(deltaeta2),0.,wtx)
              myTWO=myTWO+1   
              if(deltaeta.le.1) then
                call hfill(614,real(deltaeta2),0.,wtx)
              else
                call hfill(624,real(deltaeta2),0.,wtx)
              endif
11116         continue
            endif               ! nhard.ge.2
          Endif                 ! nfj.ne.0            
        ENDIF                   ! fjet          
 20     continue
        
        if (Nfwd.gt.0) myFWD=myFWD+1	
        if (Nmue.gt.0) myMUE=myMUE+1
        if (PTev) myPTev=myPTev+1
        if (XJETev) myXJETev=myXJETev+1
        if (ETAJLev) myETAJLev=myETAJLev+1

*********************************************************************
*
*                      Termination
*
*********************************************************************

      Else if(iflag.eq.3) then

* Termination: The following MUST always be done
* (i) Move to the correct PAW subdirectory
*
        call hcdir('//PAWC/'//xxxx,' ')

        lumnb=999999.
        lumpb=999999.
        if (xsec.ne.0.) then
          lumnb=1000.*real(Nevt)/real(xsec)
          lumpb=real(Nevt)/real(xsec)
          write(6,*) 'hz',xxxx
          print *,'Number of events procesed:',Nevt
          print *,'Total cross section:',xsec
          print *,'Equivalent luminosity [nb] :',lumnb
          print *,'Number of DIS events :',myDIS
          print *,'Number of Mueller fwd jets :',Nmuejet
        else
          write(6,*) 'hz',xxxx,' xsec=0 ! '
        endif
                

* normallize ds/dx
        call hzhinrm(301, 0, lumnb , 1 )

*normalize d3s/dxdQ2dpt2  
        do j=1,3
	  do k=1,3
            p2q2w=(pt2w(j)*q2w(k)) !bin width normalization
	    nfac=p2q2w*lumnb
            ih=500+k*10+j
	    call hzhinrm(ih, 0, nfac , 1 )
	  enddo
        enddo
                                                                                                      
                 
        call hzhinrm(604, 0, lumnb , 1 )
        call hzhinrm(614, 0, lumnb , 1 )
        call hzhinrm(624, 0, lumnb , 1 )
        
        write(6,*) '***************************************'
	write(6,*) 
	write(6,*) 'Nbr of events:                  ',Nevt 
 	write(6,*) 'Nbr of DIS events:               ',myDIS 
	write(6,*) 'Nbr of events with fwd jets:     ',myFWD
	write(6,*) 'Nbr of events with Mueller jets: ',myMUE
	write(6,*) 'Nbr of events with 2+fwd jets:   ',myTWO
	write(6,*) 
 	write(6,*) '***************************************'
	write(6,*) 
        write(6,*) 
 	write(6,*) '************** DIS ********************'
	write(6,*) 
	write(6,*) 'Nbr of events passing y cut:         ',myY 
 	write(6,*) 'Nbr of events passing Q2 cut:        ',myQ2 
	write(6,*) 'Nbr of events passing X cut:         ',myX 
	write(6,*) 'Nbr of events passing E cut:         ',myE 
	write(6,*) 'Nbr of events passing Thetalow cut:  
     &',myTHETALOW 
	write(6,*) 'Nbr of events passing Thetahigh cut: 
     &',myDIS 
	write(6,*) 
 	write(6,*) '***************************************'
	write(6,*) 
        write(6,*) '************** FWD JETS ***************'
	write(6,*) 
	write(6,*) 'Nbr of ev. passing PT cut:      ',myPTev
 	write(6,*) 'Nbr of ev. passing XJET cut:    ',myXJETev 	
	write(6,*) 'Nbr of ev. passing etalow cut:  ',myETAJLev 	
	write(6,*) 'Nbr of ev. passing etahigh cut: ',myFWD 
	write(6,*) 
	write(6,*) 'Nbr of jets passing PT cut:      ',myPT 
 	write(6,*) 'Nbr of jets passing XJET cut:    ',myXJET 
	write(6,*) 'Nbr of jets passing etalow cut:  ',myETAJL 
	write(6,*) 'Nbr of jets passing etahigh cut: ',myETAJH 
	write(6,*) 
 	write(6,*) '***************************************'
	write(6,*) 
      
      endif
      RETURN
      END
