*  author     : Lluis Marti (& Gero Flucke)
* D* plus jets in gamma-p (H1) 
* Ref DESY-06-110, hep-ex/0608042
* corrections by T. Toll
* some data points had no error
*
      subroutine HZH0608042(IFLAG)
      IMPLICIT NONE
#include "hzfunc.inc"
#include "hzhbook.inc"
#include "hepevtp.inc"
#include "heracmn.inc"
#include "hzjetcmn.inc"
*
*     
*     
*     
      Integer Nentry
      Integer Iflag,ierr
      Real nall,Nevt
      Character*8 xxxx
*     
      Real eb,ee,Qpi,qqradp,lumnb,lumpb
      Double Precision pi,rd
      Parameter (pi=3.141592653589793238d0,rd=180.d0/pi)
      Integer iel,idum,ibeamp,ibeaml,igam,ifj,afj,bfj
      Real x,y,q2,enel,thel
      
****  
      Double Precision PtD, EthaD, PhiD, SelJets(9), Xgamma, zDs
      Integer dijetind(2)
      Double Precision PhiDiff, dijetpt(2),tmpDbl
      
      Integer I, J, JJ, JJJ, Twice, KCount,tmpInt
      Integer Part(NHEP), Count, CountP, IsDsJet, NoGood
      Integer Kanal, Nenner, DPart, NDsVis
      Real Wgp, lumcor, c2dFrac
      
      Real Dbin(5), Pbin(5), Ebin(6), Edifbin(8), Phbin(7), PtSum(5),
     &     Xbin(5), Mbin(5), DPbin(9), Wbin(5), Dcos(6),DEtabin(7),
     &     zDsBin(7),eta2Dbin(4),pt2Dbin(4)
      Data Dbin/2.,3.5,5.,7.5,11./     
      Data DPbin/2.0,2.5,3.0,3.5,4.25,5.0,6.0,8.5,12./
      Data zDsBin/0.0,0.1,0.2,0.3,0.45,0.6,0.8/
      Data eta2Dbin/-1.5,-0.9,0.2,1.5/
      Data pt2Dbin/2.0,3.0,4.5,8.5/

      Data Pbin/3.,5.,7.5,11.,16./      
      Data Ebin/-1.5,-1.0,-0.5,0.1,0.8,1.5/     
      Data Edifbin/-4.2,-3.,-2.,-1.,0.,1.,2.,3.25/
      Data DEtabin/-2.8,-1.9,-1.,0.,1.,1.9,2.8/
      Data Phbin/0.,86.,114.,138.,154.,170.,180./ 
      Data PtSum/0.,1.8,3.5,6.,9./
      Data Xbin/0.,0.3,0.6,0.8,1./
      Data Mbin/5.,8.5,13.,18.,28./
      Data Wbin/172.,192.,212.,232.,256./
      Data Dcos/-.8,-.5,-.2,.1,.45,.8/
****  
      Real PD(8),PDErr(8),PDTErr(8),ED(6),EDErr(6),EDTErr(6),WGaP(4),
     &     WGaPErr(4),WGaPTErr(4), zDsData(6),zDsDaErr(6),zDsDaTErr(6),
     &     etapt1Data(3),etapt1DaErr(3),etapt1DaTErr(3),
     &     etapt2Data(3),etapt2DaErr(3),etapt2DaTErr(3),
     &     etapt3Data(3),etapt3DaErr(3),etapt3DaTErr(3),
     &     PtJ(4), PtJErr(4), PtJTErr(4),PDe(4),
     &     PDeErr(4),PDeTErr(4),EDe(5),EDeErr(5),EDeTErr(5),
     &     DetaData(6),DetaDaErr(6),DetaDaTErr(6),
     &     DphiData(6),DphiDaErr(6),DphiDaTErr(6),PtDJ(4),PtDJErr(4),
     &     PtDJTErr(4),MDJ(4),MDJErr(4),MDJTErr(4),XGa(4),XGaErr(4),
     &     XGaTErr(4),EtaJData(5),EtaJDaErr(5),EtaJDaTErr(5),
     &     cosThData(5),cosThDaErr(5),cosThDaTErr(5)
     
      Real PDsys(8),EDsys(6),WGasys(4),zDsDasys(6),
     &     etapt1Dasys(3),etapt2Dasys(3),etapt3Dasys(3),
     &     PtJsys(4),PDesys(4),EDesys(5),EtaJDasys(5),DetaDasys(6),
     &     DphiDasys(6),XGasys(4)


*     data for inclusive D*
*     incl. pt(D*)
      Data PD    /3.37,3.01,2.22,.97,.577, .250, .0629,.0133/
      Data PDErr /.63,.37,.23,.11,.071, .038, .013,.005/
      Data PDsys /.36,.32,.24,.10,.063, .027, .0068,.0016/

*     incl. eta(D*)
      Data ED    /3.54,2.93,1.71,2.16,1.58,.74/
      Data EDErr /.3,.25,.26,.29,.31,.41/
      Data EDsys /.39,.31,.19,.23,.18,.08/

*     incl. W_{\gamma p}
      Data WGaP    /0.112,.0784, .0601, .0548/
      Data WGaPErr /.012,.0077,.0071,.0078/
      Data WGasys /.017,.0077,.0058,.0057/

*     incl. z(D*)
      Data zDsData  /10.8,17.8,9.9,8.66, 6.0, 1.48/
      Data zDsDaErr /2.5,1.9,1.2,0.76,0.58,0.24/
      Data zDsDasys /1.2,2.0,1.1,0.93,0.64,0.19/

*     incl. eta(D*) pt-bin 1
      Data etapt1Data  /2.14, 1.14, 0.628/ 
      Data etapt1DaErr /0.25,0.17, 0.2/ 
      Data etapt1Dasys /0.23,0.13, 0.07/ 

*     incl. eta(D*) pt-bin 2
      Data etapt2Data  /1.02, 0.714, 0.495/ 
      Data etapt2DaErr /0.11,0.073,0.082/ 
      Data etapt2Dasys /0.11,0.077,0.057/ 

*     incl. eta(D*) pt-bin 3
      Data etapt3Data  /0.263, 0.24,  0.19/ 
      Data etapt3DaErr /0.043,0.037,0.034/ 
      Data etapt3Dasys /0.028,0.027,0.02/ 

*     
*     data for D*+jet
*     D*+jet: pt(jet)
      Data PtJ    /.87,  .334, .084,.0201/
      Data PtJErr /.094,.049,.021,.0071/
      Data PtJsys /.095,.037,.01,.0022/

*     D*+jet: pt(D*)
      Data PDe    /1.35,.407, .124, .0116/
      Data PDeErr /.16,.051,.017,.0048/
      Data PDesys /.15,.044,.014,.0013/

*     D*+jet: eta(D*)
      Data EDe    /1.46,1.46,.99,1.05,.33/
      Data EDeErr /.18,.17,.16,.18,.22/
      Data EDesys /.16,.16,.11,.12,.04/

*     D*+jet: eta(jet)
      Data EtaJData  /.84,1.15,1.15,.84,.99/
      Data EtaJDaErr /.16,.19,.18,.17,.17/
      Data EtaJDasys /.092,.13,.13,.093,.11/

*     D*+jet: eta(D*) - eta(jet)
      Data DetaData  /.318, .66,1.01,.63, .44,.084/
      Data DetaDaErr /.065,.10,.13,.13,.11,.071/
      Data DetaDasys /.037,.07,.11,.07,.05,.012/

*     D*+jet: delta phi(D*,jet)
      Data DphiData  /.00167,.0108, .0156, .034, .0561, .073/
      Data DphiDaErr /.00086,.0029,.004,.0062,.0077,.010/
      Data DphiDasys /.00022,.0012,.0018,.0039,.0061,.008/


* D*+jet: x_gamma(di-jet)
      Data XGa    /0.6,2.32,2.12,4.81/
      Data XGaErr /.39,.45,.51,.44/
      Data XGasys /.12,.36,.27,.53/

****  
      save xxxx,nall
      Data xxxx/'H0608042'/,NENTRY/0/
      
      real sigm,wt
      common/cwnco1/x,y,Q2,sigm

*********************************************************************
*     
*                      Initialization
*
*********************************************************************
*     
      IF (iflag.eq.1) then
*     
         write(6,*)' hzgero new with 2jets norm corr & xgam '
         Qpi = 4.*atan(1.)
         qqradp = 180./qpi
         nevt = 0
         count = 0
*     
*     
*     Initialisation: The following MUST always be done
*     (i) make subdirectory in PAWC
*     - use the name as the xxxxxx in HZxxxxxx subroutine
*     (i) make subdirectory in o/p file
*     
         Call hcdir('//PAWC',' ')
         call hmdir(xxxx,'S')
         Call hcdir('//HISTO',' ')
         call hmdir(xxxx,'S')
         call hbook1(221,'  y     ',100,0.,1.,0.)
         call hbook1(222,'  Q2     ',100,0.,0.01,0.)
         
** New Plots	 
         call hbookb(120,'incl. pt(D*) xsection(nb)',8,DPbin,0.)
         call hbookb(-120,'incl. pt(D*) xsection(nb)',8,DPbin,0.)
         call hbookb(-121,'incl. pt(D*) xsection(nb)',8,DPbin,0.)
         
         call hbook1(130,'incl. eta(D*) xsection(nb)',6,-1.5,1.5,0.)
         call hbook1(-130,'incl. eta(D*) xsection(nb)',6,-1.5,1.5,0.)
         call hbook1(-131,'incl. eta(D*) xsection(nb)',6,-1.5,1.5,0.)
         
         call hbookb(140,'incl. D* Wgp xsection(nb)',4,Wbin,0.)	
         call hbookb(-140,'incl. D* Wgp xsection(nb)',4,Wbin,0.)
         call hbookb(-141,'incl. D* Wgp xsection(nb)',4,Wbin,0.)
         
         call hbookb(150,'incl. D* z(D*) xsection(nb)',6,zDsBin,0.)
         call hbookb(-150,'incl. D* z(D*) xsection(nb)',6,zDsBin,0.)	 
         call hbookb(-151,'incl. D* z(D*) xsection(nb)',6,zDsBin,0.)
* inclusive eta(D*) in bins of pt(D*)
         call hbookb(160,'incl. D* eta(D*) xsec(nb) pt1',3,eta2Dbin,0.)
         call hbookb(-160,'incl. D* eta(D*) xsec(nb) pt1',3,eta2Dbin,0.)	 
         call hbookb(-161,'incl. D* eta(D*) xsec(nb) pt1',3,eta2Dbin,0.)

         call hbookb(170,'incl. D* eta(D*) xsec(nb) pt2',3,eta2Dbin,0.)
         call hbookb(-170,'incl. D* eta(D*) xsec(nb) pt2',3,eta2Dbin,0.)	 
         call hbookb(-171,'incl. D* eta(D*) xsec(nb) pt2',3,eta2Dbin,0.)

         call hbookb(180,'incl. D* eta(D*) xsec(nb) pt3',3,eta2Dbin,0.)
         call hbookb(-180,'incl. D* eta(D*) xsec(nb) pt3',3,eta2Dbin,0.)	 
         call hbookb(-181,'incl. D* eta(D*) xsec(nb) pt3',3,eta2Dbin,0.)
*
** now D*+jet
* 
         call hbookb(223,'D*+jet pt(D*) xsection(nb)',4,Dbin,0.)
         call hbookb(-223,'D*+jet pt(D*) xsection(nb)',4,Dbin,0.) 
         call hbookb(-224,'D*+jet pt(D*) xsection(nb)',4,Dbin,0.) 
         
         call hbookb(232,'D*+jet EtaD* xsection(nb) ',5,Ebin,0.)	 
         call hbookb(-232,'D*+jet EtaD* xsection(nb) ',5,Ebin,0.)	  
         call hbookb(-233,'D*+jet EtaD* xsection(nb) ',5,Ebin,0.)	   
         
         call hbookb(320,' Eta(DJet) - Eta(Jet)  ',7,Edifbin,0.)
         
         call hbookb(325,'D*+jet Eta(D) - Eta(Jet)   ',6,DEtabin,0.)
         call hbookb(-325,'D*+jet Eta(D) - Eta(Jet)   ',6,DEtabin,0.)  
         call hbookb(-326,'D*+jet Eta(D) - Eta(Jet)   ',6,DEtabin,0.)  
         
         call hbookb(423,'D*+jet PtJet xsec(nb)   ',4,Pbin,0.)
         call hbookb(-423,'D*+jet PtJet xsec(nb)   ',4,Pbin,0.) 
         call hbookb(-424,'D*+jet PtJet xsec(nb)   ',4,Pbin,0.) 
         
         call hbookb(432,'D*+jet EtaJet xsec(nb)  ',5,Ebin,0.)	 
         call hbookb(-432,'D*+jet EtaJet xsec(nb)  ',5,Ebin,0.)	 
         call hbookb(-433,'D*+jet EtaJet xsec(nb)  ',5,Ebin,0.)	 
         
         call hbookb(450,'D*+jet PhiD - PhiJet   ',6,Phbin,0.)
         call hbookb(-450,'D*+jet PhiD - PhiJet   ',6,Phbin,0.)
         call hbookb(-451,'D*+jet PhiD - PhiJet   ',6,Phbin,0.)
         
         
*
** now D* tagged dijets
         call hbookb(500,'D* in Dijet: Xgamma',4,Xbin,0.)
         call hbookb(-500,'D* in Dijet: Xgamma',4,Xbin,0.)
         call hbookb(-501,'D* in Dijet: Xgamma',4,Xbin,0.)

c         call hbookb(505,'D* in Dijet: pt(jet1)',4,Pbin,0.)	
c         call hbookb(510,'D* in Dijet: pt(jet2)',4,Pbin,0.)	
c         call hbookb(515,'D* in Dijet: pt(D*-jet)',4,Pbin,0.)
c         call hbookb(525,'D* in Dijet: eta(D*-jet)',5,Ebin,0.)
c         call hbookb(530,'D* in Dijet: eta(oth. jet)',5,Ebin,0.)
c         call hbookb(535,'D* in Dijet: eta(D*-jet)-eta(o. jet)',
c     &        6,DEtabin,0.)
c         call hbookb(540,'D* in Dijet: delta phi',6,Phbin,0.)

 
** New Plots	 
	 
c         CALL HBNT(1999,'ana  ',' ')
c         CALL HBNAME (1999,'kin',x,'x,y,Q2,sigm')
*********************************************************************
*
*                      Event Processing
*
*********************************************************************
      Else if(iflag.eq.2) then
*
* Filling: The following MUST always be done
* (i) move to the correct sub-directory in PAWC
*
         call hcdir('//PAWC/'//xxxx,' ')
*
         wt=wtx
         NENTRY=NENTRY+1
*
         ierr=HZIBEAM(ibeamp,ibeaml)

*
* get kinematics
*
         q2=real(HZPHOKIN(1))
         x =real(HZPHOKIN(2))
         y =real(HZPHOKIN(3))
         
         sigm = real(Xsec)
*     
* get electron
*
         iel=HZIDELEC(idum)
         if (iel.eq.-1) then
            write(*,*) 'Hz'//xxxx,' electron not found '
            return
         endif
          
         Ee=real(PHEP(4,iel))
		 
******************************************
         Do J=1, NHEP
            If (iabs(IDHEP(J)).eq.413) Then
               DPart = DPart + 1  
               Call hzDRates(J, Kanal)	   	   
            End If  
         End Do  	   
         Call hzCDRates(Nenner)	   
         
* Cuts on Q2 and y
         If (q2.gt.0.01) Return
         If (y.lt.0.29.or.y.gt.0.65) Return
         Twice = 0
         
** Find a D* event (ID=413)
         Do J=1, NHEP
            IsDsJet = 0	
            If (iabs(IDHEP(J)).eq.413) Then
               
** Apply cuts on (12. GeV <) PtD > 2 GeV	   
               PtD = HZPT(J)
               If (PtD.gt.2.d0) Then
** Apply cuts on Etha(D*)<1.5
                  EthaD=HZETA(J)
                  If (abs(EthaD).lt.1.5d0) Then

                     Call hzFillsSub(J, Part, CountP)		
                     Call hzStatus(1, J, Part, CountP) !make D* stable, daughters special
                     Call HZJTFIND(11, 1., Numjets, Jets)

*** Here we apply cuts on PtJet 
*** Cuts on Jets     3.< PtJet  (<16.GeV) 
****              -1.5 < EthaJet < 1.5 
                     Do I=1, 9  ! initialise	
                        SelJets(I) = 0.d0
                        if (I.le.2) then
                           dijetpt(I) = 0.d0
                           dijetind(I) = 0
                        endif
                     end do
                     Do JJ=1, Numjets
**** fullfill basic jet cuts  
                        If (abs(Jets(JJ,1)).lt.1.5d0.and.
     &                       Jets(JJ,3).gt.3.d0) then
**** ...and look or dijets
                           if (dijetind(1).eq.0.or. ! select higher pt jet
     &                          Jets(JJ,3).gt.dijetpt(1)) then
                              dijetind(2)=dijetind(1) ! degrade current first jet...
                              dijetpt(2)=dijetpt(1)   ! ...to become second jet
                              dijetind(1)=JJ          ! save index and pt...
                              dijetpt(1)=Jets(JJ,3)   ! ...of first jet
                           else if (dijetind(2).eq.0.or. ! select 2nd jet
     &                             Jets(JJ,3).gt.dijetpt(2)) then
                              dijetind(2)=JJ
                              dijetpt(2)=Jets(JJ,3)
                           endif
**** ...and look for non-D* jet
                           if(IJETNO(J).ne.JJ) Then
                              IsDsJet = 1
                              if(Jets(JJ,3).gt.SelJets(3)) then ! look for jet with higher pt
                                 SelJets(9) = JJ
                                 Do I=1, 8	
                                    SelJets(I) = Jets(JJ,I)
                                 End Do  
                              End If		  
                           End If ! end non-D*-jet
                        End If ! end basic jet cuts fulfilled
                     End Do
                     if(IsDsJet.eq.1) ! fill x_gamma(D*+j) and M(D*+jet)
     &                   call hzCalculus(J, int(SelJets(9)), Xgamma,iel)
                     if (dijetpt(1).gt.4.d0.and.dijetind(2).ne.0.d0)then !D* tagged Dijet
                        call hfill(505,real(dijetpt(1)),0.,real(wtx))
                        call hfill(510,real(dijetpt(2)),0.,real(wtx))
* associate D* and its jet:
                        if (IJETNO(J).eq.dijetind(2)) then
                           tmpInt=dijetind(1)
                           dijetind(1)=dijetind(2)
                           dijetind(2)=tmpInt
                           tmpDbl=dijetpt(1)
                           dijetpt(1)=dijetpt(2)
                           dijetpt(2)=tmpDbl
                        elseif (IJETNO(J).ne.dijetind(1)) then
* neither of the jets is D*-jet, choose closer one in eta-phi
                           PhiDiff = abs(HZPHI(J) - Jets(dijetind(1),2))
                           if (PhiDiff.gt.pi) PhiDiff=(2.d0*pi)-PhiDiff 
                           tmpDbl=(HZETA(J)-Jets(dijetind(1),1))**2 + ! R^2 for jet1
     &                          PhiDiff**2
                           PhiDiff = abs(HZPHI(J)-Jets(dijetind(2),2))
                           if (PhiDiff.gt.pi) PhiDiff=(2.d0*pi)-PhiDiff 
                           if (tmpDbl.gt.
     &                          (HZETA(J)-Jets(dijetind(2),1))**2 +
     &                          PhiDiff**2) then ! 2 closer to D*
                              tmpInt=dijetind(1)
                              dijetind(1)=dijetind(2)
                              dijetind(2)=tmpInt
                              tmpDbl=dijetpt(1)
                              dijetpt(1)=dijetpt(2)
                              dijetpt(2)=tmpDbl
                           endif
                        endif
                        call hfill(515,real(dijetpt(1)),0.,real(wtx))
                        call hfill(520,real(dijetpt(2)),0.,real(wtx))
                        call hfill(525,real(Jets(dijetind(1),1)),0.,
     &                     real(wtx))
                        call hfill(530,real(Jets(dijetind(2),1)),0., 
     &                     real(wtx))
                        call hfill(535, real(Jets(dijetind(1),1) -
     &                       Jets(dijetind(2),1)),0.,real(wtx))

                        PhiDiff = abs(Jets(dijetind(1),2) - 
     &                       Jets(dijetind(2),2))
                        If (PhiDiff.gt.pi) PhiDiff = (2.d0*pi) - PhiDiff
                        PhiDiff = PhiDiff * 180.d0/ pi
                        call hfill(540,real(PhiDiff),0.,real(wtx))

                        call hzxgam2j(dijetind(1),
     &                        dijetind(2),iel,Xgamma) ! calc Xgamma
                        call hfill(500,real(Xgamma),0.,real(wtx))
                     endif ! dijet cuts fulfilled and dijet filling

                     Call hzStatus(0, J, Part, CountP)!make D* unstable, daughters stable
                     
                     NDsVis = NDsVis + 1
                     Wgp =sqrt(real(HZDISKIN(4)))
*                    ((E-pz)_{D*})/(2*y*E_e)
                     zDs = (PHEP(4,J)-PHEP(3,J))/(2.d0*y*PHEP(4,ibeaml))
                     call hfill(120,real(PtD),0.,real(wtx))
                     call hfill(130,real(EthaD),0.,real(wtx))
                     call hfill(140,Wgp,0.,real(wtx))	  	   
                     call hfill(150,real(zDs),0.,real(wtx))
                     if(real(PtD).lt.pt2Dbin(2)) then
                        call hfill(160,real(EthaD),0.,real(wtx))
                     elseif(real(PtD).lt.pt2Dbin(3)) then
                        call hfill(170,real(EthaD),0.,real(wtx))
                     elseif(real(PtD).lt.pt2Dbin(4)) then
                        call hfill(180,real(EthaD),0.,real(wtx))
                     endif


                  End If        !EthaD cut
               End If           !PtD cut

            End If              !D* founded  

            If (IsDsJet.eq.1) Then
               If (Twice.eq.1) KCount = KCount + 1
               Twice = 1
               
               Count = Count + 1        
               call hfill(221,real(y),0.,real(wtx))
               call hfill(222,real(q2),0.,real(wtx))
               
               call hfill(223,real(PtD),0.,real(wtx))
               call hfill(232,real(EthaD),0.,real(wtx))
               
               call hfill(320,real(Jets(IJETNO(J),1)-SelJets(1)),0.,
     &          real(wtx))

               call hfill(325,real(EthaD-SelJets(1)),0.,real(wtx))
               
               call hfill(423,real(SelJets(3)),0.,real(wtx))	  
               call hfill(432,real(SelJets(1)),0.,real(wtx))	  
               
               PhiD = HZPHI(J)
               PhiDiff = abs(PhiD - Jets(int(SelJets(9)),2))
               If (PhiDiff.gt.pi) PhiDiff = (2.d0*pi)- PhiDiff 
               PhiDiff = PhiDiff * 180.d0/pi
               call hfill(450,real(PhiDiff),0.,real(wtx))	  
               
               call hfill(460,real(sqrt((SelJets(5)+PHEP(1,J))**2+
     &              (SelJets(6)+PHEP(2,J))**2)),0.,real(wtx))	  
               
               call hfill(490,real(tanh((EthaD-SelJets(1))/2.d0)),0.,
     &          real(wtx))
            End If
         End Do                 ! Loop over PHEP
*** Find a D* event - End

*********************************************************************
*
*                      Termination
*
*********************************************************************

      Else if(iflag.eq.3) then

* Termination: The following MUST always be done
* (i) Move to the correct PAW subdirectory
*
         call hcdir('//PAWC/'//xxxx,' ')
*     
         nevt=ntot
         lumnb=999999.
         lumpb=999999.
         c2dFrac = 1.*DPart/(1.*Nenner)
	   if(c2dFrac.ge.1) c2dFrac = 1.
         if (xsec.ne.0.d0) then
            lumnb=1000.*real(Nevt)/real(xsec)
            lumpb=real(Nevt)/real(xsec)
            print *,'Number of events procesed:',Nevt
            print *,'Total cross section [pb]:',xsec
            print *,'Equivalent luminosity [nb] :',lumnb
            Write(*,*) 'D* particles       ',DPart
            Write(*,*) 'D* in Visible range ', NDsVis
            Write(*,*) 'D* + Jet events    ',Count
            Write(*,*) 'Double selected events ',KCount	    
            Write(*,*) 'selected Kanal ',Kanal
            Write(*,*) 'D*->D Pi->K Pi Pi ', real(1.*Kanal/(1.*Dpart))
            Write(*,*) 'Num events c->D* ',Nenner
            Write(*,*) 'c -> D* ', real(c2dFrac)
         else
            write(6,*) 'hz',xxxx,' xsec=0 ! '
         endif
         
** Normaliation
         lumcor = lumnb*c2dFrac/.235
	   if(c2dFrac.ge.1.) lumcor = lumnb
         call hzhinrm(120, 0, lumcor, 1 ) !incl. pt(D*)
         call hpak(-120,PD)
         call hpake(-120,PDErr)
         call hpak(-121,PD)
         do i=1,8
            PDTErr(i)=sqrt(PDErr(i)**2+PDsys(i)**2)
         enddo
         call hpake(-121,PDTErr)
         
         call hzhinrm(130, 0, lumcor , 1 ) !incl. eta(D*)
         call hpak(-130,ED)
         call hpake(-130,EDErr)
         call hpak(-131,ED)
         do i=1,6
            EDTErr(i)=sqrt(EDErr(i)**2+EDsys(i)**2)
         enddo
         call hpake(-131,EDTErr)
         
         call hzhinrm(140, 0, lumcor , 1 ) !incl. W_{\gamma p}
         call hpak(-140,WGaP)
         call hpake(-140,WGaPErr)
         call hpak(-141,WGaP)
         do i=1,4
            WGaPTErr(i)=sqrt(WGaPErr(i)**2+WGasys(i)**2)
         enddo
         call hpake(-141,WGaPTErr)
         
         call hzhinrm(150, 0, lumcor , 1 ) ! incl. z(D*)
         call hpak(-150,zDsData)
         call hpake(-150,zDsDaErr)
         call hpak(-151,zDsData)
         do i=1,6
            zDsDaTErr(i)=sqrt(zDsDaErr(i)**2+zDsDasys(i)**2)
         enddo
         call hpake(-151,zDsDaTErr)	   

         call hzhinrm(160, 0, lumcor , 1 ) ! incl. eta(D*) for pt bin 1
         call hpak(-160,etapt1Data)
         call hpake(-160,etapt1DaErr)
         call hpak(-161,etapt1Data)
         do i=1,3
            etapt1DaTErr(i)=sqrt(etapt1DaErr(i)**2+etapt1Dasys(i)**2)
         enddo
         call hpake(-161,etapt1DaTErr)

         call hzhinrm(170, 0, lumcor , 1 ) ! incl. eta(D*) for pt bin 2
         call hpak(-170,etapt2Data)
         call hpake(-170,etapt2DaErr)
         call hpak(-171,etapt2Data)
         do i=1,3
            etapt2DaTErr(i)=sqrt(etapt2DaErr(i)**2+etapt2Dasys(i)**2)
         enddo
         call hpake(-171,etapt2DaTErr)

         call hzhinrm(180, 0, lumcor , 1 ) ! incl. eta(D*) for pt bin 3
         call hpak(-180,etapt3Data)
         call hpake(-180,etapt3DaErr)
         call hpak(-181,etapt3Data)
         do i=1,3
            etapt3DaTErr(i)=sqrt(etapt3DaErr(i)**2+etapt3Dasys(i)**2)
         enddo
         call hpake(-181,etapt3DaTErr)

         call hopera(221,'+E',221,221,1./lumnb,0.)
         call hopera(222,'+E',222,222,1./lumnb,0.)
         
         call hzhinrm(223, 0, lumcor , 1 ) ! D*+jet: pt(D*)
         call hpak(-223,PDe)
         call hpake(-223,PDeErr)
         call hpak(-224,PDe)
         do i=1,4
            PDeTErr(i)=sqrt(PDeErr(i)**2+PDesys(i)**2)
         enddo
         call hpake(-224,PDeTErr)
         
         call hzhinrm(232, 0, lumcor , 1 ) ! D*+jet: eta(D*) 
         call hpak(-232,EDe)
         call hpake(-232,EDeErr)
         call hpak(-233,EDe)
         do i=1,5
            EDeTErr(i)=sqrt(EDeErr(i)**2+EDesys(i)**2)
         enddo
         call hpake(-233,EDeTErr)	   
         
         call hzhinrm(320, 0, lumcor , 1 )
         call hzhinrm(325, 0, lumcor , 1 ) ! D*+jet: eta(D*) - eta(jet)
         call hpak(-325,DetaData)
         call hpake(-325,DetaDaErr)
         call hpak(-326,DetaData)
         do i=1,6
            DetaDaTErr(i)=sqrt(DetaDaErr(i)**2+DetaDasys(i)**2)
         enddo
         call hpake(-326,DetaDaTErr)	   
         
         call hzhinrm(423, 0, lumcor , 1 ) ! D*+jet: pt(et)
         call hpak(-423,PtJ)
         call hpake(-423,PtJErr)
         call hpak(-424,PtJ)
         do i=1,4
            PtJTErr(i)=sqrt(PtJErr(i)**2+PtJsys(i)**2)
         enddo
         call hpake(-424,PtJTErr)	   
         
         call hzhinrm(432, 0, lumcor , 1 ) ! D*+jet: eta(jet)
         call hpak(-432,EtaJData)
         call hpake(-432,EtaJDaErr)
         call hpak(-433,EtaJData)
         do i=1,5
            EtaJDaTErr(i)=sqrt(EtaJDaErr(i)**2+EtaJDasys(i)**2)
         enddo
         call hpake(-433,EtaJDaTErr)	   
         
         call hzhinrm(450, 0, lumcor , 1 ) ! D*+jet: delta phi
         call hpak(-450,DphiData)
         call hpake(-450,DphiDaErr)
         call hpak(-451,DphiData)
         do i=1,6
            DphiDaTErr(i)=sqrt(DphiDaErr(i)**2+DphiDasys(i)**2)
         enddo
         call hpake(-451,DphiDaTErr)	   
         
         call hzhinrm(500, 0, lumcor , 1 ) ! D*+jet: xgamma(di-jet)
         call hpak(-500,XGa)
         call hpake(-500,XGaErr)
         call hpak(-501,XGa)
         do i=1,4
            XGaTErr(i)=sqrt(XGaErr(i)**2+XGasys(i)**2)
         enddo
         call hpake(-501,XGaTErr)
         
	    
         call hzhinrm(505, 0, lumcor , 1 ) ! 
         call hzhinrm(510, 0, lumcor , 1 ) ! 
         call hzhinrm(515, 0, lumcor , 1 ) ! 
         call hzhinrm(520, 0, lumcor , 1 ) ! 
         call hzhinrm(525, 0, lumcor , 1 ) ! 
         call hzhinrm(530, 0, lumcor , 1 ) ! 
         call hzhinrm(535, 0, lumcor , 1 ) ! 
         call hzhinrm(540, 0, lumcor , 1 ) ! 
*     * Normalization - End	
         
      endif
*
      RETURN
      END
