	subroutine HZh0701023(IFLAG) ! based on paper 06-240

* Production of D*+- Mesons with Dijets in Deep-Inelastic Scattering at HERA.
* By H1 Collaboration (A. Aktas et al.). DESY-06-240, Dec 2006. 31pp.
* Published in Eur.Phys.J.C51:271-287,2007.
* e-Print: hep-ex/0701023
* Author: Axel Cholewa
      IMPLICIT NONE
#include "hzfunc.inc"
#include "hzhbook.inc"
#include "hepevtp.inc"
#include "heracmn.inc"
#include "hzjetcmn.inc"
*
*
      Integer Nentry
      Integer Iflag,ierr
      Real nall,Nevt
      Character*8 xxxx
*
      Real lumnb,lumpb
      Integer iel,idum,ibeam,igam
      Double Precision pi,rd
      Parameter (pi=3.141592653589793238d0,rd=180.d0/pi)
      Real x,y,q2,enel,thel
*
      save xxxx,nall
      Data xxxx/'h0701023'/,NENTRY/0/
*
      real sigm,wt
      common/cwnco1/x,y,Q2,sigm  ! makes available without passing
*
*********************************************************************
*                      Additional Declarations
*********************************************************************
*
      integer i,j,idhe,ihep,ktalgo,jetcount,ddjflag
      integer dsjetind,ojetind,jet1ind,jet2ind
      double precision pbeam(4),pgam(4),ph(5)
      double precision jet1(4),jet2(4),jettemp(4),pxpbrt(3)
      double precision djet(4),ojet(4),djetbrt(4),ojetbrt(4)
      double precision jettempbrt(4),pbeambrt(4),sinbrt,jettempeta
      double precision gpvec(4),gpbeta(3),dvec(4),dvecgp(4),pxpgp(3)
      double precision pbeamgp(4),ptgp
      double precision EtJettempBrt,etjet1max,etjet2max
      double precision ptcheck,eta,pt,coner,mjj,w2,z
      real qmax,qmin,ymax,ymin,ptmax,ptmin,etadmax,etajmax,etajmin
      real etj1min,etj2min,w      
*      
*********************************************************************
*                      Data Arrays
*********************************************************************
*
      real h1q2bins(6),h1q2data(5)
      real h1xbins(6),h1xdata(5)
      real h1ptbins(6),h1ptdata(5)
      real h1wbins(6),h1wdata(5)
      real h1etabins(7),h1etadata(6)
      real h1zbins(8),h1zdata(7)
*
      real h2q2bins(6),h2q2data(5)
      real h2xbins(6),h2xdata(5)
      real h2ptbins(6),h2ptdata(5)
      real h2etabins(7),h2etadata(6)
*
      real h3q2bins(6),h3q2data(5)
      real h3xbins(5),h3xdata(4)
      real h3ptbins(6)
      real h3etbins(4),h3etdata(3)
      real h3mjjbins(5),h3mjjdata(4)
      real h3etabins(6),h3etadjdata(5),h3etaojdata(5)
*
      real h1q2staterr(5),h1q2syserr(10),h1q2errtot(5)
      real h1xstaterr(5),h1xsyserr(10),h1xerrtot(5)
      real h1ptstaterr(5),h1ptsyserr(10),h1pterrtot(5)
      real h1wstaterr(5),h1wsyserr(10),h1werrtot(5)
      real h1etastaterr(6),h1etasyserr(12),h1etaerrtot(6)
      real h1zstaterr(7),h1zsyserr(14),h1zerrtot(7)
*
      real h2q2staterr(5),h2q2syserr(10),h2q2errtot(5)
      real h2xstaterr(5),h2xsyserr(10),h2xerrtot(5)
      real h2ptstaterr(5),h2ptsyserr(10),h2pterrtot(5)
      real h2etastaterr(6),h2etasyserr(12),h2etaerrtot(6)
*
      real h3q2staterr(5),h3q2syserr(10),h3q2errtot(5)
      real h3xstaterr(4),h3xsyserr(8),h3xerrtot(4)
      real h3etstaterr(3),h3etsyserr(6),h3eterrtot(3)
      real h3mjjstaterr(4),h3mjjsyserr(8),h3mjjerrtot(4)
      real h3etadjstaterr(5),h3etadjsyserr(10),h3etadjerrtot(5)
      real h3etaojstaterr(5),h3etaojsyserr(10),h3etaojerrtot(5)
*
* bins...
*
      data h1q2bins/ 2, 4.22, 10, 17.8, 31.7, 100 /
      data h1xbins/ 0.000028, 0.0002, 0.0005, 0.0013, 0.0032, 0.02 /
      data h1wbins/ 70, 110, 150, 190, 230, 270 /
      data h1ptbins/ 1.5, 2, 2.5, 3.5, 5, 10 /
      data h1etabins/ -1.5, -1, -0.5, 0, 0.5, 1, 1.5 /
      data h1zbins/ 0, 0.1, 0.2, 0.3, 0.4, 0.5, 0.7, 1 /
*
      data h2q2bins/ 2, 4.22, 10, 17.8, 31.7, 100 /
      data h2xbins/ 0.000028, 0.0002, 0.0005, 0.0013, 0.0032, 0.02 /
      data h2ptbins/ 1.5, 2, 2.5, 3.5, 5, 10 /
      data h2etabins/ -1.5, -1, -0.5, 0, 0.5, 1, 1.5 /
*
      data h3q2bins/ 2, 4.22, 10, 17.8, 31.7, 100 /
      data h3xbins/ 0.000028, 0.0002, 0.0005, 0.0013, 0.02 /
      data h3ptbins/ 1.5, 2, 2.5, 3.5, 5, 10 /
      data h3etbins/ 4, 6.5, 10, 20 /
      data h3mjjbins/ 0, 11, 17, 25, 50 /
      data h3etabins/ -2, 0.9, 1.5, 2, 3, 5 /
*
* experimental data...
*
      data h1q2data/ 0.92, 0.358, 0.142, 0.065, 0.0124 /
      data h1xdata/ 11940, 6311, 2176, 498, 18.4 /
      data h1wdata/ 0.043, 0.048, 0.041, 0.0291, 0.0153 /
      data h1ptdata/ 3.3, 3.16, 1.92, 0.79, 0.104 /
      data h1etadata/ 2.15, 2.43, 2.48, 2.56, 2.49, 1.86 /
      data h1zdata/ 5.9, 12.2, 11.9, 9.4, 11.1, 8.0, 1.35 /
*      
      data h2q2data/ 0.54, 0.181, 0.069, 0.031, 0.0058 /
      data h2xdata/ 7916, 3340, 974, 205, 7.1 /
      data h2ptdata/ 0.64, 1.47, 1.20, 0.65, 0.093 /
      data h2etadata/ 0.92, 1.18, 1.27, 1.40, 1.42, 1.03 /
*
      data h3q2data/ 0.197, 0.059, 0.028, 0.0154, 0.0033 /
      data h3xdata/ 2688, 1255, 438, 13.0 /
      data h3etdata/ 0.32, 0.138, 0.018 /
      data h3mjjdata/ 0.058, 0.089, 0.026, 0.0023 /
      data h3etadjdata/ 0.066, 0.66, 0.62, 0.45, 0.058 /
      data h3etaojdata/ 0.048, 0.43, 0.65, 0.48, 0.117 /
*
* statistical errors...
*
      data h1q2staterr/ 0.05, 0.017, 0.009, 0.004, 0.0009 /
      data h1xstaterr/ 587, 311, 106, 33, 2.3 /
      data h1wstaterr/ 0.002, 0.002, 0.002, 0.0018, 0.0015 /
      data h1ptstaterr/ 0.3, 0.20, 0.08, 0.04, 0.007 /
      data h1etastaterr/ 0.14, 0.13, 0.14, 0.15, 0.15, 0.16 /
      data h1zstaterr/ 0.8, 0.8, 0.7, 0.6, 0.6, 0.4, 0.11 /
*
      data h2q2staterr/ 0.03, 0.010, 0.005, 0.003, 0.0005 /
      data h2xstaterr/ 407, 186, 60, 18, 1.1 /
      data h2ptstaterr/ 0.11, 0.12, 0.06, 0.03, 0.007 /
      data h2etastaterr/ 0.08, 0.08, 0.09, 0.09, 0.09, 0.10 /
*
      data h3q2staterr/ 0.021, 0.007, 0.004, 0.0022, 0.0005 /
      data h3xstaterr/ 288, 140, 49, 1.9 /
      data h3etstaterr/ 0.02, 0.014, 0.004 /
      data h3mjjstaterr/ 0.005, 0.008, 0.005, 0.0012 /
      data h3etadjstaterr/ 0.010, 0.06, 0.07, 0.05, 0.014 /
      data h3etaojstaterr/ 0.010, 0.06, 0.08, 0.05, 0.019 /
*
* systematic errors...
*
      data h1q2syserr/ 0.07, 0.026, 0.012, 0.005, 0.0014,
     +		       0.08, 0.029, 0.012, 0.006, 0.0011 /
      data h1xsyserr/ 1079, 466, 170, 36, 1.6,
     + 		      1142, 491, 167, 54, 2.4 /
      data h1wsyserr/ 0.004, 0.004, 0.003, 0.0033, 0.0024,
     +		      0.006, 0.004, 0.004, 0.0023, 0.0028 /
      data h1ptsyserr/ 0.5, 0.23, 0.13, 0.06, 0.010,
     +		       0.3, 0.31, 0.17, 0.07, 0.009 /
      data h1etasyserr/ 0.20, 0.17, 0.17, 0.21, 0.28, 0.18,
     +		        0.21, 0.20, 0.19, 0.26, 0.23, 0.23 /
      data h1zsyserr/ 1.2, 1.4, 1.4, 0.9, 0.8, 0.8, 0.41,
     +		      0.8, 1.3, 1.3, 1.0, 1.0, 1.5, 0.52 /
*
      data h2q2syserr/ 0.04, 0.021, 0.005, 0.003, 0.0010,
     +		       0.05, 0.019, 0.008, 0.004, 0.0009 /
      data h2xsyserr/ 606, 250, 107, 26, 0.5,
     +		      791, 316, 104, 43, 1.9 /
      data h2ptsyserr/ 0.21, 0.11, 0.09, 0.05, 0.009,
     +		       0.05, 0.18, 0.14, 0.07, 0.009 /
      data h2etasyserr/ 0.06, 0.08, 0.09, 0.11, 0.21, 0.10,
     +		        0.13, 0.11, 0.14, 0.16, 0.21, 0.15 /
*
      data h3q2syserr/ 0.027, 0.012, 0.004, 0.0014, 0.0008,
     +                 0.016, 0.008, 0.004, 0.0029, 0.0008 /
      data h3xsyserr/ 345, 112, 61, 1.5, 
     +               253, 114, 71, 2.7 /
      data h3etsyserr/ 0.02, 0.035, 0.010, 
     +                 0.03, 0.013, 0.005 /
      data h3mjjsyserr/ 0.005, 0.019, 0.002, 0.0018, 
     +                  0.004, 0.011, 0.004, 0.0008 /
      data h3etadjsyserr/ 0.007, 0.11, 0.07, 0.11, 0.018, 
     +                    0.007, 0.07, 0.10, 0.07, 0.015 /
      data h3etaojsyserr/ 0.009, 0.04, 0.09, 0.13, 0.010, 
     +                    0.005, 0.06, 0.07, 0.05, 0.021 /
*
*********************************************************************
*
      IF (iflag.eq.1) then
*
         nentry=0
	 nevt=0
*
         write(6,*)' HZana for 06-240: preliminary version'
*
*
*      Initialisation: The following MUST always be done
*      (i) make subdirectory in PAWC
*       - use the name as the xxxxxx in HZxxxxxx subroutine
*      (i) make subdirectory in o/p file
*
	call hcdir('//PAWC',' ')
	call hmdir(xxxx,'S')
	call hcdir('//HISTO',' ')
	call hmdir(xxxx,'S')
*
* fill total error array with quadrature-summed statistical and averaged +- systematic errors
*                - Doing this because I don't know how to make asymmetric errors in the hbook. Could be done later in Root.
*
      do i=1,5
        h1q2errtot(i)=(h1q2staterr(i)**2+
     +           ((h1q2syserr(i)+h1q2syserr(i+5))*0.5)**2)**0.5
      enddo
      do i=1,5
        h1xerrtot(i)=(h1xstaterr(i)**2+
     +           ((h1xsyserr(i)+h1xsyserr(i+5))*0.5)**2)**0.5
      enddo
      do i=1,5
        h1werrtot(i)=(h1wstaterr(i)**2+
     +           ((h1wsyserr(i)+h1wsyserr(i+5))*0.5)**2)**0.5
      enddo
      do i=1,5
        h1pterrtot(i)=(h1ptstaterr(i)**2+
     +           ((h1ptsyserr(i)+h1ptsyserr(i+5))*0.5)**2)**0.5
      enddo
      do i=1,6
        h1etaerrtot(i)=(h1etastaterr(i)**2+
     +           ((h1etasyserr(i)+h1etasyserr(i+6))*0.5)**2)**0.5
      enddo
      do i=1,7
        h1zerrtot(i)=(h1zstaterr(i)**2+
     +           ((h1zsyserr(i)+h1zsyserr(i+7))*0.5)**2)**0.5
      enddo
*
      do i=1,5
        h2q2errtot(i)=(h2q2staterr(i)**2+
     +           ((h2q2syserr(i)+h2q2syserr(i+5))*0.5)**2)**0.5
      enddo
      do i=1,5
        h2xerrtot(i)=(h2xstaterr(i)**2+
     +           ((h2xsyserr(i)+h2xsyserr(i+5))*0.5)**2)**0.5
      enddo
      do i=1,5
        h2pterrtot(i)=(h2ptstaterr(i)**2+
     +           ((h2ptsyserr(i)+h2ptsyserr(i+5))*0.5)**2)**0.5
      enddo
      do i=1,6
        h2etaerrtot(i)=(h2etastaterr(i)**2+
     +           ((h2etasyserr(i)+h2etasyserr(i+6))*0.5)**2)**0.5
      enddo
*
      do i=1,5
        h3q2errtot(i)=(h3q2staterr(i)**2+
     +           ((h3q2syserr(i)+h3q2syserr(i+5))*0.5)**2)**0.5
      enddo
      do i=1,4
        h3xerrtot(i)=(h3xstaterr(i)**2+
     +           ((h3xsyserr(i)+h3xsyserr(i+4))*0.5)**2)**0.5
      enddo
      do i=1,3
        h3eterrtot(i)=(h3etstaterr(i)**2+
     +           ((h3etsyserr(i)+h3etsyserr(i+3))*0.5)**2)**0.5
      enddo
      do i=1,4
        h3mjjerrtot(i)=(h3mjjstaterr(i)**2+
     +           ((h3mjjsyserr(i)+h3mjjsyserr(i+4))*0.5)**2)**0.5
      enddo
      do i=1,5
        h3etadjerrtot(i)=(h3etadjstaterr(i)**2+
     +          ((h3etadjsyserr(i)+h3etadjsyserr(i+5))*0.5)**2)**0.5
      enddo
      do i=1,5
        h3etaojerrtot(i)=(h3etaojstaterr(i)**2+
     +          ((h3etaojsyserr(i)+h3etaojsyserr(i+5))*0.5)**2)**0.5
      enddo
*
*
* Call MC histograms
*
*
	call hbookb(101,'dsigma/dq2 06-240 MC',5,h1q2bins,0.)
	call hbookb(102,'dsigma/dx 06-240 MC',5,h1xbins,0.)
	call hbookb(103,'dsigma/dw 06-240 MC',5,h1wbins,0.)
	call hbookb(104,'dsigma/dpt 06-240 MC',5,h1ptbins,0.)
	call hbookb(105,'dsigma/deta 06-240 MC',6,h1etabins,0.)
	call hbookb(106,'dsigma/dz 06-240 MC',7,h1zbins,0.)
*
	call hbookb(201,'dsigma/dq2 06-240 MC (pt* > 2.0)'
     +		,5,h2q2bins,0.)
	call hbookb(202,'dsigma/dx 06-240 MC (pt* > 2.0)'
     +		,5,h2xbins,0.)
	call hbookb(203,'dsigma/dpt 06-240 MC (pt* > 2.0)'
     +		,5,h2ptbins,0.)
	call hbookb(204,'dsigma/deta 06-240 MC (pt* > 2.0)'
     +		,6,h2etabins,0.)
*
	call hbookb(301,'dsigma/dq2 06-240 MC (with dijets)'
     +		,5,h3q2bins,0.)
	call hbookb(302,'dsigma/dx 06-240 MC (with dijets)'
     +		,4,h3xbins,0.)
	call hbookb(303,'dsigma/dpt 06-240 MC (with dijets)'
     +		,5,h3ptbins,0.)
	call hbookb(304,'dsigma/dEt 06-240 MC (with dijets)'
     +		,3,h3etbins,0.)
	call hbookb(305,'dsigma/dMjj 06-240 MC (with dijets)'
     +		,4,h3mjjbins,0.)
	call hbookb(306,'dsigma/detaDJ 06-240 MC (with dijets)'
     +		,5,h3etabins,0.)
	call hbookb(307,'dsigma/detaOJ 06-240 MC (with dijets)'
     +		,5,h3etabins,0.)
*
* Call data histograms
*
	call hbookb(-101,'dsigma/dq2 06-240 data',5,h1q2bins,0.)
	call hbookb(-102,'dsigma/dx 06-240 data',5,h1xbins,0.)
	call hbookb(-103,'dsigma/dw 06-240 data',5,h1wbins,0.)
	call hbookb(-104,'dsigma/dpt 06-240 data',5,h1ptbins,0.)
	call hbookb(-105,'dsigma/deta 06-240 data',6,h1etabins,0.)
	call hbookb(-106,'dsigma/dz 06-240 data',7,h1zbins,0.)
*
	call hbookb(-201,'dsigma/dq2 06-240 data (pt* > 2.0)'
     +		,5,h2q2bins,0.)
	call hbookb(-202,'dsigma/dx 06-240 data (pt* > 2.0)'
     +		,5,h2xbins,0.)
	call hbookb(-203,'dsigma/dpt 06-240 data (pt* > 2.0)'
     +		,5,h2ptbins,0.)
	call hbookb(-204,'dsigma/deta 06-240 data (pt* > 2.0)'
     +		,6,h2etabins,0.)
*
	call hbookb(-301,'dsigma/dq2 06-240 data (with dijets)'
     +		,5,h3q2bins,0.)
	call hbookb(-302,'dsigma/dx 06-240 data (with dijets)'
     +		,4,h3xbins,0.)
*	call hbookb(-303,'dsigma/dpt 06-240 data (with dijets)'
*     +		,5,h3ptbins,0.)
	call hbookb(-304,'dsigma/dEt 06-240 data (with dijets)'
     +		,3,h3etbins,0.)
	call hbookb(-305,'dsigma/dMjj 06-240 data (with dijets)'
     +		,4,h3mjjbins,0.)
	call hbookb(-306,'dsigma/detaDJ 06-240 data (with dijets)'
     +		,5,h3etabins,0.)
	call hbookb(-307,'dsigma/detaOJ 06-240 data (with dijets)'
     +		,5,h3etabins,0.)
*
* Fill data histograms
*
	call hpak(-101,h1q2data)
	call hpak(-102,h1xdata)
	call hpak(-103,h1wdata)
	call hpak(-104,h1ptdata)
	call hpak(-105,h1etadata)
	call hpak(-106,h1zdata)
*
	call hpak(-201,h2q2data)
	call hpak(-202,h2xdata)
	call hpak(-203,h2ptdata)
	call hpak(-204,h2etadata)
*
	call hpak(-301,h3q2data)
	call hpak(-302,h3xdata)
*	call hpak(-303,h3ptdata)
	call hpak(-304,h3etdata)
	call hpak(-305,h3mjjdata)
	call hpak(-306,h3etadjdata)
	call hpak(-307,h3etaojdata)
*
* Add errors...
*
	call hpake(-101,h1q2errtot)
	call hpake(-102,h1xerrtot)
	call hpake(-103,h1werrtot)
	call hpake(-104,h1pterrtot)
	call hpake(-105,h1etaerrtot)
	call hpake(-106,h1zerrtot)
*
	call hpake(-201,h2q2errtot)
	call hpake(-202,h2xerrtot)
	call hpake(-203,h2pterrtot)
	call hpake(-204,h2etaerrtot)
*
	call hpake(-301,h3q2errtot)
	call hpake(-302,h3xerrtot)
*	call hpake(-303,h3pterrtot)
	call hpake(-304,h3eterrtot)
	call hpake(-305,h3mjjerrtot)
	call hpake(-306,h3etadjerrtot)
	call hpake(-307,h3etaojerrtot)
*
*********************************************************************
*                      Event Processing
*********************************************************************
*
      Else if(iflag.eq.2) then
*	
      wt=wtx
      NENTRY=NENTRY+1
*
* Filling: The following MUST always be done
* (i) move to the correct sub-directory in PAWC
         call hcdir('//PAWC/'//xxxx,' ')
*
         Nevt = Nevt + wtx
*
* get kinematics
*
         q2=real(HZDISKIN(1))
	 x=real(HZDISKIN(2))
         y =real(HZDISKIN(3))
	 w2 =(HZDISKIN(4))
		w=real(w2**0.5)
	 sigm = real(Xsec)
*
* error flag
*
         ierr=HZIBEAM(ibeam,idum)
*
* get proton beam
*
         if (.not.(ierr.eq.1)) then
            write(6,*) 'HZ'//xxxx,' beams not found ! '
	    return
         else
            Do i=1,4
               pbeam(i)=PHEP(i,IBEAM)
            enddo
         endif
*
* get electron
*
         iel=HZIDELEC(idum)
         if (iel.eq.-1) then
            write(*,*) 'Hz'//xxxx,' electron not found '
            return
         endif
*
* get photon
*
         ierr=HZIPGAM(ph)
         if (ierr.eq.-1) then
            write(6,*) 'HZ'//xxxx,' boson vector not found ! '
            return
         else
            do i=1,4
               pgam(i)=ph(i)
            enddo
         endif
*
*********************************************************************
*                      Cuts - scroll right for comments
*********************************************************************
*
	ddjflag=1							! flag of 1(reject) or 0(accept) checking for D* and dijets
	jetcount=0
	jet1ind=0
	jet2ind=0
*
	ktalgo=14							! kt-cluster used in paper 06-240, section 4 pg 9
	coner=1.0							! standard radius
*
	qmax=100.0							! kinematic cut values
	qmin=2.0
	ymax=0.7
	ymin=0.05
	ptmax=15.0							! mom' of D*
	ptmin=1.5
	etadmax=1.5							! pseudo rap of D*
	etajmax=2.5							! pseudo rap of jets
	etajmin=-1.0
	etj1min=4.0							! jet energies
	etj2min=3.0
*
	if (q2.ge.qmin .and. q2.le.qmax					! Q2 cuts
     +		.and. y.ge.ymin .and. y.le.ymax				! y cuts
     +			)then
*
	  do ihep=1,nhep
	    idhe=idhep(ihep)
	    if (abs(idhe).eq.413) then
	      pt=hzpt(ihep)
	      eta=hzeta(ihep)
	      if (pt.ge.ptmin .and. pt.le.ptmax
     +	           .and. abs(eta).le.etadmax
     +	        	  ) then
     *
     		z=(phep(4,ihep)-phep(3,ihep))/(2*y*phep(4,idum))
*		
		call hfill(101,real(q2),0.,1.)
		call hfill(102,real(x),0.,1.)
		call hfill(103,real(w),0.,1.)
		call hfill(104,real(pt),0.,1.)
		call hfill(105,real(eta),0.,1.)
		call hfill(106,real(z),0.,1.)
*
		do j=1,4
		  gpvec(j)=phep(j,ibeam)+phep(j,idum)-phep(j,iel)
		  dvec(j)=phep(j,ihep)
		enddo
		do j=1,3
		  gpbeta(j)=-gpvec(j)/gpvec(4)
		enddo
*
		call hzboost(gpbeta(1),gpbeta(2),gpbeta(3)		! boosting for cuts on pt in proton-gamma rest frame
     +						,dvec,dvecgp)
		call hzboost(gpbeta(1),gpbeta(2),gpbeta(3)
     +						,pbeam,pbeamgp)
		call pxp(dvecgp,pbeamgp,pxpgp)
*
		ptgp=((pxpgp(1)**2+pxpgp(2)**2+pxpgp(3)**2)/
     +		   (pbeamgp(1)**2+pbeamgp(2)**2+pbeamgp(3)**2))**0.5
*
		if(ptgp.gt.2)then
		  call hfill(201,real(q2),0.,1.)
		  call hfill(202,real(x),0.,1.)
		  call hfill(203,real(pt),0.,1.)
		  call hfill(204,real(eta),0.,1.)
		endif
*
                ddjflag=0						! yes, found suitable D*
	      endif
	    endif
	  enddo
	endif
*
	if (ddjflag.eq.0) then
	  call hzjtfind(ktalgo,coner,jetcount,Jets)			! only want to look for dijets if certain everything else is satisfied
	endif
*
	if (jetcount.ge.2) then						! Begin boosting for Breit frame cuts on jets
*
	  etjet1max=0.0
	  etjet2max=0.0
*
	  do j=1,4
	    jet1(j)=0.0
            jet2(j)=0.0
	  enddo
*
	  call hzbrtini(pbeam,pgam,ierr)
	  if (ierr.eq.1) then
            write(6,*) 'HZ'//xxxx,' hzbrtini has issues !'
            return
          else
            call hzbrt(pbeam,pbeambrt,ierr)
	    if (ierr.eq.1) then
              write(6,*) 'HZ'//xxxx,' hzbrt on pbeam has issues !'
              return
            endif
	  endif
*
	  do i=1,jetcount						! Gets two jets ordered by Et in Breit frame
*
	    jettempeta=Jets(i,1)
	    if (jettempeta.ge.etajmin
     +           .and. jettempeta.le.etajmax
     +               ) then
	      do j=1,3
	        jettemp(j)=jets(i,(j+4))
	      enddo
    	      jettemp(4)=jets(i,4)
*
	      call hzbrt(jettemp,jettempbrt,ierr)
	      if (ierr.eq.1) then
                write(6,*) 'HZ'//xxxx,' hzbrt jettemp has issues !'
                return
              endif
*
	      call pxp(jettempbrt,pbeambrt,pxpbrt)
*
	      sinbrt=((pxpbrt(1)**2+pxpbrt(2)**2
     +			+pxpbrt(3)**2)**0.5)/
     +           ((jettempbrt(1)**2+jettempbrt(2)**2
     +			+jettempbrt(3)**2)**0.5)
     	      sinbrt=sinbrt/
     +           ((pbeambrt(1)**2+pbeambrt(2)**2
     +			+pbeambrt(3)**2)**0.5)
*
	      etjettempbrt=jettempbrt(4)*sinbrt
*
	      if (etjettempbrt.gt.etjet1max) then
	        etjet2max=etjet1max
		jet2ind=jet1ind
	        etjet1max=etjettempbrt
		jet1ind=i
		do j=1,4
		  jet2(j)=jet1(j)
		  jet1(j)=jettemp(j)
		enddo
	      else if (etjettempbrt.gt.etjet2max) then
	        etjet2max=etjettempbrt
		jet2ind=i
		do j=1,4
		  jet2(j)=jettemp(j)
		enddo
	      endif
	    endif
	  enddo
*
	  if (etjet1max.ge.etj1min .and.
     +	      etjet2max.ge.etj2min
     +			) then
*
	    do ihep=1,nhep
	      idhe=idhep(ihep)
	      if (abs(idhe).eq.413) then				! doing this again to select correct D* with dijets
	        pt=hzpt(ihep)
	        eta=hzeta(ihep)
	        if (pt.ge.ptmin .and. pt.le.ptmax .and.
     +		    abs(eta).le.etadmax
     +		         ) then
*
     		  dsjetind=ijetno(ihep)
*
		  if (dsjetind.eq.jet1ind) then				! The D* was in jet 1
*
		    do j=1,4
		      djet(j)=jet1(j)
		      ojet(j)=jet2(j)
		    enddo
		    ojetind=jet2ind
*
		  else							! The D* wasn't in the first leading jet - now have to find the D* jet
*
		    do j=1,3
		      djet(j)=jets(dsjetind,j+4)
		      ojet(j)=jet1(j)
		    enddo
		    djet(4)=jets(dsjetind,4)
		    ojet(4)=jet1(4)
		    ojetind=jet1ind
*
		  endif			  
*		  
		  mjj=0.0
		  do j=1,3
		    mjj=mjj+(djet(j)+ojet(j))**2
		  enddo
		  mjj=((djet(4)+ojet(4))**2-mjj)**0.5
*
		  call hfill(301,real(q2),0.,1.)
		  call hfill(302,real(x),0.,1.)
		  call hfill(303,real(pt),0.,1.)
		  call hfill(304,real(etjet1max),0.,1.)
		  call hfill(305,real(mjj),0.,1.)
*
	        endif
	      endif
	    enddo ! end of D* cuts
	  endif
	endif ! end of jet cuts
*
      Else if(iflag.eq.3) then
* Termination: The following MUST always be done
* (i) Move to the correct PAW subdirectory
*
         call hcdir('//PAWC/'//xxxx,' ')
*
         lumnb=999999.
         lumpb=999999.
         if (xsec.ne.0.) then
            lumnb=1000.*real(Nevt)/real(xsec)
            lumpb=real(Nevt)/real(xsec)
            print *,'Number of events procesed:',Nevt
            print *,'Total cross section:',xsec
            print *,'Equivalent luminosity [nb] :',lumnb
*
*      histogram normalisation
*
            call hzhinrm(101,0,lumnb,1)
            call hzhinrm(102,0,lumnb,1)
            call hzhinrm(103,0,lumnb,1)
            call hzhinrm(104,0,lumnb,1)
            call hzhinrm(105,0,lumnb,1)
            call hzhinrm(106,0,lumnb,1)
*
            call hzhinrm(201,0,lumnb,1)
            call hzhinrm(202,0,lumnb,1)
            call hzhinrm(203,0,lumnb,1)
            call hzhinrm(204,0,lumnb,1)
*
            call hzhinrm(301,0,lumnb,1)
            call hzhinrm(302,0,lumnb,1)
            call hzhinrm(303,0,lumnb,1)
            call hzhinrm(304,0,lumnb,1)
            call hzhinrm(305,0,lumnb,1)
            call hzhinrm(306,0,lumnb,1)
            call hzhinrm(307,0,lumnb,1)
*
	 else
            write(6,*) 'hz',xxxx,' xsec=0 ! '
         endif
      endif
*
      RETURN
      END
*
      SUBROUTINE PXP ( A, B, AXB )
*
*  Given:
*     A        d(4)      first p-vector
*     B        d(4)      second p-vector
*
*  Returned:
*     AXB      d(3)      A x B
*
      IMPLICIT NONE
      double precision A(4), B(4), AXB(3)
      double precision XA, YA, ZA, XB, YB, ZB
*      
      XA = A(1)
      YA = A(2)
      ZA = A(3)
      XB = B(1)
      YB = B(2)
      ZB = B(3)
      AXB(1) = YA*ZB - ZA*YB
      AXB(2) = ZA*XB - XA*ZB
      AXB(3) = XA*YB - YA*XB
*
      return
      end
