      Subroutine Hzfilhep
************************************************************************
* Purpose:
* Transfer data to HERACMN and HEPEVTP
* Input: none
* Output: none
* Author: N. Brook
* Modified :
* J. Butterworth (for HERWIG61) 3/5/00
* J. Butterworth (for 'HO1') 23/4/00
* M. Hayes (for 'PHO')
* N. Pavel introduce POMPYT 8.5.96
* H. Jung (RAPGAP with PYTHIA6)
* A. Solano (interface RIDI - 15.12.98)
* G. Grindhammer (allow for HERWIG+PYTHIA/JETSET -> PYTHRW and for
*                 QCDINS+HERWIG+PYTHIA/JETSET -> PYTINS, 10.06.1999)
************************************************************************
#include "hepevtp.inc"
#include "heracmn.inc"

      COMMON /LEPTOU/ CUT(14),LST(40),PARL(30),X,Y,W2,Q2,U
C     Common/Pyint5/Ngen(0:200,3),Xxsec(0:200,3)
      Integer NGENPD, Ngen
      double precision Xxsec
      Common/Pyint5/NGENPD,Ngen(0:500,3),Xxsec(0:500,3)
 
      COMMON/POMSIG/NEVT,SIGTOT
*
      COMMON /RESULT/ S1,S2,S3,S4
      logical lp
      Data lp/.false./
* RAPGAP COMMON for xsec
      DOUBLE PRECISION AVGI,SD
      COMMON/EFFIC/AVGI,SD,NING,NOUTG
* RIDI commons
      logical duejet,trejet,fragm,wei,two,longit,transv,user
      logical lightf,thlim,charm,strange,checkout,onlych
      COMMON/LOGICA/duejet,trejet,fragm,wei,two,longit,transv,user,
     +              lightf,thlim,charm,strange,checkout,onlych
      Integer nevent2,itoteve2,itwoev2,iwei2,nmass
      Real fk_2,weimax2,
     +            sig2t,sig2l,weit2,weil2,twint2,twinte2,
     +            cs2,cst2,csl2,tcs2,tcse2,
     +            tcst2,tcste2,tcsl2,tcsle2,
     +            tcsb2,tcsbe2,tcsi2,tcsie2,tcsa2,tcsae2,tcsf2,tcsfe2
      COMMON/WEI2/nevent2,itoteve2,itwoev2,iwei2,nmass,fk_2,weimax2,
     +            sig2t,sig2l,weit2,weil2,twint2(7),twinte2(7),
     +            cs2(2),cst2(2),csl2(2),tcs2(2),tcse2(2),
     +            tcst2(2),tcste2(2),tcsl2(2),tcsle2(2),
     +            tcsb2,tcsbe2,tcsi2,tcsie2,tcsa2,tcsae2,tcsf2,tcsfe2
      Integer nevent3,ITOTEVE3,itwoev3,IWEI3,nskip
      Real fk_3,weimax3,
     +            weit3,weil3,TWINT3,TWINTE3,
     +            cs3,cst3,csl3,tcs3,tcse3,
     +            tcst3,tcste3,tcsl3,tcsle3,
     +            tcsb3,tcsbe3,tcsi3,tcsie3,tcsa3,tcsae3,tcsf3,tcsfe3
      COMMON/WEI3/nevent3,ITOTEVE3,itwoev3,IWEI3,nskip,fk_3,weimax3,
     +            weit3,weil3,TWINT3(7),TWINTE3(7),
     +            cs3(2),cst3(2),csl3(2),tcs3(2),tcse3(2),
     +            tcst3(2),tcste3(2),tcsl3(2),tcsle3(2),
     +            tcsb3,tcsbe3,tcsi3,tcsie3,tcsa3,tcsae3,tcsf3,tcsfe3
      logical radcor,radcor_i,radcor_f,radcor_a
      common/radlog/radcor,radcor_i,radcor_f,radcor_a
*
* include LUJETS common
      COMMON/LUJETS/N,K(4000,5),P(4000,5),V(4000,5)
* include pythia6 pyjets common
      double precision PP,VP
      COMMON/PYJETS/NP,NPAD,KP(4000,5),PP(4000,5),VP(4000,5)
      Data Ncnt /0/
*
      Ncnt = Ncnt + 1
      Ntot = Ncnt
*
      if (lp) then
       write(6,*) ' ncnt= ',ncnt,' gen= ',gen
      endif
*
      if(gen(1:3).eq.'PYT'.or.gen(1:3).eq.'LEP'.or.gen(1:3).eq.'ARI'
     & .or.gen(1:3).eq.'LEG'.or.gen(1:3).eq.'RAP'.or.gen(1:3).eq.'CAS'
     &.or.gen(1:3).eq.'RID'.or.gen(1:3).eq.'POM'
     & ) Then
c
        if(gen(1:3).eq.'RID') then
          if(radcor) then
c
c   Born cross section: run without radiative corrections
c
	    write(6,*) ' Please run RIDI without QED rad. correction '
            write(6,*) ' Program stopped '
	    STOP
          elseif(wei) then
c
c   Run without weights to avoid errors in using them
c
            write(6,*) ' Please run RIDI without weights '
            write(6,*) ' Program stopped '
            STOP
          endif
c
c   Get virtual photon four-vector
c
	  DO J = 1,4
            P(N+1,J) = P(1,J)-P(3,J)
	  ENDDO
          P(N+1,5) =
     &      P(N+1,4)**2-P(N+1,1)**2-P(N+1,2)**2-P(N+1,3)**2
	  P(N+1,5) = -SQRT(ABS(P(N+1,5)))
	  K(N+1,1) = 21
	  K(N+1,2) = 22
	  K(N+1,3) = 1
	  N = N+1
        endif
c
c       write(6,*) ' check on LUJETS or PYJETS common '
        IF(N.GT.0) THEN
c         write(6,*) '  LUJETS common found '
          Call HzLuhepc(1)
          Call HzLuncop
	ELSEIF(NP.GT.0) THEN
c         write(6,*) '  PYJETS common found'
	  Call Hzpyhepc(1)
	ELSE
	  write(6,*) ' cannot determine LUJETS or PYJETS common '
	ENDIF
        If(gen(1:3).eq.'PYT' .and.
     &     gen(1:6).ne.'PYTHRW' .and. gen(1:6).ne.'PYTINS') Then
C         xsec = dble(Xxsec(0,3))
          xsec = Xxsec(0,3)*1d9
        Else if (gen(1:6).eq.'PYTHRW') Then
          xsec = avwgt
          call HZPYTCOP
        Else if (gen(1:6).eq.'PYTINS') Then
          xsec = avwgt
          call HZPYTCOP
        Else if (gen(1:3).eq.'LEG') Then
          xsec = dble(s1)
        Elseif(gen(1:3).eq.'RAP'.or.gen(1:3).eq.'CAS') Then
          xsec = AVGI*1000.
        else
          xsec = dble(parl(24))
        Endif
        if (lp) write(6,*) ' xsec= ',xsec
*
      ELSE IF((GEN(1:3).EQ.'DJA')) THEN
         CALL HZDJHEPC(1)
         if (lp) write(6,*) ' ...calling hzluncop '
         CALL HZLUNCOP
         XSEC = DBLE(PARL(24))
        if (lp) write(6,*) ' xsec= ',xsec
*
      else if(gen(1:3).eq.'HRW') Then
        Call Hzhrwcop
c     xsec = avwgt 
c     Please note, the cross section is not filled here. That is left to
c     the user since that avoids having dangerous copies of common
c     blocks in here. JMB 3/5/2000
c     
      else if(gen(1:3).eq.'SHA') Then
        Call Hzshcop
      else if(gen(1:3).eq.'PHO') Then
        Call Hzphocop
C     please note the cross section is not filled here. This is left to
C     the user, due to the design of PHOJET.  NPA 8.5.96
      else if(gen(1:3).eq.'POM') Then
        call hzgamad
c        write(6,*) ' check on LUJETS or PYJETS common '
        IF(N.GT.0) THEN
c        write(6,*) '  LUJETS common found '
        Call HzLuhepc(1)
        Call HzLuncop
	  ELSEIF(NP.GT.0) THEN
c        write(6,*) '  PYJETS common found'
	  Call Hzpyhepc(1)
	  ELSE
	  write(6,*) ' cannot determine LUJETS or PYJETS common '
	  ENDIF
c from mb --> pb	
        xsec = sigtot*1.e9
        call hzdifkin
* --> end NPA 8.5.96
      else if(gen(1:3).eq.'INS') Then
        Call Hzhrwcop
        xsec = avwgt
      else if(gen(1:3).eq.'HO1') Then
        Call Hzho1cop
        xsec = 1.0
      Else
         Write(6,*) ' HZFILHEP: UNKNOWN GENERATOR'
      Endif
*
      wtx=1.
*
      Return
      End
