*CMZ :  2.00/02 08/10/99  12.32.15  by  Tancredi Carli
*CMZ :  1.01/11 31/12/97  14.45.54  by  Tancredi Carli
*CMZ :  1.01/07 02/10/97  17.09.02  by  Tancredi Carli
*-- Author :
	Subroutine HZHEPTOP
*****************************************************************************
*
* This routine replaces the HEP-Common with the partons within(also
* including beams,scattered lepton and docu-Z0).
*
* For HERWIG some other particles are also included because of the different
* event history, but they are irrelevant for further processing.
*
* The purpose is to calculate quantities on the partonic level.
* To avoid difficulties in the use within other routines (which usually
* access the stable hadrons in the HEP-Common) the status of the partons
* is switched from 2(unstable/decayed) to 1(undecayed).
*
* The used partonlist is produced by Hzparton(npart,plist), which can be
* tested with hzpscon(iflag) on conservation of transversal momentum and
* s.
*
*  written by: Reimer Selle (rselle@rec06.desy.de)
*****************************************************************************
*
*
	IMPLICIT NONE
*
#include "hepevtp.inc"
#include "hzfunc.inc"
*
 
*                                          subroutine-related var.
*                                          -----------------------
      Integer plist(nmxhep)
      Integer ihep,i,j,k,l,npart,lastp
      Integer iel,idum
*                                          test-variable
      Logical lp,part
      Data lp/.false./
      Logical first
      Data first/.true./
 
*********************************************************************
*
       if (first) then
        first=.false.
        write(6,*) '**hzheptop: run on partons only ! '
       endif
*
       lastp=0
*                                      get partonlist
       call hzparton(npart,plist)
       if (lp) write(*,*)'HEPP npart:',npart
*                                      find last parton in hep-common
       do i=1,npart
        if (plist(i).gt.lastp) then
         lastp=plist(i)
        endif
       enddo
 
       if (lp) write(*,*)'last parton:',lastp
       if (lp) then
        do i=1,npart
         write(*,*)'plist:',plist(i)
        enddo
       endif
 
       NEVHEP=0
*                                      erase informations after partons
       do 1000 ihep=lastp+1,nhep
        ISTHEP(ihep)=0
        IDHEP(ihep)=0
        JMOHEP(1,ihep)=0
        JMOHEP(2,ihep)=0
        JDAHEP(1,ihep)=0
        JDAHEP(2,ihep)=0
 
        do j=1,5
         PHEP(j,ihep)=0.
        enddo
        do k=1,4
         VHEP(k,ihep)=0.
        enddo
 1000	continue
 
*                                      find scattered electron
       iel=HZIDELEC(idum)
 
*                                      find remaining non-partons and
*                                      erase them!
        do 2000 ihep=iel+1,lastp
         part=.false.
         do j=1,npart
          if (ihep.eq.plist(j)) then
           part=.true.
           goto 2000
          endif
         enddo
 
         if (.not.part) then
 
          ISTHEP(ihep)=0
          IDHEP(ihep)=0
          JMOHEP(1,ihep)=0
          JMOHEP(2,ihep)=0
          JDAHEP(1,ihep)=0
          JDAHEP(2,ihep)=0
*
          do j=1,5
           PHEP(j,ihep)=0.
          enddo
          do k=1,4
           VHEP(k,ihep)=0.
          enddo
         endif
 2000	continue
*                                compress COMMON
 
        nhep=lastp
 
3000    continue
 
        do i=iel+1,lastp
         if (IDHEP(i).eq.0) then
          nhep=nhep-1
          do k=i,lastp-1
           ISTHEP(k)=ISTHEP(k+1)
           IDHEP(k)=IDHEP(k+1)
           JMOHEP(1,k)=JMOHEP(1,k+1)
           JMOHEP(2,k)=JMOHEP(2,k+1)
           JDAHEP(1,k)=JDAHEP(1,k+1)
           JDAHEP(2,k)=JDAHEP(2,k+1)
           do j=1,5
            PHEP(j,k)=PHEP(j,k+1)
           enddo
           do j=1,4
            VHEP(j,k)=VHEP(j,k+1)
           enddo
          enddo
         endif
        enddo
*
        do i=iel+1,nhep
         if (IDHEP(i).eq.0) goto 3000
        enddo
*
*                                 stabilize partons
*                                 the partons should be the only decayed
*                                 particles left in the Common!
        do k=1,nhep
         if (ISTHEP(k).eq.2) then
          ISTHEP(k)=1
         endif
        enddo
 
        if (lp) write(*,*)'final nhep:',nhep
       END
