*CMZ :  2.00/04 31/07/2000  21.11.45  by  Tancredi Carli
*CMZ :  1.01/02 12/05/92  10.27.55  by  M. Erdmann
*CMZ :  0.05/00 16/12/91  20.44.48  by  M. Erdmann
*-- Author :    C. Jacobsson   24/07/91
      SUBROUTINE QEMIN2 (JETMUL,INDEC,DMMT,FTOPO,MREV,NEW,IFLAG)
**********************************************************************
*    PURPOSE
*     SEARCH FOR A BETTER MINIMUM THAN A PREVIOS ONE
*       by climbing up along the shallowest slope, for up to mrev steps
*       if 'down' step is found, it tries to find a minimum from
*       there along the steepest slope down
*
C* AUTHOR: G. KNIES  13-06-91
C     VERSION OF 31/1/91  CAN BE CALLED FOR JETMULTIPL    2<=JETMUL<=5
C     VERSION OF 15/2/91  CAN BE CALLED JETFUNCTION INDEX 1<=INDEC<=10
C     VERSION OF 10/6/91  covariant N-directional thrust included
C     VERSION OF 13/6/91  can go reverse to search for 2. minimum
C     VERSION OF 19/6/91  reject min2 if not deeper than min1
C     VERSION OF 11/11/91  Test on index<2*jptmax for ijp,ij,ldjc
*D: QEMIN2 00500 gk. add some safety
C  ***************  INPUT PARAMETERS  ********************************
C  *
C   JETMUL = CURRENT MULTIPLICITY OF JETS,
C   INDEC = POSITION OF CALL FOR CURRENT JETFUNCTION
C   MREV = LIMIT FOR 'CLIMBING' REVERS STEPS
C     WARM START: REFINEMENT OF A J=JETMUL MULTPLICITY DECOMPOSITION
C     BE DECOMPOSED.
C   MINPA  = MINIMUM NUMBER OF PARTICLES REQUESTED FOR A JET
C
C     VIA COMMON/QCTBUF/
C   JTBI  = NUMBER OF INPUT VECTORS FOR CURRENT EVENT (MAX : JTBIMX)
C   QPI(I,IPA) THE INPUT PARTICLE MOMENTUM VECTORS, 1=<IPA<=JTBI
C               I=1,2,3,4,5: PX,PY,PZ,E,M; I=6: CHARGE
C  *
C  *******************  OUTPUT PARAMETERS   **************************
C  *
C     DMMT = CHANGE in value of jetfunction
C     NEW  = 0(no)/1(an) decline of jetfunction found
C  *
C  ****************  INTERNAL PARAMETERS  **************************
C  *
C   THE (INTERNAL) JET "NAMES" ARE "JND":
C    1-JET DECO: JND = 1 (TRIVIAL, UNDECOMPOSED EVENT)
C    2-JET DECO: JND = 2,3
C    3-JET DECO: JND = 4,5,6
C    4-JET DECO: JND = 7,8,9,10
C    5-JET DECO: JND = 11,12,13,14,15
C    JINDH = HIGHEST JET NAME AT JND= JETMUL*(JETMUL+1)/2
C    JINDL = LOWEST JET NAME AT JND = JINDH - (JETMUL-1)
C
C   LIST OF PARTICLE ASSIGNMENTS TO JETS IN ARRAY LPJ(I,JND,INDEC)
C    LPJ(I,JND,INDEC) = IPA INDEX FOR PARTICLES IN SUBSET JND, AT I>2
C    LPJ(1,JND,INDEC) = (CURRENT) NO. OF PARTICLES IN JET JND
C    LPJ(2,JND,INDEC) = ICJ FOR MOMENTUM VECTOR OF CURRENT JET JND
C  *
C  *********************************************************************
C
C   THE DECOMPOSITION
C    IS CONTROLLED BY THE CHOICE OF THE JET FUNCTION "JETFU",
C    AND CAN BE INFLUENCED BY SOME BOUNDARY CONDITIONS.
C   JETFU SELECTS THE JETFUNCTION TO BE MINIMIZED
C     JETFU    1     2      3    4    5      6     7  8  9  10  *****
C             -P   -BETA    M   M**2  PETEE  USER   USER USER
C

C                                                        INTERNAL ARRAYS
C     LDC(I)     NO OF CURRENT VALID PARTICLES IN SET I
C     LDA(I)     NO OF ORIGINAL + IMMIGRATED PARTICLES IN SET I
*D: QEMIN2 10102 me. lower case to upper case
#include "decoma.inc"
#include "qjmacs.inc"

*
       double precision eve,evx,evy,evz,evs,ej,ejh,pj,tjet,pr,p
       double precision sjh,pjh,pjhc,fmeq,ejt,pjt,sjt,pjtc,tne,tnx
       double precision tny,tnz,enj,pnj,snj,hne,hnx,hny,hnz,smsq
       integer ldc,nhls,idp,ld,lda
       double precision dmm,dmmt,dmij,dmml,dmh0,dmt0,dmt1 
       DIMENSION LDC(5),NHLS(5),IDP(5),LD(2*JPTMAX+2,5),LDA(5)
       DIMENSION TJET(10,15)
       DIMENSION P(5,2*JPTMAX),PR(5,2*JPTMAX)
       EQUIVALENCE (P(1,1),QPI(1,1))
       EQUIVALENCE (PR(1,1),QTBIR(1,1))
       LOGICAL DOWN
C
C
      DATA JCAL/0/
C and only to satisfy the silly compiler I initialize
      DATA IJP/0/
      IFLAG=0
      DOWN=.FALSE.
      JETFU=JETF(INDEC)

************************************************************************
*                                                                      *
*      INITIALIZE JET MULTIPLET FROM THE ALREADY ACHIEVED MINIMUM      *
*      OF THE SAME JET FUNCTION AND MULTIPLET                          *
************************************************************************
C  number of backward steps
      NREV=0
C                          THE RANGE OF JET NAMES JND FOR CURRENT JETMUL
      JNDH=JETMUL*(JETMUL+1)/2
      JTMLM1=JETMUL-1
      JNDL=JNDH-JTMLM1
      JNDHM1=JNDH-1
      JNDLM1=JNDL-1
C   JET MEMBER LISTS and momenta are already existing -
      EC2=ECONF
      DMMT=0.
           IF(NEVPRI.GE.2) THEN
             PRINT *,'INI"ON FROM PREVIOS MULT FINISHED'
             PRINT *,
     1 JNDL,'=< JND <=',JNDH,('JET#,-LIST LPJ=',JND,(LPJ(I,JND,INDEC),
     2I=1,(LPJ(1,JND,INDEC)+2)),JND=JNDL,JNDH)
                           ENDIF
************************************************************************
*                                                                      *
*   R E V E R S E   M I N I M I Z A T I O N    L O O P                 *
*                                                                      *
************************************************************************
      IF(JCAL.GT.0) GOTO 1001
      JCAL=JCAL+1
      WRITE(6,1000) INDEC
 1001  CONTINUE
 1000 FORMAT(' ****  MEMBER EMIN2 IN ACTION ****   for INDEC=',I4)
C  LDC(I) =CURRENT # OF PARTICLES IN SET I
C  LDA(I) =# OF PARTICLES IN SET I AT START + THE IMMIGRANTS
C  NHLS(I)=# OF PARTICLES IN SET I AT START
C  IDP(I) = P - VECTOR INDEX FOR SET #I
C  MINPA IS THE MINIMUM NUMBER OF PARTICLES TO BE LEFT IN A JET

      DO 1  J=1,5
      IDP(J)=0
      LDC(J)=0
      LDA(J)=0
      NHLS(J)=0
  1   CONTINUE
      DO 2  J=1,JETMUL
      JP = JNDLM1+J
      IDP(J)=LPJ(2,JP,INDEC)
      LDC(J)=LPJ(1,JP,INDEC)
      LDA(J)=LPJ(1,JP,INDEC)
      NHLS(J)=LPJ(1,JP,INDEC)
      DO 3 K=1,10
  3   TJET(K,JP)=PJET(K,JP,INDEC)
  2   CONTINUE
      DO 4 I=1,5
      DO 5 J=1,2*IPTMAX+2
  5   LD(J,I)=0
  4   CONTINUE
      DO 6 J=1,JETMUL
      LD(1,J)=LPJ(1,JNDLM1+J,INDEC)
      LD(2,J)=LPJ(2,JNDLM1+J,INDEC)
      DO 7 K=3,IPTMAX+2
  7   LD(K,J)=LPJ(K,JNDLM1+J,INDEC) + ITROFF(INDEC)
  6   CONTINUE
C* Event 4-vector
      J1=LPJ(2,1,INDEC)
      EVE=PJET(4,J1,INDEC)
      EVX=PJET(1,J1,INDEC)
      EVY=PJET(2,J1,INDEC)
      EVZ=PJET(3,J1,INDEC)
      EVS=PJET(5,J1,INDEC)**2
C                                    M I N I M I Z A T I O N   S T A R T
      DMMT=0.
      DMML=0.
  15  CONTINUE
C  set sufficient high initial value for minimum chance of jet function
      DMM=100000.
C                                       M I N I M I Z A T I O N  L O O P
C   LOOK FOR THAT PARICLE TRANSITION FROM ANY (HOME) JET TO
C   ANY (TARGET) JET YIELDING THE SMALLEST INCREASE OF THE JETFUNCTION
CCC   DMM=0.
C INDEX OF BEST HOME SET
      IHBEST=0
C INDEX OF BEST TARGET SET
      ITBEST=0
C INDEX OF BEST PARTICLE TO FLIP
      IPBEST=0
      FTOPO=0.
C                                             H O M E  S E T  L O O P  I
       DO 100 I=1,JETMUL
C                                                      HOME JET SELECTED
C                  ENOUGH PARTICLES IN HOME JET FOR FURTHER EMIGRATION ?
       IF(LDC(I).LE.MINPA) GOTO 100
C IF ONLY ORIGINAL MEMBERS OF HOMESET ARE ADMITTED FOR MIGRATION
       NHL=NHLS(I)+2
C IF ORIGINAL MEMBERS OF HOMESET AND IMMIGRANTS ARE ADMITTED
       IF(DOWN .AND. IREV(INDEC).EQ.2) NHL=LDA(I)+2
       IF(NHL.LE.2) GOTO 100
       IPH=IDP(I)
C      CALL FMEQ(DMH0,IPH,EC2,JETFU)
C         CALCULATE CONTRIBUTION OF PRESENT HOME JET TO THE JET FUNCTION
       HE = TJET(4,IPH)
       HX = TJET(1,IPH)
       HY = TJET(2,IPH)
       HZ = TJET(3,IPH)
       EJH = HE*HE
       PJH = HX*HX + HY*HY + HZ*HZ
       SJH = EJH - PJH
C  GO TO THE REQUESTED JET FUNCTION
       GOTO (301,302,303,304,310,310,310,310,310,310),JETFU
  301   PJHC=HE*EVE-HX*EVX-HY*EVY-HZ*EVZ
        PJHC = PJHC*PJHC/EVS - SJH
        IF(PJHC.LT.0.) PJHC=0.
        DMH0=-SQRT(PJHC)
        GOTO 16
  302   FMEQ=EJH-PJH
        FMEQ=FMEQ/(EJH+EC2)
        DMH0=-SQRT(1.-FMEQ)
        GOTO 16
  303   FMEQ=EJH-PJH
C because of rounding errors when beam pipe particles present
        IF(FMEQ.LT.0.) FMEQ=0.
        DMH0=SQRT(FMEQ)
        GOTO 16
  304   DMH0=EJH-PJH
        GOTO 16
  310   DMH0=0.

   16 CONTINUE
        FTOPO=FTOPO+DMH0

C                                         T A R G E T  S E T  L O O P  J
         DO 110 J=1,JETMUL
C                                                    TARGET JET SELECTED
         IF(J.EQ.I) GOTO 110
         IPT=IDP(J)
C        CALL FMEQ(DMT0,IPT,EC2,JETFU)
C      CALCULATE CONTRIBUTION OF SELECTED TARGET JET TO THE JET FUNCTION
       TE = TJET(4,IPT)
       TX = TJET(1,IPT)
       TY = TJET(2,IPT)
       TZ = TJET(3,IPT)
       EJT = TE*TE
       PJT = TX*TX + TY*TY + TZ*TZ
       SJT = EJT - PJT
C                                       GO TO THE REQUESTED JET FUNCTION
       GOTO (311,312,313,314,320,320,320,320,320,320),JETFU
  311   PJTC=TE*EVE-TX*EVX-TY*EVY-TZ*EVZ
        PJTC = PJTC*PJTC/EVS - SJT
        IF(PJTC.LT.0) PJTC=0.
        DMT0=-SQRT(PJTC)
        GOTO 17
  312   FMEQ=EJT-PJT
        FMEQ=FMEQ/(EJT+EC2)
        DMT0=-SQRT(1.-FMEQ)
        GOTO 17
  313   FMEQ=EJT-PJT
C because of rounding errors when virgin target jet empty:
        IF(FMEQ.LT.0.) FMEQ=0.
        DMT0=SQRT(FMEQ)
        GOTO 17
  314   DMT0=EJT-PJT
        GOTO 17
  320   DMT0=0.
   17    DMIJ=DMH0 + DMT0
C  ************************  P A R T I C E L  S E A R C H   L O O P  IJP
C  *                                                                   *
        DO 111 ILH=3,NHL
        IJP=LD(ILH,I)
C                              TEST PARTICLE IJP FROM HOME SET SELECTED
        IF(IJP.LE.0) GOTO 111
        IF(IJP.GT.(2*JPTMAX)) GOTO 99
C       CALL AFMEQ(DMT1,IPT,IJP,EC2,JETFU)
C   CALCULATE JET FUNCTION FOR TARGET JET + IMMIGRATED TEST PARTICLE
       TNE=TE + P(4,IJP)
       TNX=TX + P(1,IJP)
       TNY=TY + P(2,IJP)
       TNZ=TZ + P(3,IJP)
       ENJ = TNE*TNE
       PNJ = TNX*TNX + TNY*TNY + TNZ*TNZ
       SNJ = ENJ - PNJ
       GOTO (321,322,323,324,330,330,330,330,330,330),JETFU
  321   PJTC=TNE*EVE-TNX*EVX-TNY*EVY-TNZ*EVZ
        PJTC = PJTC*PJTC/EVS - SNJ
        IF(PJTC.LT.0.) PJTC=0.
        DMT1=-SQRT(PJTC)
        GOTO 18
  322   FMEQ=ENJ-PNJ
        FMEQ=FMEQ/(ENJ+EC2)
        DMT1=-SQRT(1.-FMEQ)
        GOTO 18
  323   FMEQ=ENJ-PNJ
C because of rounding errors when virgin target jet empty:
        IF(FMEQ.LT.0.) FMEQ=0.
        DMT1=SQRT(FMEQ)
        GOTO 18
  324   DMT1=ENJ-PNJ
        GOTO 18
  330   DMT1=0.
   18  CONTINUE
C       CALL SFMEQ(DMH1,IPH,IJP,EC2,JETFU)
C   CALCULATE JET FUNCTION FOR HOME JET - EMIGRATED TEST PARTICLE
       HNE=HE - P(4,IJP)
       HNX=HX - P(1,IJP)
       HNY=HY - P(2,IJP)
       HNZ=HZ - P(3,IJP)
       ENJ = HNE*HNE
       PNJ = HNX*HNX + HNY*HNY + HNZ*HNZ
       SNJ = ENJ - PNJ
       GOTO (331,332,333,334,340,340,340,340,340,340),JETFU
  331   PJHC=HNE*EVE-HNX*EVX-HNY*EVY-HNZ*EVZ
        PJHC = PJHC*PJHC/EVS - SNJ
        IF(PJHC.LT.0.) PJHC=0.
        DMH1=-SQRT(PJHC)
        GOTO 19
  332   FMEQ=ENJ-PNJ
        FMEQ=FMEQ/(ENJ+EC2)
        DMH1=-SQRT(1.-FMEQ)
        GOTO 19
  333   FMEQ=ENJ-PNJ
C because of rounding errors when NEARLY  jet empty:
        IF(FMEQ.LT.0.) FMEQ=0.
        DMH1=SQRT(FMEQ)
        GOTO 19
  334   DMH1=ENJ-PNJ
        GOTO 19
  340   DMH1=0.
C  IS JET FUNCTION WITH CURRENT TEST PARICLE
C    SMALLER THAN FOR ANY PREVIOS ONE ? -- THEN REMEMBER IT!
   19  DM = DMH1 + DMT1 - DMIJ
         IF(DM.GE.DMM) GOTO 111
         DMM=DM
         IHBEST=I
         ITBEST=J
         IPBEST=ILH
C                                                                 *
C *****************  END PARTICLE SEARCH LOOP *********************
 111     CONTINUE
C                                                                  *
C *****************  END TARGET JET LOOP ***************************
 110    CONTINUE
C                                                                   *
C *****************  END HOME JET LOOP ******************************
 100   CONTINUE
C   DMM WAS THE REDUCTION IN JET FUNCTION ACHIEVED FOR THE BEST
C    PARTICLE MIGRATION BETWEEN ANY TWO JETS.
C   DMMT IS THE REDUCTION ACCUMULATED SINCE BEGINNING THE DECOMPOSITION
      IF(DOWN .AND. DMM.GE.0.) GOTO 200
      DMMT=DMMT+DMM
C   F O R   T H E  B E S T   S O L U T I O N   F O U N D
C    F L I P  P A R T I C E L P(,IJ)  F R O M
C         IJ =  LD(ILH,IH)=>LD(ILT,JT)
      IH=IHBEST
      JT=ITBEST
      ILH=IPBEST
      IJ=LD(ILH,IH)
      IF(IJ.GE.(2*JPTMAX)) GOTO 99
      IPH=IDP(IH)
      IPT=IDP(JT)
      IF(NEVPRI.GE.2)
     1PRINT *,'QEMIN2, SEARCH END, DMM,DMML=',DMM,DMML
     2,'I,HJ, TJ',LD(IPBEST,IHBEST)
     3,IHBEST,ITBEST
C     IF(IJ.LE.0) GOTO 200
      LDC(IH)=LDC(IH) - 1
      LDC(JT)=LDC(JT) + 1
      LDA(JT)=LDA(JT) + 1
      ILT=LDA(JT)+2
      LD(ILT,JT)=LD(ILH,IH)
      LD(ILH,IH)=-LD(ILH,IH)
C  PARTICEL IJ HAS BEEN INVALIDATED IN LD(HOME)
C  PARTICEL IJ HAS BEEN ADDED     TO LD(TARGET)
C  UPDATE FOUR MOMENTA OF MODIFIED JETS
C     CALL SUB(IPH,IJ,IPH)
C     CALL ADD(IPT,IJ,IPT)
      DO 130 I=1,4
      TJET(I,IPH)=TJET(I,IPH)-P(I,IJ)
      TJET(I,IPT)=TJET(I,IPT)+P(I,IJ)
  130 CONTINUE
      TJET(6,IPH)=TJET(6,IPH)-PR(1,IJ)
      TJET(6,IPT)=TJET(6,IPT)+PR(1,IJ)
C  particle with the smallest increment to the jet function is flipped
C  if jet function got smaller (success!), reverse search is ended .
      IF(DMM.LE.0)  GOTO  131
      IF(DMM.GT.DMML) NREV=NREV+1
      DMML=DMM
C  check if maximum number of steps reached (no hint for 2. min. found)
      IF(NREV.GT.MREV) GOTO 50
C    N O W  S E A R C H  F O R  N E X T  B E S T  F L I P
      GOTO 15
 131  DOWN=.TRUE.
      GOTO 15
 200  CONTINUE
C   2. MINIMUM  HAS BEEN REACHED , CHECK IF LOWER THAN MIN1
      IF(DMMT.GE.0.) GOTO 50
C   C O M P R E S S  LD   A R R A Y S
      DO 30 J=1,JETMUL
      LDC(J)=0
       DO 31 I=3,2*IPTMAX+2
       M1=LD(I,J)
       IF(M1.LE.0) GOTO 31
       LDC(J)=LDC(J) + 1
       LDCJ=LDC(J)
      IF(LDCJ.GT.(2*JPTMAX)) GOTO 99
       LD(LDCJ+2,J)=M1
  31   CONTINUE
      NL3=LDC(J)+3
      IF(NL3.GT.(2*JPTMAX+2)) GOTO 99
      DO 32 I=NL3,2*IPTMAX+2
  32  LD(I,J)=0
  30  LD(1,J)=LDC(J)
      DO 40 J=1,JETMUL
      JP=JNDLM1+J
      LPJ(1,JP,INDEC)=LD(1,J)
      LPJ(2,JP,INDEC)=LD(2,J)
C  UPDATE JET VECTORS
      DO 43 K=1,10
   43 PJET(K,JP,INDEC)=TJET(K,JP)
C  UPDATE JET MEMBER LISTINGS
      DO 41 I=1,IPTMAX+2
      LPJ(I,JP,INDEC)=LD(I,J) - ITROFF(INDEC)
   41 CONTINUE
      JND=LPJ(2,JP,INDEC)

C  ADD M AND |P| TO JET VECTORS
      EJ=PJET(4,JND,INDEC)**2
      PJ=0.
      DO 42 I=1,3
      PJ=PJ+PJET(I,JND,INDEC)**2
   42 CONTINUE
      SMSQ=EJ-PJ
      IF (SMSQ.LT.0.) SMSQ=0.
      PJET(5,JND,INDEC)=SQRT(SMSQ)
C because of rounding errors when NEARLY  jet empty:
      PJET(8,JND,INDEC)=SQRT(PJ)
  40  CONTINUE
      NEW=1
      RETURN
  50  NEW=0
C no better minimum found
      RETURN
  99  CONTINUE
      PRINT *,'QEMIN2: IJP OUT OF RANGE:',IJP
      IFLAG=1
      RETURN
      END
