*CMZ :  1.01/08 16/10/97  11.23.17  by  Tancredi Carli
*-- Author :
C $RCSfile$ $Revision: 207 $ $Date: 2001-08-08 14:06:45 +0200 (Mi, 08. Aug 2001) $
C{{{}}}
C{{{  dist
      FUNCTION dist(A,I,B,J,IDIS)
C{{{  description
CN  dist -- subroutine for jadejet
CS  NOT FOR EXTERNAL CALLING, v = dist (a,i,b,j,idis)
CA  Thomas Hadig
CT  $Date: 2001-08-08 14:06:45 +0200 (Mi, 08. Aug 2001) $
CV  $Revision: 207 $
CF  $RCSfile$
CI. a(4,*) -- array 1
CI. i -- index of array 1
CI. b(4,*) -- array 2
CI. j -- index of array 2
CI. idis -- distance measure (1 : JADE, 2 : E,P,E0)
CO. dist -- distance between two particles
CP  No options available
CB  No bugs known
CD  dist -- calculates the distance between  the particles i of array a
CD+ and j of array b using the distance measure defined by idis.
C*
C}}}
 
      IMPLICIT NONE
      DOUBLE PRECISION A(4,*),B(4,*)
      INTEGER I,J,IDIS
C 1 : JADE .... 2 Ei Ej ( 1- cos (theta_ij))
C 2 : E,P,E0 .. (p_i + p_j)^2
 
      DOUBLE PRECISION dist
 
      DOUBLE PRECISION AP2,VP2
      DOUBLE PRECISION C(4)
 
      IF (IDIS.eq.1) THEN
        IF ((AP2(A,I).lt.1d-10).or.(AP2(B,J).lt.1d-10)) THEN
          dist=0d0
        ELSE
          dist = 2D0 * A(4,I) * B(4,J) * (1D0 -
     +     (A(1,I)*B(1,J) + A(2,I)*B(2,J) + A(3,I)*B(3,J)) /
     +      sqrt(AP2(A,I)*AP2(B,J)) )
        ENDIF
      ELSEIF (IDIS.eq.2) THEN
        C(1)=A(1,I)+B(1,J)
        C(2)=A(2,I)+B(2,J)
        C(3)=A(3,I)+B(3,J)
        C(4)=A(4,I)+B(4,J)
        dist = C(4)*C(4)-VP2(C)
      ELSE
        WRITE (*,*) 'DIST: unknown distance scheme'
        STOP
      ENDIF
 
      RETURN
      END
