*CMZ :  1.01/15 12/08/98  19.34.23  by  Tancredi Carli
*-- Author :
C}}}
c---------- -----------------------------------------
C{{{  vadd
      SUBROUTINE dvadd(A,I,B,J,IRECOM)
C{{{  description
CN  vadd -- add two vectors
CS  call vadd (a,i,b,j,IRECOM)
CA  Thomas Hadig
CT  $Date: 2002-03-28 16:40:03 +0100 (Do, 28. Mär 2002) $
CV  $Revision: 231 $
CF  $RCSfile$
CI. A(4,*) -- array 1
CI. I -- index for array 1
CI. B(4,*) -- array 2
CI. J -- index for array 2
CI. IRECOM -- recombination scheme (1 : E/JADE, 2 : E0, 3 : P)
CO. None
CP  No options available
CB  No bugs known
CD  vadd -- adds vector j of array b to vector i of array a (result is in
CD+ vector i of array a). You can use the
CD+ irecom -- input to select a recombination scheme.
C*
C}}}
 
      IMPLICIT NONE
      DOUBLE PRECISION A(4,*),B(4,*)
      INTEGER I,J,IRECOM
C IRECOM : recombination scheme
C  1 : E/JADE .... 4-vector addition, not massless
C  2 : E0 ........ momentum rescaling, massless
C  3 : P ......... energy rescaling, massless
 
      DOUBLE PRECISION AP2
      DOUBLE PRECISION FAC
 
      B(1,J)=A(1,I)+B(1,J)
      B(2,J)=A(2,I)+B(2,J)
      B(3,J)=A(3,I)+B(3,J)
      B(4,J)=A(4,I)+B(4,J)
      IF (IRECOM.eq.1) THEN
        CONTINUE
      ELSEIF (IRECOM.eq.2) THEN
        FAC=SQRT(AP2(B,J))/B(4,J)
        B(1,J)=B(1,J)*FAC
        B(2,J)=B(2,J)*FAC
        B(3,J)=B(3,J)*FAC
      ELSEIF (IRECOM.eq.3) THEN
        B(4,J)=SQRT(AP2(B,J))
      ELSE
        WRITE (*,*) 'VADD: unknown scheme'
        STOP
      ENDIF
      RETURN
      END
