*CMZ :  1.01/02 09/04/96  15.43.52  by  Tancredi Carli
*-- Author : Tancredi Carli
      SUBROUTINE JCLUST(EVIS,XJCUT,JMODE,NPI,PI,NP,P)
********************************************************
* Jade algorithmn:                                     *
* Input:                                               *
* EVIS; visible energy                                 *
* XJCUT: Energy fraction xcut=xjcut*w**2               *
* Jmode: 1: m= ENi*ENj*(1-costh)
*        2: m=2*min(ENi**2,ENJ**2)*(1-costh))
* NPI= number of particles to be considered            *
* PI(4,N) particle to be joined                        *
*                                                      *
*                                                      *
********************************************************
      Implicit none
*
      Logical lp
      Data lp/.false./
      Real SM,XCUT,XJCUT,EVIS
      Integer lleng,i,j,l,jmode,nj,iposs,nn
      PARAMETER (SM=1.E-10)
      PARAMETER (LLENG=2000)
C     COMMON/PPLUND/N,NJ,P(5,LLENG),K(5,LLENG)
*
      Real PRMIN,P1,P2,COSTH,PMASS,AJETM2
      Integer mxjet,imin,jmin,npi,np
      PARAMETER (MXJET=95)
      Real PI(4,LLENG),P(5,LLENG)
      Integer IFLAG(LLENG)
*
      LOGICAL LBEGIN
************************************************************************
**********  STEERING PARAMETERS OF   JET FINDING ALGORITHMS ************
************************************************************************
*
*
      DATA LBEGIN/.TRUE./
*
******* THE ONLY ONE PARAMETER FOR THIS ALGORITHM ************
*
      IF (LBEGIN) THEN
 1000 FORMAT(1H1 / 2(' ===============',44X)/2(' |    JCLUST   |',44X)/
     &2(' ===============',44X)//2X,//
     &'  ========THE ONLY PARAMETER OF THIS ALGORITHM =============='//
     &'                         XCUT   =', F11.5//)
      WRITE(6,1000) XJCUT
 1100 FORMAT(77X, '*************'/
     &       ' THE PARAMETERS OF THIS ALGORITHM YOU CAN ',
     &'CHANGE IN THE MAIN PROGRAM UNIT    |  A N A L  |  BY ',
     &'ASIGNIG THE PARAMETERS '/77X, '*************'//)
      WRITE(6,1100)
       LBEGIN = .FALSE.
      ENDIF
*
*  XCUT IS REDEFINED WITH THE HELP OF ENERGY VISIBLE IN THE EVENT
*
      XCUT=XJCUT*EVIS**2
*
      if (lp) then
       write(6,*) ' jmode= ',jmode,' evis= ',evis
       write(6,*) ' xcut= ',xcut,' xjcut= ',xjcut
       write(6,*) ' npi= ',npi
      endif
*
      Do i=1,npi
       IFLAG(i)=1
      enddo
*
      IMIN=0
      JMIN=0
   20 CONTINUE
*
* MAIN LOOP
*
      PRMIN=1.0E20
*
      DO 100 I=1,NPI-1
*
C      if (lp) then
C       write(6,*) i,' pi= ',PI(4,i),PI(1,i),PI(2,i),PI(3,i)
C      endif
*
      IF(IFLAG(I).GT.999) GO TO 100
      DO 200 J=I+1,NPI
      IF(IFLAG(J).GT.999) GO TO 200
*
* CALCULATE INVARIANT MASS-SQUARED AND FIND PAIR WHICH GIVES LOWEST
* 2. FORMULA USED BY JADE; ALL MASSES ARE PIONS
*
      P1=SQRT(PI(1,I)**2+PI(2,I)**2+PI(3,I)**2)
      P2=SQRT(PI(1,J)**2+PI(2,J)**2+PI(3,J)**2)
      COSTH=(PI(1,I)*PI(1,J)+PI(2,I)*PI(2,J)+PI(3,I)*PI(3,J))/(P1*P2)
      IF(JMODE.EQ.1) THEN
       PMASS=2.*PI(4,I)*PI(4,J)*(1.-COSTH)
      ELSEIF(JMODE.EQ.2) THEN
       PMASS=2.0*AMIN1(PI(4,I)**2,PI(4,J)**2)*(1.-COSTH)
      ENDIF
      IF(PMASS.LT.PRMIN) THEN
       PRMIN=PMASS
       IMIN=I
       JMIN=J
      END IF
*
* COUNT PAIRS WHOSE MASS EXCEEDS XCUT
*     IF(PMASS.GT.XCUT) NCLUS=NCLUS+1
*
  200 CONTINUE
  100 CONTINUE
*
* STOP PROCESS IF ALL PAIRS HAVE MASSES WHICH EXCEED XCUT
*
      IF(PRMIN.GT.XCUT) GO TO 500
*
* COMBINE LOWEST MASS PAIR INTO A PSEUDOPARTICLE WITH INDEX OF THE FIRST
* PARTICLE AND FLAG THE SECOND PARTICLE AS DEAD.
*
      IFLAG(IMIN)=IFLAG(IMIN)+IFLAG(JMIN)
      IFLAG(JMIN)=1000
*
      DO 300 L=1,4
      PI(L,IMIN)=PI(L,IMIN)+PI(L,JMIN)
  300 CONTINUE
      GO TO 20
*
  500 CONTINUE
*
* NOW FIND THE JETS: ALL PSEUDOPARTICLES
*
      NP=0
      DO 600 IPOSS=1,NPI
* SKIP DEAD PARTICLES.
      if (lp) then
C       write(6,*) iposs,' pi= ', PI(1,IPOSS),PI(2,IPOSS),
C     &            PI(3,IPOSS),PI(4,IPOSS),' ifl= ',IFLAG(IPOSS)
      endif
      IF(IFLAG(IPOSS).GT.999) GO TO 600
      NP=NP+1
*
      P(1,NP) = PI(1,IPOSS)
      P(2,NP) = PI(2,IPOSS)
      P(3,NP) = PI(3,IPOSS)
      P(4,NP) = PI(4,IPOSS)
*
      AJETM2 = P(4,NP)**2-P(1,NP)**2-P(2,NP)**2-P(3,NP)**2
*     IF(AJETM2.GT.0.) P(5,NP) = SQRT(AJETM2)
      IF(AJETM2.LT.0.)THEN
       P(5,NP)=0.
      ELSE
       P(5,NP)=SQRT(AJETM2)
      ENDIF
*
C      if (lp) then
C       write(6,*) np,' p= ', P(1,np),P(2,np),
C     &                    P(3,np),P(4,np),P(5,np)
C      endif
*
  600 CONTINUE
*
      RETURN
      END
