****************************************************
*
* Authors:  H. Jung, K. Peters 27-01-2005
*
*  B* - J/psi cross sections of CDF
*  MEASUREMENT OF THE J/PSI MESON AND B-HADRON PRODUCTION CROSS SECTIONS 
*  IN P ANTI-P COLLISIONS AT S(NN)**(1/2) = 1960-GEV.
*  By CDF Collaboration (D. Acosta et al.). FERMILAB-PUB-04-440-E, Dec 2004. 59pp.
*  Submitted to Phys.Rev.D
*  e-Print Archive: hep-ex/041207
****************************************************


      subroutine hzh0412071(IFLAG)
      IMPLICIT NONE
*
      Real pi,dpi,rd,ee,eb,dphi,Qpi,qqradp,sigma_tot,xntot
      real p,ptb,et,rapb,th,phdum,phang,xd,dst_xsec
      real ptbb,rapbb
      real ps,pts,ets,raps,ths,phangs
      Logical lp
      data lp/.false./
*
      Character string*20
*
      real alph_em
      Parameter (alph_em=7.29927e-3)
      Real gev2nb,lum,fact,lumnb

      Integer iqbin,i1,i3,idhisto,idpaw

      Parameter (gev2nb=0.389e6)
      Integer maxhi
      Parameter (maxhi=10000)
      Real nev(maxhi)
      Integer nentry
      Real n2,nall,nall2,nall3
      Real xw
      Data nall/0/
      Integer jcut,ncut,iel,idum,id,idq2,idx
      Parameter (ncut=4,pi=3.1415927,dpi=2.*pi,rd=180./pi,ee=27.5)
*
      Integer ierr,ibeam,igam
      Double precision pbeam(4),pgam(4),pcm(4),ph(5),phb(4),phbb(4)
      Double Precision Phc(4)
      Real rap,pt
      Integer imuon,ij,idtest
      Double Precision phbbar(4)
*
      integer err_flag
      real x,y,w2,q2

      Double Precision Q2C,YY,YY_BAR,XG,XG_BAR,KT2_1,KT2_2,PT2H,SHH
      COMMON/CASKIN/Q2C,YY,YY_BAR,XG,XG_BAR,KT2_1,KT2_2,PT2H,SHH
#include "hzfunc.inc"
#include "hzhbook.inc"
#include "hepevtp.inc"
#include "heracmn.inc"
*
      Double precision plab(5,NMXHEP)
      Integer iflag,ihep,i,j,k,l,nb,nbb
      Logical bottom,ldstar
      Real ptcut,rapcut,nbtot,nbsel,nbsela,nbpsi,npsi,nbpsit,impsi
      Integer ipt,nptbin
      Parameter (nptbin=25)
      Real ptbin(nptbin+1),pthisto(nptbin+1)
	Data ptbin/1.25,1.5,1.75,2.0,2.25,2.5,2.75,3.0,
     &           3.25,3.5,3.75,4.0,4.25,4.5,4.75,5.0,
     &           5.5,6.0,6.5,7.0,8.0,9.0,10.,12.,14.,17./
      
      Real sigjpsi(nptbin),sigst(nptbin),sigsy(nptbin),sigtot(nptbin)
	Data sigjpsi/6.57,6.65,5.95,6.65,5.81,5.62,4.93,4.52,
     &             4.06,3.33,3.39,2.52,2.27,2.16,1.87,1.44,1.11,
     &             0.857,0.644,0.481,0.279,0.162,0.0875,0.0474,
     &             0.0266/
      Data sigst  /0.72,0.46,0.39,0.36,0.31,0.27,0.24,0.21,0.18,
     &             0.15,0.15,0.12,0.11,0.10,0.089,0.051,0.041,
     &             0.034,0.027,0.015,0.011,0.0075,0.0037,0.0028,
     &             0.0018/
      Data sigsy  /1.3,1.3,1.1,1.2,1.0,0.9,0.78,0.65,0.5,0.45,
     &             0.45,0.35,0.27,0.25,0.22,0.17,0.13,0.1,0.07,
     &             0.046,0.023,0.022,0.015,0.0083,0.0050/

      Real ptmin,delta
      Real xkt1,xkt2,x1,x2
      Integer igl1,igl2
      Integer Ngg,Ngg0,ijpsi
      Real ptg,ptglu(100),rapg,rapglu(100)
      Real ptbbar,rapbbar,Deltarap,mb,mbb,BRmu,rapj
	Integer id1,id2
*     
      Character*8 xxxx
      Data xxxx/'h0412071'/
      Integer MINT
      Double Precision VINT
      COMMON/PYINT1/MINT(400),VINT(400)
*
*
*********************************************************************
*
*                      Initialization
*
*********************************************************************
      NENTRY=NENTRY+1
*
      IF (iflag.eq.1) then
*
c         write(6,*)' hzbjpsicdf my private Version'
         Qpi = 4.*atan(1.)
         qqradp = 180./qpi
         nbtot = 0.
         nbsel = 0.
         nbpsi = 0.
         nbpsit = 0.
*
*
*      Initialisation: The following MUST always be done
*      (i) make subdirectory in PAWC
*       - use the name as the xxxxxx in HZxxxxxx subroutine
*      (i) make subdirectory in o/p file
*
         Call hcdir('//PAWC',' ')
         call hmdir(xxxx,'S')
         Call hcdir('//HISTO',' ')
         call hmdir(xxxx,'S')
*
*****************************
*  Make histograms of b cross section
*****************************
*
*
         ptmin=5.

         call hbook1(21,' beam1 log(xg) (all)',50,-5.,0.,0.)
         call hbook1(31,' beam2 log(xg) (all)',50,-5.,0.,0.)
         call hbook1(22,' beam1 kt_2 (all)',50,0.,10.,0.)
         call hbook1(32,' beam2 kt_2 (all)',50,0.,10.,0.)
         call hbookb( 1001,'dsigma/dpt (Jpsi)  ',nptbin,ptbin,0.)
         call hbookb(-1001,'dsigma/dpt (Jpsi) data ',nptbin,ptbin,0.)
         call hbookb(-1002,'dsigma/dpt (Jpsi) data(tot) '
     + ,nptbin,ptbin,0.)
         call hpak(-1001,sigjpsi)
         call hpake(-1001,sigst)
	   do i=1,nptbin
	   sigtot(i) = sqrt(sigst(i)**2 + sigsy(i)**2)
	   enddo
         call hpak(-1002,sigjpsi)
         call hpake(-1002,sigtot)
*
*
*********************************************************************
*                      Event Processing
*
*********************************************************************
*
      Else if(iflag.eq.2) then
*
        call hcdir('//PAWC/'//xxxx,' ')
*
* total number of generated events
         nall=nall+wtx
*
         bottom=.false.
         ptcut = 4.5
         rapcut = 1.
         nb=0
         nbb=0

        Do  ihep=1,nhep
            If(idhep(ihep).eq.5.and.nb.eq.0.and.
     +   (isthep(ihep).eq.2.or.isthep(ihep).eq.1)) then
               bottom=.true.
               nb=nb+1
               Do i=1,4
                  Phb(i)=PHEP(i,ihep)
               enddo
		   mb  = PHEP(5,ihep)
c        write(6,*) ' id = ',idhep(ihep),isthep(ihep),ihep,nb
            endif
            If(idhep(ihep).eq.-5.and.nbb.eq.0.and.
     +   (isthep(ihep).eq.2.or.isthep(ihep).eq.1)) then
               nbb=nbb+1
               Do i=1,4
                  Phbb(i)=PHEP(i,ihep)
                  Phbbar(i) = Phb(i) + Phbb(i)
               enddo
		   mbb = PHEP(5,ihep)
c        write(6,*) ' id = ',idhep(ihep),isthep(ihep),ihep,nbb
            endif
c        write(6,*) ' id = ',idhep(ihep),isthep(ihep),ihep,nb
         enddo
         if(nb.eq.1) then
c        write(6,*) ' PYTHIA MINT(1) ',MINT(1),
c     &     ' flavour ',(MINT(I),I=21,24)
            nbtot = nbtot + wtx
c         call hzgetvar(phb,p,ptb,et,th,phang,rap,err_flag)
            ptb = real(sqrt( phb(1)**2+phb(2)**2 ))
            ptbb = real(sqrt( phbb(1)**2+phbb(2)**2 ))
c         ptbbar = real(sqrt( phbbar(1)**2+phbbar(2)**2 ))
c here use CDF definition
            ptbbar = real(ptb+ptbb)/2. + (mb + mbb)/2.
            If (Phbbar(3).ge.Phbbar(4)) then
               rapbbar=1000.
            Elseif (Phbbar(3).le.-Phbbar(4)) then
               rapbbar=-1000.
            Else
               rapbbar=0.5*Log((Phbbar(4)+Phbbar(3))/
     +         (Phbbar(4)-Phbbar(3)))
            Endif
            If (Phb(3).ge.Phb(4)) then
               rapb=1000.
            Elseif (Phb(3).le.-Phb(4)) then
               rapb=-1000.
            Else
               rapb=0.5*Log((Phb(4)+Phb(3))/(Phb(4)-Phb(3)))
            Endif
            If (Phbb(3).ge.Phbb(4)) then
               rapbb=1000.
            Elseif (Phbb(3).le.-Phbb(4)) then
               rapbb=-1000.
            Else
               rapbb=0.5*Log((Phbb(4)+Phbb(3))/(Phbb(4)-Phbb(3)))
            Endif
c        write(6,*) ' b .... ',pt,rap,ptcut,rapcut
c        write(6,*) ' b phc ',(phc(i),i=1,4)
            xkt1 = real(sqrt(kt2_1))
            xkt2 = real(sqrt(kt2_2))
            if(gen(1:3).eq.'CAS'.or.gen(1:3).eq.'RAP') then
               igl1=4
               igl2=6
            elseif(gen(1:3).eq.'PYT') then
               igl1= 5
               igl2= 6
            endif
            xkt1 = real(sqrt(phep(1,igl1)**2+phep(2,igl1)**2))
            xkt2 = real(sqrt(phep(1,igl2)**2+phep(2,igl2)**2))
c        write(6,*) 'kt ', xkt1,sqrt(kt2_1),xkt2,sqrt(kt2_2)
            x1=real(yy)
            x2=real(xg)
            x1=(phep(4,igl1)+dabs(phep(3,igl1)))/2d0/phep(4,1)
            x2=(phep(4,igl2)+dabs(phep(3,igl2)))/2d0/phep(4,2)
c        write(6,*) ' x',x1,yy,x2,xg
            call hfill(21,real(log10(x1)),0.,1.)
            call hfill(31,real(log10(x2)),0.,1.)
            call hfill(22,xkt1,0.,1.)
            call hfill(32,xkt2,0.,1.)
            if(abs(rapb).lt.rapcut) then
               nbsel = nbsel + wtx
            endif
             if(abs(rapb).lt.0.6) then
               nbsela = nbsela + wtx
            endif
        endif
C now look for Jpsi
c        write(6,*) ' new event'

        Ijpsi = 0
        do ihep=1,nhep
            if ( Iabs(idhep(ihep)) .eq. 443 ) then
		impsi=iabs(idhep(Jmohep(1,ihep)))
		if(impsi.eq.511.or.impsi.eq.521.or.impsi.eq.531.or.
     &         impsi.eq.5122.or.impsi.eq.5232) then		
                Do i=1,4
                   Phc(i)=PHEP(i,ihep)
                enddo
c		    write(6,*) ' Jpsi found ',ihep,
c     &		' imother = ',idhep(Jmohep(1,ihep))
           
                npsi = npsi + 1
*  LAB variables
                call hzgetvar(phc,p,pt,et,th,phdum,rap,err_flag)
                If (Phc(3).ge.Phc(4)) then
                  rapj=1000.
                Elseif (Phc(3).le.-Phc(4)) then
                  rapj=-1000.
                Else
                  rapj=0.5*Log((Phc(4)+Phc(3))/(Phc(4)-Phc(3)))
                Endif
c		    write(6,*) 'pt  ',pt,' rap ',rap,rapj
		    if(abs(rap).lt.0.6.and.pt.gt.1.25) then 
			 nbpsit = nbpsit+1
		    endif
		    if(abs(rapj).lt.0.6.and.pt.gt.1.25) then 
c		      write(6,*) ' Jpsi found in |y|<0.6',ihep,
c     &		' imother = ',idhep(Jmohep(1,ihep))
		       ijpsi = 1
c		       write(6,*) ' Jpsi found ',ihep,idhep(ihep)
                   call hfill(1001,real(pt),0.,1.)
			 nbpsi = nbpsi+1
		    endif
		else 
c		    write(6,*) ' Jpsi found (not from B) ',ihep,
c     &		' imother = ',idhep(Jmohep(1,ihep))
            endif
            endif
         enddo

   10   Continue
*
*********************************************************************
*
*                      Termination
*
*********************************************************************
*
      Else if(iflag.eq.3) then
*
*      Termination: The following MUST always be done
*      (i) Move to the correct PAW subdirectory
*
         call hcdir('//PAWC/'//xxxx,' ')
*
*
*
* Obtain total cross-section

         write(6,*) ' hz',xxxx,' Total Cross section in nb',xsec/1000.
         BRmu=0.06
         write(6,*) ' hz',xxxx,' nall,nr(b),',nall,nbsel
         write(6,*) ' hz',xxxx,' nr(jpsi),nr(jpsi,|y|<0.6)',npsi,nbpsi
     &	   ,nbpsit
         write(6,*) ' hz',xxxx,' Cross sections in nb'
         write(6,*) ' hz',xxxx,' sigma(bbar, |y|<0.6)',
     &	   xsec/1000.*nbsela/nall,' sigma(bbar, |y|<1)',
     &	   xsec/1000.*nbsel/nall
         write(6,*) ' hz',xxxx,' sigma(B->J/psi->mumu)',
     &	   xsec/1000.*nbpsi*BRmu/nall

*
         lum=999999999.
         if (xsec.ne.0.) then
            lum=real(nall)/real(xsec)
         else
            write(6,*) 'hz',xxxx,' xsec=0 ! '
         endif
         lumnb =real(nall)/real(0.001*xsec)

*      normalize the histos
c normalise ptmu histo to unit rapidity (interval 2.4 < y < 3.2)
         call hopera(1001,'+E',1001,1001,BRmu/lumnb,0.)
         call hzhinrm(1001, 0, 1., 1 )
*
*
*
      endif
      RETURN
      END
