	Subroutine hzh9807014(iflag)
*****************************************************************************
*       
*       TEVATRON DIJET D0 NEED TO BE RUN WITH MERGING/SPLITTING
*       THRESHOLD SET TO 50%
*       
*       for all three phases (iflag=1,2,3)
*       
*       iflag = 1,2 or 3 depending on wether it is the initialization,
*       processing or termination phase (respectively)
*       
*       The default jetfinder is PUCELL
*       To change jetfinder use these values to call the initialisation phase.
*       1 + 10 * (jetfinder number)
*       
*       
*       DATA IN PB.
*       DATA IS IN HISTOGRAM 151
*       MC IS IN HISTOGRAM 110
*
*       Phys.Rev.Lett.82:2457-2462,1999
*       hep-ex/9807014
*       Author : I.BOROZAN
*       
*       
*****************************************************************************
*       
*       HERA Tuning defined commons

	IMPLICIT NONE

#include "hepevtp.inc"
#include "heracmn.inc"
#include "hzfunc.inc"
#include "hzjetcmn.inc"
	

	CHARACTER*6 jetf

        INTEGER NJET,ivx
c        DOUBLE PRECISION Jets(50,8)
        DOUBLE PRECISION CONER,dijetmass,masscut,dijetmassUE
	SAVE CONER

	INTEGER myil,myip
	INTEGER loop,loop2,loop1,ISTAT,loop4,E_max(100)
	DOUBLE PRECISION px(2),py(2),pz(2),ptsq(2),NRG,petite(50)
	DOUBLE PRECISION ppsq(2),energy(2),ivy(100),
     &    event,cs,mass(2),phi(2)
	DOUBLE PRECISION rap(50),Et(50),Ei(50),Ri(50),
     &    Emax,secmax,k,rap2(2)
	
C       --- cuts arrays
	DOUBLE PRECISION rapcut2(2), et2(2)
	SAVE rapcut2, masscut

C       --- private copies of Xsec and Ntot from HERACMN
	DOUBLE PRECISION mhxsec(2),mhntot(2)

	INTEGER intiflag, chjet, iproc, iflag,MAXEV
	SAVE chjet
C       --- define default jet algorithm (PUCELL)
	DATA chjet/7/
	INTEGER hzflag
        
        Real pi
	REAL pttemp(12)
	INTEGER ivec,jvec,ICYCLE
	INTEGER p,j,i,l,m,ierr

        REAL norm(15),bins2(16),mass2(15),masserr(15),bins3(10)
	REAL norme(15)
        REAL totalmasserr(15),staterr(15)        
	
	
	Data bins2/200.0,220.0,240.0,270.0,300.0,320.0,350.0,390.0,430.0
     &    ,470.0,510.0,550.0,600.0,700.0,800.0,1400.0/
	
c       DATA bins3/0.0,20.0,40.0,60.0,80.0,100.0,120.0,140.0,160.0,     
c	1    180.0/ 

	
	Data mass2/3.78d-2,2.10d-2,1.16d-2,6.18d-3,3.55d-3,2.12d-3,1.18d
     &    -3,5.84d-4,2.89d-4,1.64d-4,8.74d-5,4.49d-5,1.73d-5,4.58d-6
     &    ,2.39d-7/


        Data masserr/0.12d-2,0.09d-2,0.06d-2,0.11d-3,0.11d-3,0.07d-3,0
     &    .01d-3,0.09d-4,0.06d-4,0.05d-4,0.34d-5,0.17d-5,0.07d-5,0
     &    .38d-6,0.35d-7/
        

c       storing systematic error ******

	staterr(1)=4.3848d-3
	staterr(2)=2.4045d-3
	staterr(3)=1.3456d-3
	staterr(4)=7.2615d-4
	staterr(5)=4.189d-4
	staterr(6)=2.5652d-4
	staterr(7)=1.3393d-4
	staterr(8)=1.0804d-4
	staterr(9)=3.5836d-5
	staterr(10)=2.1238d-5
	staterr(11)=1.18427d-5
	staterr(12)=6.4656d-6
	staterr(13)=2.77665d-6
	staterr(14)=8.7936d-7
	staterr(15)=6.22595d-8          

        
        intiflag=iflag
	iproc=2


C       --- choose jet finder
	
	IF ((intiflag.gt.10).and.(MOD(intiflag,10).eq.1)) THEN
	   chjet=INT(intiflag/10)
	   intiflag=MOD(intiflag,10)
	ENDIF
	
	IF (intiflag.eq.1) THEN
C       *** Initialisation run ***
C       *** Create directories ***



           CALL HCDIR('//HISTO',' ')
	   CALL HMDIR('h9807014','S')
	   CALL HCDIR('//PAWC',' ')
	   CALL HMDIR('h9807014','S')
	   CALL HCDIR('//HISTO/h9807014',' ')
 	   CALL HCDIR('//PAWC/h9807014',' ') 

c$$$    c       open all the hbook's for generating the final histo for the
c$$$    c       paper number hep-ex/9912022

	   CALL HBOOKB(105,'Diff D0 dijet masse Xsec-Ue',15,bins2,0.)

	   CALL HBOOKB(106,'Norm',15,bins2,0.)

	   CALL HBOOKB(151,'Real data for dijet masse(D0)',15,bins2,0.)

	   CALL HBOOKB(109,'Diff D0 dijet mass Xsec',15,bins2,0.)

	   CALL HIDOPT(0,'stat')
	   CALL HBARX(0)

c$$$    
c$$$    C       --- basic cuts for rapidity plots
           rapcut2(1)=-1.0
           rapcut2(2)=1.0
   	   masscut=200.0

C       --- standard cone radius is 1.0** change cone radius to 0.7

           CONER=0.7
	   
           CALL HZJETRAD(1,CONER) 
	   IF (CONER.lt.0.0) THEN
	      CONER=0.7
	   ENDIF
	   CALL HZJTNAME(chjet,jetf)
	   
	   WRITE(6,*)'**********************************************'
	   WRITE(6,*)'*   H9807014 called, histograms will be output. *'
	   WRITE(6,*)'*     Jet finder selected : ',jetf,'           *'
	   WRITE(6,1001)'*        with cone radius : ',CONER,'   *'
	   WRITE(6,*)'**********************************************'
	   
 1001	   FORMAT(A29,F5.2,A13)
	   
	ELSE IF (intiflag.eq.2) THEN


C       *** Filling runs ***
	   
C       *** Change directory to our graphs ***
	   
           CALL HCDIR('//HISTO/h9807014',' ')
           CALL HCDIR('//PAWC/h9807014',' ')
	   
	   CALL hzjtfind(chjet,CONER,NJET,Jets)

C       ******Initilasing  all  array to 0.

	   DO  m=1,2              
	      
	      Et2(m)=0.0
	      rap2(m)=0.0 
	      phi(1)=0.0
	      phi(2)=0.0          

	   END DO     

	   IF (NJET.ge.2) then
	      
	      DO loop=1,2
		 mass(loop)=Jets(loop,8)
		 rap2(loop)=Jets(loop,1)  
		 phi(loop)=Jets(loop,2)
		 Et2(loop)=Jets(loop,3)
	      END DO 
	      

C       this will bin the events for the Differential Dijet Mass Xsec*****        
	      
	      IF (((rap2(1).gt.rapcut2(1)).and.(rap2(1).lt
     &  	   .rapcut2(2))).and.((rap2(2).gt.rapcut2(1))
     &  	   .and.(rap2(2).lt.rapcut2(2)))) then

		 
		 dijetmassUE=SQRT((2.0*(Et2(1)-1.385442)*(Et2(2)-1.385442))
     &  	      *((cosh(rap2(2)
     &  	      -rap2(1))-cos(phi(1)-phi(2)))))           
		 

		 
		 dijetmass=SQRT((2.0*(Et2(1))*(Et2(2)))
     &  	      *((cosh(rap2(2)
     &	      -rap2(1))-cos(phi(1)-phi(2)))))           
		 

		 IF (dijetmass.gt.masscut) then

C       this is the Dijet without UE  jet substraction
c       **************           
		    
		    CALL hfill(105,real(dijetmass),0.,wtx)
		    
		    IF (dijetmassUE.gt.masscut) then

		       CALL hfill(109,real(dijetmassUE),0.,wtx) 
		       
		    END IF    

		 END IF 
		 
	      END IF
	      
	   END IF  
	   
c       this is the end of the Dijet plot ***********************************
	   

        ELSE IF (intiflag.eq.3) THEN
	   
C       *** Termination run ***
C       *** Change directory ***
	   CALL HCDIR('//HISTO/h9807014',' ')
	   CALL HCDIR('//PAWC/h9807014',' ')
	   

c       write(*,*) Ntot
c       write(*,*) Xsec

	   norm(1)=(1.0/((Ntot/(Xsec*1000.))*20*2*2))
	   norm(2)=(1.0/((Ntot/(Xsec*1000.))*20*2*2))
	   norm(3)=(1.0/((Ntot/(Xsec*1000.))*30*2*2))          
	   norm(5)=(1.0/((Ntot/(Xsec*1000.))*30*2*2))
	   norm(4)=(1.0/((Ntot/(Xsec*1000.))*20*2*2))
	   norm(6)=(1.0/((Ntot/(Xsec*1000.))*30*2*2))
	   norm(7)=(1.0/((Ntot/(Xsec*1000.))*40*2*2))
	   norm(8)=(1.0/((Ntot/(Xsec*1000.))*40*2*2))
	   norm(9)=(1.0/((Ntot/(Xsec*1000.))*40*2*2))
	   norm(10)=(1.0/((Ntot/(Xsec*1000.))*40*2*2))
	   norm(11)=(1.0/((Ntot/(Xsec*1000.))*40*2*2))
	   norm(12)=(1.0/((Ntot/(Xsec*1000.))*50*2*2))
	   norm(13)=(1.0/((Ntot/(Xsec*1000.))*100*2*2))
	   norm(14)=(1.0/((Ntot/(Xsec*1000.))*100*2*2))
	   norm(15)=(1.0/((Ntot/(Xsec*1000.))*600*2*2))

	   DO loop4 = 1, 15
	      norme(loop4) = 0.0
	   ENDDO

c       this will store the above numbers in the histogram 

	   CALL HPAK(106,norm)
	   CALL HPAKE(106,norme)

c       this will plot the right cross section ***********        

	   CALL HOPERA(105,'*E',106,107,1.0,1.0)    
	   
	   CALL HOPERA(109,'*E',106,110,1.0,1.0) 


	   DO loop4=1,15
	      totalmasserr(loop4)=1000.*((staterr(loop4))**2+
     &          (masserr(loop4))**2)**0.5
	      mass2(loop4)=1000.*mass2(loop4)
	   END DO


C       fills the histo with real data *****
	   
	   CALL HPAK(151,mass2)
	   
	   CALL HPAKE(151,totalmasserr)                   
	   

C       *** Finish off histograms ***
	   
	   IF (Xsec.eq.0) THEN
	      PRINT*,
     &          'D0 dijet: termination called with zero cross section'
	      PRINT*,'          cross section graph meaningless'
	      Xsec=1
	   ENDIF
	   IF (Ntot.eq.0) THEN
	      PRINT*,'D0 dijet: termination called with no total events'
	      PRINT*,'          cross section graph meaningless'
	      Ntot=1
	   ENDIF
	   
C       --- store Xsec and Ntot for both direct and resolved events.
	   
	   mhXsec(iproc)=Xsec
	   mhntot(iproc)=Ntot

	ELSE

c       *** End ****

	   print*
     &  	,'D0 dijet: Please run routine with iflag set to 1,2 or 3'
	   
	ENDIF

	RETURN

	END 
     
