      Subroutine hzh9807018(iflag)
*****************************************************************************
*     
*     TEVATRON INCLUSIVE JET D0 TO BE RUN WITH MERGING/SPLITTING 
*     THRESHOLD SET TO 50% 
*     
*     
*     for all three phases (iflag=1,2,3)
*     
*     iflag = 1,2 or 3 depending on wether it is the initialization,
*     processing or termination phase (respectively)
*     
*     To change jetfinder use these values to call the initialisation
c     phase.
*     1 + 10 * (jetfinder number)
*     
*     This routine produces two Monte Carlo graphs.
*     id 10 is the normalised cross section in nb 
*     These graph will be
*     meaningless unless Xsec and Ntot are set before
*     calling the termination routine.
*     (Xsec - total cross section returned by MC)
*     (Ntot - number of events passed to this routine)
*     
*     HISTOGRAM 50 = DATA
*     HISTOGRAM 13 = MC (!)
*
*     xsecs are in fb.
*     hep-ex/9807018
*     Phys.Rev.Lett.82:2451-2456,1999
*     
*     Author : I.BOROZAN
*     
*     
*****************************************************************************
*     
*     HERA Tuning defined commons

      IMPLICIT NONE

#include "hepevtp.inc"
#include "heracmn.inc"
#include "hzfunc.inc"
#include "hzjetcmn.inc"

C     --- MY Variables      
      Integer otherIjet,loop20 
      Double Precision totaljetenergy1(60),SUM(60)
      Common/my/totaljetenergy1,SUM,otherIjet 

      CHARACTER*6 jetf

      INTEGER NJET,ivx
      DOUBLE PRECISION rupcut3(2)
      DOUBLE PRECISION CONER,mtotal,ETUE,Et4
      SAVE CONER

      INTEGER myil,myip
      INTEGER loop,loop2,loop1,ISTAT,loop4,E_max(100)
      DOUBLE PRECISION phi(50),px(2),py(2),pz(2),ptsq(2),NRG,petite(50)
      DOUBLE PRECISION ppsq(2),energy(2),ivy(100),event,cs,mass(2)
      DOUBLE PRECISION rap(50),Et3(50),Ei(50),Ri(50),Emax,secmax,k
     &     ,rap2(2)
      
      
C     --- cuts arrays
      DOUBLE PRECISION rapcut(2),Etcut(5)
      SAVE rapcut, etcut

C     --- private copies of Xsec and Ntot from HERACMN
      DOUBLE PRECISION mhxsec(2),mhntot(2)

      INTEGER intiflag, chjet, iproc, iflag,MAXEV
      SAVE chjet
C     --- define default jet algorithm (PUCELL)
      DATA chjet/7/
      INTEGER hzflag
      
      Real pi
      REAL pttemp(12)
      INTEGER ivec,jvec,ICYCLE
      INTEGER p,j,i,l,m,ierr
C     ---- define utilityoutput
      
      REAL sqrt,bins2(18)      
      INTEGER up
      
      REAL const1,const2,const3,const4,const5
      
      REAL et(24),eet(24),stater(24),bins(25),norm(24),norme(24)
      
      Data et/6.59d6,2.89d6,1.41d6,7.07d5,3.88d5,2.21d5,1.27d5,7
     &     .70d4,4.86d4,3.07d4,2.00d4,1.34d4,9.12d3,6.15d3,4.29d3
     &     ,2.93d3,2.14d3,1.30d3,6.54d2,3.77d2,1.79d2,6.82d1,1
     &     .89d1,1.24d0/

      
      Data eet/0.04d6,0.03d6,0.02d6,0.04d5,0.03d5,0.02d5,0.02d5,0
     &     .04d4,0.03d4,0.02d4,0.02d4,0.01d4,0.1d3,0.09d3,0.07d3,0
     &     .06d3,0.05d3,0.03d3,0.20d2,0.15d2,0.08d2,0.52d1,0.19d1
     &     ,0.31d0/
      
      
      Data bins/60.0,70.0,80.0,90.0,100.0,110.0,120.0,130.0,140.0
     &     ,150.0,160.0,170.0,180.0,190.0,200.0,210.0,220.0,230.0
     &     ,250.0,270.0,290.0,320.0,350.0,410.0,560.0/

      
      

      stater(1)=5.27200d5
      stater(2)=2.312d5
      stater(3)=1.128d5
      stater(4)=5.656d4
      stater(5)=3.104d4
      stater(6)=1.768d4
      stater(7)=1.016d4
      stater(8)=1.016d4
      stater(9)=6.16d3
      stater(10)=3.888d3
      stater(11)=2.456d3
      stater(12)=1.8d3
      stater(13)=1.206d3
      stater(14)=8.208d2
      stater(15)=6.15d2
      stater(16)=4.29d2
      stater(17)=3.223d2
      stater(18)=1.43d2
      stater(19)=7.194d1
      stater(20)=4.524d1
      stater(21)=3.327d1
      stater(22)=1.023d1
      stater(23)=3.213
      stater(24)=3.224d-1






      intiflag=iflag
      iproc=2



C     --- choose jet finder
      
      
      
      IF ((intiflag.gt.10).and.(MOD(intiflag,10).eq.1)) THEN
         chjet=INT(intiflag/10)
         intiflag=MOD(intiflag,10)
      ENDIF
      
      IF (intiflag.eq.1) THEN
C     *** Initialisation run ***
C     *** Create directories ***



         CALL HCDIR('//HISTO',' ')
         CALL HMDIR('h9807018','S')
         CALL HCDIR('//PAWC',' ')
         CALL HMDIR('h9807018','S')
         

C     open all the hbook's for generating the final histo for the
c     paper number hep-ex/9807018
         

c     CALL HBOOK1(2,'number of hits',50,0.0,600.0,0.0)
c     CALL HBOOK2(1,'ET(mi) vs ETjet',50,0.0,600.0,20,0.0
c     &     ,200.0,0.)
         CALL HBOOK1(10,'Monte Carlo rapidity',16 ,-4.0 ,4.0 ,0.)
         CALL HBOOKB(21,'MC Et',24,bins,0.)
         CALL HBOOKB(22,'MC Et',24,bins,0.) 
c     CALL HBOOKB(23,'MC Et',24,bins,0.)
         CALL HBOOKB(24,'X sec for Inclusive jets',24,bins,0.)
         CALL HBOOKB(25,'MC Et',24,bins,0.)
         CALL HBOOKB(30,'MC Et',24,bins,0.)    
         CALL HBOOKB(20,'MC Et',24,bins,0.)
         CALL HBOOKB(11,'Et with Ue subtracted Inclusive jets',24,bins,0
     &        .)

c     CALL HBOOK1(30,'Et_max',45.,50.0,500.0,0.)
         
         CALL hbookb(50,'Measured data DO for inc jets',24,bins,0.)
         CALL HBOOKB(23,'Xsec for Inclusive jets - UE',24,bins,0.)
         CALL HBOOKB(13,'Xsec for Inclusive jets-UE(D0)',24,bins,0.) 
         CALL HIDOPT(0,'stat')
         CALL HBARX(0)


         CALL HCDIR('//HISTO/h9807018',' ')
         CALL HCDIR('//PAWC/h9807018',' ')
         


C     --- basic cuts for rapidity plots
         Etcut(1)=60.0
         rapcut(1)=-0.5   
         rapcut(2)=0.5

C     --- standard cone radius is 1.0
         CONER=0.7
         CALL HZJETRAD(1,CONER) 
         IF (CONER.lt.0.0) THEN
            CONER=0.7
         ENDIF
         CALL HZJTNAME(chjet,jetf)
         
         WRITE(6,*)'**********************************************'
         WRITE(6,*)'*   HZEVT called, histograms will be output. *'
         WRITE(6,*)'*     Jet finder selected : ',jetf,'           *'
         WRITE(6,1001)'*        with cone radius : ',CONER,'   *'
         WRITE(6,*)'**********************************************'
         
 1001    FORMAT(A29,F5.2,A13)
         
      ELSE IF (intiflag.eq.2) THEN


C     *** Filling runs ***
         
C     *** Change directory to our graphs ***
         
         
         CALL HCDIR('//PAWC/h9807018',' ')
         
         CALL hzjtfind(chjet,CONER,NJET,Jets)

*         write(*,*) 'inc d0: njet =',njet

C     ******Initilasing  all  array to 0.

         DO  m=1,50
            
            Et3(m)=0.0   
c     Ei(m)=0.0
c     Ri(m)=0.0
            rap(m)=0.0
            
         ENDDO  

         IF (NJET.ge.1) then

            DO loop=1,NJET
               
               Et3(loop)=Jets(loop,3)
               rap(loop)=Jets(loop,1)
*               write(*,*) et3(loop),rap(loop)

            ENDDO 

            DO loop2=1,NJET
               
               IF ((Et3(loop2).ge.Etcut(1)).and.((rap(loop2).ge.rapcut(1
     &              )).and.(rap(loop2).le.rapcut(2)))) then
                  
                  
                  ETUE=(Et3(loop2)-0.904386)
                  
                  CALL hfill(21,real(Et3(loop2)),0.,wtx)
                  CALL hfill(11,real(EtUE),0.,wtx)

               END IF
               
            END DO
            
         END IF
         
      ELSE IF (intiflag.eq.3) THEN

         write(*,*) 'finishing up d0 inc.'
C     *** Termination run ***
C     *** Change directory ***
         CALL HCDIR('//PAWC/h9807018',' ')
C     *** Finish off histograms ***
         
         DO loop4=1,17
            
            norm(loop4)=(1.0/((Ntot/(Xsec*1.d6))*10.0))

         END DO  

         norm(18)=(1.0/((Ntot/(Xsec*1.d6))*20.0))
         norm(19)=(1.0/((Ntot/(Xsec*1.d6))*20.0))
         norm(20)=(1.0/((Ntot/(Xsec*1.d6))*20.0))
         norm(21)=(1.0/((Ntot/(Xsec*1.d6))*30.0))
         norm(22)=(1.0/((Ntot/(Xsec*1.d6))*30.0))
         norm(23)=(1.0/((Ntot/(Xsec*1.d6))*60.0))
         norm(24)=(1.0/((Ntot/(Xsec*1.d6))*150.0))

         do loop4 = 1, 24
            norme(loop4) = 0.
         end do

c     *********this part will generate  histo with real data***********
         
         DO up=1,24

            eet(up)=sqrt(eet(up)**2+stater(up)**2)

            
         END DO     

c     write(*,*)'UJA'

c     this call is for histo with diff bins width****
         
c     CALL hbookb(50,'realdata',24,bins,0.)
         
c     CALL HBOOKB(23,'Normalisation values',24,bins,0.)
         
         CALL HPAK(23,norm)
         CALL HPAKE(23,norme)
         
         CALL HOPERA(23,'*E',21,24,1.0,1.0) 

         CALL HOPERA(23,'*E',11,13,1.0,1.0)

         CALL hpak(50,et)
         
         CALL hpake(50,eet)
         


c     ****************************************************************
c     end of histo *********************        
******************************************************************
******************************************************************

         
         IF (Xsec.eq.0) THEN
            write(*,*)
     $           'H9807018: termination called with zero cross section'
            write(*,*),'          cross section graph meaningless'
            Xsec=1
         ENDIF
         IF (Ntot.eq.0) THEN
            write(*,*
     $           )'H9807018: termination called with no total events'
            write(*,*)'          cross section graph meaningless'
            Ntot=1
         ENDIF
         
C     --- store Xsec and Ntot for both direct and resolved events.
         
         mhXsec(iproc)=Xsec
         mhntot(iproc)=Ntot

      ELSE

c     *** End ****

         Write(*,*
     $        )'H9807018: Please run routine with iflag set to 1,2 or 3'
         
      ENDIF

      RETURN

      END 
     
