*****************************************************************************
 
 
 
 
 
 
 
********************************************
* SUBROUTINES used by subroutine Hz97098 : *
********************************************
 
 
      subroutine H1means (id, chtitl, ncx, xbins, n, ae, ye)
*****************************************************************************
*     Subroutine H1means builds up 3 histos with H1 data:
*       Histo-ID = - id        for combined errors (ce)
*                = - (100+id)  for statist. errors (ae) only
*                = - (200+id)  for syst. errros (ye) only
*
 
      Implicit None
 
      Integer      id, ncx, i
      Real         n, ae, ye, xbins
      Real         ce(20)
      Character*80 chtitl
      Dimension xbins(ncx+1)
      Dimension n(ncx)
      Dimension ae(ncx)
      Dimension ye(ncx)
 
      do i = 1, ncx
         ce(i) = sqrt( ae(i)**2. + ye(i)**2. )
      enddo
 
      call hbookb(-id, chtitl, ncx, xbins, 0.)
      call hpak(-id, n)
      call hpake(-id, ce)
 
      call hbookb(-100-id, chtitl, ncx, xbins, 0.)
      call hpak(-100-id, n)
      call hpake(-100-id, ae)
 
      call hbookb(-200-id, chtitl, ncx, xbins, 0.)
      call hpak(-200-id, n)
      call hpake(-200-id, ye)
 
      end
