*CMZ :  1.00/02 12/03/96  18.14.49  by  Tancredi Carli
*CMZ :  0.00/01 03/01/96  12.05.22  by  HZtool
*-- Author :
       Subroutine Hzboost(dbex,dbey,dbez,p,pnew)
C#*****************************************************************
C#
C#  HZBOOST : Performs Lorentz boosts of given 4-momentum-vector
C#
C#  PURPOSE : Performs Lorentz boosts of given 4-momentum-vector
C#
C# INPUT :
C#   BEX, BEY, BEZ  =
C#        gives the direction and size, beta, of a
C#         Lorentz boost, such that a particle initially at rest
C#       will  have p/E = beta afterwards
C#
C#    P             =  is the vector to be acted upon
C#
C#  OUTPUT :
C#   PNEW           =  is the boosted vector
C#
C# Author: LUROBO in JETSET (modified by N Brook)
C#
C#*****************************************************************
       Implicit Double Precision (A-H,O-Z)
       Dimension dp(4), p(4), pnew(4)
       do ivec = 1, 4
          pnew(ivec) = p(ivec)
       enddo
       IF(dBEX**2+dBEY**2+dBEZ**2.GT.1d-20) THEN
C...LORENTZ BOOST (TYPICALLY FROM REST TO MOMENTUM/ENERGY=BETA)
        DGA=1D0/SQRT(1D0-DBEX**2-DBEY**2-DBEZ**2)
        DBEP=DBEX*P(1)+DBEY*P(2)+DBEZ*P(3)
        DGABEP=DGA*(DGA*DBEP/(1D0+DGA)+P(4))
        PNEW(1)=P(1)+DGABEP*DBEX
        PNEW(2)=P(2)+DGABEP*DBEY
        PNEW(3)=P(3)+DGABEP*DBEZ
        PNEW(4)=DGA*(P(4)+DBEP)
      ENDIF
      RETURN
      END
