*CMZ :  1.00/02 12/03/96  19.08.32  by  Tancredi Carli
*CMZU:  0.00/04 26/01/96  11.59.05  by  Tancredi Carli
*CMZ :  0.00/01 05/01/96  18.26.42  by  HZtool
*-- Author :
      Subroutine HZBRTINI(pbeam,pgam,Ierr)
C#*****************************************************************
C#      Subroutine HZBRTINI(pbeam,pgam,Ierr)
C#      Entry HZBRT(p,pnew,Ierr)
C#
C# HZBRTINI/HZBRT (entry point) : Lorentz boost to Breit frame
C# PURPOSE : Lorentz boost to Breit frame
C#
C# INPUT :
C#   PBEAM    =  the 4 vector of the proton beam
C#   PGAM     =  the 4 vector of the virtual exchanged boson
C#   P        =   the vector to be acted upon
C# OUTPUT :
C#   PNEW     =  the boosted vector
C#   IERR     =  an error flag (1 = failed)
C#
C# HZBRTINI - called once an event to set up boost and rotation
C#          variables
C# HZBRT  - perform the actual boost of particles
C#
C# Author: N Brook
C#
C#*****************************************************************
*
      Implicit Double Precision (A-H,O-Z)
*
#include "hzfunc.inc"
*
      Dimension pbeam(4), pgam(4)
      Dimension p(4), phcm(4), pnew(4),phcm3(3)
      Dimension Robo(3)
      Logical Lboost
      Parameter(pi=3.141592654)
*
      Ierr = 1
      gammas = pgam(4)**2 - pgam(3)**2 - pgam(2)**2 - pgam(1)**2
      if(gammas.ge.0.0) Return
      xb = -gammas/2./(pgam(4)*pbeam(4)-pgam(3)*pbeam(3))
      if(xb.gt.1.0.or.xb.lt.0.0) Return
* set up boost parameters
      do 5 ivec = 1, 3
 5    robo(ivec) = (pgam(ivec)+2.*xb*pbeam(ivec))/
     &             (pgam(4)+2.*xb*pbeam(4))
*
*     chksq = vdot(robo,robo,3)
*     If(chksq.gt.1.) Return
* ... and necessary rotation angles
      call hzboost(-robo(1),-robo(2),-robo(3),pgam,phcm)
      theta = HZPHMANG(phcm(3),sqrt(phcm(2)**2+phcm(1)**2))
      phi   = HZPHMANG(phcm(1),phcm(2))
*
      Ierr = 0
      Return
*
      Entry HZBRT(p,pnew,Ierr)
*
      Ierr = 1
* boost and rotate particle to Breit frame
      call hzboost(-robo(1),-robo(2),-robo(3),p,phcm)
      Do 6 ivec=1,3
 6    phcm3(ivec)=phcm(ivec)
      call hzphmrot(-phi,0.d0,phcm3,phcm3)
      call hzphmrot(0.d0,pi-theta,phcm3,phcm3)
      Do 7 ivec=1,3
 7    phcm(ivec)=phcm3(ivec)
      Do ivec = 1, 4
         pnew(ivec) = phcm(ivec)
      enddo
*
      Ierr = 0
      Return
      End
