      FUNCTION HzDEta (ipart1,ipart2)
************************************************************************
*     input:  ipart1:        index of particle 1 in HEP common
*     input:  ipart2:        index of particle 2 in HEP common
*
*     return value: eta between particles 
*     
*     written by: Oliver Gutsche
************************************************************************
      IMPLICIT NONE
 
#include "hepevtp.inc"
#include "hzfunc.inc"
 
      Integer ipart1,ipart2

      DOUBLE PRECISION eta1,eta2,deta
 
*     check particle index
      if ((ipart1.lt.1).or.(ipart1.gt.NHEP).or.
     &     (ipart2.lt.1).or.(ipart2.gt.NHEP)) then
         deta = 0.D0
      else

*     get eta for particles
         eta1 = HZETA(ipart1)
         eta2 = HZETA(ipart2)

*     calculate difference 1 -> 2
         
         deta = ABS(eta1-eta2)
      endif

      HzDEta = deta
 
      RETURN
      END
















