*CMZ :  1.01/05 20/08/96  10.38.59  by   Tancredi Carli
*CMZU:  0.00/04 26/01/96  12.00.37  by  Tancredi Carli
*CMZ :  0.00/01 05/01/96  14.11.56  by  HZtool
*-- Author :
      Function Hzdiskin(Itype)
**********************************************************
* Purpose:
* Return DIS kinem. variables
* Input:
* If Itype = 1 -> Q2
*    itype = 2 -> xbj
*    itype = 3 -> ybj
*    itype = 4 -> W2
* Author: N. Brook
**********************************************************
*
      Implicit Double Precision (A-H,O-Z)
*
#include "hepevtp.inc"
#include "hzfunc.inc"
#include "heracmn.inc"
*
      Dimension pgam(5), pbeam(5)
      Integer iel,idum
*
      hzdiskin = -1.
*
      Jgam = hzipgam(pgam)
      if(jgam.ne.1) Then
       Write(6,*) 'HZDISKIN: No record of virt. photon found'
       Return
      endif
*
      kbeam = hzibeam(ip,il)
      If(kbeam.ne.1) Then
        Write(6,*) 'HZDISKIN: No record of beam particles'
        Return
      Endif
*
*

c      write(6,*) ' in hzdiskin ', il,ip
c      write(6,*) ' pgam ',(pgam(i),i=1,4)
      q2 = -(pgam(4)**2-pgam(3)**2-pgam(2)**2-pgam(1)**2)
      xbj = q2/2./
     +      (phep(4,ip)*pgam(4) - phep(3,ip)*pgam(3)
     1        -phep(2,ip)*pgam(2) - phep(1,ip)*pgam(1))
      cms = (phep(4,ip)+phep(4,il))**2
     +      - ((phep(3,ip)+phep(3,il))**2
     1         +(phep(2,ip)+phep(2,il))**2
     2         +(phep(1,ip)+phep(1,il))**2)
      If(itype.eq.1) Then
        hzdiskin = q2
      else if(itype.eq.2) then
        hzdiskin =xbj
      else if(itype.eq.3) then
        hzdiskin = q2/xbj/cms
      else if(itype.eq.4) then
        hzdiskin = q2*(1.-xbj)/xbj + phep(5,ip)**2
      else
        write(6,*) ' HZDISKIN: itype should be in range 1-4'
      endif
*
      return
      end
