*CMZ :  2.00/00 13/08/99  15.28.14  by  Tancredi Carli
*-- Author :
*-- Author :
      Function Hzeebeam(i1,i2)
*******************************************************
* Purpose:
* Find posn of electron and positron beam
* returns
* If find both beams Hzeebeam = 1
* if find only electron beam Hzeebeam = -1
* if find only positron beam Hzeebeam = 0
* Input: none
* Output: i1 pointer to electron
*         i2 pointer to positron
*
* Author: N. Brook
* PHOJET mods : M. Hayes
* Gen="POM" added by H. Jung
* PYTHIA and PHOJET mode: J.Elmsheuser
*
* last change: 02 Aug 99
*******************************************************
      Implicit Double Precision (A-H,O-Z)
      Logical  lelec,lposi,lp
      Data lp/.false./
*
#include "hepevtp.inc"
#include "heracmn.inc"
#include "hzfunc.inc"
*
      hzeebeam = -2
      lelec  = .false.
      lposi  = .false.
      i1=-1
      i2=-1

      If(gen(1:3).eq.'HRW' .or.gen(1:3).eq.'INS' ) Then
        Do Ihep = Nhep,1,-1
          if (lp) then
            write(6,'(A,4F9.3,a,i4,a,i4)') '**hzeebeam: HRW= ',
     +           (PHEP(i,ihep),i=1,4),' ist= ',
     +           Isthep(ihep),' idhep= ',idhep(ihep)
          endif
          If((Isthep(ihep).eq.101.or.Isthep(ihep).eq.102)
     +         .and.idhep(ihep).eq.11) Then
            i1 = ihep
            hzeebeam = hzeebeam + 1
          else If((Isthep(ihep).eq.101.or.Isthep(ihep).eq.102)
     +           .and.idhep(ihep).eq.-11) Then
            i2 = ihep
            hzeebeam = hzeebeam + 2
          Endif
          If(hzeebeam.eq.1) Return
        Enddo
      ElseIf ((gen(1:3).eq.'PYT').or.(gen(1:3).eq.'PHO')) Then
        IF ((idhep(1).eq.11).and.(idhep(2).eq.-11)) Then
          i1 = 1
          i2 = 2
          hzeebeam = hzeebeam + 3
        ElseIf ((idhep(1).eq.-11).and.(idhep(2).eq.11)) Then
          i1 = 2
          i2 = 1
          hzeebeam = hzeebeam + 3
        ElseIf ((idhep(1).eq.11).and.(idhep(2).ne.-11)) Then
          i1 = 1
          hzeebeam = hzeebeam + 1
        ElseIf ((idhep(1).eq.-11).and.(idhep(2).ne.11)) Then
          i1 = 2
          hzeebeam = hzeebeam + 2
        ElseIf ((idhep(2).eq.11).and.(idhep(1).ne.-11)) Then
          i2 = 1
          hzeebeam = hzeebeam + 1
        ElseIf ((idhep(2).eq.-11).and.(idhep(1).ne.11)) Then
          i2 = 2
          hzeebeam = hzeebeam + 2
        Endif
        If(hzeebeam.eq.1) Return
      Else
        write(6,*) '**hzeebeam: generator not found gen=',gen
      Endif
*
      Return
      End
