**********************************************************   
* This Subroutine finds the "sons" of a D* particle (decay 
*  product particles) 

      Subroutine HZFillsSub(NumD, Part, CountP)
      IMPLICIT NONE

* HEP event prime common
* (for explanation see manual)
      Integer NMXHEP
      PARAMETER (NMXHEP=4000)
      Integer NEVHEP,NHEP,ISTHEP,IDHEP
      Integer JMOHEP,JDAHEP
      Double Precision PHEP,VHEP
      COMMON/HEPEVTP/NEVHEP,NHEP,ISTHEP(NMXHEP),IDHEP(NMXHEP),
     & JMOHEP(2,NMXHEP),JDAHEP(2,NMXHEP),PHEP(5,NMXHEP),VHEP(4,NMXHEP)
*

      Integer I, J, JJ, Count, CountP, NumD, Again
      Integer Mare(NHEP), Fills(NHEP), Part(NHEP)
      
      integer ilooptt
      Again = 1	
      CountP = 0
      Mare(1) = NumD
      JJ = 1
      
      ilooptt=0
      Do While (Again.eq.1)       
         ilooptt=ilooptt+1
         if(ilooptt.gt.NHEP) then
            write(6,*) 'HZTOOL warning in HZFILLSSUB:'
            write(6,*) 'No stable D* daughters found'
            return
         endif
	 Again = 0
* Loop over all Mothers founded    
         Count = JJ      
         JJ = 0 
	 Do I=1, Count
            If (ISTHEP(Mare(I)).gt.1) Then
               Do J=JDAHEP(1,Mare(I)), JDAHEP(2,Mare(I))
                  JJ = JJ  + 1
                  Fills(JJ) = J
                  Again = 1
               End Do  
            Else
               If (ISTHEP(Mare(I)).eq.1) Then     
                  CountP = CountP + 1 
                  Part(CountP)=Mare(I)
               End If
            End If     	        
	 End Do	 
	 Do J=1, JJ
            Mare(J) = Fills(J)
	 End Do
         ilooptt=ilooptt+1
         if(ilooptt.gt.NHEP) then
            write(6,*) 'HZTOOL warning in HZFILLSSUB:'
            write(6,*) 'No stable D* daughters found'
            return
         endif
      End Do	 

* NumD  : number of the D* particle on the PHEP List       
* CountP: number of stable particles from D* decay.
* Count : number of daughters (decayed particles) found in an iteration 
*     and to be checked if they are stable or if the have also 
*     decayed into new particle.
* Fills():D* decay particles. This will be stored in Mare() to be checked 
*     in the next iteration if they also decay.
      
      Return
      End
