       subroutine hzgetvar(pcm,p,pt,et,th,ph,rap,err_flag)
***********************************************************
*      Input: pcm  - 4 vector
*
*      Output: p   - momentum
*              pt  - transverse momentum
*              et  - transverse energy
*              th  - theta
*              ph  - phi
*              rap - rapidity
***********************************************************
       implicit none

       double precision   pcm(4)
       real   p,pt,et,th,ph,rap
       integer err_flag
       real qpi,qqradP,rd
#include "hzfunc.inc"
*
       Qpi = 4.*atan(1.)
       qqradp = 180./qpi
       rd = qqradp
           err_flag = 0
           p      = real(sqrt(pcm(1)**2+pcm(2)**2+pcm(3)**2 ))
           pt     = real(sqrt( pcm(1)**2+pcm(2)**2 ))
           if (p.eq.0.) then
c            write(6,*) xxxx,' p = ',p
            err_flag = -1
           else
            et     = real(pcm(4)) * pt / p
            th     = (acos(real(pcm(3))/p))
            ph     = HZPHMANG(pcm(1),pcm(2))
            if (abs(     th*rd).lt.1.e-4 .or.
     &          abs(180.-th*rd).lt.1.e-4 ) then
C             write(6,*) xxxx,' th = ',th
             err_flag = -2

            else
             rap    = -log(tan( th/2. ))
*                                            check on rap=nan (e.g. pt=0)

              if (rap.ne.rap) then
               write(6,*),'Warning:  rap = ',rap,' th= ',th*rd,
     &         ' particle skipped ! '

               err_flag = -3
              endif
            endif
           endif
        return
        end


