*CMZ :  1.01/15 02/09/98  14.06.34  by  Tancredi Carli
*-- Author :
      SUBROUTINE HZHADGAP(xmas,ymas,xpom,t)
      IMPLICIT NONE
* Reconstruct the hadronic final state at the
* (generated)  hadron level following the H1 definition of diffraction
* presented at  Eilat 1995. In this scheme the hadronaic final state is
* separated into two systems ep--->eXY where X (the diffractive system) and
* Y (the proton dissociation system) are separated by the largest gap in
* rapidity in the event. This definition works for all processes and
* diffractive and non-diffractive.
* GAP NOW FOUND IN GAMMA PROTON CMS SYSTEM
*
#include "hzfunc.inc"
#include "hzhbook.inc"
#include "hepevtp.inc"
#include "heracmn.inc"
* New ! Two systems X and Y are collected into two 4-vectors
* PMX and IPMY
*   GAGOBJ = 1 if object in X
*   GAGOBJ = 2 if object in Y
*   GAGOBJ = 0 Problem !
*
*
      Double precision pbeam(4),pgam(4),pcm(5),ph(5),pboost(5,NMXHEP)
      Double precision pmx(5),pmy(5),pstore(5,nmxhep)
*
      Integer i,ihep
      Real pi,rd,eb,ee
      Parameter (ee=27.5)
      Integer iel,idum,ip,ie
      Parameter (pi=3.1415927,rd=180./pi)
* Also Complete 4-vector of hadronic final state is given
* maximum number of objects in event
      REAL DUM,GAPTEST
      LOGICAL FLAG
      Integer max_nobj,max_gobj,iobj,ibobj,ierr,iog,ii,k,iround
      Integer nogag,npgag,nngag
      real gagobj,etamx,etamy,rapgug,rapglg,grapg,gapg
      real etamyg,etamxg,eyg,pxyg,pyyg,pzyg,pxxg,pyxg,pzxg,exg
      real smygag,smxgag,fac,ptchk,small
      Parameter (small=1.e-3)
      Real x,y,q2
      Double precision ehg,pxhg,pyhg,pzhg
      PARAMETER(MAX_GOBJ=5000)
      PARAMETER(MAX_NOBJ=5000)
      DIMENSION IOBJ(MAX_NOBJ),IBOBJ(MAX_NOBJ),GAGOBJ(MAX_NOBJ)
      REAL ARR(4)
      DOUBLE PRECISION EXGD,PXXGD,PYXGD,PZXGD
      DOUBLE PRECISION EYGD,PXYGD,PYYGD,PZYGD
      DOUBLE PRECISION EHGD,PXHGD,PYHGD,PZHGD
*
      Real xmas,ymas,t,xpom
      Real mxgag,mygag
*
      double precision qp,qx,qy,qz,qe,qm,qch,qth,qrap
      Integer ki
      double precision qpb,qxb,qyb,qzb,qeb,qmb,qthb,qrapb
* common that gives the position of particles in X and Y system
      integer nxobj,nyobj,nxgag,nygag
      double precision pom
      common /diffhad/pom(5),nxobj(5000),nyobj(5000),nxgag,nygag

      QP  (KI)=PHEP(4,KI)
      QX  (KI)=PHEP(1,KI)
      QY  (KI)=PHEP(2,KI)
      QZ  (KI)=PHEP(3,KI)
      QE  (KI)=PHEP(4,KI)
      QM  (KI)=PHEP(5,KI)
      QCH (KI)=Ihchrg(KI)
      QPB  (KI)=Pboost(4,KI)
      QXB  (KI)=Pboost(1,KI)
      QYB  (KI)=Pboost(2,KI)
      QZB  (KI)=Pboost(3,KI)
      QEB  (KI)=Pboost(4,KI)
      QMB  (KI)=Pboost(5,KI)

      QTH(KI)=DACOS(QZ(KI)/DMAX1(QP(KI),DABS(QZ(KI))))
      QRAP(KI)=0.5D0*(DLOG(DMAX1(0.0000001D0,QE(KI)+QZ(KI))) -
     +              DLOG(DMAX1(0.0000001D0,QE(KI)-QZ(KI))))
      QTHB(KI)=DACOS(QZB(KI)/DMAX1(QPB(KI),DABS(QZB(KI))))
      QRAPB(KI)=0.5D0*(DLOG(DMAX1(0.0000001D0,QEB(KI)+QZB(KI))) -
     +              DLOG(DMAX1(0.0000001D0,QEB(KI)-QZB(KI))))
      do i=1,nhep
         do k=1,5
            pstore(k,i)=phep(k,i)
         enddo
      enddo
      MXGAG=0.0
      MYGAG=0.0
      T=0.0
      EHGD=0.0D0
      PXHGD=0.0D0
      PYHGD=0.0D0
      PZHGD=0.0D0
      EHG=0.0D0
      PXHG=0.0D0
      PYHG=0.0D0
      PZHG=0.0D0
      IOG =0
      do i=1,5
         pmx(i)=0.
         pmy(i)=0.
      enddo
      ierr=HZIBEAM(ip,ie)
      if (.not.(ierr.eq.1)) then
         write(6,*) 'HZHADGAP beams not found ! '
         return
      else
         Do i=1,4
            pbeam(i)=PHEP(i,ip)
         enddo
      endif
      ierr=HZIPGAM(ph)
      if (ierr.eq.-1) then
         write(6,*) 'HZHADGAP boson vector not found ! '
C        call VZERO(ph,5)
        Do i=1,5
         ph(i)=0.
        enddo
      else
         Do i=1,4
            pgam(i)=ph(i)
         enddo
      endif
*
      iel=HZIDELEC(idum)
      if (iel.eq.-1) then
         write(*,*) 'Hz electron not found '
         return
      endif
*
      call HZHCMINI(pbeam,pgam,ierr)
      if (ierr.eq.1) then
         write(6,*) 'HZHADGAP problem with boost to cms ! ', ierr
         return
      endif
*      call hzlulist(1)
      DO I=1,Nhep
*     Reject if not stable...
         IF(isthep(i).ne.1) GOTO 10
         if(iel.eq.i) goto 10
         if(ip.eq.i) goto 10
         if(ie.eq.i) goto 10
* fill an array with phan vetors of the hadronic final state
*   (used subsequently for sorting)
* do not select scattered electron
* JPP - 23/04/96 - Do not include Electron or Photon
         IF(IOG.LT.MAX_GOBJ)THEN
* Make 4-vector of hadronic final state
* Make complete hadronic final state 4 vector
            EHGD=EHGD+PHEP(4,I)
            PXHGD=PXHGD+PHEP(1,I)
            PYHGD=PYHGD+PHEP(2,I)
            PZHGD=PZHGD+PHEP(3,I)
* Boost vector into gamma*-proton cms
            Do ii=1,4
               Ph(ii)=PHEP(ii,i)
            enddo
            call HZHCM(ph,pcm,ierr)
            if (ierr.eq.1) then
               write(6,*) 'HZHADGAP problem with boost to cms ! '
               return
            endif
            Do ii=1,4
               pboost(ii,i)=pcm(ii)
            enddo
c revert z axis to coincide with rapidity definition
            pboost(3,i)=-pcm(3)
            IOG=IOG+1
            IOBJ(IOG)=I
            IBOBJ(IOG)=I
         ENDIF
   10    CONTINUE
      ENDDO
*      write(6,*) ' IOG ',IOG,(IOBJ(I),I=1,IOG)
      EHG=SNGL(EHGD)
      PXHG=SNGL(PXHGD)
      PYHG=SNGL(PYHGD)
      PZHG=SNGL(PZHGD)
      IROUND=0
   20 FLAG=.FALSE.
      IROUND=IROUND+1
      DO I=1,IOG-1
         IF(QRAPB(IBOBJ(I+1)).LT.QRAPB(IBOBJ(I))) THEN
* add a small piece to rapgug to avoid precision problems
*         IF(QRAPB(IBOBJ(I+1)).LT.(QRAPB(IBOBJ(I))+SMALL)) THEN
            DUM=IOBJ(I+1)
            IOBJ(I+1)=IOBJ(I)
            IOBJ(I)=DUM

            DUM=IBOBJ(I+1)
            IBOBJ(I+1)=IBOBJ(I)
            IBOBJ(I)=DUM

            FLAG=.TRUE.

         ENDIF
      ENDDO
      IF(IROUND.GE.10000) then
         WRITE(6,*) ' hzhadgap: Something wrong with eta sorting'
         write(6,*) ' hzhadgap: IOG = ',IOG
         write(6,*) ' hzhadgap: IOBJ = ',(IOBJ(i),i=1,iog)
         write(6,*) ' hzhadgap: QRAPB = ',(QRAPB(IOBJ(i)),i=1,iog)

*        call hzlulist(1)
      endif
      IF(FLAG.AND.IROUND.LE.10001) GOTO 20
* Find largest gap
      GAPG=0.0
      RAPGLG=-8.0
      RAPGUG=-8.0
      DO I=1,IOG-1
         GAPTEST=QRAPB(IBOBJ(I+1))-QRAPB(IBOBJ(I))
*        write(6,*) ' gaptest',gaptest,gapg,ibobj(i)
         IF(GAPTEST.GT.GAPG)THEN
            GAPG=GAPTEST
            RAPGLG=QRAPB(IBOBJ(I))
            RAPGUG=QRAPB(IBOBJ(I+1))
*          write(6,*) 'rapgug ',rapgug,ibobj(i)
            ETAMXG=-LOG(TAN(QTH(IOBJ(I))/2))
            ETAMYG=-LOG(TAN(QTH(IOBJ(I+1))/2))
            IF(ETAMYG.GT.99.0) ETAMYG=99.0
            IF(ETAMXG.GT.99.0) ETAMXG=99.0
            IF(ETAMYG.LT.-99.0) ETAMYG=-99.0
            IF(ETAMXG.LT.-99.0) ETAMXG=-99.0
         ENDIF
      ENDDO
* Make hadronic final state considering only those particles with ETA<ETAGL
* JPP - Make 4-vectors from these two systems for external use
*     pmx
*     pmy
      EXG=0.0
      PXXG=0.0
      PYXG=0.0
      PZXG=0.0

      NOGAG=0

      EYG=0.0
      PXYG=0.0
      PYYG=0.0
      PZYG=0.0

      NYGAG=0
      NXGAG=0
      SMXGAG=0.0
      SMYGAG=0.0

* JPP Double precision for construction of X and Y
      EXGD=0.D0
      PXXGD=0.D0
      PYXGD=0.D0
      PZXGD=0.D0
      EYGD=0.D0
      PXYGD=0.D0
      PYYGD=0.D0
      PZYGD=0.D0
* subtract a small piece to rapgug to avoid precision problems
      RAPGUG=RAPGUG-SMALL
*      write(6,*) 'rapgug ',rapgug
      DO I=1,IOG
*        write(6,*) ' qrapb,rapgug',QRAPB(IBOBJ(I)),RAPGUG,IBOBJ(I)
         IF(QRAPB(IBOBJ(I)).LT.RAPGUG)THEN
            DO K=1,5
               PMX(K)=PMX(K)+phep(K,IOBJ(I))
            ENDDO
            GAGOBJ(I) = 1
C Now double precision
            EXGD=EXGD+phep(4,IOBJ(I))
            PXXGD=PXXGD+phep(1,IOBJ(I))
            PYXGD=PYXGD+phep(2,IOBJ(I))
            PZXGD=PZXGD+phep(3,IOBJ(I))
* Total charges of tracks
            IF(QCH(IOBJ(I)).EQ.0) NOGAG=NOGAG+1
            IF(QCH(IOBJ(I)).GT.0) NPGAG=NPGAG+1
            IF(QCH(IOBJ(I)).LT.0) NNGAG=NNGAG+1
            NXGAG = NXGAG + 1
            nxobj(nxgag)=IOBJ(I)
* Workout invariant mass in a method that is less sensitive to rounding
* errors. It unfortunately requires going through the particles twice
            SMXGAG=SMXGAG+phep(5,IOBJ(I))**2
*           write(6,*) ' check mx ',iobj(I)
            DO II=1,IOG
               IF(QRAPB(IBOBJ(II)).LT.RAPGUG.AND.II.NE.I)THEN
                  SMXGAG=SMXGAG+ PHEP(4,IOBJ(I))*phep(4,IOBJ(II))-
     +            PHEP(3,IOBJ(I))*phep(3,IOBJ(II))- PHEP(2,IOBJ(I))*
     +            phep(2,IOBJ(II))- PHEP(1,IOBJ(I))*phep(1,IOBJ(II)
     +            )
               ENDIF
            ENDDO
         ELSE
            DO K=1,5
               PMY(K)=PMY(K)+phep(K,IOBJ(I))
            ENDDO
            GAGOBJ(I) = 2
* Now double precision
            EYGD=EYGD+phep(4,IOBJ(I))
            PXYGD=PXYGD+phep(1,IOBJ(I))
            PYYGD=PYYGD+phep(2,IOBJ(I))
            PZYGD=PZYGD+phep(3,IOBJ(I))
            NYGAG=NYGAG+1
            nyobj(nygag)=IOBJ(I)
* Workout invariant mass in a method that is less sensitive to rounding
* errors. It unfortunately requires going through the particles twice
*          SMYGAG=SMYGAG+phep(5,IOBJ(I))**2
*           write(6,*) ' check my ',iobj(I)
            DO II=1,IOG
               IF(QRAPB(IBOBJ(II)).GT.RAPGLG.AND.II.NE.I)THEN
                  SMYGAG=SMYGAG+ PHEP(4,IOBJ(I))*phep(4,IOBJ(II))-
     +            PHEP(3,IOBJ(I))*phep(3,IOBJ(II))- PHEP(2,IOBJ(I))*
     +            phep(2,IOBJ(II))- PHEP(1,IOBJ(I))*phep(1,IOBJ(II)
     +            )
               ENDIF
            ENDDO
         ENDIF
      ENDDO
* Make invariant masses of X and Y systems
      IF(SMXGAG.GT.0)THEN
         MXGAG = SQRT(SMXGAG)
      ELSE
         MXGAG = 0.0
      ENDIF
      IF(SMYGAG.GT.0)THEN
         MYGAG = SQRT(SMYGAG)
      ELSE
         MYGAG = 0.0
      ENDIF
*      write(6,*) ' mx',pmx(4)**2-pmx(1)**2-pmx(2)**2-pmx(3)**2
*      write(6,*) 'mxgag ',mxgag**2
*      write(6,*) ' my',pmy(4)**2-pmy(1)**2-pmy(2)**2-pmy(3)**2
*      write(6,*) 'mygag ',mygag**2

* Check masses
      IF(NYGAG.EQ.1) THEN
         DO I=1,IOG
            IF(GAGOBJ(I).EQ.2) THEN
               MYGAG = QM(IOBJ(I))
            ENDIF
         ENDDO
         IF(MYGAG.LT.0.1) MYGAG=0.1
      ENDIF
      IF(NXGAG.EQ.1) THEN
         DO I=1,IOG
            IF(GAGOBJ(I).EQ.1) THEN
               MXGAG = QM(IOBJ(I))
            ENDIF
         ENDDO
         IF(MXGAG.LT.0.1) MXGAG=0.1
      ENDIF
      PMX(5)=MXGAG
      PMY(5)=MYGAG
      ymas = mygag
      xmas = mxgag

* Get squared momentum transfer at proton vertex
      IF(ip.NE.0) THEN
         t =(phep(4,ip)-PMY(4))**2 -(phep(1,ip)-PMY(1))**2 -
     +   (phep(2,ip)-PMY(2))**2 -(phep(3,ip)-PMY(3))**2
*         t =phep(5,ip)**2 -
*     &    2.d0*(phep(4,ip)*PMY(4) - phep(1,ip)*PMY(1) -
*     &    phep(2,ip)*PMY(2) - phep(3,ip)*PMY(3)) + PMY(5)**2
      ELSE
         WRITE(6,*) 'No hadron beam particle'
         t = 0.0
      ENDIF


* Boost objects into gamma*-pom centre of mass system now that
* kinematics known
      q2=real(HZDISKIN(1))
      y =real(HZDISKIN(3))
      FAC = 4.*real(phep(4,ie))*real(phep(4,ip))*Y
      IF(FAC.GT.0.) THEN
* Create pseudo-pomeron = proton 4-vector * xpgag
* Create vector for "pomeron" = p - Y
         Do I=1,4
            pom(i) = phep(i,ip) - pmy(i)
         enddo

         xpom = (Q2+MXGAG**2-T)/FAC

      ENDIF
      if(xpom.lt.0.0.or.xpom.gt.1.) then
c       write(6,*) ' hzhadgap: xpom=',xpom,' t = ',t,' m_x=',xmas,ymas
c       write(6,*) ' hzhadgap: y=',y
c       write(6,*) ' hzhadgap: e-beam',real(phep(4,ie))
c       write(6,*) ' hzhadgap: p-beam',real(phep(4,ip))
         xpom=1.

      endif
*      write(6,*) ' hzhadgap: xpom=',xpom,' t = ',t,' m_x=',xmas,ymas
*      call hzlulist(1)
* Check PT
      PTCHK = SQRT((PXXG+PXYG)**2+(PYXG+PYYG)**2)
      do i=1,nhep
         do k=1,5
            phep(k,i)=pstore(k,i)
         enddo
      enddo
      RETURN
      END
