      Function Hzibeam(ip,il)
*******************************************************
* Purpose:
* Find posn of proton and lepton beam
* returns
* If find both beams Hzibeam = 1
* if find only lepton beam Hzibeam = 0
* if find only proton beam Hzibeam = -1
* Input: none
* Output: ip pointer to proton
*         il pointer to lepton
*
* Author; N. Brook
* PHOJET mods : M. Hayes
* Gen="POM" added by H. Jung
*******************************************************
      Implicit Double Precision (A-H,O-Z)
      Logical  llep,lprot,lp
      Data lp/.false./
*
#include "hepevtp.inc"
#include "heracmn.inc"
#include "hzfunc.inc"
*
c      write(6,*) ' enter hzibeam'
      hzibeam = -2
      llep  = .false.
      lprot = .false.
      ip=-1
      il=-1
      If(gen(1:3).eq.'PYT'.or.gen(1:3).eq.'LEP'.or.gen(1:3).eq.'ARI'
     & .or.gen(1:3).eq.'LEG' .or.gen(1:3).eq.'RAP'.or.gen(1:3).eq.'CAS'
     & .or.gen(1:3).eq.'RID'.or.gen(1:3).eq.'DSN' 
     & .or.gen(1:3).eq.'SHA')Then
c     JMB important to loop upwards, otherwise you get the wrong
c     electron in photoproduction.
       Do Ihep = 1,Nhep,1
C*TC
c         write(6,*) ' ihep = ',ihep,' ist= ',Isthep(ihep),
c     &   ' id= ',idhep(ihep)
*
         If(Isthep(ihep).eq.3
     +      .and.idhep(ihep).eq.2212) Then
           ip = ihep
           hzibeam = hzibeam + 1
         Else if(Isthep(ihep).eq.3
     +           .and.abs(idhep(ihep)).eq.11) Then
           il = ihep
           hzibeam = hzibeam + 2
         Endif
         If(hzibeam.eq.1) Return
       Enddo
CTW-120697->
      else if(gen(1:3).eq.'DJA') then
****** e+/- should be particle 1, the proton part. 2
         if (idhep(2).eq.2212) then
            ip = 2
            hzibeam = hzibeam + 1
         endif
         if (abs(idhep(1)).eq.11) then
            il = 1
            hzibeam = hzibeam + 2
         endif
         if(hzibeam.eq.1) return
CTW<-120697-
      Else If(gen(1:3).eq.'HRW' .or.gen(1:3).eq.'INS' ) Then
       Do Ihep = Nhep,1,-1
         if (lp) then
          write(6,'(A,4F9.3,a,i4,a,i4)') '**hzibeam: HRW= ',
     +    (PHEP(i,ihep),i=1,4),' ist= ',
     +    Isthep(ihep),' idhep= ',idhep(ihep)
         endif
         If((Isthep(ihep).eq.101.or.Isthep(ihep).eq.102
     +   .or.Isthep(ihep).eq.201.or.Isthep(ihep).eq.202)
     +      .and.idhep(ihep).eq.2212) Then
           ip = ihep
           hzibeam = hzibeam + 1
         else If((Isthep(ihep).eq.101.or.Isthep(ihep).eq.102
     +   .or.Isthep(ihep).eq.201.or.Isthep(ihep).eq.202)
     +      .and.abs(idhep(ihep)).eq.11) Then
           il = ihep
           hzibeam = hzibeam + 2
         Endif
c	   write(6,*) ' for herwig ',hzibeam,Isthep(ihep),idhep(ihep)
         If(hzibeam.eq.1) Return
       Enddo
c	   write(6,*) ' for herwig ',hzibeam
      Else If(gen(1:3).eq.'PHO') Then
* Trivial since the Proton should be particle 1, e+/- part. 2
	IF (idhep(1).eq.2212) Then
           ip = 1
           hzibeam = hzibeam + 1
         Endif
        If (abs(idhep(2)).eq.11) Then
           il = 2
           hzibeam = hzibeam + 2
         Endif
         If(hzibeam.eq.1) Return
      Else If(gen(1:3).eq.'POM') Then
* Trivial since the Proton should be particle 1, e+/- part. 2
	IF (idhep(1).eq.2212) Then
           ip = 1
           hzibeam = hzibeam + 1
         Endif
        If (abs(idhep(2)).eq.11) Then
           il = 2
           hzibeam = hzibeam + 2
         Endif
         If(hzibeam.eq.1) Return
      Else If(gen(1:3).eq.'SMA') Then
* Trivial since the Proton should be particle 2, e+/- part. 1
	IF (idhep(2).eq.2212) Then
           ip = 2
           hzibeam = hzibeam + 1
         Endif
        If (abs(idhep(1)).eq.11) Then
           il = 1
           hzibeam = hzibeam + 2
         Endif
         If(hzibeam.eq.1) Return
      Else If(gen(1:3).eq.'HO1') Then
* Trivial since the Proton should be particle 2, e+/- part. 1
	IF (idhep(2).eq.2212) Then
           ip = 2
           hzibeam = hzibeam + 1
        Endif
        If (abs(idhep(1)).eq.11) Then
           il = 1
           hzibeam = hzibeam + 2
        Endif
        If(hzibeam.eq.1) Return
      Else
       write(6,*) '**hzibeam: generator not found gen=',gen
      Endif
*
      Return
      End
