      Function Hzidelec(idum)
**********************************************************
* Purpose:
* hzidelec return the position of the scatt. e-/+
*
* For LEPTO, ARIADNE and HERWIG the first stable particle is
* the scatt. lepton
* & in PYTHIA & in PHOJET (MEH'96)
*
* if no stable particle found hzidelec < 0
* Input: idum only a dummy
*
* Author: N. Brook
***********************************************************
      Implicit Double Precision (A-H,O-Z)
*
#include "hepevtp.inc"
#include "heracmn.inc"
#include "hzfunc.inc"
*
      hzidelec = -1
      if(gen(1:3).eq.'LEP'.or.gen(1:3).eq.'ARI'.or.
     +   gen(1:3).eq.'HRW'.or.gen(1:3).eq.'PYT'.or.
     +   gen(1:3).eq.'POM'.or.gen(1:3).eq.'DJA'.or.
     +   gen(1:3).eq.'PHO'.or.gen(1:3).eq.'RAP'.or.
     +   gen(1:3).eq.'CAS'.or.gen(1:3).eq.'SMA'.or.
     +   gen(1:3).eq.'RID'.or.gen(1:3).eq.'DSN'.or.
     +   gen(1:3).eq.'HO1'.or.gen(1:3).eq.'SHA'
     + ) then
        Do Ihep = 1, Nhep
         if(Isthep(Ihep).eq.1.and.abs(idhep(ihep)).eq.11) then
           hzidelec = ihep
           Return
         Endif
        Enddo
      Elseif (gen(1:3).eq.'INS') then
        Do Ihep = 1, Nhep
         if(  Isthep(Ihep).eq.1
     +       .and.(abs(idhep(ihep)).eq.11))then
           hzidelec = ihep
           Return
         Endif
        Enddo
      Elseif (gen(1:3).eq.'LEG') then
        Do Ihep = 1, Nhep
         if(  Isthep(Ihep).eq.1
     +       .and.(abs(idhep(ihep)).eq.11))then
           hzidelec = ihep
           Return
         Endif
        Enddo
      Else
        Write(6,*) ' HZIDELEC: UNKNOWN GENERATOR'
      Endif
*
      return
      end
