      FUNCTION HzInvMas (ipart1,ipart2)
************************************************************************
*     input:  ipart1:        index of particle 1 in HEP common
*     input:  ipart2:        index of particle 2 in HEP common
*
*     return value: invariant mass of particles, if squared invariant mass
*     is less than 0, return 0
*     
*     written by: Oliver Gutsche
************************************************************************
      IMPLICIT NONE
 
#include "hepevtp.inc"
#include "hzfunc.inc"
 
      Integer ipart1,ipart2

      DOUBLE PRECISION msq

*     check particle index
      if ((ipart1.lt.1).or.(ipart1.gt.NHEP).or.
     &     (ipart2.lt.1).or.(ipart2.gt.NHEP)) then
         msq = 0.D0
      else

         msq = (PHEP(4,ipart1)+PHEP(4,ipart2))**2 -
     &        (PHEP(1,ipart1)+PHEP(1,ipart2))**2 -
     &        (PHEP(2,ipart1)+PHEP(2,ipart2))**2 -
     &        (PHEP(3,ipart1)+PHEP(3,ipart2))**2

         if ( msq.lt.0.D0 ) msq=0.D0

      endif

      HzInvMas = sqrt(msq)
  
      RETURN
      END
















