*CMZ :  1.02/02 23/10/98  11.02.43  by  Tancredi Carli
*-- Author :
      FUNCTION HzPhi (ipart)
************************************************************************
*     input:  ipart:        index of particle in HEP common
*     output: return value: azimutal angle (phi) of particle,
*                           or 0.D0 if calculation not possible
*     no other subroutines are called
*     written by: Andreas von Manteuffel
************************************************************************
      IMPLICIT NONE

#include "hepevtp.inc"

      Double Precision HzPhi
      Integer ipart
      Double Precision dpx, dpy, dpz, dpt2, dphi
c      write(6,*) ' here in hzphi '
c --- check particle index
      if ((ipart.lt.1).or.(ipart.gt.NHEP)) then
         dphi = 0.D0
      else

c --- get particle momentum components
         dpx = PHEP(1,ipart)
         dpy = PHEP(2,ipart)
         dpz = PHEP(3,ipart)
         dpt2 = dpx**2+dpy**2
c        write(6,*) dpx,dpy,dpz,dpt2
c --- check if calculation is possible
         if (dpt2.EQ.0.D0) THEN
            dphi=0.
         else

c --- get azimutal angle (phi)
            dphi=ATAN2(dpy,dpx)
         endif
      endif

      HzPhi = dphi

      RETURN
      END
