*CMZ :  1.01/14 25/03/98  18.47.52  by  Tancredi Carli
*CMZU:  0.00/05 29/01/96  16.52.30  by  Mark Hayes
      Function Hzphokin(Itype)
**********************************************************
* Purpose:
* Return DIS kinem. variables
* Input:
* If Itype = 1 -> Q2
*    itype = 2 -> xbj
*    itype = 3 -> ybj
*    itype = 4 -> W2
* Photoproduction Author : M. Hayes
* Original Author: N. Brook
**********************************************************

      IMPLICIT NONE

#include "hepevtp.inc"
#include "hzfunc.inc"

      INTEGER itype
      DOUBLE PRECISION q2,ybj,pgam(5),pbeam(5),cms
      INTEGER il,ip,jgam,kbeam
*
      hzphokin = -1.0d0
      Jgam = hzipgamn(pgam)
      if(jgam.ne.1) Then
       Write(6,*) 'HZPHOKIN: No record of virt. photon found'
       Return
      endif
      kbeam = hzibeam(ip,il)
      If(kbeam.ne.1) Then
        Write(6,*) 'HZPHOKIN: No record of beam particles'
        Return
      Endif

      q2 = -(pgam(4)**2-pgam(3)**2-pgam(2)**2-pgam(1)**2)
      cms = (phep(4,ip)+phep(4,il))**2
     +      - ((phep(3,ip)+phep(3,il))**2
     1         +(phep(2,ip)+phep(2,il))**2
     2         +(phep(1,ip)+phep(1,il))**2)
      ybj=(phep(4,ip)*pgam(4) - phep(3,ip)*pgam(3)
     +        -phep(2,ip)*pgam(2) - phep(1,ip)*pgam(1))/
     1    (phep(4,ip)*phep(4,il) - phep(3,ip)*phep(3,il)
     2        -phep(2,ip)*phep(2,il) - phep(1,ip)*phep(1,il))
      If(itype.eq.1) Then
        hzphokin = q2
      else if(itype.eq.2) then
	PRINT*,'HZPHOKIN : current version has no x_proton calculation'
      else if(itype.eq.3) then
	hzphokin = ybj
      else if(itype.eq.4) then
	PRINT*,'HZPHOKIN : current version has no W2 calculation'
      else
        write(6,*) ' HZPHOKIN: itype should be in range 1-4'
      endif
*
      return
      end
