*CMZ :  1.02/02 23/10/98  11.02.43  by  Tancredi Carli
*-- Author :
      FUNCTION HzTheta (ipart)
************************************************************************
*     input:  ipart:        index of particle in HEP common
*     output: return value: polar angle of particle
*     no other subroutines are called
*     written by: Andreas von Manteuffel
************************************************************************

      IMPLICIT NONE

#include "hepevtp.inc"

      Double Precision HzTheta
      Integer ipart
      Double Precision dpx, dpy, dpz, dp, dcosthta, dtheta

c --- check particle index
      if ((ipart.lt.1).or.(ipart.gt.NHEP)) then
         dtheta = 0.D0
      else

c --- get particle momentum components
         dpx = PHEP(1,ipart)
         dpy = PHEP(2,ipart)
         dpz = PHEP(3,ipart)
         dp = SQRT(dpx**2+dpy**2+dpz**2)

c --- check if calculation is possible
         if (dp.eq.0.D0) then
            dtheta = 0.D0
         else

c --- get polar angle of particle
            dcosthta = dpz/dp
            if (abs(dcosthta).gt.1.D0) then
               if (dcosthta.gt.0.D0) then
                  dtheta = 0.D0
               else
                  dtheta = 180.D0
               endif
            else
               dtheta = ACOS(dcosthta)
            endif
         endif
      endif

      HzTheta = dtheta

      RETURN
      END
