*CMZ :  2.00/00 13/08/99  17.13.07  by  Tancredi Carli
*CMZ :  1.01/15 04/06/98
*-- Author :
      SubRoutine CFilpagp (icellpa,Err)
      Implicit None
C
C *********************************************************
C
C PURPOSE:       Fill CluCom from Caltru for the CDF algorithm.
C CALLED FROM:   CCCOFL
C COMMUNICATION:
C AUTHOR:        Paul de Jong, NIKHEF-H, 08-01-1992.
C *********************************************************
C --DATE--:--NAME--:--MODIFICATIONS------------------------
c 17.3.93 :  G.C.  : hadrons in HCM
C *********************************************************
C
*
* .. Calorimeter common with data card keys.
*
      Logical Lccdb(6), Lccal, Lcclu(4), Lolddata, Lsamp(6), Lnob, Lnos
      Logical First_of_all, First_physics, New_Run, New_Run_Physics
      Logical Test_Trigger, Run_Corrupt, NOC5, UNOGAF, UNOBOR, BADBOR,
     +        BADGAF
      Real    Rcslf(10), Rcslb(10), Rcslr(10), Rcslg(10), Aimpar(25),
     +        Jadepar(20), Cdfpar(20), Condspar(10), Canpar(10),
     +        Rzscut(5),Timecut(2)
      Integer Icana, Iclhi, Icldb(4), Iescale
      Character*12 Object_Type
*
      COMMON / CKey / Lccdb, Lccal, Lcclu, Lolddata, Lsamp,
     +          Lnob, Lnos, First_of_all, First_physics, New_Run,
     +          New_Run_Physics, Test_Trigger, Run_Corrupt, NOC5,
     +          UNOGAF, UNOBOR, BADGAF, BADBOR,
     +          Rcslf, Rcslb, Rcslr,
     +          Rcslg, Aimpar, Jadepar, Cdfpar, Condspar, Canpar,
     +          Rzscut, Timecut,Icana, Iclhi, Icldb, Iescale,
     +          Object_Type
C
*
* .. Calorimeter common for CluClu steering parameters.
*
      Integer Ndis,Nscale,Nmass,Nelecspec,Nrecomb,Nmcalc,Ibeamp
      Real    Djoinpt,Yjoinwinv,Dinit,Converg,Emcccut,Hacccut,Emcpcut,
     ,        Hacpcut,Emclcut,Haclcut,Djoinmass,Yjoinevis
*
      Common/CluPar/Ndis,Nscale,Nmass,Nelecspec,Nrecomb,Nmcalc,
     ,              Djoinpt,Yjoinwinv,Dinit,Converg,Emcccut,
     ,              Hacccut,Emcpcut,Hacpcut,Emclcut,Haclcut,
     ,              Djoinmass,Yjoinevis,Ibeamp
C.
*
* .. Calorimeter common for cluster finding a la LuClus (CluClu).
*
      Integer Nsblock, Npart
      Parameter (Nsblock = 4000)
      Integer KC(Nsblock,5)
      Real    PC(Nsblock,5), VC(Nsblock,5)
*
      COMMON/CluCom/Npart,KC,PC,VC
C.
      INTEGER CPsPar,CPsPar_9999
      INTEGER CPsPar_ID
      CHARACTER*4 CPsPar_Type
      REAL CPsPar_E,CPsPar_Px,CPsPar_Py,CPsPar_Pz
 
      COMMON/CPsPar/CPsPar,CPsPar_ID,CPsPar_Type,CPsPar_E,CPsPar_Px,
     +   CPsPar_Py,CPsPar_Pz,CPsPar_9999
 
C
C .. Calorimeter common for special treatment of electron in jet finding.
C
      Integer Ifound
C
      Common/Cfound/Ifound
C.
C
C .. Common block for the CDF-like jet algorithm.
C
      Integer Nseed, Nnoseed, MaxIter, Imode
      Real EtSeedcut,EtSneedcut,RadPC,Radius,Frac,ESeedcut,ESneedcut
C
      Common /CDFCom/ EtSeedcut,EtSneedcut,RadPC,Radius,MaxIter,Frac,
     ,                Imode,Nseed,Nnoseed,ESeedcut,ESneedcut
C.
*
*.. Parameter specifications for logical unit numbers
*
        Integer Lp, Lgeom, Lout, Lin, Lcards, LHBook, Lanal, Lpdst
        integer Levtsum
        Parameter (Lp=6)
        Parameter (Lgeom=8)
        Parameter (Lout=9)
        Parameter (Lcards=7)
        Parameter (LHBook=51)
        Parameter (Levtsum=52)
        Parameter (Lpdst=6)
        Parameter (Lanal=88)

#include "pucell.inc"

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c   1 = electron                                              c
c   2 = proton                                                c
c   3 = final electron                                        c
c   4 = photon/Z0                                             c
c   5 = Proton + photon                                       c
c  13 = Photon/Z0 in Hadronic System                          c
c  14 = Proton in Hadronic System                             c
c  15 = electron in Hadronic System                           c
c  16 = scattered electron in Hadronic System                 c
c  101-nch = hadrons in LAB                                   c
c  101+nch-2*nch = hadrons in Hadronic System                 c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
C
      INTEGER I, J, Err, Ielc, Ipart, Idum
      REAL Phi,X,Y,Z,R,Et,E
      LOGICAL ERROR, First
      real eta,pi
      integer ievj,iend
      Data First /.TRUE./
      Data ievj/49/
      integer icellpa,maxcell
C
C
      pi=4.*atan(1.)
C
      Err=0
      Do 25 J=1,5
         Do 10 I=1,Nsblock
            KC(I,J)=0
            VC(I,J)=0.
            PC(I,J)=0.
10    Continue
25    Continue
c
C
C Loop over all hit cells.
C
       ievj=ievj+1
       Npart=0
       Nseed=0
       Nnoseed=0
c---------------
      Do 200 I=1,icellpa
c         maxcell=100+icellpa
          maxcell=100
C----------------
         E   = pucellp(4,i+maxcell)
         ETA = pucellp(6,i+maxcell)
         Et  = pucellp(7,i+maxcell)
         PHI = pucellp(8,i+maxcell)
 
         if(E.gt.1000.) goto 200
         If (Imode.EQ.1) Then
            If (Et.LT.EtSneedcut) GoTo 200
         Else if (Imode.EQ.2) Then
            If (E.LT.ESneedcut) GoTo 200
         Endif
         Ipart=0
         If (Npart.EQ.0) Then
            Ipart=1
            GoTo 400
         Endif
         Do 300 J=1,Npart
            If (Imode.EQ.1) Then
               If (PC(J,3).GT.Et) GoTo 300
            Else if (Imode.EQ.2) Then
               If (PC(J,4).GT.E) GoTo 300
            Endif
            Ipart=J
            GoTo 301
  300    Continue
  301    If (Ipart.EQ.0) Ipart=Npart+1
         Do 500 J=Npart,Ipart,-1
            PC(J+1,1)=PC(J,1)
            PC(J+1,2)=PC(J,2)
            PC(J+1,3)=PC(J,3)
            PC(J+1,4)=PC(J,4)
            PC(J+1,5)=PC(J,5)
            KC(J+1,1)=KC(J,1)
            KC(J+1,2)=KC(J,2)
            VC(J+1,5)=VC(J,5)
  500    Continue
  400    PC(Ipart,1)=eta
         PC(Ipart,2)=Phi
         PC(Ipart,3)=ET
         PC(Ipart,4)=E
         PC(Ipart,5)=0.
         KC(Ipart,1)=0
         VC(Ipart,5)=i
         Npart=Npart+1
         If (Imode.EQ.1) Then
         If (PC(Ipart,3).GT.EtSeedcut) Then
            KC(Ipart,2)=2
            Nseed=Nseed+1
         Else if (PC(Ipart,3).GT.EtSNeedcut) Then
            KC(Ipart,2)=0
            Nnoseed=Nnoseed+1
         Else
            KC(Ipart,2)=0
         Endif
         Else if (Imode.EQ.2) Then
         If (PC(Ipart,4).GT.ESeedcut) Then
            KC(Ipart,2)=2
            Nseed=Nseed+1
          Else if (PC(Ipart,4).GT.ESNeedcut) Then
            KC(Ipart,2)=0
            Nnoseed=Nnoseed+1
         Else
            KC(Ipart,2)=0
         Endif
         Endif
  200 Continue
 
c
      RETURN
      END
